(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define gerbil/tools/gxpkg#main
    (lambda _args2529_
      (letrec* ((_install-cmd2531_
                 (std/getopt#command__%
                  '#f
                  '"install one or more packages"
                  'install
                  (std/getopt#rest-arguments__%
                   '#f
                   '"package to install"
                   absent-value
                   'pkg)))
                (_uninstall-cmd2532_
                 (std/getopt#command__%
                  '#f
                  '"uninstall one or more packages"
                  'uninstall
                  (std/getopt#flag__%__0
                   '#f
                   '"force uninstall even if there are orphaned dependencies"
                   'force
                   '"-f")
                  (std/getopt#rest-arguments__%
                   '#f
                   '"package to uninstall"
                   absent-value
                   'pkg)))
                (_update-cmd2533_
                 (std/getopt#command__%
                  '#f
                  '"update one or more packages"
                  'update
                  (std/getopt#rest-arguments__%
                   '#f
                   '"package to update; all for all packages"
                   absent-value
                   'pkg)))
                (_link-cmd2534_
                 (std/getopt#command__%
                  '#f
                  '"link a local development package"
                  'link
                  (std/getopt#argument__%
                   '#f
                   '"package to link"
                   absent-value
                   'pkg)
                  (std/getopt#argument__%
                   '#f
                   '"path to package source directory"
                   absent-value
                   'src)))
                (_unlink-cmd2535_
                 (std/getopt#command__%
                  '#f
                  '"unlink one or more local development packages"
                  'unlink
                  (std/getopt#flag__%__0
                   '#f
                   '"force unlink even if there are orphaned dependencies"
                   'force
                   '"-f")
                  (std/getopt#rest-arguments__%
                   '#f
                   '"package to unlink"
                   absent-value
                   'pkg)))
                (_build-cmd2536_
                 (std/getopt#command__%
                  '#f
                  '"rebuild one or more packages and their dependents"
                  'build
                  (std/getopt#rest-arguments__%
                   '#f
                   '"package to build; all for all packages"
                   absent-value
                   'pkg)))
                (_clean-cmd2537_
                 (std/getopt#command__%
                  '#f
                  '"clean compilation artefacts from one or more packages"
                  'clean
                  (std/getopt#rest-arguments__%
                   '#f
                   '"package to clean"
                   absent-value
                   'pkg)))
                (_list-cmd2538_
                 (std/getopt#command__% '#f '"list installed packages" 'list))
                (_retag-cmd2539_
                 (std/getopt#command__%
                  '#f
                  '"retag installed packages"
                  'retag))
                (_search-cmd2540_
                 (std/getopt#command__%
                  '#f
                  '"search the package directory"
                  'search
                  (std/getopt#rest-arguments__%
                   '#f
                   '"keywords to search for"
                   absent-value
                   'keywords)))
                (_help-cmd2541_
                 (std/getopt#command__%
                  '#f
                  '"display help; help <command> for command help"
                  'help
                  (std/getopt#optional-argument__%
                   '#f
                   absent-value
                   string->symbol
                   absent-value
                   'command)))
                (_gopt2542_
                 (std/getopt#getopt
                  _install-cmd2531_
                  _uninstall-cmd2532_
                  _update-cmd2533_
                  _link-cmd2534_
                  _unlink-cmd2535_
                  _build-cmd2536_
                  _clean-cmd2537_
                  _list-cmd2538_
                  _retag-cmd2539_
                  _search-cmd2540_
                  _help-cmd2541_)))
        (with-exception-catcher
         (lambda (_g25432545_)
           (if ((lambda (_$obj2548_)
                  (let ()
                    (declare (not safe))
                    (##structure-instance-of?
                     _$obj2548_
                     'std/getopt#getopt-error::t)))
                _g25432545_)
               (let ((_exn2551_ _g25432545_))
                 (std/getopt#getopt-display-help__%
                  _exn2551_
                  '"gxpkg"
                  (current-error-port))
                 (exit '1))
               (if '#t
                   (let ((_e2553_ _g25432545_))
                     (display-exception _e2553_ (current-error-port))
                     (exit '2))
                   (raise _g25432545_))))
         (lambda ()
           (let ((_g7435_ (std/getopt#getopt-parse _gopt2542_ _args2529_)))
             (begin
               (let ((_g7436_ (let ()
                                (declare (not safe))
                                (if (##values? _g7435_)
                                    (##vector-length _g7435_)
                                    1))))
                 (if (not (let () (declare (not safe)) (##fx= _g7436_ 2)))
                     (error "Context expects 2 values" _g7436_)))
               (let ((_cmd2556_
                      (let () (declare (not safe)) (##vector-ref _g7435_ 0)))
                     (_opt2557_
                      (let () (declare (not safe)) (##vector-ref _g7435_ 1))))
                 (let* ((_ht2559_ _opt2557_) (_$e2812_ _cmd2556_))
                   (if (eq? 'install _$e2812_)
                       (gerbil/tools/gxpkg#install-pkgs
                        (table-ref _ht2559_ 'pkg))
                       (if (eq? 'uninstall _$e2812_)
                           (gerbil/tools/gxpkg#uninstall-pkgs
                            (table-ref _ht2559_ 'pkg)
                            (table-ref _ht2559_ 'force '#f))
                           (if (eq? 'update _$e2812_)
                               (gerbil/tools/gxpkg#update-pkgs
                                (table-ref _ht2559_ 'pkg))
                               (if (eq? 'link _$e2812_)
                                   (gerbil/tools/gxpkg#pkg-link
                                    (table-ref _ht2559_ 'pkg)
                                    (table-ref _ht2559_ 'src))
                                   (if (eq? 'unlink _$e2812_)
                                       (gerbil/tools/gxpkg#unlink-pkgs
                                        (table-ref _ht2559_ 'pkg)
                                        (table-ref _ht2559_ 'force '#f))
                                       (if (eq? 'build _$e2812_)
                                           (gerbil/tools/gxpkg#build-pkgs
                                            (table-ref _ht2559_ 'pkg))
                                           (if (eq? 'clean _$e2812_)
                                               (gerbil/tools/gxpkg#clean-pkgs
                                                (table-ref _ht2559_ 'pkg))
                                               (if (eq? 'list _$e2812_)
                                                   (gerbil/tools/gxpkg#list-pkgs)
                                                   (if (eq? 'retag _$e2812_)
                                                       (gerbil/tools/gxpkg#pkg-retag)
                                                       (if (eq? 'search
                                                                _$e2812_)
                                                           (gerbil/tools/gxpkg#pkg-search
                                                            (table-ref
                                                             _ht2559_
                                                             'keywords))
                                                           (if (eq? 'help
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _$e2812_)
                       (std/getopt#getopt-display-help-topic__0
                        _gopt2542_
                        (table-ref _ht2559_ 'command '#f)
                        '"gxkpg")
                       '#!void))))))))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
  (define gerbil/tools/gxpkg#install-pkgs
    (lambda (_pkgs2485_)
      (if (let _lp2487_ ((_rest2490_ _pkgs2485_) (_result2492_ '#f))
            (let* ((_rest24942502_ _rest2490_)
                   (_else24962510_ (lambda () _result2492_))
                   (_K24982517_
                    (lambda (_rest2513_ _pkg2514_)
                      (if (gerbil/tools/gxpkg#pkg-install _pkg2514_)
                          (_lp2487_ _rest2513_ '#t)
                          (_lp2487_ _rest2513_ _result2492_)))))
              (if (let () (declare (not safe)) (##pair? _rest24942502_))
                  (let ((_hd24992520_
                         (let () (declare (not safe)) (##car _rest24942502_)))
                        (_tl25002522_
                         (let () (declare (not safe)) (##cdr _rest24942502_))))
                    (let* ((_pkg2525_ _hd24992520_) (_rest2527_ _tl25002522_))
                      (_K24982517_ _rest2527_ _pkg2525_)))
                  (_else24962510_))))
          (gerbil/tools/gxpkg#pkg-retag)
          '#!void)))
  (define gerbil/tools/gxpkg#uninstall-pkgs
    (lambda (_pkgs2440_ _force?2441_)
      (if (let _lp2443_ ((_rest2446_ _pkgs2440_) (_result2448_ '#f))
            (let* ((_rest24502458_ _rest2446_)
                   (_else24522466_ (lambda () _result2448_))
                   (_K24542473_
                    (lambda (_rest2469_ _pkg2470_)
                      (if (gerbil/tools/gxpkg#pkg-uninstall__%
                           _pkg2470_
                           _force?2441_)
                          (_lp2443_ _rest2469_ '#t)
                          (_lp2443_ _rest2469_ _result2448_)))))
              (if (let () (declare (not safe)) (##pair? _rest24502458_))
                  (let ((_hd24552476_
                         (let () (declare (not safe)) (##car _rest24502458_)))
                        (_tl24562478_
                         (let () (declare (not safe)) (##cdr _rest24502458_))))
                    (let* ((_pkg2481_ _hd24552476_) (_rest2483_ _tl24562478_))
                      (_K24542473_ _rest2483_ _pkg2481_)))
                  (_else24522466_))))
          (gerbil/tools/gxpkg#pkg-retag)
          '#!void)))
  (define gerbil/tools/gxpkg#update-pkgs
    (lambda (_pkgs2394_)
      (if (let _lp2396_ ((_rest2399_ _pkgs2394_) (_result2401_ '#f))
            (let* ((_rest24032411_ _rest2399_)
                   (_else24052419_ (lambda () _result2401_))
                   (_K24072426_
                    (lambda (_rest2422_ _pkg2423_)
                      (if (gerbil/tools/gxpkg#pkg-update _pkg2423_)
                          (_lp2396_ _rest2422_ '#t)
                          (_lp2396_ _rest2422_ _result2401_)))))
              (if (let () (declare (not safe)) (##pair? _rest24032411_))
                  (let ((_hd24082429_
                         (let () (declare (not safe)) (##car _rest24032411_)))
                        (_tl24092431_
                         (let () (declare (not safe)) (##cdr _rest24032411_))))
                    (let* ((_pkg2434_ _hd24082429_) (_rest2436_ _tl24092431_))
                      (_K24072426_ _rest2436_ _pkg2434_)))
                  (_else24052419_))))
          (begin
            (for-each
             (lambda (_pkg2438_)
               (if (equal? _pkg2438_ '"all")
                   (for-each
                    gerbil/tools/gxpkg#pkg-install-deps
                    (gerbil/tools/gxpkg#pkg-list))
                   (gerbil/tools/gxpkg#pkg-install-deps _pkg2438_)))
             _pkgs2394_)
            (for-each gerbil/tools/gxpkg#pkg-build _pkgs2394_)
            (gerbil/tools/gxpkg#pkg-retag))
          '#!void)))
  (define gerbil/tools/gxpkg#link-pkg
    (lambda (_pkg2391_ _src2392_)
      (gerbil/tools/gxpkg#pkg-link _pkg2391_ _src2392_)))
  (define gerbil/tools/gxpkg#unlink-pkgs
    (lambda (_pkgs2384_ _force?2385_)
      (for-each
       (lambda (_g23862388_)
         (gerbil/tools/gxpkg#pkg-unlink__% _g23862388_ _force?2385_))
       _pkgs2384_)))
  (define gerbil/tools/gxpkg#build-pkgs
    (lambda (_pkgs2382_) (for-each gerbil/tools/gxpkg#pkg-build _pkgs2382_)))
  (define gerbil/tools/gxpkg#clean-pkgs
    (lambda (_pkgs2380_) (for-each gerbil/tools/gxpkg#pkg-clean _pkgs2380_)))
  (define gerbil/tools/gxpkg#list-pkgs
    (lambda () (for-each displayln (gerbil/tools/gxpkg#pkg-list))))
  (define gerbil/tools/gxpkg#retag-pkgs
    (lambda () (gerbil/tools/gxpkg#pkg-retag)))
  (define gerbil/tools/gxpkg#search-pkgs
    (lambda (_keywords2376_) (gerbil/tools/gxpkg#pkg-search _keywords2376_)))
  (define gerbil/tools/gxpkg#+root-dir+ (getenv '"GERBIL_PATH" '"~/.gerbil"))
  (define gerbil/tools/gxpkg#+pkg-root-dir+
    (path-expand '"pkg" gerbil/tools/gxpkg#+root-dir+))
  (define gerbil/tools/gxpkg#+pkg-lib-dir+
    (path-expand '"lib" gerbil/tools/gxpkg#+root-dir+))
  (define gerbil/tools/gxpkg#+pkg-lib-static-dir+
    (path-expand '"static" gerbil/tools/gxpkg#+pkg-lib-dir+))
  (define gerbil/tools/gxpkg#+pkg-bin-dir+
    (path-expand '"bin" gerbil/tools/gxpkg#+root-dir+))
  (define gerbil/tools/gxpkg#pkg-root-dir
    (let ((_once2373_
           (make-promise
            (lambda ()
              (create-directory* gerbil/tools/gxpkg#+root-dir+)
              (create-directory* gerbil/tools/gxpkg#+pkg-root-dir+)
              (create-directory* gerbil/tools/gxpkg#+pkg-lib-dir+)
              (create-directory* gerbil/tools/gxpkg#+pkg-lib-static-dir+)
              (create-directory* gerbil/tools/gxpkg#+pkg-bin-dir+)))))
      (lambda () (force _once2373_) gerbil/tools/gxpkg#+pkg-root-dir+)))
  (define gerbil/tools/gxpkg#pkg-install
    (lambda (_pkg2360_)
      (letrec ((_git-clone-url2362_
                (lambda (_pkg2370_)
                  (string-append '"https://" _pkg2370_ '".git"))))
        (if (or (string-prefix? '"github.com/" _pkg2360_)
                (string-prefix? '"gitlab.com/" _pkg2360_)
                (string-prefix? '"bitbucket.org/" _pkg2360_))
            (gerbil/tools/gxpkg#pkg-install-git
             _pkg2360_
             (_git-clone-url2362_ _pkg2360_))
            (error '"Unknown package provider" _pkg2360_)))))
  (define gerbil/tools/gxpkg#pkg-install-git
    (lambda (_pkg2350_ _clone-url2351_)
      (let* ((_root2353_ (gerbil/tools/gxpkg#pkg-root-dir))
             (_dest2355_ (path-expand _pkg2350_ _root2353_)))
        (if (file-exists? _dest2355_)
            '#f
            (let ((_path2358_ (path-directory _dest2355_)))
              (displayln '"... install " _pkg2350_)
              (create-directory* _path2358_)
              (std/misc/process#run-process__%
               '#f
               void
               absent-value
               absent-value
               _path2358_
               absent-value
               '#f
               absent-value
               absent-value
               absent-value
               (cons '"git"
                     (cons '"clone" (cons '"-q" (cons _clone-url2351_ '())))))
              (gerbil/tools/gxpkg#pkg-install-deps _pkg2350_)
              (gerbil/tools/gxpkg#pkg-build__0 _pkg2350_)
              '#t)))))
  (define gerbil/tools/gxpkg#pkg-install-deps
    (lambda (_pkg2343_)
      (let* ((_plist2345_ (gerbil/tools/gxpkg#pkg-plist _pkg2343_))
             (_deps2347_ (pgetq 'depend: _plist2345_ '())))
        (for-each gerbil/tools/gxpkg#pkg-install _deps2347_))))
  (define gerbil/tools/gxpkg#pkg-uninstall__%
    (lambda (_pkg2323_ _force?2324_)
      (let* ((_root2326_ (gerbil/tools/gxpkg#pkg-root-dir))
             (_dest2328_ (path-expand _pkg2323_ _root2326_)))
        (if (file-exists? _dest2328_)
            (if (not (gerbil/tools/gxpkg#file-symbolic-link? _dest2328_))
                (begin
                  (if _force?2324_
                      '#!void
                      (let ((_deps2331_
                             (gerbil/tools/gxpkg#pkg-dependents__0 _pkg2323_)))
                        (if (null? _deps2331_)
                            '#!void
                            (error '"Refuse to uninstall package; orphaned dependencies"
                                   _deps2331_))))
                  (gerbil/tools/gxpkg#pkg-clean _pkg2323_)
                  (displayln '"... uninstall " _pkg2323_)
                  (std/misc/process#run-process__%
                   '#f
                   void
                   absent-value
                   absent-value
                   absent-value
                   absent-value
                   absent-value
                   absent-value
                   absent-value
                   absent-value
                   (cons '"rm"
                         (cons '"-rf" (cons (path-normalize _dest2328_) '()))))
                  '#t)
                '#f)
            '#f))))
  (define gerbil/tools/gxpkg#pkg-uninstall__0
    (lambda (_pkg2336_)
      (let ((_force?2338_ '#f))
        (gerbil/tools/gxpkg#pkg-uninstall__% _pkg2336_ _force?2338_))))
  (define gerbil/tools/gxpkg#pkg-uninstall
    (lambda _g7438_
      (let ((_g7437_ (let () (declare (not safe)) (##length _g7438_))))
        (cond ((let () (declare (not safe)) (##fx= _g7437_ 1))
               (apply gerbil/tools/gxpkg#pkg-uninstall__0 _g7438_))
              ((let () (declare (not safe)) (##fx= _g7437_ 2))
               (apply gerbil/tools/gxpkg#pkg-uninstall__% _g7438_))
              (else
               (##raise-wrong-number-of-arguments-exception
                gerbil/tools/gxpkg#pkg-uninstall
                _g7438_))))))
  (define gerbil/tools/gxpkg#pkg-update
    (lambda (_pkg2272_)
      (if (equal? _pkg2272_ '"all")
          (let _lp2274_ ((_rest2277_ (gerbil/tools/gxpkg#pkg-list))
                         (_result2279_ '#f))
            (let* ((_rest22812289_ _rest2277_)
                   (_else22832297_ (lambda () _result2279_))
                   (_K22852304_
                    (lambda (_rest2300_ _pkg2301_)
                      (if (gerbil/tools/gxpkg#pkg-update _pkg2301_)
                          (_lp2274_ _rest2300_ '#t)
                          (_lp2274_ _rest2300_ _result2279_)))))
              (if (let () (declare (not safe)) (##pair? _rest22812289_))
                  (let ((_hd22862307_
                         (let () (declare (not safe)) (##car _rest22812289_)))
                        (_tl22872309_
                         (let () (declare (not safe)) (##cdr _rest22812289_))))
                    (let* ((_pkg2312_ _hd22862307_) (_rest2314_ _tl22872309_))
                      (_K22852304_ _rest2314_ _pkg2312_)))
                  (_else22832297_))))
          (if (or (string-prefix? '"github.com/" _pkg2272_)
                  (string-prefix? '"gitlab.com/" _pkg2272_)
                  (string-prefix? '"bitbucket.org/" _pkg2272_))
              (gerbil/tools/gxpkg#pkg-update-git _pkg2272_)
              (error '"Unknown package provider" _pkg2272_)))))
  (define gerbil/tools/gxpkg#pkg-update-git
    (lambda (_pkg2260_)
      (let* ((_root2262_ (gerbil/tools/gxpkg#pkg-root-dir))
             (_dest2264_ (path-expand _pkg2260_ _root2262_)))
        (if (file-exists? _dest2264_)
            '#!void
            (error '"Cannot update uknown package" _pkg2260_))
        (if (not (gerbil/tools/gxpkg#file-symbolic-link? _dest2264_))
            (begin
              (displayln '"... update " _pkg2260_)
              (let* ((_result2267_
                      (std/misc/process#run-process__%
                       '#f
                       absent-value
                       absent-value
                       absent-value
                       _dest2264_
                       absent-value
                       absent-value
                       absent-value
                       absent-value
                       absent-value
                       (cons '"git" (cons '"pull" '()))))
                     (_update?2269_
                      (not (equal? _result2267_ '"Already up-to-date.\n"))))
                _update?2269_))
            '#f))))
  (define gerbil/tools/gxpkg#pkg-link
    (lambda (_pkg2252_ _src2253_)
      (let* ((_root2255_ (gerbil/tools/gxpkg#pkg-root-dir))
             (_dest2257_ (path-expand _pkg2252_ _root2255_)))
        (if (file-exists? _dest2257_)
            (error '"Cannot link package; destination already exists"
                   _pkg2252_
                   _dest2257_)
            '#!void)
        (create-directory* (path-directory _dest2257_))
        (create-symbolic-link _src2253_ _dest2257_))))
  (define gerbil/tools/gxpkg#pkg-unlink__%
    (lambda (_pkg2232_ _force?2233_)
      (let* ((_root2235_ (gerbil/tools/gxpkg#pkg-root-dir))
             (_dest2237_ (path-expand _pkg2232_ _root2235_)))
        (if (file-exists? _dest2237_)
            (begin
              (if (gerbil/tools/gxpkg#file-symbolic-link? _dest2237_)
                  '#!void
                  (error '"Cannot unlink package; not a symbolic link"
                         _dest2237_))
              (if _force?2233_
                  '#!void
                  (let ((_deps2240_
                         (gerbil/tools/gxpkg#pkg-dependents__0 _pkg2232_)))
                    (if (null? _deps2240_)
                        '#!void
                        (error '"Refuse to unlink package; orphaned dependencies"
                               _deps2240_))))
              (gerbil/tools/gxpkg#pkg-clean _pkg2232_)
              (delete-file _dest2237_))
            '#!void))))
  (define gerbil/tools/gxpkg#pkg-unlink__0
    (lambda (_pkg2245_)
      (let ((_force?2247_ '#f))
        (gerbil/tools/gxpkg#pkg-unlink__% _pkg2245_ _force?2247_))))
  (define gerbil/tools/gxpkg#pkg-unlink
    (lambda _g7440_
      (let ((_g7439_ (let () (declare (not safe)) (##length _g7440_))))
        (cond ((let () (declare (not safe)) (##fx= _g7439_ 1))
               (apply gerbil/tools/gxpkg#pkg-unlink__0 _g7440_))
              ((let () (declare (not safe)) (##fx= _g7439_ 2))
               (apply gerbil/tools/gxpkg#pkg-unlink__% _g7440_))
              (else
               (##raise-wrong-number-of-arguments-exception
                gerbil/tools/gxpkg#pkg-unlink
                _g7440_))))))
  (define gerbil/tools/gxpkg#pkg-build__%
    (lambda (_pkg2190_ _dependents?2191_)
      (if (equal? _pkg2190_ '"all")
          (let* ((_pkgs2193_ (gerbil/tools/gxpkg#pkg-list))
                 (_deps2199_
                  (map (lambda (_g21942196_)
                         (gerbil/tools/gxpkg#pkg-dependents*__%
                          _g21942196_
                          _pkgs2193_))
                       _pkgs2193_))
                 (_pkgs+deps2201_ (map cons _pkgs2193_ _deps2199_))
                 (_sorted2206_
                  (std/sort#sort
                   _pkgs+deps2201_
                   (lambda (_pa2203_ _pb2204_)
                     (member (car _pb2204_) (cdr _pa2203_))))))
            (for-each
             (lambda (_g22082210_)
               (gerbil/tools/gxpkg#pkg-build__% _g22082210_ '#f))
             (map car _sorted2206_)))
          (let* ((_root2213_ (gerbil/tools/gxpkg#pkg-root-dir))
                 (_path2215_ (path-expand _pkg2190_ _root2213_))
                 (_g7441_ (if (file-exists? _path2215_)
                              '#!void
                              (error '"Cannot build unknown package"
                                     _pkg2190_)))
                 (_build.ss2218_
                  (gerbil/tools/gxpkg#pkg-build-script _pkg2190_)))
            (displayln '"... build " _pkg2190_)
            (std/misc/process#run-process__%
             '#f
             void
             absent-value
             absent-value
             _path2215_
             absent-value
             '#f
             absent-value
             absent-value
             absent-value
             (cons _build.ss2218_ (cons '"compile" '())))
            (if _dependents?2191_
                (for-each
                 gerbil/tools/gxpkg#pkg-build
                 (gerbil/tools/gxpkg#pkg-dependents__0 _pkg2190_))
                '#!void)))))
  (define gerbil/tools/gxpkg#pkg-build__0
    (lambda (_pkg2224_)
      (let ((_dependents?2226_ '#t))
        (gerbil/tools/gxpkg#pkg-build__% _pkg2224_ _dependents?2226_))))
  (define gerbil/tools/gxpkg#pkg-build
    (lambda _g7443_
      (let ((_g7442_ (let () (declare (not safe)) (##length _g7443_))))
        (cond ((let () (declare (not safe)) (##fx= _g7442_ 1))
               (apply gerbil/tools/gxpkg#pkg-build__0 _g7443_))
              ((let () (declare (not safe)) (##fx= _g7442_ 2))
               (apply gerbil/tools/gxpkg#pkg-build__% _g7443_))
              (else
               (##raise-wrong-number-of-arguments-exception
                gerbil/tools/gxpkg#pkg-build
                _g7443_))))))
  (define gerbil/tools/gxpkg#pkg-clean
    (lambda (_pkg1911_)
      (letrec* ((_gpath1913_ (getenv '"GERBIL_PATH" '"~/.gerbil"))
                (_libdir1914_ (path-expand '"lib" _gpath1913_))
                (_bindir1915_ (path-expand '"bin" _gpath1913_))
                (_clean-lib1916_
                 (lambda (_mod2148_)
                   (let* ((_modpath2150_ (path-expand _mod2148_ _libdir1914_))
                          (_moddir2152_ (path-directory _modpath2150_))
                          (_modname2154_ (path-strip-directory _modpath2150_))
                          (_mod-dot2156_ (string-append _modname2154_ '"."))
                          (_mod-us2158_ (string-append _modname2154_ '"__"))
                          (_mod-nested2160_
                           (string-append _modname2154_ '"$")))
                     (if (file-exists? _moddir2152_)
                         (for-each
                          (lambda (_file2163_)
                            (if (or (string-prefix? _mod-dot2156_ _file2163_)
                                    (string-prefix? _mod-us2158_ _file2163_)
                                    (string-prefix?
                                     _mod-nested2160_
                                     _file2163_))
                                (let ((_path2171_
                                       (path-expand _file2163_ _moddir2152_)))
                                  (delete-file _path2171_))
                                '#!void))
                          (directory-files _moddir2152_))
                         '#!void))
                   (let* ((_static-libdir2173_
                           (path-expand '"static" _libdir1914_))
                          (_static-modname2175_
                           (string-join (string-split _mod2148_ '#\/) '"__"))
                          (_mod-self2177_
                           (string-append _static-modname2175_ '".scm"))
                          (_mod-nested2179_
                           (string-append _static-modname2175_ '"$")))
                     (if (file-exists? _static-libdir2173_)
                         (for-each
                          (lambda (_file2182_)
                            (if (or (equal? _file2182_ _mod-self2177_)
                                    (string-prefix?
                                     _mod-nested2179_
                                     _file2182_))
                                (let ((_path2187_
                                       (path-expand
                                        _file2182_
                                        _static-libdir2173_)))
                                  (delete-file _path2187_))
                                '#!void))
                          (directory-files _static-libdir2173_))
                         '#!void))))
                (_clean-bin1917_
                 (lambda (_exe2144_)
                   (let ((_bin2146_ (path-expand _exe2144_ _bindir1915_)))
                     (if (file-exists? _bin2146_)
                         (delete-file _bin2146_)
                         '#!void))))
                (_clean-static-include1918_
                 (lambda (_file2137_)
                   (let* ((_filename2139_ (path-strip-directory _file2137_))
                          (_static-path2141_
                           (path-expand
                            _filename2139_
                            (path-expand '"static" _libdir1914_))))
                     (if (file-exists? _static-path2141_)
                         (delete-file _static-path2141_)
                         '#!void)))))
        (let* ((_root1920_ (gerbil/tools/gxpkg#pkg-root-dir))
               (_path1922_ (path-expand _pkg1911_ _root1920_))
               (_g7444_ (if (file-exists? _path1922_)
                            '#!void
                            (error '"Cannot clean unknown package" _pkg1911_)))
               (_build.ss1925_ (gerbil/tools/gxpkg#pkg-build-script _pkg1911_))
               (_build-spec1927_
                (std/misc/process#run-process__%
                 '#f
                 read
                 absent-value
                 absent-value
                 _path1922_
                 absent-value
                 absent-value
                 absent-value
                 absent-value
                 absent-value
                 (cons _build.ss1925_ (cons '"spec" '()))))
               (_plist1929_ (gerbil/tools/gxpkg#pkg-plist _pkg1911_))
               (_prefix1931_ (pgetq 'package: _plist1929_))
               (_prefix1933_
                (if _prefix1931_ (symbol->string _prefix1931_) '#f))
               (_with-prefix1937_
                (if _prefix1933_
                    (lambda (_mod1935_)
                      (string-append _prefix1933_ '"/" _mod1935_))
                    values)))
          (for-each
           (lambda (_e19391941_)
             (let* ((_g19431986_ _e19391941_)
                    (_E19521990_
                     (lambda () (error '"No clause matching" _g19431986_))))
               (let ((_K19842132_
                      (lambda (_modf2130_)
                        (_clean-lib1916_ (_with-prefix1937_ _modf2130_))))
                     (_K19792114_
                      (lambda (_modf2112_)
                        (_clean-lib1916_ (_with-prefix1937_ _modf2112_))))
                     (_K19742095_
                      (lambda (_modf2093_)
                        (_clean-lib1916_ (_with-prefix1937_ _modf2093_))))
                     (_K19692076_
                      (lambda (_modf2074_)
                        (_clean-lib1916_ (_with-prefix1937_ _modf2074_))))
                     (_K19642053_
                      (lambda (_opts2050_ _modf2051_)
                        (_clean-lib1916_ (_with-prefix1937_ _modf2051_))
                        (_clean-bin1917_ (pgetq 'bin: _opts2050_ _modf2051_))))
                     (_K19592029_
                      (lambda (_opts2026_ _modf2027_)
                        (_clean-lib1916_ (_with-prefix1937_ _modf2027_))
                        (_clean-bin1917_ (pgetq 'bin: _opts2026_ _modf2027_))))
                     (_K19542007_
                      (lambda (_file2005_)
                        (_clean-static-include1918_ _file2005_)))
                     (_K19531996_
                      (lambda (_unexpected1994_)
                        (displayln
                         '"Ignoring unexpected build artifact "
                         _unexpected1994_))))
                 (let ((_try-match19452127_
                        (lambda ()
                          (if (let ()
                                (declare (not safe))
                                (##pair? _g19431986_))
                              (let ((_tl19812119_
                                     (let ()
                                       (declare (not safe))
                                       (##cdr _g19431986_)))
                                    (_hd19802117_
                                     (let ()
                                       (declare (not safe))
                                       (##car _g19431986_))))
                                (if (let ()
                                      (declare (not safe))
                                      (##eq? _hd19802117_ 'gxc:))
                                    (if (let ()
                                          (declare (not safe))
                                          (##pair? _tl19812119_))
                                        (let* ((_hd19822122_
                                                (let ()
                                                  (declare (not safe))
                                                  (##car _tl19812119_)))
                                               (_modf2125_ _hd19822122_))
                                          (_K19792114_ _modf2125_))
                                        (let ((_unexpected1999_ _g19431986_))
                                          (_K19531996_ _unexpected1999_)))
                                    (if (let ()
                                          (declare (not safe))
                                          (##eq? _hd19802117_ 'gsc:))
                                        (if (let ()
                                              (declare (not safe))
                                              (##pair? _tl19812119_))
                                            (let* ((_hd19772103_
                                                    (let ()
                                                      (declare (not safe))
                                                      (##car _tl19812119_)))
                                                   (_modf2106_ _hd19772103_))
                                              (_K19742095_ _modf2106_))
                                            (let ((_unexpected1999_
                                                   _g19431986_))
                                              (_K19531996_ _unexpected1999_)))
                                        (if (let ()
                                              (declare (not safe))
                                              (##eq? _hd19802117_ 'ssi:))
                                            (if (let ()
                                                  (declare (not safe))
                                                  (##pair? _tl19812119_))
                                                (let* ((_hd19722084_
                                                        (let ()
                                                          (declare (not safe))
                                                          (##car _tl19812119_)))
                                                       (_modf2087_
                                                        _hd19722084_))
                                                  (_K19692076_ _modf2087_))
                                                (let ((_unexpected1999_
                                                       _g19431986_))
                                                  (_K19531996_
                                                   _unexpected1999_)))
                                            (if (let ()
                                                  (declare (not safe))
                                                  (##eq? _hd19802117_ 'exe:))
                                                (if (let ()
                                                      (declare (not safe))
                                                      (##pair? _tl19812119_))
                                                    (let ((_tl19682063_
                                                           (let ()
                                                             (declare
                                                               (not safe))
                                                             (##cdr _tl19812119_)))
                                                          (_hd19672061_
                                                           (let ()
                                                             (declare
                                                               (not safe))
                                                             (##car _tl19812119_))))
                                                      (let ((_modf2066_
                                                             _hd19672061_)
                                                            (_opts2068_
                                                             _tl19682063_))
                                                        (_K19642053_
                                                         _opts2068_
                                                         _modf2066_)))
                                                    (let ((_unexpected1999_
                                                           _g19431986_))
                                                      (_K19531996_
                                                       _unexpected1999_)))
                                                (if (let ()
                                                      (declare (not safe))
                                                      (##eq? _hd19802117_
                                                             'static-exe:))
                                                    (if (let ()
                                                          (declare (not safe))
                                                          (##pair? _tl19812119_))
                                                        (let ((_tl19632039_
                                                               (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (declare (not safe))
                         (##cdr _tl19812119_)))
                      (_hd19622037_
                       (let () (declare (not safe)) (##car _tl19812119_))))
                  (let ((_modf2042_ _hd19622037_) (_opts2044_ _tl19632039_))
                    (_K19592029_ _opts2044_ _modf2042_)))
                (let ((_unexpected1999_ _g19431986_))
                  (_K19531996_ _unexpected1999_)))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                    (if (let ()
                                                          (declare (not safe))
                                                          (##eq? _hd19802117_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         'static-include:))
                (if (let () (declare (not safe)) (##pair? _tl19812119_))
                    (let ((_tl19582017_
                           (let () (declare (not safe)) (##cdr _tl19812119_)))
                          (_hd19572015_
                           (let () (declare (not safe)) (##car _tl19812119_))))
                      (if (let () (declare (not safe)) (##null? _tl19582017_))
                          (let ((_file2020_ _hd19572015_))
                            (_clean-static-include1918_ _file2020_))
                          (let ((_unexpected1999_ _g19431986_))
                            (_K19531996_ _unexpected1999_))))
                    (let ((_unexpected1999_ _g19431986_))
                      (_K19531996_ _unexpected1999_)))
                (let ((_unexpected1999_ _g19431986_))
                  (_K19531996_ _unexpected1999_)))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                              (let ((_unexpected1999_ _g19431986_))
                                (_K19531996_ _unexpected1999_))))))
                   (if (string? _g19431986_)
                       (let ((_modf2135_ _g19431986_))
                         (_K19842132_ _modf2135_))
                       (_try-match19452127_))))))
           _build-spec1927_)))))
  (define gerbil/tools/gxpkg#pkg-list
    (lambda ()
      (letrec* ((_root1836_ (gerbil/tools/gxpkg#pkg-root-dir))
                (_walk1837_
                 (lambda (_dir1899_ _pkgpath1900_)
                   (for-each
                    (lambda (_file1902_)
                      (let* ((_path1904_ (path-expand _file1902_ _dir1899_))
                             (_gerbil.pkg1906_
                              (path-expand '"gerbil.pkg" _path1904_))
                             (_pkgpath1908_
                              (if (string-empty? _pkgpath1900_)
                                  _file1902_
                                  (string-append
                                   _pkgpath1900_
                                   '"/"
                                   _file1902_))))
                        (if (file-exists? _gerbil.pkg1906_)
                            (std/coroutine#yield _pkgpath1908_)
                            (if (gerbil/tools/gxpkg#file-directory? _path1904_)
                                (_walk1837_ _path1904_ _pkgpath1908_)
                                '#!void))))
                    (directory-files _dir1899_)))))
        (let ((_iterable1861_ (lambda () (_walk1837_ _root1836_ '"")))
              (_iter-do1863_
               (lambda (_val1840_)
                 (let* ((_val18421847_ _val1840_)
                        (_E18441851_
                         (lambda ()
                           (error '"No clause matching" _val18421847_)))
                        (_K18451856_ (lambda (_pkg1854_) _pkg1854_))
                        (_pkg1859_ _val18421847_))
                   (_K18451856_ _pkg1859_)))))
          (if (pair? _iterable1861_)
              (map _iter-do1863_ _iterable1861_)
              (if (null? _iterable1861_)
                  '()
                  (let* ((_it1866_ (std/iter#iter _iterable1861_))
                         (_next!1869_
                          (let ()
                            (declare (not safe))
                            (##unchecked-structure-ref
                             _it1866_
                             '2
                             std/iter#iterator::t
                             '#f))))
                    (declare (not safe))
                    (let ((_root1874_ (cons '#f '())))
                      (let _lp1877_ ((_tl1880_ _root1874_))
                        (let ((_val1883_ (_next!1869_ _it1866_)))
                          (if (eq? std/iter#iter-end _val1883_)
                              (begin
                                (let ((_$e1885_
                                       (##unchecked-structure-ref
                                        _it1866_
                                        '3
                                        std/iter#iterator::t
                                        '#f)))
                                  (if _$e1885_
                                      ((lambda (_g18871889_)
                                         (_g18871889_ _it1866_))
                                       _$e1885_)
                                      '#!void))
                                (cdr _root1874_))
                              (let* ((_xval1892_ (_iter-do1863_ _val1883_))
                                     (_tl*1895_ (cons _xval1892_ '())))
                                (set-cdr! _tl1880_ _tl*1895_)
                                (_lp1877_ _tl*1895_)))))))))))))
  (define gerbil/tools/gxpkg#pkg-retag
    (lambda ()
      (let* ((_root1828_ (gerbil/tools/gxpkg#pkg-root-dir))
             (_dirs1832_
              (filter (lambda (_file1830_)
                        (gerbil/tools/gxpkg#file-directory?
                         (path-expand _file1830_ _root1828_)))
                      (directory-files _root1828_))))
        (displayln '"... tagging packages")
        (std/misc/process#run-process__%
         '#f
         absent-value
         absent-value
         absent-value
         _root1828_
         absent-value
         absent-value
         absent-value
         absent-value
         absent-value
         (cons '"gxtags" _dirs1832_)))))
  (define gerbil/tools/gxpkg#pkg-search
    (lambda (_keywords1699_)
      (letrec ((_search1701_
                (lambda (_alst1767_)
                  (let _lp1769_ ((_rest1771_ _alst1767_) (_r1772_ '()))
                    (let* ((_rest17731783_ _rest1771_)
                           (_else17751791_ (lambda () (reverse _r1772_)))
                           (_K17771806_
                            (lambda (_rest1794_ _desc1795_ _pkg1796_ _hd1797_)
                              (if (andmap1 (lambda (_kw1799_)
                                             (let ((_rx1801_
                                                    (std/pregexp#pregexp
                                                     (string-append
                                                      '"(?i:"
                                                      _kw1799_
                                                      '")"))))
                                               (or (std/pregexp#pregexp-match
                                                    _rx1801_
                                                    _pkg1796_)
                                                   (std/pregexp#pregexp-match
                                                    _rx1801_
                                                    _desc1795_))))
                                           _keywords1699_)
                                  (_lp1769_ _rest1794_ (cons _hd1797_ _r1772_))
                                  (_lp1769_ _rest1794_ _r1772_)))))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _rest17731783_))
                          (let ((_hd17781809_
                                 (let ()
                                   (declare (not safe))
                                   (##car _rest17731783_)))
                                (_tl17791811_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _rest17731783_))))
                            (let ((_hd1814_ _hd17781809_))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _hd17781809_))
                                  (let ((_hd17801816_
                                         (let ()
                                           (declare (not safe))
                                           (##car _hd17781809_)))
                                        (_tl17811818_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _hd17781809_))))
                                    (let* ((_pkg1821_ _hd17801816_)
                                           (_desc1823_ _tl17811818_)
                                           (_rest1825_ _tl17791811_))
                                      (_K17771806_
                                       _rest1825_
                                       _desc1823_
                                       _pkg1821_
                                       _hd1814_)))
                                  (_else17751791_))))
                          (_else17751791_))))))
               (_display-pkgs1702_
                (lambda (_alst1708_)
                  (let ((_iterable1741_ _alst1708_)
                        (_iter-do1743_
                         (lambda (_val1710_)
                           (let* ((_val17121719_ _val1710_)
                                  (_E17141723_
                                   (lambda ()
                                     (error '"No clause matching"
                                            _val17121719_)))
                                  (_K17151729_
                                   (lambda (_desc1726_ _pkg1727_)
                                     (displayln _pkg1727_ '": " _desc1726_))))
                             (if (let ()
                                   (declare (not safe))
                                   (##pair? _val17121719_))
                                 (let ((_hd17161732_
                                        (let ()
                                          (declare (not safe))
                                          (##car _val17121719_)))
                                       (_tl17171734_
                                        (let ()
                                          (declare (not safe))
                                          (##cdr _val17121719_))))
                                   (let* ((_pkg1737_ _hd17161732_)
                                          (_desc1739_ _tl17171734_))
                                     (_K17151729_ _desc1739_ _pkg1737_)))
                                 (_E17141723_))))))
                    (if (pair? _iterable1741_)
                        (for-each _iter-do1743_ _iterable1741_)
                        (if (null? _iterable1741_)
                            '#!void
                            (let* ((_it1746_ (std/iter#iter _iterable1741_))
                                   (_next!1749_
                                    (let ()
                                      (declare (not safe))
                                      (##unchecked-structure-ref
                                       _it1746_
                                       '2
                                       std/iter#iterator::t
                                       '#f))))
                              (declare (not safe))
                              (begin
                                (let _lp1754_ ()
                                  (let ((_val1758_ (_next!1749_ _it1746_)))
                                    (if (eq? std/iter#iter-end _val1758_)
                                        '#!void
                                        (begin
                                          (_iter-do1743_ _val1758_)
                                          (_lp1754_)))))
                                (let ((_$e1760_
                                       (##unchecked-structure-ref
                                        _it1746_
                                        '3
                                        std/iter#iterator::t
                                        '#f)))
                                  (if _$e1760_
                                      ((lambda (_g17621764_)
                                         (_g17621764_ _it1746_))
                                       _$e1760_)
                                      '#!void))
                                '#!void))))))))
        (let ((_alst1704_ (gerbil/tools/gxpkg#pkg-directory-list)))
          (if (null? _keywords1699_)
              (_display-pkgs1702_ _alst1704_)
              (let ((_matches1706_ (_search1701_ _alst1704_)))
                (_display-pkgs1702_ _matches1706_)))))))
  (define gerbil/tools/gxpkg#+pkg-directory+
    '"https://raw.githubusercontent.com/vyzo/gerbil-directory/master/README.md")
  (define gerbil/tools/gxpkg#pkg-directory-list
    (lambda ()
      (let* ((_txt1561_
              (std/net/request#request-text
               (std/net/request#http-get__%
                '#f
                absent-value
                absent-value
                absent-value
                absent-value
                absent-value
                absent-value
                gerbil/tools/gxpkg#+pkg-directory+)))
             (_lines1563_ (string-split _txt1561_ '#\newline)))
        (let _lp1566_ ((_rest1568_ _lines1563_))
          (let* ((_rest15691576_ _rest1568_)
                 (_E15711580_
                  (lambda () (error '"No clause matching" _rest15691576_)))
                 (_K15721687_
                  (lambda (_rest1583_ _hd1584_)
                    (if (equal? _hd1584_ '"<!-- begin-pkg -->")
                        (let _lp21586_ ((_rest1588_ (cddr _rest1583_))
                                        (_pkgs1589_ '()))
                          (let* ((_rest15901597_ _rest1588_)
                                 (_E15921601_
                                  (lambda ()
                                    (error '"No clause matching"
                                           _rest15901597_)))
                                 (_K15931675_
                                  (lambda (_rest1604_ _hd1605_)
                                    (if (equal? _hd1605_ '"<!-- end-pkg -->")
                                        (reverse _pkgs1589_)
                                        (let* ((_g16061617_
                                                (string-split _hd1605_ '#\|))
                                               (_E16081621_
                                                (lambda ()
                                                  (error '"No clause matching"
                                                         _g16061617_)))
                                               (_K16091657_
                                                (lambda (_pkg-desc1624_
                                                         _pkg-link1625_)
                                                  (let* ((_g16261635_
                                                          (std/pregexp#pregexp-match
                                                           '"\\[([^]]+)\\]"
                                                           _pkg-link1625_))
                                                         (_E16281639_
                                                          (lambda ()
                                                            (error '"No clause matching"
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           _g16261635_)))
                 (_K16291644_
                  (lambda (_pkg1642_)
                    (_lp21586_
                     _rest1604_
                     (cons (cons _pkg1642_
                                 (std/srfi/13#string-trim__0 _pkg-desc1624_))
                           _pkgs1589_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                    (if (let ()
                                                          (declare (not safe))
                                                          (##pair? _g16261635_))
                                                        (let ((_tl16311647_
                                                               (let ()
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (declare (not safe))
                         (##cdr _g16261635_))))
                  (if (let () (declare (not safe)) (##pair? _tl16311647_))
                      (let ((_hd16321650_
                             (let ()
                               (declare (not safe))
                               (##car _tl16311647_)))
                            (_tl16331652_
                             (let ()
                               (declare (not safe))
                               (##cdr _tl16311647_))))
                        (let ((_pkg1655_ _hd16321650_))
                          (if (let ()
                                (declare (not safe))
                                (##null? _tl16331652_))
                              (_K16291644_ _pkg1655_)
                              (_E16281639_))))
                      (_E16281639_)))
                (_E16281639_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                          (if (let ()
                                                (declare (not safe))
                                                (##pair? _g16061617_))
                                              (let ((_tl16111660_
                                                     (let ()
                                                       (declare (not safe))
                                                       (##cdr _g16061617_))))
                                                (if (let ()
                                                      (declare (not safe))
                                                      (##pair? _tl16111660_))
                                                    (let ((_hd16121663_
                                                           (let ()
                                                             (declare
                                                               (not safe))
                                                             (##car _tl16111660_)))
                                                          (_tl16131665_
                                                           (let ()
                                                             (declare
                                                               (not safe))
                                                             (##cdr _tl16111660_))))
                                                      (let ((_pkg-link1668_
                                                             _hd16121663_))
                                                        (if (let ()
                                                              (declare
                                                                (not safe))
                                                              (##pair? _tl16131665_))
                                                            (let* ((_hd16141670_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            (let () (declare (not safe)) (##car _tl16131665_)))
                           (_pkg-desc1673_ _hd16141670_))
                      (_K16091657_ _pkg-desc1673_ _pkg-link1668_))
                    (_E16081621_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                    (_E16081621_)))
                                              (_E16081621_)))))))
                            (if (let ()
                                  (declare (not safe))
                                  (##pair? _rest15901597_))
                                (let ((_hd15941678_
                                       (let ()
                                         (declare (not safe))
                                         (##car _rest15901597_)))
                                      (_tl15951680_
                                       (let ()
                                         (declare (not safe))
                                         (##cdr _rest15901597_))))
                                  (let* ((_hd1683_ _hd15941678_)
                                         (_rest1685_ _tl15951680_))
                                    (_K15931675_ _rest1685_ _hd1683_)))
                                (_E15921601_))))
                        (_lp1566_ _rest1583_)))))
            (if (let () (declare (not safe)) (##pair? _rest15691576_))
                (let ((_hd15731690_
                       (let () (declare (not safe)) (##car _rest15691576_)))
                      (_tl15741692_
                       (let () (declare (not safe)) (##cdr _rest15691576_))))
                  (let* ((_hd1695_ _hd15731690_) (_rest1697_ _tl15741692_))
                    (_K15721687_ _rest1697_ _hd1695_)))
                (_E15711580_)))))))
  (define gerbil/tools/gxpkg#+pkg-plist+ (make-table))
  (define gerbil/tools/gxpkg#pkg-plist
    (lambda (_pkg1543_)
      (let ((_$e1545_
             (table-ref gerbil/tools/gxpkg#+pkg-plist+ _pkg1543_ '#f)))
        (if _$e1545_
            (values _$e1545_)
            (let* ((_root1548_ (gerbil/tools/gxpkg#pkg-root-dir))
                   (_path1550_ (path-expand _pkg1543_ _root1548_))
                   (_gerbil.pkg1552_ (path-expand '"gerbil.pkg" _path1550_))
                   (_g7445_ (if (file-exists? _gerbil.pkg1552_)
                                '#!void
                                (error '"Bad package; missing gerbil.pkg"
                                       _pkg1543_)))
                   (_plist1555_ (call-with-input-file _gerbil.pkg1552_ read))
                   (_plist1557_
                    (if (eof-object? _plist1555_) '() _plist1555_)))
              (table-set! gerbil/tools/gxpkg#+pkg-plist+ _pkg1543_ _plist1557_)
              _plist1557_)))))
  (define gerbil/tools/gxpkg#pkg-build-script
    (lambda (_pkg1527_)
      (let* ((_root1529_ (gerbil/tools/gxpkg#pkg-root-dir))
             (_path1531_ (path-expand _pkg1527_ _root1529_))
             (_plist1533_ (gerbil/tools/gxpkg#pkg-plist _pkg1527_))
             (_build1535_ (pgetq 'build: _plist1533_))
             (_build.ss1540_
              (path-expand
               (let ((_$e1537_ _build1535_))
                 (if _$e1537_ _$e1537_ '"build.ss"))
               _path1531_)))
        (if (file-exists? _build.ss1540_)
            '#!void
            (error '"Bad package; missing build script"
                   _pkg1527_
                   _build.ss1540_))
        (path-normalize _build.ss1540_))))
  (define gerbil/tools/gxpkg#pkg-dependents__%
    (lambda (_pkg1505_ _pkgs1506_)
      (letrec ((_dependent1508_
                (lambda (_xpkg1510_)
                  (let* ((_plist1512_
                          (gerbil/tools/gxpkg#pkg-plist _xpkg1510_))
                         (_deps1514_ (pgetq 'depend: _plist1512_ '())))
                    (if (member _pkg1505_ _deps1514_) _xpkg1510_ '#f)))))
        (filter-map1 _dependent1508_ _pkgs1506_))))
  (define gerbil/tools/gxpkg#pkg-dependents__0
    (lambda (_pkg1520_)
      (let ((_pkgs1522_ (gerbil/tools/gxpkg#pkg-list)))
        (gerbil/tools/gxpkg#pkg-dependents__% _pkg1520_ _pkgs1522_))))
  (define gerbil/tools/gxpkg#pkg-dependents
    (lambda _g7447_
      (let ((_g7446_ (let () (declare (not safe)) (##length _g7447_))))
        (cond ((let () (declare (not safe)) (##fx= _g7446_ 1))
               (apply gerbil/tools/gxpkg#pkg-dependents__0 _g7447_))
              ((let () (declare (not safe)) (##fx= _g7446_ 2))
               (apply gerbil/tools/gxpkg#pkg-dependents__% _g7447_))
              (else
               (##raise-wrong-number-of-arguments-exception
                gerbil/tools/gxpkg#pkg-dependents
                _g7447_))))))
  (define gerbil/tools/gxpkg#pkg-dependents*__%
    (lambda (_pkg1449_ _pkgs1450_)
      (let ((_deps1452_
             (gerbil/tools/gxpkg#pkg-dependents__% _pkg1449_ _pkgs1450_)))
        (let _lp1454_ ((_rest1456_ _deps1452_) (_r1457_ '()))
          (let* ((_rest14581466_ _rest1456_)
                 (_else14601474_ (lambda () _r1457_))
                 (_K14621482_
                  (lambda (_rest1477_ _pkg1478_)
                    (if (member _pkg1478_ _r1457_)
                        (_lp1454_ _rest1477_ _r1457_)
                        (let ((_deps1480_
                               (gerbil/tools/gxpkg#pkg-dependents__%
                                _pkg1478_
                                _pkgs1450_)))
                          (_lp1454_
                           (foldl1 cons _rest1477_ _deps1480_)
                           (cons _pkg1478_ _r1457_)))))))
            (if (let () (declare (not safe)) (##pair? _rest14581466_))
                (let ((_hd14631485_
                       (let () (declare (not safe)) (##car _rest14581466_)))
                      (_tl14641487_
                       (let () (declare (not safe)) (##cdr _rest14581466_))))
                  (let* ((_pkg1490_ _hd14631485_) (_rest1492_ _tl14641487_))
                    (_K14621482_ _rest1492_ _pkg1490_)))
                (_else14601474_)))))))
  (define gerbil/tools/gxpkg#pkg-dependents*__0
    (lambda (_pkg1497_)
      (let ((_pkgs1499_ (gerbil/tools/gxpkg#pkg-list)))
        (gerbil/tools/gxpkg#pkg-dependents*__% _pkg1497_ _pkgs1499_))))
  (define gerbil/tools/gxpkg#pkg-dependents*
    (lambda _g7449_
      (let ((_g7448_ (let () (declare (not safe)) (##length _g7449_))))
        (cond ((let () (declare (not safe)) (##fx= _g7448_ 1))
               (apply gerbil/tools/gxpkg#pkg-dependents*__0 _g7449_))
              ((let () (declare (not safe)) (##fx= _g7448_ 2))
               (apply gerbil/tools/gxpkg#pkg-dependents*__% _g7449_))
              (else
               (##raise-wrong-number-of-arguments-exception
                gerbil/tools/gxpkg#pkg-dependents*
                _g7449_))))))
  (define gerbil/tools/gxpkg#file-directory?
    (lambda (_path1446_) (eq? (file-type _path1446_) 'directory)))
  (define gerbil/tools/gxpkg#file-symbolic-link?
    (lambda (_path1444_)
      (eq? (file-info-type (file-info _path1444_ '#f)) 'symbolic-link))))
