(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/actor/rpc/connection#errorf
    (lambda (_fmt257133_ . _args257134_)
      (std/logger#log-message 'rpc '0 _fmt257133_ _args257134_)))
  (define std/actor/rpc/connection#warnf
    (lambda (_fmt257130_ . _args257131_)
      (std/logger#log-message 'rpc '1 _fmt257130_ _args257131_)))
  (define std/actor/rpc/connection#infof
    (lambda (_fmt257127_ . _args257128_)
      (std/logger#log-message 'rpc '2 _fmt257127_ _args257128_)))
  (define std/actor/rpc/connection#debugf
    (lambda (_fmt257124_ . _args257125_)
      (std/logger#log-message 'rpc '3 _fmt257124_ _args257125_)))
  (define std/actor/rpc/connection#verbosef
    (lambda (_fmt257119_ . _args257121_)
      (std/logger#log-message 'rpc '4 _fmt257119_ _args257121_)))
  (define std/actor/rpc/connection#rpc-server-connection
    (lambda (_rpc-server257105_
             _actors257106_
             _sock257107_
             _sa257108_
             _cliaddr257109_
             _proto-e257110_)
      (with-exception-catcher
       (lambda (_g257111257113_)
         (if '#t
             (let ((_e257116_ _g257111257113_))
               (std/actor/rpc/connection#rpc-connection-cleanup
                _rpc-server257105_
                _e257116_
                _sock257107_))
             (raise _g257111257113_)))
       (lambda ()
         (std/actor/rpc/connection#rpc-set-nodelay!
          _sock257107_
          (std/os/_socket#sockaddr_family _sa257108_))
         (std/actor/rpc/connection#rpc-connection-loop
          _rpc-server257105_
          _actors257106_
          _sock257107_
          _cliaddr257109_
          _proto-e257110_)))))
  (define std/actor/rpc/connection#rpc-client-connection
    (lambda (_rpc-server257088_ _actors257089_ _address257090_ _proto-e257091_)
      (with-exception-catcher
       (lambda (_g257092257094_)
         (if '#t
             (let ((_e257097_ _g257092257094_))
               (std/actor/rpc/connection#rpc-connection-cleanup
                _rpc-server257088_
                _e257097_
                '#f))
             (raise _g257092257094_)))
       (lambda ()
         (let* ((_sa257100_ (std/os/socket#socket-address _address257090_))
                (_cli257102_
                 (std/net/socket/api#ssocket-connect__0 _sa257100_)))
           (std/actor/rpc/connection#rpc-set-nodelay!
            _cli257102_
            (std/os/_socket#sockaddr_family _sa257100_))
           (std/actor/rpc/connection#rpc-connection-loop
            _rpc-server257088_
            _actors257089_
            _cli257102_
            _address257090_
            _proto-e257091_))))))
  (define std/actor/rpc/connection#rpc-set-nodelay!
    (lambda (_sock257082_ _safamily257083_)
      (if (or (eq? _safamily257083_ std/os/_socket#AF_INET)
              (eq? _safamily257083_ std/os/_socket#AF_INET6))
          (std/os/socket#socket-setsockopt
           (##direct-structure-ref
            _sock257082_
            '1
            std/net/socket/base#!socket::t
            '#f)
           std/os/_socket#IPPROTO_TCP
           std/os/_socket#TCP_NODELAY
           '1)
          '#!void)))
  (define std/actor/rpc/connection#rpc-keep-alive '60)
  (define std/actor/rpc/connection#set-rpc-keep-alive-interval!
    (lambda (_dt257077_)
      (if (or (not _dt257077_) (and (real? _dt257077_) (positive? _dt257077_)))
          (set! std/actor/rpc/connection#rpc-keep-alive _dt257077_)
          (error '"bad keep-alive; expected positive real or #f" _dt257077_))))
  (define std/actor/rpc/connection#rpc-idle-timeout '#f)
  (define std/actor/rpc/connection#set-rpc-idle-timeout!
    (lambda (_dt257072_)
      (if (or (not _dt257072_) (and (real? _dt257072_) (positive? _dt257072_)))
          (set! std/actor/rpc/connection#rpc-idle-timeout _dt257072_)
          (error '"bad idle interval; expected positive real or #f"
                 _dt257072_))))
  (define std/actor/rpc/connection#rpc-call-timeout '60)
  (define std/actor/rpc/connection#set-rpc-call-timeout!
    (lambda (_dt257070_)
      (if (and (real? _dt257070_) (positive? _dt257070_) (finite? _dt257070_))
          (set! std/actor/rpc/connection#rpc-call-timeout _dt257070_)
          (if (not _dt257070_)
              (set! std/actor/rpc/connection#rpc-call-timeout '#f)
              (error '"bad timeout; expected finite positive real or #f"
                     _dt257070_)))))
  (define std/actor/rpc/connection#continuation-table::t
    (make-struct-type
     'std/actor/rpc/connection#continuation-table::t
     '#f
     '6
     'continuation-table
     '((final: . #t))
     ':init!
     '(mx continuations
          stream-continuations
          stream-actors
          timeouts
          continuation-timeouts)))
  (define std/actor/rpc/connection#continuation-table?
    (make-struct-predicate std/actor/rpc/connection#continuation-table::t))
  (define std/actor/rpc/connection#make-continuation-table
    (lambda _$args257067_
      (apply make-struct-instance
             std/actor/rpc/connection#continuation-table::t
             _$args257067_)))
  (define std/actor/rpc/connection#continuation-table-mx
    (make-struct-field-accessor
     std/actor/rpc/connection#continuation-table::t
     '0))
  (define std/actor/rpc/connection#continuation-table-continuations
    (make-struct-field-accessor
     std/actor/rpc/connection#continuation-table::t
     '1))
  (define std/actor/rpc/connection#continuation-table-stream-continuations
    (make-struct-field-accessor
     std/actor/rpc/connection#continuation-table::t
     '2))
  (define std/actor/rpc/connection#continuation-table-stream-actors
    (make-struct-field-accessor
     std/actor/rpc/connection#continuation-table::t
     '3))
  (define std/actor/rpc/connection#continuation-table-timeouts
    (make-struct-field-accessor
     std/actor/rpc/connection#continuation-table::t
     '4))
  (define std/actor/rpc/connection#continuation-table-continuation-timeouts
    (make-struct-field-accessor
     std/actor/rpc/connection#continuation-table::t
     '5))
  (define std/actor/rpc/connection#continuation-table-mx-set!
    (make-struct-field-mutator
     std/actor/rpc/connection#continuation-table::t
     '0))
  (define std/actor/rpc/connection#continuation-table-continuations-set!
    (make-struct-field-mutator
     std/actor/rpc/connection#continuation-table::t
     '1))
  (define std/actor/rpc/connection#continuation-table-stream-continuations-set!
    (make-struct-field-mutator
     std/actor/rpc/connection#continuation-table::t
     '2))
  (define std/actor/rpc/connection#continuation-table-stream-actors-set!
    (make-struct-field-mutator
     std/actor/rpc/connection#continuation-table::t
     '3))
  (define std/actor/rpc/connection#continuation-table-timeouts-set!
    (make-struct-field-mutator
     std/actor/rpc/connection#continuation-table::t
     '4))
  (define std/actor/rpc/connection#continuation-table-continuation-timeouts-set!
    (make-struct-field-mutator
     std/actor/rpc/connection#continuation-table::t
     '5))
  (define std/actor/rpc/connection#&continuation-table-mx
    (make-struct-field-unchecked-accessor
     std/actor/rpc/connection#continuation-table::t
     '0))
  (define std/actor/rpc/connection#&continuation-table-continuations
    (make-struct-field-unchecked-accessor
     std/actor/rpc/connection#continuation-table::t
     '1))
  (define std/actor/rpc/connection#&continuation-table-stream-continuations
    (make-struct-field-unchecked-accessor
     std/actor/rpc/connection#continuation-table::t
     '2))
  (define std/actor/rpc/connection#&continuation-table-stream-actors
    (make-struct-field-unchecked-accessor
     std/actor/rpc/connection#continuation-table::t
     '3))
  (define std/actor/rpc/connection#&continuation-table-timeouts
    (make-struct-field-unchecked-accessor
     std/actor/rpc/connection#continuation-table::t
     '4))
  (define std/actor/rpc/connection#&continuation-table-continuation-timeouts
    (make-struct-field-unchecked-accessor
     std/actor/rpc/connection#continuation-table::t
     '5))
  (define std/actor/rpc/connection#&continuation-table-mx-set!
    (make-struct-field-unchecked-mutator
     std/actor/rpc/connection#continuation-table::t
     '0))
  (define std/actor/rpc/connection#&continuation-table-continuations-set!
    (make-struct-field-unchecked-mutator
     std/actor/rpc/connection#continuation-table::t
     '1))
  (define std/actor/rpc/connection#&continuation-table-stream-continuations-set!
    (make-struct-field-unchecked-mutator
     std/actor/rpc/connection#continuation-table::t
     '2))
  (define std/actor/rpc/connection#&continuation-table-stream-actors-set!
    (make-struct-field-unchecked-mutator
     std/actor/rpc/connection#continuation-table::t
     '3))
  (define std/actor/rpc/connection#&continuation-table-timeouts-set!
    (make-struct-field-unchecked-mutator
     std/actor/rpc/connection#continuation-table::t
     '4))
  (define std/actor/rpc/connection#&continuation-table-continuation-timeouts-set!
    (make-struct-field-unchecked-mutator
     std/actor/rpc/connection#continuation-table::t
     '5))
  (define std/actor/rpc/connection#continuation-table:::init!
    (lambda (_self257065_)
      (if (##fx< '6 (##vector-length _self257065_))
          (begin
            (##vector-set! _self257065_ '1 (make-mutex 'continuation-table))
            (##vector-set! _self257065_ '2 (make-table 'test: eqv?))
            (##vector-set! _self257065_ '3 (make-table 'test: eq?))
            (##vector-set! _self257065_ '4 (make-table 'test: eqv?))
            (##vector-set! _self257065_ '5 (make-table 'test: eq?))
            (##vector-set! _self257065_ '6 (make-table 'test: eqv?)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self257065_))))
  (bind-method!
   std/actor/rpc/connection#continuation-table::t
   ':init!
   std/actor/rpc/connection#continuation-table:::init!
   '#f)
  (define std/actor/rpc/connection#continuation-table-get
    (lambda (_cont-table256932_ _cont256933_)
      (let ((_mx256935_
             (##unchecked-structure-ref
              _cont-table256932_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256935_)
        (let ((_res256940_
               (let ((_ct256938_
                      (##unchecked-structure-ref
                       _cont-table256932_
                       '2
                       std/actor/rpc/connection#continuation-table::t
                       '#f)))
                 (table-ref _ct256938_ _cont256933_ '#f))))
          (mutex-unlock! _mx256935_)
          _res256940_))))
  (define std/actor/rpc/connection#continuation-table-remove!
    (lambda (_cont-table256870_ _cont256871_)
      (let ((_mx256873_
             (##unchecked-structure-ref
              _cont-table256870_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256873_)
        (let ((_res256929_
               (let* ((_ct256876_
                       (##unchecked-structure-ref
                        _cont-table256870_
                        '2
                        std/actor/rpc/connection#continuation-table::t
                        '#f))
                      (_continuation256877256879_
                       (table-ref _ct256876_ _cont256871_ '#f)))
                 (if _continuation256877256879_
                     (let ((_continuation256882_ _continuation256877256879_))
                       (table-set! _ct256876_ _cont256871_)
                       (let* ((_continuation256883256892_ _continuation256882_)
                              (_E256885256896_
                               (lambda ()
                                 (error '"No clause matching"
                                        _continuation256883256892_)))
                              (_K256886256902_
                               (lambda (_stream?256899_ _k256900_)
                                 (if _stream?256899_
                                     (table-set!
                                      (##unchecked-structure-ref
                                       _cont-table256870_
                                       '3
                                       std/actor/rpc/connection#continuation-table::t
                                       '#f)
                                      _k256900_)
                                     '#!void))))
                         (if (##fx= (if (##values? _continuation256883256892_)
                                        (##vector-length
                                         _continuation256883256892_)
                                        '1)
                                    '4)
                             (let* ((_e256887256905_
                                     (##vector-ref
                                      _continuation256883256892_
                                      '0))
                                    (_e256888256908_
                                     (##vector-ref
                                      _continuation256883256892_
                                      '1))
                                    (_e256889256911_
                                     (##vector-ref
                                      _continuation256883256892_
                                      '2))
                                    (_k256914_ _e256889256911_)
                                    (_e256890256916_
                                     (##vector-ref
                                      _continuation256883256892_
                                      '3))
                                    (_stream?256919_ _e256890256916_))
                               (_K256886256902_ _stream?256919_ _k256914_))
                             (_E256885256896_)))
                       (let* ((_tt256921_
                               (##unchecked-structure-ref
                                _cont-table256870_
                                '6
                                std/actor/rpc/connection#continuation-table::t
                                '#f))
                              (_timeo256922256924_
                               (table-ref _tt256921_ _cont256871_ '#f)))
                         (if _timeo256922256924_
                             (let ((_timeo256927_ _timeo256922256924_))
                               (table-set! _tt256921_ _cont256871_)
                               (table-set!
                                (##unchecked-structure-ref
                                 _cont-table256870_
                                 '5
                                 std/actor/rpc/connection#continuation-table::t
                                 '#f)
                                _timeo256927_))
                             '#f))
                       _continuation256882_)
                     '#f))))
          (mutex-unlock! _mx256873_)
          _res256929_))))
  (define std/actor/rpc/connection#continuation-table-get-stream-actor
    (lambda (_cont-table256859_ _cont256860_)
      (let ((_mx256862_
             (##unchecked-structure-ref
              _cont-table256859_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256862_)
        (let ((_res256867_
               (let ((_st256865_
                      (##unchecked-structure-ref
                       _cont-table256859_
                       '4
                       std/actor/rpc/connection#continuation-table::t
                       '#f)))
                 (table-ref _st256865_ _cont256860_ '#f))))
          (mutex-unlock! _mx256862_)
          _res256867_))))
  (define std/actor/rpc/connection#continuation-table-put-stream-actor!
    (lambda (_cont-table256847_ _cont256848_ _val256849_)
      (let ((_mx256851_
             (##unchecked-structure-ref
              _cont-table256847_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256851_)
        (let ((_res256856_
               (let ((_st256854_
                      (##unchecked-structure-ref
                       _cont-table256847_
                       '4
                       std/actor/rpc/connection#continuation-table::t
                       '#f)))
                 (table-set! _st256854_ _cont256848_ _val256849_))))
          (mutex-unlock! _mx256851_)
          _res256856_))))
  (define std/actor/rpc/connection#continuation-table-remove-stream-actor!
    (lambda (_cont-table256836_ _cont256837_)
      (let ((_mx256839_
             (##unchecked-structure-ref
              _cont-table256836_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256839_)
        (let ((_res256844_
               (let ((_st256842_
                      (##unchecked-structure-ref
                       _cont-table256836_
                       '4
                       std/actor/rpc/connection#continuation-table::t
                       '#f)))
                 (table-set! _st256842_ _cont256837_))))
          (mutex-unlock! _mx256839_)
          _res256844_))))
  (define std/actor/rpc/connection#continuation-table-get-stream-cont
    (lambda (_cont-table256825_ _k256826_)
      (let ((_mx256828_
             (##unchecked-structure-ref
              _cont-table256825_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256828_)
        (let ((_res256833_
               (let ((_sct256831_
                      (##unchecked-structure-ref
                       _cont-table256825_
                       '3
                       std/actor/rpc/connection#continuation-table::t
                       '#f)))
                 (table-ref _sct256831_ _k256826_ '#f))))
          (mutex-unlock! _mx256828_)
          _res256833_))))
  (define std/actor/rpc/connection#continuation-table-get-timeout
    (lambda (_cont-table256814_ _timeo256815_)
      (let ((_mx256817_
             (##unchecked-structure-ref
              _cont-table256814_
              '1
              std/actor/rpc/connection#continuation-table::t
              '#f)))
        (mutex-lock! _mx256817_)
        (let ((_res256822_
               (let ((_tt256820_
                      (##unchecked-structure-ref
                       _cont-table256814_
                       '5
                       std/actor/rpc/connection#continuation-table::t
                       '#f)))
                 (table-ref _tt256820_ _timeo256815_ '#f))))
          (mutex-unlock! _mx256817_)
          _res256822_))))
  (define std/actor/rpc/connection#continuation-table-dump!__%
    (lambda (_cont-table256688_ _port256689_)
      (call-with-parameters
       (lambda ()
         (let ((_mx256692_
                (##unchecked-structure-ref
                 _cont-table256688_
                 '1
                 std/actor/rpc/connection#continuation-table::t
                 '#f)))
           (mutex-lock! _mx256692_)
           (let* ((_cont-table256694256705_ _cont-table256688_)
                  (_E256696256709_
                   (lambda ()
                     (error '"No clause matching" _cont-table256694256705_)))
                  (_K256697256773_
                   (lambda (_ctmos256712_
                            _tmos256713_
                            _sactors256714_
                            _sconts256715_
                            _conts256716_)
                     (displayln
                      '"continuations: "
                      (table-length _conts256716_))
                     (table-for-each
                      (lambda (_wire-id256718_ _continuation256719_)
                        (let* ((_continuation256720256729_
                                _continuation256719_)
                               (_E256722256733_
                                (lambda ()
                                  (error '"No clause matching"
                                         _continuation256720256729_)))
                               (_K256723256741_
                                (lambda (_stream?256736_
                                         _k256737_
                                         _proto256738_
                                         _actor256739_)
                                  (displayln
                                   _wire-id256718_
                                   '" -> "
                                   (cons _actor256739_
                                         (cons _proto256738_
                                               (cons _k256737_
                                                     (cons _stream?256736_
                                                           '()))))))))
                          (if (##fx= (if (##values? _continuation256720256729_)
                                         (##vector-length
                                          _continuation256720256729_)
                                         '1)
                                     '4)
                              (let* ((_e256724256744_
                                      (##vector-ref
                                       _continuation256720256729_
                                       '0))
                                     (_actor256747_ _e256724256744_)
                                     (_e256725256749_
                                      (##vector-ref
                                       _continuation256720256729_
                                       '1))
                                     (_proto256752_ _e256725256749_)
                                     (_e256726256754_
                                      (##vector-ref
                                       _continuation256720256729_
                                       '2))
                                     (_k256757_ _e256726256754_)
                                     (_e256727256759_
                                      (##vector-ref
                                       _continuation256720256729_
                                       '3))
                                     (_stream?256762_ _e256727256759_))
                                (_K256723256741_
                                 _stream?256762_
                                 _k256757_
                                 _proto256752_
                                 _actor256747_))
                              (_E256722256733_))))
                      _conts256716_)
                     (displayln
                      '"stream-continuations: "
                      (table-length _sconts256715_))
                     (table-for-each
                      (lambda (_k256764_ _wire-id256765_)
                        (displayln _k256764_ '" -> " _wire-id256765_))
                      _sconts256715_)
                     (displayln
                      '"stream-actors: "
                      (table-length _sactors256714_))
                     (table-for-each
                      (lambda (_wire-id256767_ _sactor256768_)
                        (displayln _wire-id256767_ '" -> " _sactor256768_))
                      _sactors256714_)
                     (displayln '"timeouts: " (table-length _tmos256713_))
                     (table-for-each
                      (lambda (_tmo256770_ _wire-id256771_)
                        (displayln
                         (time->seconds _tmo256770_)
                         '" -> "
                         _wire-id256771_))
                      _tmos256713_))))
             (if (##structure-direct-instance-of?
                  _cont-table256694256705_
                  'std/actor/rpc/connection#continuation-table::t)
                 (let* ((_e256698256776_
                         (##vector-ref _cont-table256694256705_ '1))
                        (_e256699256779_
                         (##vector-ref _cont-table256694256705_ '2))
                        (_conts256782_ _e256699256779_)
                        (_e256700256784_
                         (##vector-ref _cont-table256694256705_ '3))
                        (_sconts256787_ _e256700256784_)
                        (_e256701256789_
                         (##vector-ref _cont-table256694256705_ '4))
                        (_sactors256792_ _e256701256789_)
                        (_e256702256794_
                         (##vector-ref _cont-table256694256705_ '5))
                        (_tmos256797_ _e256702256794_)
                        (_e256703256799_
                         (##vector-ref _cont-table256694256705_ '6))
                        (_ctmos256802_ _e256703256799_))
                   (_K256697256773_
                    _ctmos256802_
                    _tmos256797_
                    _sactors256792_
                    _sconts256787_
                    _conts256782_))
                 (_E256696256709_)))
           (mutex-unlock! _mx256692_)))
       current-output-port
       _port256689_)))
  (define std/actor/rpc/connection#continuation-table-dump!__0
    (lambda (_cont-table256807_)
      (let ((_port256809_ (current-error-port)))
        (std/actor/rpc/connection#continuation-table-dump!__%
         _cont-table256807_
         _port256809_))))
  (define std/actor/rpc/connection#continuation-table-dump!
    (lambda _g310899_
      (let ((_g310898_ (##length _g310899_)))
        (cond ((##fx= _g310898_ 1)
               (apply std/actor/rpc/connection#continuation-table-dump!__0
                      _g310899_))
              ((##fx= _g310898_ 2)
               (apply std/actor/rpc/connection#continuation-table-dump!__%
                      _g310899_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/rpc/connection#continuation-table-dump!
                _g310899_))))))
  (define std/actor/rpc/connection#rpc-connection-loop
    (lambda (_rpc-server255638_
             _actors255639_
             _sock255640_
             _peer-address255641_
             _proto-e255642_)
      (letrec* ((_input-buffer255644_
                 (std/net/socket/buffer#open-ssocket-input-buffer__0
                  _sock255640_))
                (_output-buffer255645_
                 (std/net/socket/buffer#open-ssocket-output-buffer__0
                  _sock255640_))
                (_g310900_
                 (let ((_g310901_
                        (_proto-e255642_
                         _input-buffer255644_
                         _output-buffer255645_)))
                   (let ((_g310902_
                          (if (##values? _g310901_)
                              (##vector-length _g310901_)
                              1)))
                     (if (not (##fx= _g310902_ 2))
                         (error "Context expects 2 values" _g310902_)))
                   _g310901_))
                (_read-e255646_ (##vector-ref _g310900_ 0))
                (_write-e255647_ (##vector-ref _g310900_ 1))
                (_cont-table255648_
                 (let ((__obj310895
                        (make-object
                         std/actor/rpc/connection#continuation-table::t
                         '6)))
                   (std/actor/rpc/connection#continuation-table:::init!
                    __obj310895)
                   __obj310895))
                (_next-timeout255649_ '#f)
                (_next-continuation-id255650_ '0)
                (_next-heartbeat255651_
                 (seconds->time (+ (##current-time-point) '60)))
                (_writer255652_
                 (gerbil/gambit/threads#spawn/name
                  'rpc-connection-writer
                  std/actor/rpc/connection#rpc-connection-writer
                  _output-buffer255645_
                  _write-e255647_))
                (_reader255653_
                 (gerbil/gambit/threads#spawn/name
                  'rpc-connection-reader
                  std/actor/rpc/connection#rpc-connection-reader
                  (current-thread)
                  _peer-address255641_
                  _input-buffer255644_
                  _actors255639_
                  _cont-table255648_
                  _writer255652_
                  _read-e255646_))
                (_close-connection255654_
                 (lambda ()
                   (std/net/socket/api#ssocket-close _sock255640_)
                   (thread-send _writer255652_ 'exit)
                   (let ((_mx256605_
                          (##unchecked-structure-ref
                           _cont-table255648_
                           '1
                           std/actor/rpc/connection#continuation-table::t
                           '#f)))
                     (mutex-lock! _mx256605_)
                     (table-for-each
                      (lambda (_wire-id256608_ _cont256609_)
                        (let* ((_cont256610256619_ _cont256609_)
                               (_E256612256623_
                                (lambda ()
                                  (error '"No clause matching"
                                         _cont256610256619_)))
                               (_K256613256631_
                                (lambda (_stream?256626_
                                         _k256627_
                                         _proto256628_
                                         _actor256629_)
                                  (std/actor/message#send-message__%
                                   _actor256629_
                                   (##structure
                                    std/actor/proto#!error::t
                                    (make-struct-instance
                                     std/actor/proto#rpc-error::t
                                     'rpc
                                     '"connection error")
                                    _k256627_)
                                   '#f
                                   '#f))))
                          (if (##fx= (if (##values? _cont256610256619_)
                                         (##vector-length _cont256610256619_)
                                         '1)
                                     '4)
                              (let* ((_e256614256634_
                                      (##vector-ref _cont256610256619_ '0))
                                     (_actor256637_ _e256614256634_)
                                     (_e256615256639_
                                      (##vector-ref _cont256610256619_ '1))
                                     (_proto256642_ _e256615256639_)
                                     (_e256616256644_
                                      (##vector-ref _cont256610256619_ '2))
                                     (_k256647_ _e256616256644_)
                                     (_e256617256649_
                                      (##vector-ref _cont256610256619_ '3))
                                     (_stream?256652_ _e256617256649_))
                                (_K256613256631_
                                 _stream?256652_
                                 _k256647_
                                 _proto256642_
                                 _actor256637_))
                              (_E256612256623_))))
                      (##unchecked-structure-ref
                       _cont-table255648_
                       '2
                       std/actor/rpc/connection#continuation-table::t
                       '#f))
                     (table-for-each
                      (lambda (_wire-id256654_ _stream256655_)
                        (let* ((_stream256656256663_ _stream256655_)
                               (_E256658256667_
                                (lambda ()
                                  (error '"No clause matching"
                                         _stream256656256663_)))
                               (_K256659256675_
                                (lambda (_dest256670_ _actor256671_)
                                  (let ((_abort256673_
                                         (##structure
                                          std/actor/message#message::t
                                          (##structure
                                           std/actor/proto#!abort::t
                                           _wire-id256654_)
                                          _dest256670_
                                          _actor256671_
                                          '#f)))
                                    (std/actor/message#send__0
                                     _actor256671_
                                     _abort256673_)))))
                          (if (##pair? _stream256656256663_)
                              (let ((_hd256660256678_
                                     (##car _stream256656256663_))
                                    (_tl256661256680_
                                     (##cdr _stream256656256663_)))
                                (let* ((_actor256683_ _hd256660256678_)
                                       (_dest256685_ _tl256661256680_))
                                  (_K256659256675_
                                   _dest256685_
                                   _actor256683_)))
                              (_E256658256667_))))
                      (##unchecked-structure-ref
                       _cont-table255648_
                       '4
                       std/actor/rpc/connection#continuation-table::t
                       '#f))
                     (mutex-unlock! _mx256605_))
                   (std/actor/rpc/connection#rpc-connection-shutdown
                    _rpc-server255638_)
                   (raise 'shutdown)))
                (_write-message255655_
                 (lambda (_msg256352_)
                   (let* ((_msg256353256362_ _msg256352_)
                          (_E256355256366_
                           (lambda ()
                             (error '"No clause matching" _msg256353256362_)))
                          (_K256356256581_
                           (lambda (_opts256369_
                                    _dest256370_
                                    _src256371_
                                    _content256372_)
                             (if (##structure-direct-instance-of?
                                  _dest256370_
                                  'std/actor/proto#remote::t)
                                 (let* ((_dest256373256382_ _dest256370_)
                                        (_E256375256386_
                                         (lambda ()
                                           (error '"No clause matching"
                                                  _dest256373256382_)))
                                        (_K256376256560_
                                         (lambda (_proto256389_
                                                  _address256390_
                                                  _uuid256391_)
                                           (##direct-structure-set!
                                            _msg256352_
                                            _uuid256391_
                                            '3
                                            std/actor/message#message::t
                                            '#f)
                                           (let* ((_content256392256418_
                                                   _content256372_)
                                                  (_else256400256426_
                                                   (lambda ()
                                                     (_marshal-and-write255657_
                                                      _msg256352_
                                                      _proto256389_
                                                      '#t))))
                                             (let ((_K256414256549_
                                                    (lambda (_k256536_)
                                                      (let ((_wire-id256538_
                                                             (_next-continuation-id!255656_)))
                                                        (let ((_mx256540_
                                                               (##unchecked-structure-ref
                                                                _cont-table255648_
                                                                '1
                                                                std/actor/rpc/connection#continuation-table::t
                                                                '#f)))
                                                          (mutex-lock!
                                                           _mx256540_)
                                                          (table-set!
                                                           (##unchecked-structure-ref
                                                            _cont-table255648_
                                                            '2
                                                            std/actor/rpc/connection#continuation-table::t
                                                            '#f)
                                                           _wire-id256538_
                                                           (values _src256371_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           _proto256389_
                           _k256536_
                           '#f))
                  (let ((_timeo256542256544_
                         (std/actor/rpc/connection#rpc-options-timeout
                          _opts256369_
                          std/actor/rpc/connection#rpc-call-timeout)))
                    (if _timeo256542256544_
                        (let ((_timeo256547_ _timeo256542256544_))
                          (table-set!
                           (##unchecked-structure-ref
                            _cont-table255648_
                            '5
                            std/actor/rpc/connection#continuation-table::t
                            '#f)
                           _timeo256547_
                           _wire-id256538_)
                          (table-set!
                           (##unchecked-structure-ref
                            _cont-table255648_
                            '6
                            std/actor/rpc/connection#continuation-table::t
                            '#f)
                           _wire-id256538_
                           _timeo256547_)
                          (_set-timeout!255662_ _timeo256547_))
                        '#f))
                  (mutex-unlock! _mx256540_))
                (##direct-structure-set!
                 _content256372_
                 _wire-id256538_
                 '2
                 std/actor/proto#!call::t
                 '#f)
                (_marshal-and-write255657_ _msg256352_ _proto256389_ '#t))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (_K256411256522_
                                                    (lambda (_k256509_)
                                                      (let ((_wire-id256511_
                                                             (_next-continuation-id!255656_)))
                                                        (let ((_mx256513_
                                                               (##unchecked-structure-ref
                                                                _cont-table255648_
                                                                '1
                                                                std/actor/rpc/connection#continuation-table::t
                                                                '#f)))
                                                          (mutex-lock!
                                                           _mx256513_)
                                                          (table-set!
                                                           (##unchecked-structure-ref
                                                            _cont-table255648_
                                                            '2
                                                            std/actor/rpc/connection#continuation-table::t
                                                            '#f)
                                                           _wire-id256511_
                                                           (values _src256371_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           _proto256389_
                           _k256509_
                           '#t))
                  (table-set!
                   (##unchecked-structure-ref
                    _cont-table255648_
                    '3
                    std/actor/rpc/connection#continuation-table::t
                    '#f)
                   _k256509_
                   _wire-id256511_)
                  (let ((_timeo256515256517_
                         (std/actor/rpc/connection#rpc-options-timeout
                          _opts256369_
                          '#f)))
                    (if _timeo256515256517_
                        (let ((_timeo256520_ _timeo256515256517_))
                          (table-set!
                           (##unchecked-structure-ref
                            _cont-table255648_
                            '5
                            std/actor/rpc/connection#continuation-table::t
                            '#f)
                           _timeo256520_
                           _wire-id256511_)
                          (table-set!
                           (##unchecked-structure-ref
                            _cont-table255648_
                            '6
                            std/actor/rpc/connection#continuation-table::t
                            '#f)
                           _wire-id256511_
                           _timeo256520_)
                          (_set-timeout!255662_ _timeo256520_))
                        '#f))
                  (mutex-unlock! _mx256513_))
                (##direct-structure-set!
                 _content256372_
                 _wire-id256511_
                 '2
                 std/actor/proto#!stream::t
                 '#f)
                (_marshal-and-write255657_ _msg256352_ _proto256389_ '#t))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (_K256410256493_
                                                    (lambda ()
                                                      (_marshal-and-write255657_
                                                       _msg256352_
                                                       _proto256389_
                                                       '#t)))
                                                   (_K256408256480_
                                                    (lambda (_wire-id256478_)
                                                      (std/actor/rpc/connection#continuation-table-put-stream-actor!
                                                       _cont-table255648_
                                                       _wire-id256478_
                                                       (cons _src256371_
                                                             _dest256370_))
                                                      (_marshal-and-write255657_
                                                       _msg256352_
                                                       _proto256389_
                                                       '#t)))
                                                   (_K256406256466_
                                                    (lambda (_k256462_)
                                                      (let ((_wire-id256464_
                                                             (std/actor/rpc/connection#continuation-table-get-stream-cont
                                                              _cont-table255648_
                                                              _k256462_)))
                                                        (if _wire-id256464_
                                                            (begin
                                                              (##direct-structure-set!
                                                               _content256372_
                                                               _wire-id256464_
                                                               '1
                                                               std/actor/proto#!continue::t
                                                               '#f)
                                                              (_marshal-and-write255657_
                                                               _msg256352_
                                                               _proto256389_
                                                               '#t))
                                                            (std/actor/rpc/connection#warnf
                                                             '"bad continue; unknown stream ~a"
                                                             _k256462_)))))
                                                   (_K256404256450_
                                                    (lambda (_k256446_)
                                                      (let ((_wire-id256448_
                                                             (std/actor/rpc/connection#continuation-table-get-stream-cont
                                                              _cont-table255648_
                                                              _k256446_)))
                                                        (if _wire-id256448_
                                                            (begin
                                                              (##direct-structure-set!
                                                               _content256372_
                                                               _wire-id256448_
                                                               '1
                                                               std/actor/proto#!close::t
                                                               '#f)
                                                              (_marshal-and-write255657_
                                                               _msg256352_
                                                               _proto256389_
                                                               '#t))
                                                            (std/actor/rpc/connection#warnf
                                                             '"bad close; unknown stream ~a"
                                                             _k256446_)))))
                                                   (_K256402256434_
                                                    (lambda (_k256430_)
                                                      (let ((_wire-id256432_
                                                             (std/actor/rpc/connection#continuation-table-get-stream-cont
                                                              _cont-table255648_
                                                              _k256430_)))
                                                        (if _wire-id256432_
                                                            (begin
                                                              (##direct-structure-set!
                                                               _content256372_
                                                               _wire-id256432_
                                                               '1
                                                               std/actor/proto#!abort::t
                                                               '#f)
                                                              (std/actor/rpc/connection#continuation-table-remove!
                                                               _cont-table255648_
                                                               _wire-id256432_)
                                                              (_marshal-and-write255657_
                                                               _msg256352_
                                                               _proto256389_
                                                               '#t))
                                                            (std/actor/rpc/connection#warnf
                                                             '"bad abort; unknown stream ~a"
                                                             _k256430_))))))
                                               (let* ((_try-match256399256442_
                                                       (lambda ()
                                                         (if (##structure-direct-instance-of?
                                                              _content256392256418_
                                                              'std/actor/proto#!abort::t)
                                                             (let* ((_e256403256437_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                             (##vector-ref _content256392256418_ '1))
                            (_k256440_ _e256403256437_))
                       (_K256402256434_ _k256440_))
                     (_else256400256426_))))
              (_try-match256398256458_
               (lambda ()
                 (if (##structure-direct-instance-of?
                      _content256392256418_
                      'std/actor/proto#!close::t)
                     (let* ((_e256405256453_
                             (##vector-ref _content256392256418_ '1))
                            (_k256456_ _e256405256453_))
                       (_K256404256450_ _k256456_))
                     (_try-match256399256442_))))
              (_try-match256397256474_
               (lambda ()
                 (if (##structure-direct-instance-of?
                      _content256392256418_
                      'std/actor/proto#!continue::t)
                     (let* ((_e256407256469_
                             (##vector-ref _content256392256418_ '1))
                            (_k256472_ _e256407256469_))
                       (_K256406256466_ _k256472_))
                     (_try-match256398256458_))))
              (_try-match256396256488_
               (lambda ()
                 (if (##structure-direct-instance-of?
                      _content256392256418_
                      'std/actor/proto#!sync::t)
                     (let* ((_e256409256483_
                             (##vector-ref _content256392256418_ '1))
                            (_wire-id256486_ _e256409256483_))
                       (_K256408256480_ _wire-id256486_))
                     (_try-match256397256474_))))
              (_try-match256395256505_
               (lambda ()
                 (if (or (##structure-direct-instance-of?
                          _content256392256418_
                          'std/actor/proto#!value::t)
                         (##structure-direct-instance-of?
                          _content256392256418_
                          'std/actor/proto#!yield::t)
                         (##structure-direct-instance-of?
                          _content256392256418_
                          'std/actor/proto#!error::t)
                         (##structure-direct-instance-of?
                          _content256392256418_
                          'std/actor/proto#!end::t))
                     (_K256410256493_)
                     (_try-match256396256488_))))
              (_try-match256394256533_
               (lambda ()
                 (if (##structure-direct-instance-of?
                      _content256392256418_
                      'std/actor/proto#!stream::t)
                     (let* ((_e256412256525_
                             (##vector-ref _content256392256418_ '1))
                            (_e256413256528_
                             (##vector-ref _content256392256418_ '2))
                            (_k256531_ _e256413256528_))
                       (_K256411256522_ _k256531_))
                     (_try-match256395256505_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                 (if (##structure-direct-instance-of?
                                                      _content256392256418_
                                                      'std/actor/proto#!call::t)
                                                     (let* ((_e256415256552_
                                                             (##vector-ref
                                                              _content256392256418_
                                                              '1))
                                                            (_e256416256555_
                                                             (##vector-ref
                                                              _content256392256418_
                                                              '2))
                                                            (_k256558_
                                                             _e256416256555_))
                                                       (_K256414256549_
                                                        _k256558_))
                                                     (_try-match256394256533_))))))))
                                   (if (##structure-direct-instance-of?
                                        _dest256373256382_
                                        'std/actor/proto#remote::t)
                                       (let* ((_e256377256563_
                                               (##vector-ref
                                                _dest256373256382_
                                                '1))
                                              (_e256378256566_
                                               (##vector-ref
                                                _dest256373256382_
                                                '2))
                                              (_uuid256569_ _e256378256566_)
                                              (_e256379256571_
                                               (##vector-ref
                                                _dest256373256382_
                                                '3))
                                              (_address256574_ _e256379256571_)
                                              (_e256380256576_
                                               (##vector-ref
                                                _dest256373256382_
                                                '4))
                                              (_proto256579_ _e256380256576_))
                                         (_K256376256560_
                                          _proto256579_
                                          _address256574_
                                          _uuid256569_))
                                       (_E256375256386_)))
                                 (std/actor/rpc/connection#warnf
                                  '"bad handle; no protocol ~a ~a"
                                  _dest256370_
                                  _msg256352_)))))
                     (if (##structure-direct-instance-of?
                          _msg256353256362_
                          'std/actor/message#message::t)
                         (let* ((_e256357256584_
                                 (##vector-ref _msg256353256362_ '1))
                                (_content256587_ _e256357256584_)
                                (_e256358256589_
                                 (##vector-ref _msg256353256362_ '2))
                                (_src256592_ _e256358256589_)
                                (_e256359256594_
                                 (##vector-ref _msg256353256362_ '3))
                                (_dest256597_ _e256359256594_)
                                (_e256360256599_
                                 (##vector-ref _msg256353256362_ '4))
                                (_opts256602_ _e256360256599_))
                           (_K256356256581_
                            _opts256602_
                            _dest256597_
                            _src256592_
                            _content256587_))
                         (_E256355256366_)))))
                (_next-continuation-id!255656_
                 (lambda ()
                   (let ((_next256350_ _next-continuation-id255650_))
                     (set! _next-continuation-id255650_ (+ _next256350_ '1))
                     _next256350_)))
                (_marshal-and-write255657_
                 (lambda (_msg255993_
                          _proto255994_
                          _dispatch-marshal-error?255995_)
                   (let ((_e256080_
                          (with-exception-catcher
                           (lambda (_g256069256071_)
                             (if ((lambda (_$obj256074_)
                                    (exception? _$obj256074_))
                                  _g256069256071_)
                                 (let ((_e256077_ _g256069256071_)) _e256077_)
                                 (raise _g256069256071_)))
                           (lambda ()
                             (std/actor/rpc/proto/message#rpc-proto-marshal-message
                              _msg255993_
                              _proto255994_)))))
                     (if (u8vector? _e256080_)
                         (if (fx<= (u8vector-length _e256080_)
                                   std/actor/rpc/proto/message#rpc-proto-message-max-length)
                             (thread-send _writer255652_ _e256080_)
                             (begin
                               (std/actor/rpc/connection#warnf
                                '"message too large; not sending %d bytes"
                                (u8vector-length _e256080_))
                               (let ((_content256082_
                                      (##direct-structure-ref
                                       _msg255993_
                                       '1
                                       std/actor/message#message::t
                                       '#f))
                                     (_dest256084_
                                      (##direct-structure-ref
                                       _msg255993_
                                       '3
                                       std/actor/message#message::t
                                       '#f)))
                                 (let* ((_content256086256102_ _content256082_)
                                        (_else256089256110_
                                         (lambda () '#!void)))
                                   (let ((_K256096256148_
                                          (lambda (_wire-id256145_ _e256146_)
                                            (_dispatch-error255658_
                                             _wire-id256145_
                                             '"message too large")))
                                         (_K256091256119_
                                          (lambda (_wire-id256114_ _e256116_)
                                            (if _dispatch-marshal-error?255995_
                                                (_dispatch-remote-error255659_
                                                 (##structure
                                                  std/actor/proto#!error::t
                                                  '"message too large"
                                                  _wire-id256114_)
                                                 _dest256084_)
                                                '#!void))))
                                     (let* ((___match310747310748_
                                             (lambda ()
                                               (if (##structure-direct-instance-of?
                                                    _content256086256102_
                                                    'std/actor/proto#!yield::t)
                                                   (let* ((_e256092256132_
                                                           (##vector-ref
                                                            _content256086256102_
                                                            '1))
                                                          (_e256093256137_
                                                           (##vector-ref
                                                            _content256086256102_
                                                            '2)))
                                                     (let ((_e256135_
                                                            _e256092256132_)
                                                           (_wire-id256140_
                                                            _e256093256137_))
                                                       (_K256091256119_
                                                        _wire-id256140_
                                                        _e256135_)))
                                                   '#!void)))
                                            (_try-match256088256142_
                                             (lambda ()
                                               (if (##structure-direct-instance-of?
                                                    _content256086256102_
                                                    'std/actor/proto#!error::t)
                                                   (let* ((_e256094256122_
                                                           (##vector-ref
                                                            _content256086256102_
                                                            '1))
                                                          (_e256095256127_
                                                           (##vector-ref
                                                            _content256086256102_
                                                            '2)))
                                                     (let ((_e256125_
                                                            _e256094256122_)
                                                           (_wire-id256130_
                                                            _e256095256127_))
                                                       (_K256091256119_
                                                        _wire-id256130_
                                                        _e256125_)))
                                                   (___match310747310748_))))
                                            (___match310733310734_
                                             (lambda ()
                                               (if (##structure-direct-instance-of?
                                                    _content256086256102_
                                                    'std/actor/proto#!stream::t)
                                                   (let* ((_e256097256161_
                                                           (##vector-ref
                                                            _content256086256102_
                                                            '1))
                                                          (_e256098256166_
                                                           (##vector-ref
                                                            _content256086256102_
                                                            '2)))
                                                     (let ((_e256164_
                                                            _e256097256161_)
                                                           (_wire-id256169_
                                                            _e256098256166_))
                                                       (_K256096256148_
                                                        _wire-id256169_
                                                        _e256164_)))
                                                   (_try-match256088256142_)))))
                                       (if (##structure-direct-instance-of?
                                            _content256086256102_
                                            'std/actor/proto#!call::t)
                                           (let* ((_e256099256151_
                                                   (##vector-ref
                                                    _content256086256102_
                                                    '1))
                                                  (_e256100256156_
                                                   (##vector-ref
                                                    _content256086256102_
                                                    '2)))
                                             (let ((_e256154_ _e256099256151_)
                                                   (_wire-id256159_
                                                    _e256100256156_))
                                               (_K256096256148_
                                                _wire-id256159_
                                                _e256154_)))
                                           (___match310733310734_))))))))
                         (if (##structure-instance-of?
                              _e256080_
                              'std/net/bio/buffer#chunked-output-buffer::t)
                             (if (fx<= (std/net/bio/buffer#chunked-output-length
                                        _e256080_)
                                       std/actor/rpc/proto/message#rpc-proto-message-max-length)
                                 (thread-send _writer255652_ _e256080_)
                                 (begin
                                   (std/actor/rpc/connection#warnf
                                    '"message too large; not sending %d bytes"
                                    (std/net/bio/buffer#chunked-output-length
                                     _e256080_))
                                   (let ((_content256171_
                                          (##direct-structure-ref
                                           _msg255993_
                                           '1
                                           std/actor/message#message::t
                                           '#f))
                                         (_dest256173_
                                          (##direct-structure-ref
                                           _msg255993_
                                           '3
                                           std/actor/message#message::t
                                           '#f)))
                                     (let* ((_content256175256191_
                                             _content256171_)
                                            (_else256178256199_
                                             (lambda () '#!void)))
                                       (let ((_K256185256237_
                                              (lambda (_wire-id256234_
                                                       _e256235_)
                                                (_dispatch-error255658_
                                                 _wire-id256234_
                                                 '"message too large")))
                                             (_K256180256208_
                                              (lambda (_wire-id256203_
                                                       _e256205_)
                                                (if _dispatch-marshal-error?255995_
                                                    (_dispatch-remote-error255659_
                                                     (##structure
                                                      std/actor/proto#!error::t
                                                      '"message too large"
                                                      _wire-id256203_)
                                                     _dest256173_)
                                                    '#!void))))
                                         (let* ((___match310776310777_
                                                 (lambda ()
                                                   (if (##structure-direct-instance-of?
                                                        _content256175256191_
                                                        'std/actor/proto#!yield::t)
                                                       (let* ((_e256181256221_
                                                               (##vector-ref
                                                                _content256175256191_
                                                                '1))
                                                              (_e256182256226_
                                                               (##vector-ref
                                                                _content256175256191_
                                                                '2)))
                                                         (let ((_e256224_
                                                                _e256181256221_)
                                                               (_wire-id256229_
                                                                _e256182256226_))
                                                           (_K256180256208_
                                                            _wire-id256229_
                                                            _e256224_)))
                                                       '#!void)))
                                                (_try-match256177256231_
                                                 (lambda ()
                                                   (if (##structure-direct-instance-of?
                                                        _content256175256191_
                                                        'std/actor/proto#!error::t)
                                                       (let* ((_e256183256211_
                                                               (##vector-ref
                                                                _content256175256191_
                                                                '1))
                                                              (_e256184256216_
                                                               (##vector-ref
                                                                _content256175256191_
                                                                '2)))
                                                         (let ((_e256214_
                                                                _e256183256211_)
                                                               (_wire-id256219_
                                                                _e256184256216_))
                                                           (_K256180256208_
                                                            _wire-id256219_
                                                            _e256214_)))
                                                       (___match310776310777_))))
                                                (___match310762310763_
                                                 (lambda ()
                                                   (if (##structure-direct-instance-of?
                                                        _content256175256191_
                                                        'std/actor/proto#!stream::t)
                                                       (let* ((_e256186256250_
                                                               (##vector-ref
                                                                _content256175256191_
                                                                '1))
                                                              (_e256187256255_
                                                               (##vector-ref
                                                                _content256175256191_
                                                                '2)))
                                                         (let ((_e256253_
                                                                _e256186256250_)
                                                               (_wire-id256258_
                                                                _e256187256255_))
                                                           (_K256185256237_
                                                            _wire-id256258_
                                                            _e256253_)))
                                                       (_try-match256177256231_)))))
                                           (if (##structure-direct-instance-of?
                                                _content256175256191_
                                                'std/actor/proto#!call::t)
                                               (let* ((_e256188256240_
                                                       (##vector-ref
                                                        _content256175256191_
                                                        '1))
                                                      (_e256189256245_
                                                       (##vector-ref
                                                        _content256175256191_
                                                        '2)))
                                                 (let ((_e256243_
                                                        _e256188256240_)
                                                       (_wire-id256248_
                                                        _e256189256245_))
                                                   (_K256185256237_
                                                    _wire-id256248_
                                                    _e256243_)))
                                               (___match310762310763_))))))))
                             (if _dispatch-marshal-error?255995_
                                 (begin
                                   (std/actor/rpc/connection#errorf
                                    '"marshal error: ~a"
                                    _e256080_)
                                   (let ((_content256260_
                                          (##direct-structure-ref
                                           _msg255993_
                                           '1
                                           std/actor/message#message::t
                                           '#f))
                                         (_dest256262_
                                          (##direct-structure-ref
                                           _msg255993_
                                           '3
                                           std/actor/message#message::t
                                           '#f)))
                                     (let* ((_content256264256280_
                                             _content256260_)
                                            (_else256267256288_
                                             (lambda () '#!void)))
                                       (let ((_K256274256326_
                                              (lambda (_wire-id256323_
                                                       _e256324_)
                                                (_dispatch-error255658_
                                                 _wire-id256323_
                                                 '"marshal error")))
                                             (_K256269256297_
                                              (lambda (_wire-id256292_
                                                       _e256294_)
                                                (if _dispatch-marshal-error?255995_
                                                    (_dispatch-remote-error255659_
                                                     (##structure
                                                      std/actor/proto#!error::t
                                                      '"marshal error"
                                                      _wire-id256292_)
                                                     _dest256262_)
                                                    '#!void))))
                                         (let* ((___match310805310806_
                                                 (lambda ()
                                                   (if (##structure-direct-instance-of?
                                                        _content256264256280_
                                                        'std/actor/proto#!yield::t)
                                                       (let* ((_e256270256310_
                                                               (##vector-ref
                                                                _content256264256280_
                                                                '1))
                                                              (_e256271256315_
                                                               (##vector-ref
                                                                _content256264256280_
                                                                '2)))
                                                         (let ((_e256313_
                                                                _e256270256310_)
                                                               (_wire-id256318_
                                                                _e256271256315_))
                                                           (_K256269256297_
                                                            _wire-id256318_
                                                            _e256313_)))
                                                       '#!void)))
                                                (_try-match256266256320_
                                                 (lambda ()
                                                   (if (##structure-direct-instance-of?
                                                        _content256264256280_
                                                        'std/actor/proto#!error::t)
                                                       (let* ((_e256272256300_
                                                               (##vector-ref
                                                                _content256264256280_
                                                                '1))
                                                              (_e256273256305_
                                                               (##vector-ref
                                                                _content256264256280_
                                                                '2)))
                                                         (let ((_e256303_
                                                                _e256272256300_)
                                                               (_wire-id256308_
                                                                _e256273256305_))
                                                           (_K256269256297_
                                                            _wire-id256308_
                                                            _e256303_)))
                                                       (___match310805310806_))))
                                                (___match310791310792_
                                                 (lambda ()
                                                   (if (##structure-direct-instance-of?
                                                        _content256264256280_
                                                        'std/actor/proto#!stream::t)
                                                       (let* ((_e256275256339_
                                                               (##vector-ref
                                                                _content256264256280_
                                                                '1))
                                                              (_e256276256344_
                                                               (##vector-ref
                                                                _content256264256280_
                                                                '2)))
                                                         (let ((_e256342_
                                                                _e256275256339_)
                                                               (_wire-id256347_
                                                                _e256276256344_))
                                                           (_K256274256326_
                                                            _wire-id256347_
                                                            _e256342_)))
                                                       (_try-match256266256320_)))))
                                           (if (##structure-direct-instance-of?
                                                _content256264256280_
                                                'std/actor/proto#!call::t)
                                               (let* ((_e256277256329_
                                                       (##vector-ref
                                                        _content256264256280_
                                                        '1))
                                                      (_e256278256334_
                                                       (##vector-ref
                                                        _content256264256280_
                                                        '2)))
                                                 (let ((_e256332_
                                                        _e256277256329_)
                                                       (_wire-id256337_
                                                        _e256278256334_))
                                                   (_K256274256326_
                                                    _wire-id256337_
                                                    _e256332_)))
                                               (___match310791310792_)))))))
                                 (std/actor/rpc/connection#errorf
                                  '"marshal error: ~a"
                                  _e256080_)))))))
                (_dispatch-error255658_
                 (lambda (_wire-id255942_ _what255943_)
                   (let* ((_g255944255954_
                           (std/actor/rpc/connection#continuation-table-remove!
                            _cont-table255648_
                            _wire-id255942_))
                          (_else255946255962_ (lambda () '#!void))
                          (_K255948255970_
                           (lambda (_stream?255965_
                                    _k255966_
                                    _proto255967_
                                    _actor255968_)
                             (std/actor/message#send-message__%
                              _actor255968_
                              (##structure
                               std/actor/proto#!error::t
                               (make-struct-instance
                                std/actor/proto#rpc-error::t
                                'rpc
                                _what255943_)
                               _k255966_)
                              '#f
                              '#f))))
                     (if (##fx= (if (##values? _g255944255954_)
                                    (##vector-length _g255944255954_)
                                    '1)
                                '4)
                         (let* ((_e255949255973_
                                 (##vector-ref _g255944255954_ '0))
                                (_actor255976_ _e255949255973_)
                                (_e255950255978_
                                 (##vector-ref _g255944255954_ '1))
                                (_proto255981_ _e255950255978_)
                                (_e255951255983_
                                 (##vector-ref _g255944255954_ '2))
                                (_k255986_ _e255951255983_)
                                (_e255952255988_
                                 (##vector-ref _g255944255954_ '3))
                                (_stream?255991_ _e255952255988_))
                           (_K255948255970_
                            _stream?255991_
                            _k255986_
                            _proto255981_
                            _actor255976_))
                         '#!void))))
                (_dispatch-remote-error255659_
                 (lambda (_what255939_ _dest255940_)
                   (_marshal-and-write255657_
                    (##structure
                     std/actor/message#message::t
                     _what255939_
                     '#!void
                     _dest255940_
                     '#f)
                    '#f
                    '#f)))
                (_dispatch-timeout255660_
                 (lambda (_timeo255932_)
                   (set! _next-timeout255649_ '#f)
                   (let ((_$e255934_
                          (std/actor/rpc/connection#continuation-table-get-timeout
                           _cont-table255648_
                           _timeo255932_)))
                     (if _$e255934_
                         ((lambda (_wire-id255937_)
                            (_dispatch-error255658_
                             _wire-id255937_
                             '"timeout"))
                          _$e255934_)
                         '#!void))))
                (_timeout<255661_
                 (lambda (_a255929_ _b255930_)
                   (< (time->seconds _a255929_) (time->seconds _b255930_))))
                (_set-timeout!255662_
                 (lambda (_timeo255924_)
                   (if (or (not _next-timeout255649_)
                           (_timeout<255661_
                            _timeo255924_
                            _next-timeout255649_))
                       (set! _next-timeout255649_ _timeo255924_)
                       '#!void)))
                (_timeout-event255663_
                 (lambda ()
                   (if _next-timeout255649_
                       '#!void
                       (let ((_mx255917_
                              (##unchecked-structure-ref
                               _cont-table255648_
                               '1
                               std/actor/rpc/connection#continuation-table::t
                               '#f)))
                         (mutex-lock! _mx255917_)
                         (let ((_timeouts255920_
                                (##unchecked-structure-ref
                                 _cont-table255648_
                                 '5
                                 std/actor/rpc/connection#continuation-table::t
                                 '#f)))
                           (if (fxzero? (table-length _timeouts255920_))
                               '#!void
                               (table-for-each
                                (lambda (_timeo255922_ _g310903_)
                                  (_set-timeout!255662_ _timeo255922_))
                                _timeouts255920_)))
                         (mutex-unlock! _mx255917_)))
                   _next-timeout255649_))
                (_heartbeat!255664_
                 (lambda ()
                   (let ((_dead-continuations255864_
                          (let ((_mx255820_
                                 (##unchecked-structure-ref
                                  _cont-table255648_
                                  '1
                                  std/actor/rpc/connection#continuation-table::t
                                  '#f)))
                            (mutex-lock! _mx255820_)
                            (let ((_res255861_
                                   (hash-fold
                                    (lambda (_wire-id255823_
                                             _continuation255824_
                                             _r255825_)
                                      (let* ((_continuation255826255835_
                                              _continuation255824_)
                                             (_E255828255839_
                                              (lambda ()
                                                (error '"No clause matching"
                                                       _continuation255826255835_)))
                                             (_K255829255844_
                                              (lambda (_actor255842_)
                                                (if (and (thread? _actor255842_)
                                                         (std/misc/threads#thread-dead?
                                                          _actor255842_))
                                                    (cons _wire-id255823_
                                                          _r255825_)
                                                    _r255825_))))
                                        (if (##fx= (if (##values?
                                                        _continuation255826255835_)
                                                       (##vector-length
                                                        _continuation255826255835_)
                                                       '1)
                                                   '4)
                                            (let* ((_e255830255847_
                                                    (##vector-ref
                                                     _continuation255826255835_
                                                     '0))
                                                   (_actor255850_
                                                    _e255830255847_)
                                                   (_e255831255852_
                                                    (##vector-ref
                                                     _continuation255826255835_
                                                     '1))
                                                   (_e255832255855_
                                                    (##vector-ref
                                                     _continuation255826255835_
                                                     '2))
                                                   (_e255833255858_
                                                    (##vector-ref
                                                     _continuation255826255835_
                                                     '3)))
                                              (_K255829255844_ _actor255850_))
                                            (_E255828255839_))))
                                    '()
                                    (##unchecked-structure-ref
                                     _cont-table255648_
                                     '2
                                     std/actor/rpc/connection#continuation-table::t
                                     '#f))))
                              (mutex-unlock! _mx255820_)
                              _res255861_))))
                     (for-each
                      (lambda (_wire-id255866_)
                        (let* ((_g255867255877_
                                (std/actor/rpc/connection#continuation-table-remove!
                                 _cont-table255648_
                                 _wire-id255866_))
                               (_else255869255885_ (lambda () '#!void))
                               (_K255871255893_
                                (lambda (_stream?255888_
                                         _k255889_
                                         _proto255890_
                                         _actor255891_)
                                  (std/actor/rpc/connection#debugf
                                   '"removing continuation ~a for dead actor ~a"
                                   _wire-id255866_
                                   _actor255891_)
                                  (if _stream?255888_
                                      (_dispatch-remote-error255659_
                                       (##structure
                                        std/actor/proto#!abort::t
                                        _wire-id255866_)
                                       std/actor/rpc/base#null-uuid)
                                      '#!void))))
                          (if (##fx= (if (##values? _g255867255877_)
                                         (##vector-length _g255867255877_)
                                         '1)
                                     '4)
                              (let* ((_e255872255896_
                                      (##vector-ref _g255867255877_ '0))
                                     (_actor255899_ _e255872255896_)
                                     (_e255873255901_
                                      (##vector-ref _g255867255877_ '1))
                                     (_proto255904_ _e255873255901_)
                                     (_e255874255906_
                                      (##vector-ref _g255867255877_ '2))
                                     (_k255909_ _e255874255906_)
                                     (_e255875255911_
                                      (##vector-ref _g255867255877_ '3))
                                     (_stream?255914_ _e255875255911_))
                                (_K255871255893_
                                 _stream?255914_
                                 _k255909_
                                 _proto255904_
                                 _actor255899_))
                              '#!void)))
                      _dead-continuations255864_))
                   (set! _next-heartbeat255651_
                         (seconds->time (+ (##current-time-point) '60)))))
                (_dump!255665_
                 (lambda (_port255816_)
                   (call-with-parameters
                    (lambda ()
                      (displayln '"=== rpc-connection ===")
                      (displayln '"peer-address: " _peer-address255641_)
                      (displayln
                       '"next-continuation-id: "
                       _next-continuation-id255650_)
                      (displayln
                       '"next-timeout: "
                       (if _next-timeout255649_
                           (time->seconds _next-timeout255649_)
                           '#f)))
                    current-output-port
                    _port255816_)
                   (std/actor/rpc/connection#continuation-table-dump!__%
                    _cont-table255648_
                    _port255816_)))
                (_loop255666_
                 (lambda ()
                   (let ((_g310904_
                          (std/actor/message#receive-timeout
                           (_timeout-event255663_)
                           _dispatch-timeout255660_
                           _next-heartbeat255651_
                           (lambda (_$e255680_) (_heartbeat!255664_)))))
                     (begin
                       (let ((_g310905_
                              (if (##values? _g310904_)
                                  (##vector-length _g310904_)
                                  1)))
                         (if (not (##fx= _g310905_ 2))
                             (error "Context expects 2 values" _g310905_)))
                       (let ((_timeo255683_ (##vector-ref _g310904_ 0))
                             (_K255685_ (##vector-ref _g310904_ 1)))
                         (let _loop255678255688_ ()
                           (let ((_next255692_
                                  (thread-mailbox-next
                                   _timeo255683_
                                   std/actor/message#mailbox-timeout)))
                             (if (eq? _next255692_
                                      std/actor/message#mailbox-timeout)
                                 (begin
                                   (thread-mailbox-rewind)
                                   (_K255685_ _timeo255683_))
                                 ((lambda (_msg255695_)
                                    (let* ((_msg255697255719_ _msg255695_)
                                           (_else255705255727_
                                            (lambda () (_loop255678255688_))))
                                      (let ((_K255717255811_
                                             (lambda (_msg255809_)
                                               (thread-mailbox-extract-and-rewind)
                                               (_write-message255655_
                                                _msg255809_)))
                                            (_K255716255803_
                                             (lambda ()
                                               (thread-mailbox-extract-and-rewind)
                                               (_close-connection255654_)))
                                            (_K255715255795_
                                             (lambda ()
                                               (thread-mailbox-extract-and-rewind)
                                               (_close-connection255654_)))
                                            (_K255714255785_
                                             (lambda (_thread255771_)
                                               (thread-mailbox-extract-and-rewind)
                                               (with-exception-catcher
                                                (lambda (_g255772255774_)
                                                  (if ((lambda (_$obj255777_)
                                                         (uncaught-exception?
                                                          _$obj255777_))
                                                       _g255772255774_)
                                                      (let ((_e255780_
                                                             _g255772255774_))
                                                        (std/actor/rpc/connection#errorf
                                                         '"connection error: ~a"
                                                         (uncaught-exception-reason
                                                          _e255780_)))
                                                      (if '#t
                                                          (let ((_e255782_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _g255772255774_))
                    (std/actor/rpc/connection#errorf
                     '"connection error: ~a"
                     _e255782_))
                  (raise _g255772255774_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                (lambda ()
                                                  (thread-join! _thread255771_)
                                                  (std/actor/rpc/connection#warnf
                                                   '"connection error: i/o thread ~a exited unexpectedly"
                                                   (thread-name
                                                    _thread255771_))))
                                               (_close-connection255654_)))
                                            (_K255713255764_
                                             (lambda ()
                                               (thread-mailbox-extract-and-rewind)
                                               (_dump!255665_
                                                (current-error-port))))
                                            (_K255708255744_
                                             (lambda (_port255742_)
                                               (thread-mailbox-extract-and-rewind)
                                               (_dump!255665_ _port255742_)))
                                            (_K255707255733_
                                             (lambda (_bogus255731_)
                                               (thread-mailbox-extract-and-rewind)
                                               (std/actor/rpc/connection#warnf
                                                '"unexpected message ~a"
                                                _bogus255731_))))
                                        (let* ((_try-match255703255759_
                                                (lambda ()
                                                  (if (##pair? _msg255697255719_)
                                                      (let ((_tl255710255749_
                                                             (##cdr _msg255697255719_))
                                                            (_hd255709255747_
                                                             (##car _msg255697255719_)))
                                                        (if (##eq? _hd255709255747_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           'dump)
                    (if (##pair? _tl255710255749_)
                        (let ((_tl255712255754_ (##cdr _tl255710255749_))
                              (_hd255711255752_ (##car _tl255710255749_)))
                          (if (##null? _tl255712255754_)
                              (let ((_port255757_ _hd255711255752_))
                                (_K255708255744_ _port255757_))
                              (let ((_bogus255736_ _msg255697255719_))
                                (_K255707255733_ _bogus255736_))))
                        (let ((_bogus255736_ _msg255697255719_))
                          (_K255707255733_ _bogus255736_)))
                    (let ((_bogus255736_ _msg255697255719_))
                      (_K255707255733_ _bogus255736_))))
              (let ((_bogus255736_ _msg255697255719_))
                (_K255707255733_ _bogus255736_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                               (_try-match255702255767_
                                                (lambda ()
                                                  (if (##eq? _msg255697255719_
                                                             'dump)
                                                      (_K255713255764_)
                                                      (_try-match255703255759_))))
                                               (_try-match255701255790_
                                                (lambda ()
                                                  (if (thread? _msg255697255719_)
                                                      (let ((_thread255788_
                                                             _msg255697255719_))
                                                        (_K255714255785_
                                                         _thread255788_))
                                                      (_try-match255702255767_))))
                                               (_try-match255700255798_
                                                (lambda ()
                                                  (if (##eq? _msg255697255719_
                                                             'shutdown)
                                                      (_K255715255795_)
                                                      (_try-match255701255790_))))
                                               (_try-match255699255806_
                                                (lambda ()
                                                  (if (eof-object?
                                                       _msg255697255719_)
                                                      (_K255716255803_)
                                                      (_try-match255700255798_)))))
                                          (if (##structure-direct-instance-of?
                                               _msg255697255719_
                                               'std/actor/message#message::t)
                                              (let ((_msg255814_
                                                     _msg255697255719_))
                                                (_K255717255811_ _msg255814_))
                                              (_try-match255699255806_))))))
                                  _next255692_)))))))
                   (_loop255666_)))
                (_run255667_
                 (lambda ()
                   (call-with-parameters
                    (lambda () (_loop255666_))
                    std/actor/xdr#current-xdr-type-registry
                    std/actor/xdr#+xdr-default-type-registry+))))
        (begin
          (std/actor/rpc/base#rpc-monitor__0 _reader255653_)
          (std/actor/rpc/base#rpc-monitor__0 _writer255652_)
          (with-exception-catcher
           (lambda (_g255668255670_)
             (if '#t
                 (let ((_e255673_ _g255668255670_))
                   (if (eq? 'shutdown _e255673_)
                       '#!void
                       (begin
                         (std/actor/rpc/connection#errorf
                          '"unhandled exception: ~a"
                          _e255673_)
                         (with-exception-catcher
                          void
                          _close-connection255654_))))
                 (raise _g255668255670_)))
           (lambda () (_run255667_)))))))
  (define std/actor/rpc/connection#rpc-connection-writer
    (lambda (_sockbuf255547_ _write-e255548_)
      (letrec ((_loop255550_
                (lambda ()
                  (let ((_g310906_
                         (std/actor/message#receive-timeout
                          std/actor/rpc/connection#rpc-keep-alive
                          (lambda (_$e255561_)
                            (_write-e255548_ _sockbuf255547_ '#!void)
                            (_loop255550_)))))
                    (begin
                      (let ((_g310907_
                             (if (##values? _g310906_)
                                 (##vector-length _g310906_)
                                 1)))
                        (if (not (##fx= _g310907_ 2))
                            (error "Context expects 2 values" _g310907_)))
                      (let ((_timeo255564_ (##vector-ref _g310906_ 0))
                            (_K255566_ (##vector-ref _g310906_ 1)))
                        (let _loop255559255569_ ()
                          (let ((_next255573_
                                 (thread-mailbox-next
                                  _timeo255564_
                                  std/actor/message#mailbox-timeout)))
                            (if (eq? _next255573_
                                     std/actor/message#mailbox-timeout)
                                (begin
                                  (thread-mailbox-rewind)
                                  (_K255566_ _timeo255564_))
                                ((lambda (_msg255576_)
                                   (let* ((_msg255578255590_ _msg255576_)
                                          (_else255583255598_
                                           (lambda () (_loop255559255569_))))
                                     (let ((_K255588255633_
                                            (lambda (_buf255631_)
                                              (thread-mailbox-extract-and-rewind)
                                              (_write-e255548_
                                               _sockbuf255547_
                                               _buf255631_)
                                              (_loop255550_)))
                                           (_K255587255623_
                                            (lambda (_data255621_)
                                              (thread-mailbox-extract-and-rewind)
                                              (_write-e255548_
                                               _sockbuf255547_
                                               _data255621_)
                                              (_loop255550_)))
                                           (_K255586255614_
                                            (lambda ()
                                              (thread-mailbox-extract-and-rewind)
                                              '#!void))
                                           (_K255585255604_
                                            (lambda (_bogus255602_)
                                              (thread-mailbox-extract-and-rewind)
                                              (std/actor/rpc/connection#warnf
                                               '"unexpected message ~a"
                                               _bogus255602_)
                                              (_loop255550_))))
                                       (let* ((_try-match255581255617_
                                               (lambda ()
                                                 (if (##eq? _msg255578255590_
                                                            'exit)
                                                     (_K255586255614_)
                                                     (let ((_bogus255607_
                                                            _msg255578255590_))
                                                       (_K255585255604_
                                                        _bogus255607_)))))
                                              (_try-match255580255628_
                                               (lambda ()
                                                 (if (u8vector?
                                                      _msg255578255590_)
                                                     (let ((_data255626_
                                                            _msg255578255590_))
                                                       (_K255587255623_
                                                        _data255626_))
                                                     (_try-match255581255617_)))))
                                         (if (##structure-instance-of?
                                              _msg255578255590_
                                              'std/net/bio/output#output-buffer::t)
                                             (let ((_buf255636_
                                                    _msg255578255590_))
                                               (_K255588255633_ _buf255636_))
                                             (_try-match255580255628_))))))
                                 _next255573_))))))))))
        (with-exception-catcher
         (lambda (_g255551255553_)
           (if '#t
               (let ((_e255556_ _g255551255553_))
                 (std/actor/rpc/connection#errorf
                  '"unhandled exception: ~a"
                  _e255556_))
               (raise _g255551255553_)))
         (lambda () (_loop255550_))))))
  (define std/actor/rpc/connection#rpc-connection-reader
    (lambda (_conn255126_
             _connaddr255127_
             _sockbuf255128_
             _actor-table255129_
             _cont-table255130_
             _writer255131_
             _read-e255132_)
      (letrec ((_loop255134_
                (lambda (_u8buf255387_)
                  (let* ((_g255388255401_
                          (_read-e255132_ _sockbuf255128_ _u8buf255387_))
                         (_E255393255405_
                          (lambda ()
                            (error '"No clause matching" _g255388255401_))))
                    (let ((_K255397255534_
                           (lambda (_count255435_ _u8buf255436_)
                             (let* ((_buffer255438_
                                     (std/net/bio/buffer#open-input-buffer__%
                                      _u8buf255436_
                                      '0
                                      _count255435_))
                                    (_msg255440_
                                     (_read-envelope255141_ _buffer255438_)))
                               (let* ((_msg255442255449_ _msg255440_)
                                      (_else255444255457_ (lambda () '#!void))
                                      (_K255446255526_
                                       (lambda (_content255460_)
                                         (let* ((_content255461255471_
                                                 _content255460_)
                                                (_else255465255479_
                                                 (lambda ()
                                                   (_dispatch-call255135_
                                                    _msg255440_
                                                    _buffer255438_))))
                                           (let ((_K255469255517_
                                                  (lambda ()
                                                    (_dispatch-call255135_
                                                     _msg255440_
                                                     _buffer255438_)))
                                                 (_K255468255498_
                                                  (lambda ()
                                                    (_dispatch-value255136_
                                                     _msg255440_
                                                     _buffer255438_)))
                                                 (_K255467255484_
                                                  (lambda ()
                                                    (_dispatch-control255137_
                                                     _msg255440_
                                                     _buffer255438_))))
                                             (let* ((_try-match255464255493_
                                                     (lambda ()
                                                       (if (or (##structure-direct-instance-of?
                                                                _content255461255471_
                                                                'std/actor/proto#!continue::t)
                                                               (##structure-direct-instance-of?
                                                                _content255461255471_
                                                                'std/actor/proto#!close::t)
                                                               (##structure-direct-instance-of?
                                                                _content255461255471_
                                                                'std/actor/proto#!abort::t))
                                                           (_K255467255484_)
                                                           (_else255465255479_))))
                                                    (_try-match255463255513_
                                                     (lambda ()
                                                       (if (or (##structure-direct-instance-of?
                                                                _content255461255471_
                                                                'std/actor/proto#!value::t)
                                                               (##structure-direct-instance-of?
                                                                _content255461255471_
                                                                'std/actor/proto#!error::t)
                                                               (##structure-direct-instance-of?
                                                                _content255461255471_
                                                                'std/actor/proto#!yield::t)
                                                               (##structure-direct-instance-of?
                                                                _content255461255471_
                                                                'std/actor/proto#!end::t)
                                                               (##structure-direct-instance-of?
                                                                _content255461255471_
                                                                'std/actor/proto#!sync::t))
                                                           (_K255468255498_)
                                                           (_try-match255464255493_)))))
                                               (if (or (##structure-direct-instance-of?
                                                        _content255461255471_
                                                        'std/actor/proto#!call::t)
                                                       (##structure-direct-instance-of?
                                                        _content255461255471_
                                                        'std/actor/proto#!event::t)
                                                       (##structure-direct-instance-of?
                                                        _content255461255471_
                                                        'std/actor/proto#!stream::t))
                                                   (_K255469255517_)
                                                   (_try-match255463255513_))))))))
                                 (if (##structure-direct-instance-of?
                                      _msg255442255449_
                                      'std/actor/message#message::t)
                                     (let* ((_e255447255529_
                                             (##vector-ref
                                              _msg255442255449_
                                              '1))
                                            (_content255532_ _e255447255529_))
                                       (_K255446255526_ _content255532_))
                                     '#!void))
                               (_loop255134_ _u8buf255436_))))
                          (_K255396255429_
                           (lambda () (_loop255134_ _u8buf255387_)))
                          (_K255395255421_
                           (lambda () (thread-send _conn255126_ '#!eof)))
                          (_K255394255411_
                           (lambda (_unexpected255409_)
                             (error '"read unexpected object"
                                    _unexpected255409_))))
                      (let* ((_try-match255391255424_
                              (lambda ()
                                (if (eof-object? _g255388255401_)
                                    (_K255395255421_)
                                    (let ((_unexpected255414_ _g255388255401_))
                                      (_K255394255411_ _unexpected255414_)))))
                             (_try-match255390255432_
                              (lambda ()
                                (if (eq? _g255388255401_ '#!void)
                                    (_K255396255429_)
                                    (_try-match255391255424_)))))
                        (if (##fx= (if (##values? _g255388255401_)
                                       (##vector-length _g255388255401_)
                                       '1)
                                   '2)
                            (let* ((_e255398255537_
                                    (##vector-ref _g255388255401_ '0))
                                   (_e255399255542_
                                    (##vector-ref _g255388255401_ '1)))
                              (let ((_u8buf255540_ _e255398255537_)
                                    (_count255545_ _e255399255542_))
                                (_K255397255534_ _count255545_ _u8buf255540_)))
                            (_try-match255390255432_)))))))
               (_dispatch-call255135_
                (lambda (_msg255297_ _buffer255298_)
                  (let* ((_uuid255300_
                          (##direct-structure-ref
                           _msg255297_
                           '3
                           std/actor/message#message::t
                           '#f))
                         (_$e255302_
                          (std/misc/sync#sync-hash-get
                           _actor-table255129_
                           _uuid255300_)))
                    (if _$e255302_
                        ((lambda (_e255304255306_)
                           (let* ((_g255308255315_ _e255304255306_)
                                  (_E255310255319_
                                   (lambda ()
                                     (error '"No clause matching"
                                            _g255308255315_)))
                                  (_K255311255333_
                                   (lambda (_proto255322_ _actor255323_)
                                     (if (_read-payload!255142_
                                          _msg255297_
                                          _buffer255298_
                                          _proto255322_)
                                         (begin
                                           (##direct-structure-set!
                                            _msg255297_
                                            _actor255323_
                                            '3
                                            std/actor/message#message::t
                                            '#f)
                                           (##direct-structure-set!
                                            _msg255297_
                                            (let ((__obj310896
                                                   (make-object
                                                    std/actor/proto#remote::t
                                                    '4)))
                                              (std/actor/proto#remote:::init!
                                               __obj310896
                                               _conn255126_
                                               _uuid255300_
                                               _connaddr255127_
                                               _proto255322_)
                                              __obj310896)
                                            '2
                                            std/actor/message#message::t
                                            '#f)
                                           (std/actor/message#send__0
                                            _actor255323_
                                            _msg255297_))
                                         (if (or (##structure-direct-instance-of?
                                                  (##direct-structure-ref
                                                   _msg255297_
                                                   '1
                                                   std/actor/message#message::t
                                                   '#f)
                                                  'std/actor/proto#!call::t)
                                                 (##structure-direct-instance-of?
                                                  (##direct-structure-ref
                                                   _msg255297_
                                                   '1
                                                   std/actor/message#message::t
                                                   '#f)
                                                  'std/actor/proto#!stream::t))
                                             (let* ((_content255328_
                                                     (##direct-structure-ref
                                                      _msg255297_
                                                      '1
                                                      std/actor/message#message::t
                                                      '#f))
                                                    (_k255330_
                                                     (if (##structure-direct-instance-of?
                                                          _content255328_
                                                          'std/actor/proto#!call::t)
                                                         (##direct-structure-ref
                                                          _content255328_
                                                          '2
                                                          std/actor/proto#!call::t
                                                          '#f)
                                                         (##direct-structure-ref
                                                          _content255328_
                                                          '2
                                                          std/actor/proto#!stream::t
                                                          '#f))))
                                               (_dispatch-remote-error255140_
                                                (##structure
                                                 std/actor/proto#!error::t
                                                 '"unmarshal error"
                                                 _k255330_)
                                                _uuid255300_))
                                             '#!void)))))
                             (if (##fx= (if (##values? _g255308255315_)
                                            (##vector-length _g255308255315_)
                                            '1)
                                        '2)
                                 (let* ((_e255312255336_
                                         (##vector-ref _g255308255315_ '0))
                                        (_actor255339_ _e255312255336_)
                                        (_e255313255341_
                                         (##vector-ref _g255308255315_ '1))
                                        (_proto255344_ _e255313255341_))
                                   (_K255311255333_
                                    _proto255344_
                                    _actor255339_))
                                 (_E255310255319_))))
                         _$e255302_)
                        (begin
                          (std/actor/rpc/connection#warnf
                           '"cannot route message; no actor binding ~a"
                           (std/misc/uuid#uuid->string _uuid255300_))
                          (let* ((_g255345255355_
                                  (##direct-structure-ref
                                   _msg255297_
                                   '1
                                   std/actor/message#message::t
                                   '#f))
                                 (_else255347255363_ (lambda () '#!void))
                                 (_K255349255368_
                                  (lambda (_k255366_)
                                    (_dispatch-remote-error255140_
                                     (##structure
                                      std/actor/proto#!error::t
                                      '"no binding"
                                      _k255366_)
                                     _uuid255300_))))
                            (if (##structure-direct-instance-of?
                                 _g255345255355_
                                 'std/actor/proto#!call::t)
                                (let* ((_e255352255371_
                                        (##vector-ref _g255345255355_ '1))
                                       (_e255353255374_
                                        (##vector-ref _g255345255355_ '2))
                                       (_k255377_ _e255353255374_))
                                  (_K255349255368_ _k255377_))
                                (if (##structure-direct-instance-of?
                                     _g255345255355_
                                     'std/actor/proto#!stream::t)
                                    (let* ((_e255350255379_
                                            (##vector-ref _g255345255355_ '1))
                                           (_e255351255382_
                                            (##vector-ref _g255345255355_ '2))
                                           (_k255385_ _e255351255382_))
                                      (_K255349255368_ _k255385_))
                                    '#!void))))))))
               (_dispatch-value255136_
                (lambda (_msg255228_ _buffer255229_)
                  (let* ((_content255231_
                          (##direct-structure-ref
                           _msg255228_
                           '1
                           std/actor/message#message::t
                           '#f))
                         (_cont255233_ (_value-k255138_ _content255231_)))
                    (let ((_$e255236_
                           (std/actor/rpc/connection#continuation-table-get
                            _cont-table255130_
                            _cont255233_)))
                      (if _$e255236_
                          ((lambda (_e255238255240_)
                             (let* ((_g255242255251_ _e255238255240_)
                                    (_E255244255255_
                                     (lambda ()
                                       (error '"No clause matching"
                                              _g255242255251_)))
                                    (_K255245255274_
                                     (lambda (_stream?255258_
                                              _k255259_
                                              _proto255260_
                                              _actor255261_)
                                       (if (_read-payload!255142_
                                            _msg255228_
                                            _buffer255229_
                                            _proto255260_)
                                           (begin
                                             (_value-k-set!255139_
                                              _content255231_
                                              _k255259_)
                                             (##direct-structure-set!
                                              _msg255228_
                                              (let ((__obj310897
                                                     (make-object
                                                      std/actor/proto#remote::t
                                                      '4)))
                                                (std/actor/proto#remote:::init!
                                                 __obj310897
                                                 _conn255126_
                                                 (##direct-structure-ref
                                                  _msg255228_
                                                  '3
                                                  std/actor/message#message::t
                                                  '#f)
                                                 _connaddr255127_
                                                 _proto255260_)
                                                __obj310897)
                                              '2
                                              std/actor/message#message::t
                                              '#f)
                                             (if (or (##structure-direct-instance-of?
                                                      _content255231_
                                                      'std/actor/proto#!yield::t)
                                                     (##structure-direct-instance-of?
                                                      _content255231_
                                                      'std/actor/proto#!sync::t))
                                                 (let ((_ok255272_
                                                        (let ((_mx255266_
                                                               (##unchecked-structure-ref
                                                                _cont-table255130_
                                                                '1
                                                                std/actor/rpc/connection#continuation-table::t
                                                                '#f)))
                                                          (mutex-lock!
                                                           _mx255266_)
                                                          (let ((_res255269_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (if (table-ref
                              (##unchecked-structure-ref
                               _cont-table255130_
                               '2
                               std/actor/rpc/connection#continuation-table::t
                               '#f)
                              _cont255233_
                              '#f)
                             (begin
                               (std/actor/message#send__0
                                _actor255261_
                                _msg255228_)
                               '#t)
                             '#f)))
                    (mutex-unlock! _mx255266_)
                    _res255269_))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   (if _ok255272_
                                                       '#!void
                                                       (if (##structure-direct-instance-of?
                                                            _content255231_
                                                            'std/actor/proto#!sync::t)
                                                           (_dispatch-remote-error255140_
                                                            (##structure
                                                             std/actor/proto#!abort::t
                                                             _cont255233_)
                                                            (##direct-structure-ref
                                                             _msg255228_
                                                             '3
                                                             std/actor/message#message::t
                                                             '#f))
                                                           '#!void)))
                                                 (if (std/actor/rpc/connection#continuation-table-remove!
                                                      _cont-table255130_
                                                      _cont255233_)
                                                     (std/actor/message#send__0
                                                      _actor255261_
                                                      _msg255228_)
                                                     '#!void)))
                                           (begin
                                             (if (std/actor/rpc/connection#continuation-table-remove!
                                                  _cont-table255130_
                                                  _cont255233_)
                                                 (std/actor/message#send-message__%
                                                  _actor255261_
                                                  (##structure
                                                   std/actor/proto#!error::t
                                                   (make-struct-instance
                                                    std/actor/proto#rpc-error::t
                                                    'rpc
                                                    '"unmarshal error")
                                                   _k255259_)
                                                  '#f
                                                  '#f)
                                                 '#!void)
                                             (if (##structure-direct-instance-of?
                                                  _content255231_
                                                  'std/actor/proto#!sync::t)
                                                 (_dispatch-remote-error255140_
                                                  (##structure
                                                   std/actor/proto#!abort::t
                                                   _cont255233_)
                                                  (##direct-structure-ref
                                                   _msg255228_
                                                   '3
                                                   std/actor/message#message::t
                                                   '#f))
                                                 '#!void))))))
                               (if (##fx= (if (##values? _g255242255251_)
                                              (##vector-length _g255242255251_)
                                              '1)
                                          '4)
                                   (let* ((_e255246255277_
                                           (##vector-ref _g255242255251_ '0))
                                          (_actor255280_ _e255246255277_)
                                          (_e255247255282_
                                           (##vector-ref _g255242255251_ '1))
                                          (_proto255285_ _e255247255282_)
                                          (_e255248255287_
                                           (##vector-ref _g255242255251_ '2))
                                          (_k255290_ _e255248255287_)
                                          (_e255249255292_
                                           (##vector-ref _g255242255251_ '3))
                                          (_stream?255295_ _e255249255292_))
                                     (_K255245255274_
                                      _stream?255295_
                                      _k255290_
                                      _proto255285_
                                      _actor255280_))
                                   (_E255244255255_))))
                           _$e255236_)
                          (begin
                            (std/actor/rpc/connection#warnf
                             '"cannot route message; unknown continuation ~a"
                             _cont255233_)
                            (if (##structure-direct-instance-of?
                                 _content255231_
                                 'std/actor/proto#!sync::t)
                                (_dispatch-remote-error255140_
                                 (##structure
                                  std/actor/proto#!abort::t
                                  _cont255233_)
                                 (##direct-structure-ref
                                  _msg255228_
                                  '3
                                  std/actor/message#message::t
                                  '#f))
                                '#!void)))))))
               (_dispatch-control255137_
                (lambda (_msg255190_ _buffer255191_)
                  (let* ((_content255193_
                          (##direct-structure-ref
                           _msg255190_
                           '1
                           std/actor/message#message::t
                           '#f))
                         (_cont255195_ (_value-k255138_ _content255193_))
                         (_stream255197_
                          (std/actor/rpc/connection#continuation-table-get-stream-actor
                           _cont-table255130_
                           _cont255195_)))
                    (if _stream255197_
                        (let* ((_stream255199255206_ _stream255197_)
                               (_E255201255210_
                                (lambda ()
                                  (error '"No clause matching"
                                         _stream255199255206_)))
                               (_K255202255216_
                                (lambda (_dest255213_ _actor255214_)
                                  (##direct-structure-set!
                                   _msg255190_
                                   _dest255213_
                                   '2
                                   std/actor/message#message::t
                                   '#f)
                                  (std/actor/message#send__0
                                   _actor255214_
                                   _msg255190_)
                                  (std/actor/rpc/connection#continuation-table-remove-stream-actor!
                                   _cont-table255130_
                                   _cont255195_))))
                          (if (##pair? _stream255199255206_)
                              (let ((_hd255203255219_
                                     (##car _stream255199255206_))
                                    (_tl255204255221_
                                     (##cdr _stream255199255206_)))
                                (let* ((_actor255224_ _hd255203255219_)
                                       (_dest255226_ _tl255204255221_))
                                  (_K255202255216_
                                   _dest255226_
                                   _actor255224_)))
                              (_E255201255210_)))
                        (begin
                          (std/actor/rpc/connection#warnf
                           '"unexpected control message; unknown stream ~a"
                           _cont255195_)
                          (if (##structure-direct-instance-of?
                               _content255193_
                               'std/actor/proto#!abort::t)
                              '#!void
                              (_dispatch-remote-error255140_
                               (##structure
                                std/actor/proto#!error::t
                                '"uknown stream"
                                _cont255195_)
                               (##direct-structure-ref
                                _msg255190_
                                '3
                                std/actor/message#message::t
                                '#f))))))))
               (_value-k255138_
                (lambda (_obj255188_)
                  (##vector-ref
                   _obj255188_
                   (fx- (##vector-length _obj255188_) '1))))
               (_value-k-set!255139_
                (lambda (_obj255185_ _k255186_)
                  (##vector-set!
                   _obj255185_
                   (fx- (##vector-length _obj255185_) '1)
                   _k255186_)))
               (_dispatch-remote-error255140_
                (lambda (_err255177_ _dest255178_)
                  (let* ((_msg255180_
                          (##structure
                           std/actor/message#message::t
                           _err255177_
                           '#!void
                           _dest255178_
                           '#f))
                         (_data255182_
                          (std/actor/rpc/proto/message#rpc-proto-marshal-message
                           _msg255180_
                           '#f)))
                    (thread-send _writer255131_ _data255182_))))
               (_read-envelope255141_
                (lambda (_buffer255165_)
                  (with-exception-catcher
                   (lambda (_g255166255168_)
                     (if ((lambda (_$obj255171_) (exception? _$obj255171_))
                          _g255166255168_)
                         (let ((_e255174_ _g255166255168_))
                           (std/actor/rpc/connection#errorf
                            '"read error: ~a"
                            _e255174_)
                           _e255174_)
                         (raise _g255166255168_)))
                   (lambda ()
                     (std/actor/rpc/proto/message#rpc-proto-read-envelope
                      _buffer255165_)))))
               (_read-payload!255142_
                (lambda (_msg255154_ _buffer255155_ _proto255156_)
                  (with-exception-catcher
                   (lambda (_g255157255159_)
                     (if '#t
                         (let ((_e255162_ _g255157255159_))
                           (std/actor/rpc/connection#errorf
                            '"unmarshal error: ~a"
                            _e255162_)
                           '#f)
                         (raise _g255157255159_)))
                   (lambda ()
                     (std/actor/rpc/proto/message#rpc-proto-read-payload!
                      _msg255154_
                      _buffer255155_
                      _proto255156_)))))
               (_run255143_
                (lambda ()
                  (call-with-parameters
                   (lambda () (_loop255134_ (make-u8vector '4096)))
                   std/actor/xdr#current-xdr-type-registry
                   std/actor/xdr#+xdr-default-type-registry+))))
        (with-exception-catcher
         (lambda (_g255144255146_)
           (if '#t
               (let ((_e255149_ _g255144255146_))
                 (std/actor/rpc/connection#errorf
                  '"unhandled exception: ~a"
                  _e255149_))
               (raise _g255144255146_)))
         (lambda () (_run255143_))))))
  (define std/actor/rpc/connection#rpc-options-timeout
    (lambda (_opts255113_ _default255114_)
      (letrec ((_timeout255116_
                (lambda (_dt255123_ _default255124_)
                  (if (real? _dt255123_)
                      (seconds->time (+ (##current-time-point) _dt255123_))
                      (if (time? _dt255123_)
                          _dt255123_
                          (if (not _dt255123_)
                              _dt255123_
                              (_timeout255116_ _default255124_ '#f)))))))
        (let ((_$e255118_ (if _opts255113_ (memq 'timeout: _opts255113_) '#f)))
          (if _$e255118_
              ((lambda (_plist255121_)
                 (_timeout255116_ (cadr _plist255121_) _default255114_))
               _$e255118_)
              (_timeout255116_ _default255114_ '#f))))))
  (define std/actor/rpc/connection#rpc-connection-shutdown
    (lambda (_rpc-server255015_)
      (std/actor/message#send-message__0
       _rpc-server255015_
       (##structure
        std/actor/proto#!event::t
        (##structure std/actor/rpc/base#rpc.connection-shutdown::t)))
      (let _lp255017_ ()
        (let _loop255019255021_ ()
          (let ((_next255025_ (thread-mailbox-next)))
            ((lambda (_msg255028_)
               (let* ((_msg255030255038_ _msg255028_)
                      (_else255033255046_ (lambda () (_loop255019255021_))))
                 (let ((_K255036255108_
                        (lambda (_msg255060_)
                          (thread-mailbox-extract-and-rewind)
                          (let* ((_msg255061255067_ _msg255060_)
                                 (_E255063255071_
                                  (lambda ()
                                    (error '"No clause matching"
                                           _msg255061255067_)))
                                 (_K255064255100_
                                  (lambda (_content255074_)
                                    (let* ((_content255075255082_
                                            _content255074_)
                                           (_else255077255090_
                                            (lambda ()
                                              (std/actor/rpc/connection#rpc-send-error-response
                                               _msg255060_
                                               '"connection error")
                                              (_lp255017_)))
                                           (_K255079255094_
                                            (lambda ()
                                              (std/actor/rpc/connection#rpc-send-error-responses
                                               '"connection error"))))
                                      (if (##structure-direct-instance-of?
                                           _content255075255082_
                                           'std/actor/proto#!event::t)
                                          (let ((_e255080255097_
                                                 (##vector-ref
                                                  _content255075255082_
                                                  '1)))
                                            (if (##structure-direct-instance-of?
                                                 _e255080255097_
                                                 'std/actor#rpc.connection-close::t)
                                                (_K255079255094_)
                                                (_else255077255090_)))
                                          (_else255077255090_))))))
                            (if (##structure-direct-instance-of?
                                 _msg255061255067_
                                 'std/actor/message#message::t)
                                (let* ((_e255065255103_
                                        (##vector-ref _msg255061255067_ '1))
                                       (_content255106_ _e255065255103_))
                                  (_K255064255100_ _content255106_))
                                (_E255063255071_)))))
                       (_K255035255052_
                        (lambda (_ignore255050_)
                          (thread-mailbox-extract-and-rewind)
                          (_lp255017_))))
                   (if (##structure-direct-instance-of?
                        _msg255030255038_
                        'std/actor/message#message::t)
                       (let ((_msg255111_ _msg255030255038_))
                         (_K255036255108_ _msg255111_))
                       (let ((_ignore255055_ _msg255030255038_))
                         (_K255035255052_ _ignore255055_))))))
             _next255025_))))))
  (define std/actor/rpc/connection#rpc-connection-cleanup
    (lambda (_rpc-server255011_ _exn255012_ _sock255013_)
      (std/actor/rpc/connection#errorf '"connection error: ~a" _exn255012_)
      (if _sock255013_ (std/net/socket/api#ssocket-close _sock255013_) '#!void)
      (std/actor/rpc/connection#rpc-connection-shutdown _rpc-server255011_)))
  (define std/actor/rpc/connection#rpc-send-error-response
    (lambda (_msg254912_ _what254913_)
      (if (##structure-direct-instance-of?
           _msg254912_
           'std/actor/message#message::t)
          (let* ((_msg254914254922_ _msg254912_)
                 (_E254916254926_
                  (lambda () (error '"No clause matching" _msg254914254922_)))
                 (_K254917254993_
                  (lambda (_dest254929_ _src254930_ _content254931_)
                    (let* ((_content254932254945_ _content254931_)
                           (_else254935254953_ (lambda () '#!void)))
                      (let ((_K254939254974_
                             (lambda (_k254972_)
                               (std/actor/message#send-message__%
                                (##direct-structure-ref
                                 _msg254912_
                                 '2
                                 std/actor/message#message::t
                                 '#f)
                                (##structure
                                 std/actor/proto#!error::t
                                 (make-struct-instance
                                  std/actor/proto#rpc-error::t
                                  'rpc
                                  _what254913_)
                                 _k254972_)
                                '#f
                                '#f)))
                            (_K254937254961_
                             (lambda (_k254957_)
                               (let ((_abort254959_
                                      (##structure
                                       std/actor/message#message::t
                                       (##structure
                                        std/actor/proto#!abort::t
                                        _k254957_)
                                       _dest254929_
                                       _src254930_
                                       '#f)))
                                 (std/actor/message#send__0
                                  _src254930_
                                  _abort254959_)))))
                        (let* ((_try-match254934254969_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content254932254945_
                                       'std/actor/proto#!yield::t)
                                      (let* ((_e254938254964_
                                              (##vector-ref
                                               _content254932254945_
                                               '1))
                                             (_k254967_ _e254938254964_))
                                        (_K254937254961_ _k254967_))
                                      '#!void)))
                               (___match310876310877_
                                (lambda ()
                                  (if (##structure-direct-instance-of?
                                       _content254932254945_
                                       'std/actor/proto#!stream::t)
                                      (let* ((_e254940254985_
                                              (##vector-ref
                                               _content254932254945_
                                               '1))
                                             (_e254941254988_
                                              (##vector-ref
                                               _content254932254945_
                                               '2))
                                             (_k254991_ _e254941254988_))
                                        (_K254939254974_ _k254991_))
                                      (_try-match254934254969_)))))
                          (if (##structure-direct-instance-of?
                               _content254932254945_
                               'std/actor/proto#!call::t)
                              (let* ((_e254942254977_
                                      (##vector-ref _content254932254945_ '1))
                                     (_e254943254980_
                                      (##vector-ref _content254932254945_ '2))
                                     (_k254983_ _e254943254980_))
                                (_K254939254974_ _k254983_))
                              (___match310876310877_))))))))
            (if (##structure-direct-instance-of?
                 _msg254914254922_
                 'std/actor/message#message::t)
                (let* ((_e254918254996_ (##vector-ref _msg254914254922_ '1))
                       (_content254999_ _e254918254996_)
                       (_e254919255001_ (##vector-ref _msg254914254922_ '2))
                       (_src255004_ _e254919255001_)
                       (_e254920255006_ (##vector-ref _msg254914254922_ '3))
                       (_dest255009_ _e254920255006_))
                  (_K254917254993_ _dest255009_ _src255004_ _content254999_))
                (_E254916254926_)))
          '#!void)))
  (define std/actor/rpc/connection#rpc-send-error-responses
    (lambda (_what254859_)
      (let _lp254861_ ()
        (let _loop254863254865_ ()
          (let ((_next254869_ (std/actor/message#mailbox-next)))
            (if (eq? _next254869_ std/actor/message#mailbox-empty)
                ((lambda () (thread-mailbox-rewind) '#!void))
                ((lambda (_msg254873_)
                   (let* ((_msg254875254883_ _msg254873_)
                          (_else254878254891_
                           (lambda () (_loop254863254865_))))
                     (let ((_K254881254907_
                            (lambda (_msg254905_)
                              (thread-mailbox-extract-and-rewind)
                              (std/actor/rpc/connection#rpc-send-error-response
                               _msg254905_
                               _what254859_)
                              (_lp254861_)))
                           (_K254880254897_
                            (lambda (_ignore254895_)
                              (thread-mailbox-extract-and-rewind)
                              (_lp254861_))))
                       (if (##structure-direct-instance-of?
                            _msg254875254883_
                            'std/actor/message#message::t)
                           (let ((_msg254910_ _msg254875254883_))
                             (_K254881254907_ _msg254910_))
                           (let ((_ignore254900_ _msg254875254883_))
                             (_K254880254897_ _ignore254900_))))))
                 _next254869_))))))))
