(declare (block) (standard-bindings) (extended-bindings))
(begin
  (declare (not safe))
  (define std/actor/rpc/proto/cipher#::digest-type
    std/crypto/digest#digest::sha256)
  (define std/actor/rpc/proto/cipher#::digest-size
    (std/crypto/digest#digest-size std/actor/rpc/proto/cipher#::digest-type))
  (define std/actor/rpc/proto/cipher#::cipher-type
    std/crypto/cipher#cipher::aes-128-cbc)
  (define std/actor/rpc/proto/cipher#::cipher-key-length
    (std/crypto/cipher#cipher-key-length
     std/actor/rpc/proto/cipher#::cipher-type))
  (define std/actor/rpc/proto/cipher#::cipher-iv-length
    (std/crypto/cipher#cipher-iv-length
     std/actor/rpc/proto/cipher#::cipher-type))
  (define std/actor/rpc/proto/cipher#::cipher-block-size
    (std/crypto/cipher#cipher-block-size
     std/actor/rpc/proto/cipher#::cipher-type))
  (define std/actor/rpc/proto/cipher#::DH::new std/crypto/dh#DH-get-1024-160)
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-key-exchange
    (lambda (_ibuf254599_ _obuf254600_)
      (let* ((_dh254602_ (std/actor/rpc/proto/cipher#::DH::new))
             (_g310677_ (std/crypto/dh#DH-generate-key _dh254602_))
             (_pubk254605_ (std/crypto/libcrypto#DH_pub_key _dh254602_))
             (_bytes254607_ (std/crypto/bn#BN->bytes _pubk254605_)))
        (std/net/bio/output#bio-write-u8
         std/actor/rpc/proto/message#rpc-proto-key-exchange
         _obuf254600_)
        (std/net/bio/output#bio-write-u32
         (u8vector-length _bytes254607_)
         _obuf254600_)
        (std/net/bio/output#bio-write-bytes _bytes254607_ _obuf254600_)
        (std/net/bio/output#bio-force-output _obuf254600_)
        (let ((_e254610_ (std/net/bio/input#bio-read-u8 _ibuf254599_)))
          (if (eq? _e254610_
                   std/actor/rpc/proto/message#rpc-proto-key-exchange)
              (let* ((_sz254612_ (std/net/bio/input#bio-read-u32 _ibuf254599_))
                     (_g310678_
                      (if (fx> _sz254612_ '1024)
                          (std/actor/proto#raise-rpc-io-error
                           'rpc-proto-key-exchange
                           '"inordinately sized key"
                           _sz254612_)
                          '#!void))
                     (_bytes254615_ (make-u8vector _sz254612_))
                     (_g310679_
                      (std/net/bio/input#bio-read-bytes
                       _bytes254615_
                       _ibuf254599_))
                     (_peerk254618_
                      (std/crypto/bn#bytes->BN__0 _bytes254615_)))
                (std/crypto/dh#DH-compute-key _dh254602_ _peerk254618_))
              (if (eof-object? _e254610_)
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-key-exchange
                   '"connection closed")
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-key-exchange
                   '"key exchange error"
                   _e254610_)))))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-read-e
    (lambda (_secret254585_)
      (let ((_key254587_
             (subu8vector
              _secret254585_
              '0
              std/actor/rpc/proto/cipher#::cipher-key-length))
            (_hmac254588_
             (make-u8vector std/actor/rpc/proto/cipher#::digest-size))
            (_iv254589_
             (make-u8vector std/actor/rpc/proto/cipher#::cipher-iv-length))
            (_ctext254590_ (box (make-u8vector '4096))))
        (lambda (_g254591254594_ _g254592254596_)
          (std/actor/rpc/proto/cipher#rpc-cipher-proto-read
           _g254591254594_
           _g254592254596_
           _secret254585_
           _key254587_
           _hmac254588_
           _iv254589_
           _ctext254590_)))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-read
    (lambda (_ibuf254546_
             _bytes254547_
             _secret254548_
             _key254549_
             _hmac254550_
             _iv254551_
             _ctext254552_)
      (let ((_e254554_ (std/net/bio/input#bio-read-u8 _ibuf254546_)))
        (if (eq? _e254554_ std/actor/rpc/proto/message#rpc-proto-message)
            (let* ((_digest254556_
                    (let ((__obj310671
                           (make-object std/crypto/digest#digest::t '2)))
                      (std/crypto/digest#digest:::init!
                       __obj310671
                       std/actor/rpc/proto/cipher#::digest-type)
                      __obj310671))
                   (_cipher254558_
                    (let ((__obj310672
                           (make-object std/crypto/cipher#cipher::t '2)))
                      (std/crypto/cipher#cipher:::init!
                       __obj310672
                       std/actor/rpc/proto/cipher#::cipher-type)
                      __obj310672))
                   (_g310680_
                    (std/net/bio/input#bio-read-bytes
                     _hmac254550_
                     _ibuf254546_))
                   (_g310681_
                    (std/net/bio/input#bio-read-bytes _iv254551_ _ibuf254546_))
                   (_size254562_ (std/net/bio/input#bio-read-u32 _ibuf254546_))
                   (_g310682_
                    (if (fx<= _size254562_
                              std/actor/rpc/proto/message#rpc-proto-message-max-length)
                        '#!void
                        (std/actor/proto#raise-rpc-io-error
                         'rpc-proto-read
                         '"message too large"
                         _size254562_)))
                   (_ctext254569_
                    (let ((_buf254565_ (unbox _ctext254552_)))
                      (if (fx< (u8vector-length _buf254565_) _size254562_)
                          (let ((_buf254567_ (make-u8vector _size254562_)))
                            (set-box! _ctext254552_ _buf254567_)
                            _buf254567_)
                          _buf254565_)))
                   (_rd254571_
                    (std/net/bio/input#bio-read-subu8vector-unbuffered
                     _ctext254569_
                     '0
                     _size254562_
                     _ibuf254546_))
                   (_g310683_
                    (if (fx< _rd254571_ _size254562_)
                        (std/actor/proto#raise-rpc-io-error
                         'rpc-proto-read
                         '"incomplete message"
                         _rd254571_
                         _size254562_)
                        '#!void))
                   (_g310684_
                    (std/crypto/digest#digest-update!__0
                     _digest254556_
                     _secret254548_))
                   (_g310685_
                    (std/crypto/digest#digest-update!__0
                     _digest254556_
                     _iv254551_))
                   (_g310686_
                    (std/crypto/digest#digest-update!__%
                     _digest254556_
                     _ctext254569_
                     '0
                     _size254562_))
                   (_hmac*254577_
                    (std/crypto/digest#digest-final!__0 _digest254556_))
                   (_g310687_
                    (if (equal? _hmac254550_ _hmac*254577_)
                        '#!void
                        (std/actor/proto#raise-rpc-io-error
                         'rpc-proto-read
                         '"HMAC failure")))
                   (_bytes254580_
                    (if (fx< (u8vector-length _bytes254547_) _size254562_)
                        (make-u8vector _size254562_)
                        _bytes254547_))
                   (_len254582_
                    (std/crypto/cipher#decrypt-u8vector!
                     _cipher254558_
                     _key254549_
                     _iv254551_
                     _ctext254569_
                     '0
                     _size254562_
                     _bytes254580_)))
              (values _bytes254580_ _len254582_))
            (if (eq? _e254554_
                     std/actor/rpc/proto/message#rpc-proto-keep-alive)
                '#!void
                (if (eof-object? _e254554_)
                    _e254554_
                    (std/actor/proto#raise-rpc-io-error
                     'rpc-proto-read
                     '"bad message"
                     _e254554_)))))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-write-e
    (lambda (_secret254533_)
      (let ((_key254535_
             (subu8vector
              _secret254533_
              '0
              std/actor/rpc/proto/cipher#::cipher-key-length))
            (_iv254536_
             (make-u8vector std/actor/rpc/proto/cipher#::cipher-iv-length))
            (_ctext254537_ (box (make-u8vector '4096))))
        (lambda (_g254538254541_ _g254539254543_)
          (std/actor/rpc/proto/cipher#rpc-cipher-proto-write
           _g254538254541_
           _g254539254543_
           _secret254533_
           _key254535_
           _iv254536_
           _ctext254537_)))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-write
    (lambda (_obuf254468_
             _obj254469_
             _secret254470_
             _key254471_
             _iv254472_
             _ctext254473_)
      (if (eq? _obj254469_ '#!void)
          (begin
            (std/net/bio/output#bio-write-u8
             std/actor/rpc/proto/message#rpc-proto-keep-alive
             _obuf254468_)
            (std/net/bio/output#bio-force-output _obuf254468_))
          (if (u8vector? _obj254469_)
              (begin
                (std/net/bio/output#bio-write-u8
                 std/actor/rpc/proto/message#rpc-proto-message
                 _obuf254468_)
                (let* ((_digest254475_
                        (let ((__obj310673
                               (make-object std/crypto/digest#digest::t '2)))
                          (std/crypto/digest#digest:::init!
                           __obj310673
                           std/actor/rpc/proto/cipher#::digest-type)
                          __obj310673))
                       (_cipher254477_
                        (let ((__obj310674
                               (make-object std/crypto/cipher#cipher::t '2)))
                          (std/crypto/cipher#cipher:::init!
                           __obj310674
                           std/actor/rpc/proto/cipher#::cipher-type)
                          __obj310674))
                       (_g310688_ (std/crypto/etc#random-bytes!__0 _iv254472_))
                       (_plen254480_ (u8vector-length _obj254469_))
                       (_maxlen254482_
                        (fx+ _plen254480_
                             std/actor/rpc/proto/cipher#::cipher-block-size))
                       (_ctext254488_
                        (let ((_buf254484_ (unbox _ctext254473_)))
                          (if (fx< (u8vector-length _buf254484_)
                                   _maxlen254482_)
                              (let ((_buf254486_
                                     (make-u8vector _maxlen254482_)))
                                (set-box! _ctext254473_ _buf254486_)
                                _buf254486_)
                              _buf254484_)))
                       (_clen254490_
                        (std/crypto/cipher#encrypt-u8vector!
                         _cipher254477_
                         _key254471_
                         _iv254472_
                         _obj254469_
                         '0
                         _plen254480_
                         _ctext254488_))
                       (_g310689_
                        (std/crypto/digest#digest-update!__0
                         _digest254475_
                         _secret254470_))
                       (_g310690_
                        (std/crypto/digest#digest-update!__0
                         _digest254475_
                         _iv254472_))
                       (_g310691_
                        (std/crypto/digest#digest-update!__%
                         _digest254475_
                         _ctext254488_
                         '0
                         _clen254490_))
                       (_hmac254495_
                        (std/crypto/digest#digest-final!__0 _digest254475_)))
                  (std/net/bio/output#bio-write-bytes
                   _hmac254495_
                   _obuf254468_)
                  (std/net/bio/output#bio-write-bytes _iv254472_ _obuf254468_)
                  (std/net/bio/output#bio-write-u32 _clen254490_ _obuf254468_)
                  (std/net/bio/output#bio-write-subu8vector
                   _ctext254488_
                   '0
                   _clen254490_
                   _obuf254468_)
                  (std/net/bio/output#bio-force-output _obuf254468_)))
              (if (##structure-instance-of?
                   _obj254469_
                   'std/net/bio/buffer#chunked-output-buffer::t)
                  (begin
                    (std/net/bio/output#bio-write-u8
                     std/actor/rpc/proto/message#rpc-proto-message
                     _obuf254468_)
                    (let* ((_digest254498_
                            (let ((__obj310675
                                   (make-object
                                    std/crypto/digest#digest::t
                                    '2)))
                              (std/crypto/digest#digest:::init!
                               __obj310675
                               std/actor/rpc/proto/cipher#::digest-type)
                              __obj310675))
                           (_cipher254500_
                            (let ((__obj310676
                                   (make-object
                                    std/crypto/cipher#cipher::t
                                    '2)))
                              (std/crypto/cipher#cipher:::init!
                               __obj310676
                               std/actor/rpc/proto/cipher#::cipher-type)
                              __obj310676))
                           (_g310692_
                            (std/crypto/etc#random-bytes!__0 _iv254472_))
                           (_plen254503_
                            (std/net/bio/buffer#chunked-output-length
                             _obj254469_))
                           (_chunks254505_
                            (std/net/bio/buffer#chunked-output-chunks
                             _obj254469_))
                           (_maxlen254507_
                            (fx+ _plen254503_
                                 std/actor/rpc/proto/cipher#::cipher-block-size))
                           (_ctext254513_
                            (let ((_buf254509_ (unbox _ctext254473_)))
                              (if (fx< (u8vector-length _buf254509_)
                                       _maxlen254507_)
                                  (let ((_buf254511_
                                         (make-u8vector _maxlen254507_)))
                                    (set-box! _ctext254473_ _buf254511_)
                                    _buf254511_)
                                  _buf254509_)))
                           (_g310693_
                            (std/crypto/cipher#encrypt-init!
                             _cipher254500_
                             _key254471_
                             _iv254472_))
                           (_clen254521_
                            (foldl1 (lambda (_chunk254516_ _r254517_)
                                      (let ((_count254519_
                                             (std/crypto/cipher#encrypt-update!
                                              _cipher254500_
                                              _ctext254513_
                                              _r254517_
                                              _chunk254516_
                                              '0
                                              (u8vector-length
                                               _chunk254516_))))
                                        (fx+ _r254517_ _count254519_)))
                                    '0
                                    _chunks254505_))
                           (_flen254523_
                            (std/crypto/cipher#encrypt-final!__%
                             _cipher254500_
                             _ctext254513_
                             _clen254521_))
                           (_clen254525_ (fx+ _clen254521_ _flen254523_))
                           (_g310694_
                            (std/crypto/digest#digest-update!__0
                             _digest254498_
                             _secret254470_))
                           (_g310695_
                            (std/crypto/digest#digest-update!__0
                             _digest254498_
                             _iv254472_))
                           (_g310696_
                            (std/crypto/digest#digest-update!__%
                             _digest254498_
                             _ctext254513_
                             '0
                             _clen254525_))
                           (_hmac254530_
                            (std/crypto/digest#digest-final!__0
                             _digest254498_)))
                      (std/net/bio/output#bio-write-bytes
                       _hmac254530_
                       _obuf254468_)
                      (std/net/bio/output#bio-write-bytes
                       _iv254472_
                       _obuf254468_)
                      (std/net/bio/output#bio-write-u32
                       _clen254525_
                       _obuf254468_)
                      (std/net/bio/output#bio-write-subu8vector
                       _ctext254513_
                       '0
                       _clen254525_
                       _obuf254468_)
                      (std/net/bio/output#bio-force-output _obuf254468_)))
                  (std/actor/proto#raise-rpc-io-error
                   'rpc-proto-write
                   '"unexpected object"
                   _obj254469_))))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-accept
    (lambda (_ibuf254460_ _obuf254461_)
      (std/actor/rpc/proto/null#rpc-proto-accept-e
       _ibuf254460_
       _obuf254461_
       std/actor/rpc/proto/message#rpc-proto-cipher
       (lambda (_ibuf254463_ _obuf254464_)
         (let ((_secret254466_
                (std/actor/rpc/proto/cipher#rpc-cipher-proto-key-exchange
                 _ibuf254463_
                 _obuf254464_)))
           (values (std/actor/rpc/proto/cipher#rpc-cipher-proto-read-e
                    _secret254466_)
                   (std/actor/rpc/proto/cipher#rpc-cipher-proto-write-e
                    _secret254466_)))))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto-connect
    (lambda (_ibuf254452_ _obuf254453_)
      (std/actor/rpc/proto/null#rpc-proto-connect-e
       _ibuf254452_
       _obuf254453_
       std/actor/rpc/proto/message#rpc-proto-cipher
       (lambda (_ibuf254455_ _obuf254456_)
         (let ((_secret254458_
                (std/actor/rpc/proto/cipher#rpc-cipher-proto-key-exchange
                 _ibuf254455_
                 _obuf254456_)))
           (values (std/actor/rpc/proto/cipher#rpc-cipher-proto-read-e
                    _secret254458_)
                   (std/actor/rpc/proto/cipher#rpc-cipher-proto-write-e
                    _secret254458_)))))))
  (define std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto-accept
    (lambda (_ibuf254443_ _obuf254444_ _cookie254445_)
      (std/actor/rpc/proto/null#rpc-proto-accept-e
       _ibuf254443_
       _obuf254444_
       std/actor/rpc/proto/message#rpc-proto-cookie-cipher
       (lambda (_ibuf254447_ _obuf254448_)
         (std/actor/rpc/proto/cookie#rpc-cookie-proto-challenge
          _ibuf254447_
          _obuf254448_
          _cookie254445_)
         (let ((_secret254450_
                (std/actor/rpc/proto/cipher#rpc-cipher-proto-key-exchange
                 _ibuf254447_
                 _obuf254448_)))
           (values (std/actor/rpc/proto/cipher#rpc-cipher-proto-read-e
                    _secret254450_)
                   (std/actor/rpc/proto/cipher#rpc-cipher-proto-write-e
                    _secret254450_)))))))
  (define std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto-connect
    (lambda (_ibuf254432_ _obuf254433_ _cookie254434_)
      (std/actor/rpc/proto/null#rpc-proto-connect-e
       _ibuf254432_
       _obuf254433_
       std/actor/rpc/proto/message#rpc-proto-cookie-cipher
       (lambda (_ibuf254436_ _obuf254437_)
         (let ((_e254439_ (std/net/bio/input#bio-read-u8 _ibuf254436_)))
           (if (eq? _e254439_ std/actor/rpc/proto/message#rpc-proto-challenge)
               (begin
                 (std/actor/rpc/proto/cookie#rpc-cookie-proto-challenge-respond
                  _ibuf254436_
                  _obuf254437_
                  _cookie254434_)
                 (let ((_secret254441_
                        (std/actor/rpc/proto/cipher#rpc-cipher-proto-key-exchange
                         _ibuf254436_
                         _obuf254437_)))
                   (values (std/actor/rpc/proto/cipher#rpc-cipher-proto-read-e
                            _secret254441_)
                           (std/actor/rpc/proto/cipher#rpc-cipher-proto-write-e
                            _secret254441_))))
               (if (eof-object? _e254439_)
                   (std/actor/proto#raise-rpc-io-error
                    'rpc-proto-connect
                    '"connect closed")
                   (std/actor/proto#raise-rpc-io-error
                    'rpc-proto-connect
                    '"bad hello"
                    _e254439_))))))))
  (define std/actor/rpc/proto/cipher#rpc-cipher-proto
    (lambda ()
      (##structure
       std/actor/rpc/base#!rpc-protocol::t
       std/actor/rpc/proto/cipher#rpc-cipher-proto-accept
       std/actor/rpc/proto/cipher#rpc-cipher-proto-connect)))
  (define std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto__%
    (lambda (_cookie-file254405_)
      (let ((_cookie254407_ (call-with-input-file _cookie-file254405_ read)))
        (if (u8vector? _cookie254407_)
            (##structure
             std/actor/rpc/base#!rpc-protocol::t
             (lambda (_g254408254411_ _g254409254413_)
               (std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto-connect
                _g254408254411_
                _g254409254413_
                _cookie254407_))
             (lambda (_g254415254418_ _g254416254420_)
               (std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto-accept
                _g254415254418_
                _g254416254420_
                _cookie254407_)))
            (error '"Invalid cookie; expected u8vector"
                   _cookie-file254405_
                   _cookie254407_)))))
  (define std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto__0
    (lambda ()
      (let ((_cookie-file254427_ '"~/.gerbil/cookie"))
        (std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto__%
         _cookie-file254427_))))
  (define std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto
    (lambda _g310698_
      (let ((_g310697_ (##length _g310698_)))
        (cond ((##fx= _g310697_ 0)
               (apply std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto__0
                      _g310698_))
              ((##fx= _g310697_ 1)
               (apply std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto__%
                      _g310698_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/actor/rpc/proto/cipher#rpc-cookie-cipher-proto
                _g310698_)))))))
