(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/crypto/cipher#cipher::t
    (make-struct-type
     'std/crypto#cipher::t
     '#f
     '2
     'cipher
     '()
     ':init!
     '(type ctx)))
  (define std/crypto/cipher#cipher?
    (make-struct-predicate std/crypto/cipher#cipher::t))
  (define std/crypto/cipher#make-cipher
    (lambda _$args209615_
      (apply make-struct-instance std/crypto/cipher#cipher::t _$args209615_)))
  (define std/crypto/cipher#cipher-type
    (make-struct-field-accessor std/crypto/cipher#cipher::t '0))
  (define std/crypto/cipher#cipher-ctx
    (make-struct-field-accessor std/crypto/cipher#cipher::t '1))
  (define std/crypto/cipher#cipher-type-set!
    (make-struct-field-mutator std/crypto/cipher#cipher::t '0))
  (define std/crypto/cipher#cipher-ctx-set!
    (make-struct-field-mutator std/crypto/cipher#cipher::t '1))
  (define std/crypto/cipher#cipher:::init!
    (lambda (_self209610_ _type209611_)
      (if (std/crypto/libcrypto#EVP_CIPHER? _type209611_)
          '#!void
          (error '"Invalid cipher" _type209611_))
      (let ((_ctx209613_ (std/crypto/libcrypto#EVP_CIPHER_CTX_create)))
        (if _ctx209613_ '#!void (error '"Failed to allocate cipher context"))
        (if (let ((__tmp301567
                   (let ()
                     (declare (not safe))
                     (##vector-length _self209610_))))
              (declare (not safe))
              (##fx< '2 __tmp301567))
            (begin
              (let ()
                (declare (not safe))
                (##vector-set! _self209610_ '1 _type209611_))
              (let ()
                (declare (not safe))
                (##vector-set! _self209610_ '2 _ctx209613_)))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self209610_)))))
  (bind-method!
   std/crypto/cipher#cipher::t
   ':init!
   std/crypto/cipher#cipher:::init!
   '#f)
  (define std/crypto/cipher#cipher-name
    (lambda (_cipher209486_)
      (if (std/crypto/libcrypto#EVP_CIPHER? _cipher209486_)
          (std/crypto/libcrypto#EVP_CIPHER_name _cipher209486_)
          (std/crypto/libcrypto#EVP_CIPHER_name
           (##structure-ref
            _cipher209486_
            '1
            std/crypto/cipher#cipher::t
            '#f)))))
  (define std/crypto/cipher#cipher-block-size
    (lambda (_cipher209484_)
      (if (std/crypto/libcrypto#EVP_CIPHER? _cipher209484_)
          (std/crypto/libcrypto#EVP_CIPHER_block_size _cipher209484_)
          (std/crypto/libcrypto#EVP_CIPHER_block_size
           (##structure-ref
            _cipher209484_
            '1
            std/crypto/cipher#cipher::t
            '#f)))))
  (define std/crypto/cipher#cipher-key-length
    (lambda (_cipher209482_)
      (if (std/crypto/libcrypto#EVP_CIPHER? _cipher209482_)
          (std/crypto/libcrypto#EVP_CIPHER_key_length _cipher209482_)
          (std/crypto/libcrypto#EVP_CIPHER_key_length
           (##structure-ref
            _cipher209482_
            '1
            std/crypto/cipher#cipher::t
            '#f)))))
  (define std/crypto/cipher#cipher-iv-length
    (lambda (_cipher209480_)
      (if (std/crypto/libcrypto#EVP_CIPHER? _cipher209480_)
          (std/crypto/libcrypto#EVP_CIPHER_iv_length _cipher209480_)
          (std/crypto/libcrypto#EVP_CIPHER_iv_length
           (##structure-ref
            _cipher209480_
            '1
            std/crypto/cipher#cipher::t
            '#f)))))
  (define std/crypto/cipher#cipher-copy
    (lambda (_cipher209470_)
      (let* ((_ctx209472_ (std/crypto/cipher#cipher-context _cipher209470_))
             (_copy209474_
              (let ((__obj301522 (make-object std/crypto/cipher#cipher::t '2)))
                (std/crypto/cipher#cipher:::init!
                 __obj301522
                 (##structure-ref
                  _cipher209470_
                  '1
                  std/crypto/cipher#cipher::t
                  '#f))
                __obj301522)))
        (let ((_res209477_
               (std/crypto/libcrypto#EVP_CIPHER_CTX_copy
                (##structure-ref
                 _copy209474_
                 '2
                 std/crypto/cipher#cipher::t
                 '#f)
                _ctx209472_)))
          (if (let () (declare (not safe)) (##fxzero? _res209477_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void))
        _copy209474_)))
  (define std/crypto/cipher#cipher-context
    (lambda (_cipher209465_)
      (let ((_$e209467_
             (##structure-ref
              _cipher209465_
              '2
              std/crypto/cipher#cipher::t
              '#f)))
        (if _$e209467_
            _$e209467_
            (error '"Cipher has been finalized" _cipher209465_)))))
  (define std/crypto/cipher#cipher-check-key+iv-length
    (lambda (_cipher209461_ _key209462_ _iv209463_)
      (if (= (std/crypto/cipher#cipher-key-length
              (##structure-ref
               _cipher209461_
               '1
               std/crypto/cipher#cipher::t
               '#f))
             (u8vector-length _key209462_))
          '#!void
          (error '"Bad cipher key; key length mismatch"))
      (if (= (std/crypto/cipher#cipher-iv-length
              (##structure-ref
               _cipher209461_
               '1
               std/crypto/cipher#cipher::t
               '#f))
             (u8vector-length _iv209463_))
          '#!void
          (error '"Bad cipher iv; iv length mismatch"))))
  (define std/crypto/cipher#cipher-init!
    (lambda (_cipher209453_ _key209454_ _iv209455_ _EVP-init209456_)
      (std/crypto/cipher#cipher-check-key+iv-length
       _cipher209453_
       _key209454_
       _iv209455_)
      (let ((_res209458_
             (_EVP-init209456_
              (std/crypto/cipher#cipher-context _cipher209453_)
              (##structure-ref
               _cipher209453_
               '1
               std/crypto/cipher#cipher::t
               '#f)
              _key209454_
              _iv209455_)))
        (if (let () (declare (not safe)) (##fxzero? _res209458_))
            (apply std/crypto/etc#raise-libcrypto-error '())
            '#!void))))
  (define std/crypto/cipher#cipher-update!
    (lambda (_ctx209443_
             _out209444_
             _out-start209445_
             _in209446_
             _start209447_
             _end209448_
             _EVP-update209449_)
      (let ((_r209451_
             (_EVP-update209449_
              _ctx209443_
              _out209444_
              _out-start209445_
              _in209446_
              _start209447_
              _end209448_)))
        (if (not (let () (declare (not safe)) (##fxnegative? _r209451_)))
            _r209451_
            (std/crypto/etc#raise-libcrypto-error _ctx209443_)))))
  (define std/crypto/cipher#cipher-final!
    (lambda (_ctx209436_ _out209437_ _out-start209438_ _EVP-final209439_)
      (let ((_r209441_
             (_EVP-final209439_ _ctx209436_ _out209437_ _out-start209438_)))
        (if (not (let () (declare (not safe)) (##fxnegative? _r209441_)))
            _r209441_
            (std/crypto/etc#raise-libcrypto-error _ctx209436_)))))
  (define std/crypto/cipher#encrypt-init!
    (lambda (_cipher209432_ _key209433_ _iv209434_)
      (std/crypto/cipher#cipher-init!
       _cipher209432_
       _key209433_
       _iv209434_
       std/crypto/libcrypto#EVP_EncryptInit)))
  (define std/crypto/cipher#encrypt-update!
    (lambda (_cipher209425_
             _out209426_
             _out-start209427_
             _in209428_
             _start209429_
             _end209430_)
      (std/crypto/cipher#cipher-update!
       (std/crypto/cipher#cipher-context _cipher209425_)
       _out209426_
       _out-start209427_
       _in209428_
       _start209429_
       _end209430_
       std/crypto/libcrypto#EVP_EncryptUpdate)))
  (define std/crypto/cipher#encrypt-final!__%
    (lambda (_cipher209407_ _out209408_ _out-start209409_)
      (let ((_olen209411_
             (std/crypto/cipher#cipher-final!
              (std/crypto/cipher#cipher-context _cipher209407_)
              _out209408_
              _out-start209409_
              std/crypto/libcrypto#EVP_EncryptFinal)))
        (##structure-set!
         _cipher209407_
         '#f
         '2
         std/crypto/cipher#cipher::t
         '#f)
        _olen209411_)))
  (define std/crypto/cipher#encrypt-final!__0
    (lambda (_cipher209416_ _out209417_)
      (let ((_out-start209419_ '0))
        (std/crypto/cipher#encrypt-final!__%
         _cipher209416_
         _out209417_
         _out-start209419_))))
  (define std/crypto/cipher#encrypt-final!
    (lambda _g301569_
      (let ((_g301568_ (let () (declare (not safe)) (##length _g301569_))))
        (cond ((let () (declare (not safe)) (##fx= _g301568_ 2))
               (apply std/crypto/cipher#encrypt-final!__0 _g301569_))
              ((let () (declare (not safe)) (##fx= _g301568_ 3))
               (apply std/crypto/cipher#encrypt-final!__% _g301569_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/cipher#encrypt-final!
                _g301569_))))))
  (define std/crypto/cipher#decrypt-init!
    (lambda (_cipher209402_ _key209403_ _iv209404_)
      (std/crypto/cipher#cipher-init!
       _cipher209402_
       _key209403_
       _iv209404_
       std/crypto/libcrypto#EVP_DecryptInit)))
  (define std/crypto/cipher#decrypt-update!
    (lambda (_cipher209395_
             _out209396_
             _out-start209397_
             _in209398_
             _start209399_
             _end209400_)
      (std/crypto/cipher#cipher-update!
       (std/crypto/cipher#cipher-context _cipher209395_)
       _out209396_
       _out-start209397_
       _in209398_
       _start209399_
       _end209400_
       std/crypto/libcrypto#EVP_DecryptUpdate)))
  (define std/crypto/cipher#decrypt-final!__%
    (lambda (_cipher209377_ _out209378_ _out-start209379_)
      (let ((_olen209381_
             (std/crypto/cipher#cipher-final!
              (std/crypto/cipher#cipher-context _cipher209377_)
              _out209378_
              _out-start209379_
              std/crypto/libcrypto#EVP_DecryptFinal)))
        (##structure-set!
         _cipher209377_
         '#f
         '2
         std/crypto/cipher#cipher::t
         '#f)
        _olen209381_)))
  (define std/crypto/cipher#decrypt-final!__0
    (lambda (_cipher209386_ _out209387_)
      (let ((_out-start209389_ '0))
        (std/crypto/cipher#decrypt-final!__%
         _cipher209386_
         _out209387_
         _out-start209389_))))
  (define std/crypto/cipher#decrypt-final!
    (lambda _g301571_
      (let ((_g301570_ (let () (declare (not safe)) (##length _g301571_))))
        (cond ((let () (declare (not safe)) (##fx= _g301570_ 2))
               (apply std/crypto/cipher#decrypt-final!__0 _g301571_))
              ((let () (declare (not safe)) (##fx= _g301570_ 3))
               (apply std/crypto/cipher#decrypt-final!__% _g301571_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/cipher#decrypt-final!
                _g301571_))))))
  (define std/crypto/cipher#encrypt
    (lambda (_cipher209371_ _key209372_ _iv209373_ _in209374_)
      (if (string? _in209374_)
          (std/crypto/cipher#encrypt-u8vector__0
           _cipher209371_
           _key209372_
           _iv209373_
           (std/text/utf8#string->utf8__0 _in209374_))
          (if (u8vector? _in209374_)
              (std/crypto/cipher#encrypt-u8vector__0
               _cipher209371_
               _key209372_
               _iv209373_
               _in209374_)
              (if (input-port? _in209374_)
                  (std/crypto/cipher#encrypt-port
                   _cipher209371_
                   _key209372_
                   _iv209373_
                   _in209374_)
                  (error '"Bad input source" _in209374_))))))
  (define std/crypto/cipher#encrypt-u8vector__%
    (lambda (_cipher209317_
             _key209318_
             _iv209319_
             _in209320_
             _start209321_
             _end209322_)
      (let* ((_len209324_
              (let () (declare (not safe)) (##fx- _end209322_ _start209321_)))
             (_buflen209327_
              (let ((__tmp301572
                     (let ((__tmp301573
                            (std/crypto/cipher#cipher-block-size
                             _cipher209317_)))
                       (declare (not safe))
                       (##fx* '2 __tmp301573))))
                (declare (not safe))
                (##fx+ _len209324_ __tmp301572)))
             (_buf209330_ (make-u8vector _buflen209327_)))
        (std/crypto/cipher#encrypt-init! _cipher209317_ _key209318_ _iv209319_)
        (let* ((_ulen209334_
                (std/crypto/cipher#encrypt-update!
                 _cipher209317_
                 _buf209330_
                 '0
                 _in209320_
                 _start209321_
                 _end209322_))
               (_flen209337_
                (std/crypto/cipher#encrypt-final!__%
                 _cipher209317_
                 _buf209330_
                 _ulen209334_))
               (_olen209340_
                (let ()
                  (declare (not safe))
                  (##fx+ _ulen209334_ _flen209337_))))
          (if (let () (declare (not safe)) (##fx< _olen209340_ _buflen209327_))
              (u8vector-shrink! _buf209330_ _olen209340_)
              '#!void)
          _buf209330_))))
  (define std/crypto/cipher#encrypt-u8vector__0
    (lambda (_cipher209347_ _key209348_ _iv209349_ _in209350_)
      (let* ((_start209352_ '0) (_end209354_ (u8vector-length _in209350_)))
        (std/crypto/cipher#encrypt-u8vector__%
         _cipher209347_
         _key209348_
         _iv209349_
         _in209350_
         _start209352_
         _end209354_))))
  (define std/crypto/cipher#encrypt-u8vector__1
    (lambda (_cipher209356_ _key209357_ _iv209358_ _in209359_ _start209360_)
      (let ((_end209362_ (u8vector-length _in209359_)))
        (std/crypto/cipher#encrypt-u8vector__%
         _cipher209356_
         _key209357_
         _iv209358_
         _in209359_
         _start209360_
         _end209362_))))
  (define std/crypto/cipher#encrypt-u8vector
    (lambda _g301575_
      (let ((_g301574_ (let () (declare (not safe)) (##length _g301575_))))
        (cond ((let () (declare (not safe)) (##fx= _g301574_ 4))
               (apply std/crypto/cipher#encrypt-u8vector__0 _g301575_))
              ((let () (declare (not safe)) (##fx= _g301574_ 5))
               (apply std/crypto/cipher#encrypt-u8vector__1 _g301575_))
              ((let () (declare (not safe)) (##fx= _g301574_ 6))
               (apply std/crypto/cipher#encrypt-u8vector__% _g301575_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/cipher#encrypt-u8vector
                _g301575_))))))
  (define std/crypto/cipher#encrypt-u8vector!
    (lambda (_cipher209301_
             _key209302_
             _iv209303_
             _bytes209304_
             _start209305_
             _end209306_
             _buf209307_)
      (std/crypto/cipher#encrypt-init! _cipher209301_ _key209302_ _iv209303_)
      (let* ((_ulen209309_
              (std/crypto/cipher#encrypt-update!
               _cipher209301_
               _buf209307_
               '0
               _bytes209304_
               _start209305_
               _end209306_))
             (_flen209311_
              (std/crypto/cipher#encrypt-final!__%
               _cipher209301_
               _buf209307_
               _ulen209309_))
             (_olen209313_
              (let () (declare (not safe)) (##fx+ _ulen209309_ _flen209311_))))
        _olen209313_)))
  (define std/crypto/cipher#encrypt-port
    (lambda (_cipher209265_ _key209266_ _iv209267_ _inp209268_)
      (let* ((_bufsz209270_ '1024)
             (_buf209273_
              (make-u8vector
               (let ((__tmp301576
                      (std/crypto/cipher#cipher-block-size _cipher209265_)))
                 (declare (not safe))
                 (##fx+ _bufsz209270_ __tmp301576))))
             (_outp209276_ (open-output-u8vector)))
        (letrec ((_grow-buffer-if-needed209280_
                  (lambda (_ilen209295_)
                    (let ((_max-olen209298_
                           (let ((__tmp301577
                                  (std/crypto/cipher#cipher-block-size
                                   _cipher209265_)))
                             (declare (not safe))
                             (##fx+ _ilen209295_ __tmp301577))))
                      (if (let ((__tmp301578 (u8vector-length _buf209273_)))
                            (declare (not safe))
                            (##fx> _max-olen209298_ __tmp301578))
                          (set! _buf209273_ (make-u8vector _max-olen209298_))
                          '#!void)))))
          (std/crypto/cipher#encrypt-init!
           _cipher209265_
           _key209266_
           _iv209267_)
          (std/crypto/etc#call-with-binary-input
           (lambda (_bytes209283_ _start209285_ _end209287_)
             (_grow-buffer-if-needed209280_ (- _end209287_ _start209285_))
             (let ((_olen209290_
                    (std/crypto/cipher#encrypt-update!
                     _cipher209265_
                     _buf209273_
                     '0
                     _bytes209283_
                     _start209285_
                     _end209287_)))
               (write-subu8vector _buf209273_ '0 _olen209290_ _outp209276_)))
           _inp209268_)
          (let ((_olen209293_
                 (std/crypto/cipher#encrypt-final!__0
                  _cipher209265_
                  _buf209273_)))
            (write-subu8vector _buf209273_ '0 _olen209293_ _outp209276_)
            (get-output-u8vector _outp209276_))))))
  (define std/crypto/cipher#decrypt
    (lambda (_cipher209260_ _key209261_ _iv209262_ _in209263_)
      (if (u8vector? _in209263_)
          (std/crypto/cipher#decrypt-u8vector__0
           _cipher209260_
           _key209261_
           _iv209262_
           _in209263_)
          (if (input-port? _in209263_)
              (std/crypto/cipher#decrypt-port
               _cipher209260_
               _key209261_
               _iv209262_
               _in209263_)
              (error '"Bad input source" _in209263_)))))
  (define std/crypto/cipher#decrypt-u8vector__%
    (lambda (_cipher209206_
             _key209207_
             _iv209208_
             _in209209_
             _start209210_
             _end209211_)
      (let* ((_len209213_
              (let () (declare (not safe)) (##fx- _end209211_ _start209210_)))
             (_buflen209216_
              (let ((__tmp301579
                     (let ((__tmp301580
                            (std/crypto/cipher#cipher-block-size
                             _cipher209206_)))
                       (declare (not safe))
                       (##fx* '2 __tmp301580))))
                (declare (not safe))
                (##fx+ _len209213_ __tmp301579)))
             (_buf209219_ (make-u8vector _buflen209216_)))
        (std/crypto/cipher#decrypt-init! _cipher209206_ _key209207_ _iv209208_)
        (let* ((_ulen209223_
                (std/crypto/cipher#decrypt-update!
                 _cipher209206_
                 _buf209219_
                 '0
                 _in209209_
                 _start209210_
                 _end209211_))
               (_flen209226_
                (std/crypto/cipher#decrypt-final!__%
                 _cipher209206_
                 _buf209219_
                 _ulen209223_))
               (_olen209229_
                (let ()
                  (declare (not safe))
                  (##fx+ _ulen209223_ _flen209226_))))
          (if (let () (declare (not safe)) (##fx< _olen209229_ _buflen209216_))
              (u8vector-shrink! _buf209219_ _olen209229_)
              '#!void)
          _buf209219_))))
  (define std/crypto/cipher#decrypt-u8vector__0
    (lambda (_cipher209236_ _key209237_ _iv209238_ _in209239_)
      (let* ((_start209241_ '0) (_end209243_ (u8vector-length _in209239_)))
        (std/crypto/cipher#decrypt-u8vector__%
         _cipher209236_
         _key209237_
         _iv209238_
         _in209239_
         _start209241_
         _end209243_))))
  (define std/crypto/cipher#decrypt-u8vector__1
    (lambda (_cipher209245_ _key209246_ _iv209247_ _in209248_ _start209249_)
      (let ((_end209251_ (u8vector-length _in209248_)))
        (std/crypto/cipher#decrypt-u8vector__%
         _cipher209245_
         _key209246_
         _iv209247_
         _in209248_
         _start209249_
         _end209251_))))
  (define std/crypto/cipher#decrypt-u8vector
    (lambda _g301582_
      (let ((_g301581_ (let () (declare (not safe)) (##length _g301582_))))
        (cond ((let () (declare (not safe)) (##fx= _g301581_ 4))
               (apply std/crypto/cipher#decrypt-u8vector__0 _g301582_))
              ((let () (declare (not safe)) (##fx= _g301581_ 5))
               (apply std/crypto/cipher#decrypt-u8vector__1 _g301582_))
              ((let () (declare (not safe)) (##fx= _g301581_ 6))
               (apply std/crypto/cipher#decrypt-u8vector__% _g301582_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/cipher#decrypt-u8vector
                _g301582_))))))
  (define std/crypto/cipher#decrypt-u8vector!
    (lambda (_cipher209190_
             _key209191_
             _iv209192_
             _bytes209193_
             _start209194_
             _end209195_
             _buf209196_)
      (std/crypto/cipher#decrypt-init! _cipher209190_ _key209191_ _iv209192_)
      (let* ((_ulen209198_
              (std/crypto/cipher#decrypt-update!
               _cipher209190_
               _buf209196_
               '0
               _bytes209193_
               _start209194_
               _end209195_))
             (_flen209200_
              (std/crypto/cipher#decrypt-final!__%
               _cipher209190_
               _buf209196_
               _ulen209198_))
             (_olen209202_
              (let () (declare (not safe)) (##fx+ _ulen209198_ _flen209200_))))
        _olen209202_)))
  (define std/crypto/cipher#decrypt-port
    (lambda (_cipher209154_ _key209155_ _iv209156_ _inp209157_)
      (let* ((_bufsz209159_ '1024)
             (_buf209162_
              (make-u8vector
               (let ((__tmp301583
                      (std/crypto/cipher#cipher-block-size _cipher209154_)))
                 (declare (not safe))
                 (##fx+ _bufsz209159_ __tmp301583))))
             (_outp209165_ (open-output-u8vector)))
        (letrec ((_grow-buffer-if-needed209169_
                  (lambda (_ilen209184_)
                    (let ((_max-olen209187_
                           (let ((__tmp301584
                                  (std/crypto/cipher#cipher-block-size
                                   _cipher209154_)))
                             (declare (not safe))
                             (##fx+ _ilen209184_ __tmp301584))))
                      (if (let ((__tmp301585 (u8vector-length _buf209162_)))
                            (declare (not safe))
                            (##fx> _max-olen209187_ __tmp301585))
                          (set! _buf209162_ (make-u8vector _max-olen209187_))
                          '#!void)))))
          (std/crypto/cipher#decrypt-init!
           _cipher209154_
           _key209155_
           _iv209156_)
          (std/crypto/etc#call-with-binary-input
           (lambda (_bytes209172_ _start209174_ _end209176_)
             (_grow-buffer-if-needed209169_ (- _end209176_ _start209174_))
             (let ((_olen209179_
                    (std/crypto/cipher#decrypt-update!
                     _cipher209154_
                     _buf209162_
                     '0
                     _bytes209172_
                     _start209174_
                     _end209176_)))
               (write-subu8vector _buf209162_ '0 _olen209179_ _outp209165_)))
           _inp209157_)
          (let ((_olen209182_
                 (std/crypto/cipher#decrypt-final!__0
                  _cipher209154_
                  _buf209162_)))
            (write-subu8vector _buf209162_ '0 _olen209182_ _outp209165_)
            (get-output-u8vector _outp209165_))))))
  (define std/crypto/cipher#cipher::aes-128-ecb
    (std/crypto/libcrypto#EVP_aes_128_ecb))
  (define std/crypto/cipher#make-aes-128-ecb-cipher
    (lambda ()
      (let ((__obj301523 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301523
         std/crypto/cipher#cipher::aes-128-ecb)
        __obj301523)))
  (define std/crypto/cipher#aes-128-ecb-cipher?
    (lambda (_obj209151_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209151_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209151_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-cbc
    (std/crypto/libcrypto#EVP_aes_128_cbc))
  (define std/crypto/cipher#make-aes-128-cbc-cipher
    (lambda ()
      (let ((__obj301524 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301524
         std/crypto/cipher#cipher::aes-128-cbc)
        __obj301524)))
  (define std/crypto/cipher#aes-128-cbc-cipher?
    (lambda (_obj209148_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209148_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209148_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-cfb
    (std/crypto/libcrypto#EVP_aes_128_cfb))
  (define std/crypto/cipher#make-aes-128-cfb-cipher
    (lambda ()
      (let ((__obj301525 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301525
         std/crypto/cipher#cipher::aes-128-cfb)
        __obj301525)))
  (define std/crypto/cipher#aes-128-cfb-cipher?
    (lambda (_obj209145_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209145_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209145_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-ofb
    (std/crypto/libcrypto#EVP_aes_128_ofb))
  (define std/crypto/cipher#make-aes-128-ofb-cipher
    (lambda ()
      (let ((__obj301526 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301526
         std/crypto/cipher#cipher::aes-128-ofb)
        __obj301526)))
  (define std/crypto/cipher#aes-128-ofb-cipher?
    (lambda (_obj209142_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209142_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209142_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-ctr
    (std/crypto/libcrypto#EVP_aes_128_ctr))
  (define std/crypto/cipher#make-aes-128-ctr-cipher
    (lambda ()
      (let ((__obj301527 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301527
         std/crypto/cipher#cipher::aes-128-ctr)
        __obj301527)))
  (define std/crypto/cipher#aes-128-ctr-cipher?
    (lambda (_obj209139_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209139_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209139_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-ctr))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-ccm
    (std/crypto/libcrypto#EVP_aes_128_ccm))
  (define std/crypto/cipher#make-aes-128-ccm-cipher
    (lambda ()
      (let ((__obj301528 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301528
         std/crypto/cipher#cipher::aes-128-ccm)
        __obj301528)))
  (define std/crypto/cipher#aes-128-ccm-cipher?
    (lambda (_obj209136_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209136_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209136_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-ccm))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-gcm
    (std/crypto/libcrypto#EVP_aes_128_gcm))
  (define std/crypto/cipher#make-aes-128-gcm-cipher
    (lambda ()
      (let ((__obj301529 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301529
         std/crypto/cipher#cipher::aes-128-gcm)
        __obj301529)))
  (define std/crypto/cipher#aes-128-gcm-cipher?
    (lambda (_obj209133_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209133_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209133_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-gcm))
          '#f)))
  (define std/crypto/cipher#cipher::aes-128-xts
    (std/crypto/libcrypto#EVP_aes_128_xts))
  (define std/crypto/cipher#make-aes-128-xts-cipher
    (lambda ()
      (let ((__obj301530 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301530
         std/crypto/cipher#cipher::aes-128-xts)
        __obj301530)))
  (define std/crypto/cipher#aes-128-xts-cipher?
    (lambda (_obj209129_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209129_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209129_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-128-xts))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-ecb
    (std/crypto/libcrypto#EVP_aes_192_ecb))
  (define std/crypto/cipher#make-aes-192-ecb-cipher
    (lambda ()
      (let ((__obj301531 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301531
         std/crypto/cipher#cipher::aes-192-ecb)
        __obj301531)))
  (define std/crypto/cipher#aes-192-ecb-cipher?
    (lambda (_obj209126_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209126_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209126_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-cbc
    (std/crypto/libcrypto#EVP_aes_192_cbc))
  (define std/crypto/cipher#make-aes-192-cbc-cipher
    (lambda ()
      (let ((__obj301532 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301532
         std/crypto/cipher#cipher::aes-192-cbc)
        __obj301532)))
  (define std/crypto/cipher#aes-192-cbc-cipher?
    (lambda (_obj209123_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209123_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209123_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-cfb
    (std/crypto/libcrypto#EVP_aes_192_cfb))
  (define std/crypto/cipher#make-aes-192-cfb-cipher
    (lambda ()
      (let ((__obj301533 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301533
         std/crypto/cipher#cipher::aes-192-cfb)
        __obj301533)))
  (define std/crypto/cipher#aes-192-cfb-cipher?
    (lambda (_obj209120_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209120_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209120_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-ofb
    (std/crypto/libcrypto#EVP_aes_192_ofb))
  (define std/crypto/cipher#make-aes-192-ofb-cipher
    (lambda ()
      (let ((__obj301534 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301534
         std/crypto/cipher#cipher::aes-192-ofb)
        __obj301534)))
  (define std/crypto/cipher#aes-192-ofb-cipher?
    (lambda (_obj209117_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209117_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209117_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-ctr
    (std/crypto/libcrypto#EVP_aes_192_ctr))
  (define std/crypto/cipher#make-aes-192-ctr-cipher
    (lambda ()
      (let ((__obj301535 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301535
         std/crypto/cipher#cipher::aes-192-ctr)
        __obj301535)))
  (define std/crypto/cipher#aes-192-ctr-cipher?
    (lambda (_obj209114_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209114_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209114_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-ctr))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-ccm
    (std/crypto/libcrypto#EVP_aes_192_ccm))
  (define std/crypto/cipher#make-aes-192-ccm-cipher
    (lambda ()
      (let ((__obj301536 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301536
         std/crypto/cipher#cipher::aes-192-ccm)
        __obj301536)))
  (define std/crypto/cipher#aes-192-ccm-cipher?
    (lambda (_obj209111_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209111_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209111_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-ccm))
          '#f)))
  (define std/crypto/cipher#cipher::aes-192-gcm
    (std/crypto/libcrypto#EVP_aes_192_gcm))
  (define std/crypto/cipher#make-aes-192-gcm-cipher
    (lambda ()
      (let ((__obj301537 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301537
         std/crypto/cipher#cipher::aes-192-gcm)
        __obj301537)))
  (define std/crypto/cipher#aes-192-gcm-cipher?
    (lambda (_obj209107_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209107_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209107_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-192-gcm))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-ecb
    (std/crypto/libcrypto#EVP_aes_256_ecb))
  (define std/crypto/cipher#make-aes-256-ecb-cipher
    (lambda ()
      (let ((__obj301538 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301538
         std/crypto/cipher#cipher::aes-256-ecb)
        __obj301538)))
  (define std/crypto/cipher#aes-256-ecb-cipher?
    (lambda (_obj209104_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209104_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209104_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-cbc
    (std/crypto/libcrypto#EVP_aes_256_cbc))
  (define std/crypto/cipher#make-aes-256-cbc-cipher
    (lambda ()
      (let ((__obj301539 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301539
         std/crypto/cipher#cipher::aes-256-cbc)
        __obj301539)))
  (define std/crypto/cipher#aes-256-cbc-cipher?
    (lambda (_obj209101_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209101_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209101_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-cfb
    (std/crypto/libcrypto#EVP_aes_256_cfb))
  (define std/crypto/cipher#make-aes-256-cfb-cipher
    (lambda ()
      (let ((__obj301540 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301540
         std/crypto/cipher#cipher::aes-256-cfb)
        __obj301540)))
  (define std/crypto/cipher#aes-256-cfb-cipher?
    (lambda (_obj209098_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209098_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209098_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-ofb
    (std/crypto/libcrypto#EVP_aes_256_ofb))
  (define std/crypto/cipher#make-aes-256-ofb-cipher
    (lambda ()
      (let ((__obj301541 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301541
         std/crypto/cipher#cipher::aes-256-ofb)
        __obj301541)))
  (define std/crypto/cipher#aes-256-ofb-cipher?
    (lambda (_obj209095_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209095_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209095_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-ctr
    (std/crypto/libcrypto#EVP_aes_256_ctr))
  (define std/crypto/cipher#make-aes-256-ctr-cipher
    (lambda ()
      (let ((__obj301542 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301542
         std/crypto/cipher#cipher::aes-256-ctr)
        __obj301542)))
  (define std/crypto/cipher#aes-256-ctr-cipher?
    (lambda (_obj209092_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209092_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209092_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-ctr))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-ccm
    (std/crypto/libcrypto#EVP_aes_256_ccm))
  (define std/crypto/cipher#make-aes-256-ccm-cipher
    (lambda ()
      (let ((__obj301543 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301543
         std/crypto/cipher#cipher::aes-256-ccm)
        __obj301543)))
  (define std/crypto/cipher#aes-256-ccm-cipher?
    (lambda (_obj209089_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209089_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209089_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-ccm))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-gcm
    (std/crypto/libcrypto#EVP_aes_256_gcm))
  (define std/crypto/cipher#make-aes-256-gcm-cipher
    (lambda ()
      (let ((__obj301544 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301544
         std/crypto/cipher#cipher::aes-256-gcm)
        __obj301544)))
  (define std/crypto/cipher#aes-256-gcm-cipher?
    (lambda (_obj209086_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209086_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209086_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-gcm))
          '#f)))
  (define std/crypto/cipher#cipher::aes-256-xts
    (std/crypto/libcrypto#EVP_aes_256_xts))
  (define std/crypto/cipher#make-aes-256-xts-cipher
    (lambda ()
      (let ((__obj301545 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301545
         std/crypto/cipher#cipher::aes-256-xts)
        __obj301545)))
  (define std/crypto/cipher#aes-256-xts-cipher?
    (lambda (_obj209082_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209082_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209082_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::aes-256-xts))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-128-ecb
    (std/crypto/libcrypto#EVP_camellia_128_ecb))
  (define std/crypto/cipher#make-camellia-128-ecb-cipher
    (lambda ()
      (let ((__obj301546 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301546
         std/crypto/cipher#cipher::camellia-128-ecb)
        __obj301546)))
  (define std/crypto/cipher#camellia-128-ecb-cipher?
    (lambda (_obj209079_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209079_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209079_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-128-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-128-cbc
    (std/crypto/libcrypto#EVP_camellia_128_cbc))
  (define std/crypto/cipher#make-camellia-128-cbc-cipher
    (lambda ()
      (let ((__obj301547 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301547
         std/crypto/cipher#cipher::camellia-128-cbc)
        __obj301547)))
  (define std/crypto/cipher#camellia-128-cbc-cipher?
    (lambda (_obj209076_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209076_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209076_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-128-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-128-cfb
    (std/crypto/libcrypto#EVP_camellia_128_cfb))
  (define std/crypto/cipher#make-camellia-128-cfb-cipher
    (lambda ()
      (let ((__obj301548 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301548
         std/crypto/cipher#cipher::camellia-128-cfb)
        __obj301548)))
  (define std/crypto/cipher#camellia-128-cfb-cipher?
    (lambda (_obj209073_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209073_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209073_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-128-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-128-ofb
    (std/crypto/libcrypto#EVP_camellia_128_ofb))
  (define std/crypto/cipher#make-camellia-128-ofb-cipher
    (lambda ()
      (let ((__obj301549 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301549
         std/crypto/cipher#cipher::camellia-128-ofb)
        __obj301549)))
  (define std/crypto/cipher#camellia-128-ofb-cipher?
    (lambda (_obj209069_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209069_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209069_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-128-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-192-ecb
    (std/crypto/libcrypto#EVP_camellia_192_ecb))
  (define std/crypto/cipher#make-camellia-192-ecb-cipher
    (lambda ()
      (let ((__obj301550 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301550
         std/crypto/cipher#cipher::camellia-192-ecb)
        __obj301550)))
  (define std/crypto/cipher#camellia-192-ecb-cipher?
    (lambda (_obj209066_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209066_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209066_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-192-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-192-cbc
    (std/crypto/libcrypto#EVP_camellia_192_cbc))
  (define std/crypto/cipher#make-camellia-192-cbc-cipher
    (lambda ()
      (let ((__obj301551 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301551
         std/crypto/cipher#cipher::camellia-192-cbc)
        __obj301551)))
  (define std/crypto/cipher#camellia-192-cbc-cipher?
    (lambda (_obj209063_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209063_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209063_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-192-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-192-cfb
    (std/crypto/libcrypto#EVP_camellia_192_cfb))
  (define std/crypto/cipher#make-camellia-192-cfb-cipher
    (lambda ()
      (let ((__obj301552 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301552
         std/crypto/cipher#cipher::camellia-192-cfb)
        __obj301552)))
  (define std/crypto/cipher#camellia-192-cfb-cipher?
    (lambda (_obj209060_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209060_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209060_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-192-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-192-ofb
    (std/crypto/libcrypto#EVP_camellia_192_ofb))
  (define std/crypto/cipher#make-camellia-192-ofb-cipher
    (lambda ()
      (let ((__obj301553 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301553
         std/crypto/cipher#cipher::camellia-192-ofb)
        __obj301553)))
  (define std/crypto/cipher#camellia-192-ofb-cipher?
    (lambda (_obj209056_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209056_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209056_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-192-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-256-ecb
    (std/crypto/libcrypto#EVP_camellia_256_ecb))
  (define std/crypto/cipher#make-camellia-256-ecb-cipher
    (lambda ()
      (let ((__obj301554 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301554
         std/crypto/cipher#cipher::camellia-256-ecb)
        __obj301554)))
  (define std/crypto/cipher#camellia-256-ecb-cipher?
    (lambda (_obj209053_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209053_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209053_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-256-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-256-cbc
    (std/crypto/libcrypto#EVP_camellia_256_cbc))
  (define std/crypto/cipher#make-camellia-256-cbc-cipher
    (lambda ()
      (let ((__obj301555 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301555
         std/crypto/cipher#cipher::camellia-256-cbc)
        __obj301555)))
  (define std/crypto/cipher#camellia-256-cbc-cipher?
    (lambda (_obj209050_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209050_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209050_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-256-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-256-cfb
    (std/crypto/libcrypto#EVP_camellia_256_cfb))
  (define std/crypto/cipher#make-camellia-256-cfb-cipher
    (lambda ()
      (let ((__obj301556 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301556
         std/crypto/cipher#cipher::camellia-256-cfb)
        __obj301556)))
  (define std/crypto/cipher#camellia-256-cfb-cipher?
    (lambda (_obj209047_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209047_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209047_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-256-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::camellia-256-ofb
    (std/crypto/libcrypto#EVP_camellia_256_ofb))
  (define std/crypto/cipher#make-camellia-256-ofb-cipher
    (lambda ()
      (let ((__obj301557 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301557
         std/crypto/cipher#cipher::camellia-256-ofb)
        __obj301557)))
  (define std/crypto/cipher#camellia-256-ofb-cipher?
    (lambda (_obj209043_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209043_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209043_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::camellia-256-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::cast5-ecb
    (std/crypto/libcrypto#EVP_cast5_ecb))
  (define std/crypto/cipher#make-cast5-ecb-cipher
    (lambda ()
      (let ((__obj301558 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301558
         std/crypto/cipher#cipher::cast5-ecb)
        __obj301558)))
  (define std/crypto/cipher#cast5-ecb-cipher?
    (lambda (_obj209040_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209040_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209040_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::cast5-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::cast5-cbc
    (std/crypto/libcrypto#EVP_cast5_cbc))
  (define std/crypto/cipher#make-cast5-cbc-cipher
    (lambda ()
      (let ((__obj301559 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301559
         std/crypto/cipher#cipher::cast5-cbc)
        __obj301559)))
  (define std/crypto/cipher#cast5-cbc-cipher?
    (lambda (_obj209037_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209037_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209037_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::cast5-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::cast5-cfb
    (std/crypto/libcrypto#EVP_cast5_cfb))
  (define std/crypto/cipher#make-cast5-cfb-cipher
    (lambda ()
      (let ((__obj301560 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301560
         std/crypto/cipher#cipher::cast5-cfb)
        __obj301560)))
  (define std/crypto/cipher#cast5-cfb-cipher?
    (lambda (_obj209034_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209034_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209034_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::cast5-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::cast5-ofb
    (std/crypto/libcrypto#EVP_cast5_ofb))
  (define std/crypto/cipher#make-cast5-ofb-cipher
    (lambda ()
      (let ((__obj301561 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301561
         std/crypto/cipher#cipher::cast5-ofb)
        __obj301561)))
  (define std/crypto/cipher#cast5-ofb-cipher?
    (lambda (_obj209030_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209030_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209030_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::cast5-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::bf-ecb (std/crypto/libcrypto#EVP_bf_ecb))
  (define std/crypto/cipher#make-bf-ecb-cipher
    (lambda ()
      (let ((__obj301562 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301562
         std/crypto/cipher#cipher::bf-ecb)
        __obj301562)))
  (define std/crypto/cipher#bf-ecb-cipher?
    (lambda (_obj209027_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209027_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209027_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::bf-ecb))
          '#f)))
  (define std/crypto/cipher#cipher::bf-cbc (std/crypto/libcrypto#EVP_bf_cbc))
  (define std/crypto/cipher#make-bf-cbc-cipher
    (lambda ()
      (let ((__obj301563 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301563
         std/crypto/cipher#cipher::bf-cbc)
        __obj301563)))
  (define std/crypto/cipher#bf-cbc-cipher?
    (lambda (_obj209024_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209024_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209024_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::bf-cbc))
          '#f)))
  (define std/crypto/cipher#cipher::bf-cfb (std/crypto/libcrypto#EVP_bf_cfb))
  (define std/crypto/cipher#make-bf-cfb-cipher
    (lambda ()
      (let ((__obj301564 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301564
         std/crypto/cipher#cipher::bf-cfb)
        __obj301564)))
  (define std/crypto/cipher#bf-cfb-cipher?
    (lambda (_obj209021_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209021_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209021_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::bf-cfb))
          '#f)))
  (define std/crypto/cipher#cipher::bf-ofb (std/crypto/libcrypto#EVP_bf_ofb))
  (define std/crypto/cipher#make-bf-ofb-cipher
    (lambda ()
      (let ((__obj301565 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301565
         std/crypto/cipher#cipher::bf-ofb)
        __obj301565)))
  (define std/crypto/cipher#bf-ofb-cipher?
    (lambda (_obj209017_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209017_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209017_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::bf-ofb))
          '#f)))
  (define std/crypto/cipher#cipher::rc4 (std/crypto/libcrypto#EVP_rc4))
  (define std/crypto/cipher#make-rc4-cipher
    (lambda ()
      (let ((__obj301566 (make-object std/crypto/cipher#cipher::t '2)))
        (std/crypto/cipher#cipher:::init!
         __obj301566
         std/crypto/cipher#cipher::rc4)
        __obj301566)))
  (define std/crypto/cipher#rc4-cipher?
    (lambda (_obj209013_)
      (if (let ()
            (declare (not safe))
            (##structure-instance-of? _obj209013_ 'std/crypto#cipher::t))
          (eq? (std/crypto/libcrypto#EVP_CIPHER_nid
                (##structure-ref
                 _obj209013_
                 '1
                 std/crypto/cipher#cipher::t
                 '#f))
               (std/crypto/libcrypto#EVP_CIPHER_nid
                std/crypto/cipher#cipher::rc4))
          '#f))))
