(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/crypto/dh#with-null-check
    (lambda (_makef210122_)
      (let ((_$e210124_ (_makef210122_)))
        (if _$e210124_
            _$e210124_
            (error '"error allocating key; NULL POINTER")))))
  (define std/crypto/dh#DH-get-1024-160
    (lambda ()
      (std/crypto/dh#with-null-check std/crypto/libcrypto#DH_get_1024_160)))
  (define std/crypto/dh#DH-get-2048-224
    (lambda ()
      (std/crypto/dh#with-null-check std/crypto/libcrypto#DH_get_2048_224)))
  (define std/crypto/dh#DH-get-2048-256
    (lambda ()
      (std/crypto/dh#with-null-check std/crypto/libcrypto#DH_get_2048_256)))
  (define std/crypto/dh#DH-generate-key
    (lambda (_dh210114_)
      (let ((_res210116_ (std/crypto/libcrypto#DH_generate_key _dh210114_)))
        (if (let () (declare (not safe)) (##fxzero? _res210116_))
            (apply std/crypto/etc#raise-libcrypto-error '())
            '#!void))))
  (define std/crypto/dh#DH-compute-key
    (lambda (_dh210104_ _bn210105_)
      (let* ((_len210107_ (std/crypto/libcrypto#DH_size _dh210104_))
             (_secret210109_ (make-u8vector _len210107_))
             (_count210111_
              (std/crypto/libcrypto#DH_compute_key
               _secret210109_
               _bn210105_
               _dh210104_)))
        (if (let () (declare (not safe)) (##fx< _count210111_ _len210107_))
            (u8vector-shrink! _secret210109_ _count210111_)
            '#!void)
        _secret210109_))))
