(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/crypto/digest#digest::t
    (make-struct-type
     'std/crypto#digest::t
     '#f
     '2
     'digest
     '()
     ':init!
     '(type ctx)))
  (define std/crypto/digest#digest?
    (make-struct-predicate std/crypto/digest#digest::t))
  (define std/crypto/digest#make-digest
    (lambda _$args174543_
      (apply make-struct-instance std/crypto/digest#digest::t _$args174543_)))
  (define std/crypto/digest#digest-type
    (make-struct-field-accessor std/crypto/digest#digest::t '0))
  (define std/crypto/digest#digest-ctx
    (make-struct-field-accessor std/crypto/digest#digest::t '1))
  (define std/crypto/digest#digest-type-set!
    (make-struct-field-mutator std/crypto/digest#digest::t '0))
  (define std/crypto/digest#digest-ctx-set!
    (make-struct-field-mutator std/crypto/digest#digest::t '1))
  (define std/crypto/digest#digest:::init!
    (lambda (_self174535_ _type174536_)
      (if (std/crypto/libcrypto#EVP_MD? _type174536_)
          '#!void
          (error '"Invalid digest type" _type174536_))
      (let ((_ctx174538_ (std/crypto/libcrypto#EVP_MD_CTX_create)))
        (if _ctx174538_ '#!void (error '"Failed to allocate digest context"))
        (let ((_res174540_
               (std/crypto/libcrypto#EVP_DigestInit _ctx174538_ _type174536_)))
          (if (let () (declare (not safe)) (##fxzero? _res174540_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void))
        (if (let ((__tmp301422
                   (let ()
                     (declare (not safe))
                     (##vector-length _self174535_))))
              (declare (not safe))
              (##fx< '2 __tmp301422))
            (begin
              (let ()
                (declare (not safe))
                (##vector-set! _self174535_ '1 _type174536_))
              (let ()
                (declare (not safe))
                (##vector-set! _self174535_ '2 _ctx174538_)))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self174535_)))))
  (bind-method!
   std/crypto/digest#digest::t
   ':init!
   std/crypto/digest#digest:::init!
   '#f)
  (define std/crypto/digest#digest-size
    (lambda (_digest174411_)
      (if (std/crypto/libcrypto#EVP_MD? _digest174411_)
          (std/crypto/libcrypto#EVP_MD_size _digest174411_)
          (std/crypto/libcrypto#EVP_MD_size
           (##structure-ref
            _digest174411_
            '1
            std/crypto/digest#digest::t
            '#f)))))
  (define std/crypto/digest#digest-name
    (lambda (_digest174409_)
      (if (std/crypto/libcrypto#EVP_MD? _digest174409_)
          (std/crypto/libcrypto#EVP_MD_name _digest174409_)
          (std/crypto/libcrypto#EVP_MD_name
           (##structure-ref
            _digest174409_
            '1
            std/crypto/digest#digest::t
            '#f)))))
  (define std/crypto/digest#digest-copy
    (lambda (_digest174399_)
      (let* ((_ctx174401_ (std/crypto/digest#digest-context _digest174399_))
             (_copy174403_
              (let ((__obj301404 (make-object std/crypto/digest#digest::t '2)))
                (std/crypto/digest#digest:::init!
                 __obj301404
                 (##structure-ref
                  _digest174399_
                  '1
                  std/crypto/digest#digest::t
                  '#f))
                __obj301404)))
        (let ((_res174406_
               (std/crypto/libcrypto#EVP_MD_CTX_copy
                (##structure-ref
                 _copy174403_
                 '2
                 std/crypto/digest#digest::t
                 '#f)
                _ctx174401_)))
          (if (let () (declare (not safe)) (##fxzero? _res174406_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void))
        _copy174403_)))
  (define std/crypto/digest#digest-context
    (lambda (_digest174394_)
      (let ((_$e174396_
             (##structure-ref
              _digest174394_
              '2
              std/crypto/digest#digest::t
              '#f)))
        (if _$e174396_
            _$e174396_
            (error '"Digest has been finalized" _digest174394_)))))
  (define std/crypto/digest#digest-update!__%
    (lambda (_digest174354_ _bytes174355_ _start174356_ _end174357_)
      (let* ((_start174362_
              (let ((_$e174359_ _start174356_)) (if _$e174359_ _$e174359_ '0)))
             (_end174367_
              (let ((_$e174364_ _end174357_))
                (if _$e174364_ _$e174364_ (u8vector-length _bytes174355_)))))
        (let ((_res174370_
               (std/crypto/libcrypto#EVP_DigestUpdate
                (std/crypto/digest#digest-context _digest174354_)
                _bytes174355_
                _start174362_
                _end174367_)))
          (if (let () (declare (not safe)) (##fxzero? _res174370_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void)))))
  (define std/crypto/digest#digest-update!__0
    (lambda (_digest174376_ _bytes174377_)
      (let* ((_start174379_ '#f) (_end174381_ '#f))
        (std/crypto/digest#digest-update!__%
         _digest174376_
         _bytes174377_
         _start174379_
         _end174381_))))
  (define std/crypto/digest#digest-update!__1
    (lambda (_digest174383_ _bytes174384_ _start174385_)
      (let ((_end174387_ '#f))
        (std/crypto/digest#digest-update!__%
         _digest174383_
         _bytes174384_
         _start174385_
         _end174387_))))
  (define std/crypto/digest#digest-update!
    (lambda _g301424_
      (let ((_g301423_ (let () (declare (not safe)) (##length _g301424_))))
        (cond ((let () (declare (not safe)) (##fx= _g301423_ 2))
               (apply std/crypto/digest#digest-update!__0 _g301424_))
              ((let () (declare (not safe)) (##fx= _g301423_ 3))
               (apply std/crypto/digest#digest-update!__1 _g301424_))
              ((let () (declare (not safe)) (##fx= _g301423_ 4))
               (apply std/crypto/digest#digest-update!__% _g301424_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/digest#digest-update!
                _g301424_))))))
  (define std/crypto/digest#digest-update*
    (lambda (_digest174342_ _in174343_ . _args174344_)
      (apply std/crypto/etc#call-with-binary-input
             (lambda (_bytes174346_ _start174347_ _end174348_)
               (let ((_res174350_
                      (std/crypto/libcrypto#EVP_DigestUpdate
                       (std/crypto/digest#digest-context _digest174342_)
                       _bytes174346_
                       _start174347_
                       _end174348_)))
                 (if (let () (declare (not safe)) (##fxzero? _res174350_))
                     (apply std/crypto/etc#raise-libcrypto-error '())
                     '#!void)))
             _in174343_
             _args174344_)))
  (define std/crypto/digest#digest-final!__%
    (lambda (_digest174316_ _bytes174317_)
      (let* ((_ctx174319_ (std/crypto/digest#digest-context _digest174316_))
             (_size174321_ (std/crypto/libcrypto#EVP_MD_CTX_size _ctx174319_))
             (_bytes174326_
              (let ((_$e174323_ _bytes174317_))
                (if _$e174323_ _$e174323_ (make-u8vector _size174321_)))))
        (let ((_res174329_
               (std/crypto/libcrypto#EVP_DigestFinal
                _ctx174319_
                _bytes174326_)))
          (if (let () (declare (not safe)) (##fxzero? _res174329_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void))
        (##structure-set!
         _digest174316_
         '#f
         '2
         std/crypto/digest#digest::t
         '#f)
        _bytes174326_)))
  (define std/crypto/digest#digest-final!__0
    (lambda (_digest174335_)
      (let ((_bytes174337_ '#f))
        (std/crypto/digest#digest-final!__% _digest174335_ _bytes174337_))))
  (define std/crypto/digest#digest-final!
    (lambda _g301426_
      (let ((_g301425_ (let () (declare (not safe)) (##length _g301426_))))
        (cond ((let () (declare (not safe)) (##fx= _g301425_ 1))
               (apply std/crypto/digest#digest-final!__0 _g301426_))
              ((let () (declare (not safe)) (##fx= _g301425_ 2))
               (apply std/crypto/digest#digest-final!__% _g301426_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/digest#digest-final!
                _g301426_))))))
  (define std/crypto/digest#digest::md5 (std/crypto/libcrypto#EVP_md5))
  (define std/crypto/digest#make-md5-digest
    (if std/crypto/digest#digest::md5
        (lambda ()
          (let ((__obj301405 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301405
             std/crypto/digest#digest::md5)
            __obj301405))
        '#f))
  (define std/crypto/digest#md5-digest?
    (if std/crypto/digest#digest::md5
        (lambda (_obj174311_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174311_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174311_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::md5))
              '#f))
        '#f))
  (define std/crypto/digest#md5
    (if std/crypto/digest#digest::md5
        (lambda _args174305_
          (let ((_digest174308_ (std/crypto/digest#make-md5-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174308_
                   _args174305_)
            (std/crypto/digest#digest-final!__0 _digest174308_)))
        '#f))
  (define std/crypto/digest#digest::sha1 (std/crypto/libcrypto#EVP_sha1))
  (define std/crypto/digest#make-sha1-digest
    (if std/crypto/digest#digest::sha1
        (lambda ()
          (let ((__obj301406 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301406
             std/crypto/digest#digest::sha1)
            __obj301406))
        '#f))
  (define std/crypto/digest#sha1-digest?
    (if std/crypto/digest#digest::sha1
        (lambda (_obj174301_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174301_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174301_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha1))
              '#f))
        '#f))
  (define std/crypto/digest#sha1
    (if std/crypto/digest#digest::sha1
        (lambda _args174295_
          (let ((_digest174298_ (std/crypto/digest#make-sha1-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174298_
                   _args174295_)
            (std/crypto/digest#digest-final!__0 _digest174298_)))
        '#f))
  (define std/crypto/digest#digest::sha224 (std/crypto/libcrypto#EVP_sha224))
  (define std/crypto/digest#make-sha224-digest
    (if std/crypto/digest#digest::sha224
        (lambda ()
          (let ((__obj301407 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301407
             std/crypto/digest#digest::sha224)
            __obj301407))
        '#f))
  (define std/crypto/digest#sha224-digest?
    (if std/crypto/digest#digest::sha224
        (lambda (_obj174291_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174291_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174291_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha224))
              '#f))
        '#f))
  (define std/crypto/digest#sha224
    (if std/crypto/digest#digest::sha224
        (lambda _args174285_
          (let ((_digest174288_ (std/crypto/digest#make-sha224-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174288_
                   _args174285_)
            (std/crypto/digest#digest-final!__0 _digest174288_)))
        '#f))
  (define std/crypto/digest#digest::sha256 (std/crypto/libcrypto#EVP_sha256))
  (define std/crypto/digest#make-sha256-digest
    (if std/crypto/digest#digest::sha256
        (lambda ()
          (let ((__obj301408 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301408
             std/crypto/digest#digest::sha256)
            __obj301408))
        '#f))
  (define std/crypto/digest#sha256-digest?
    (if std/crypto/digest#digest::sha256
        (lambda (_obj174281_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174281_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174281_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha256))
              '#f))
        '#f))
  (define std/crypto/digest#sha256
    (if std/crypto/digest#digest::sha256
        (lambda _args174275_
          (let ((_digest174278_ (std/crypto/digest#make-sha256-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174278_
                   _args174275_)
            (std/crypto/digest#digest-final!__0 _digest174278_)))
        '#f))
  (define std/crypto/digest#digest::sha384 (std/crypto/libcrypto#EVP_sha384))
  (define std/crypto/digest#make-sha384-digest
    (if std/crypto/digest#digest::sha384
        (lambda ()
          (let ((__obj301409 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301409
             std/crypto/digest#digest::sha384)
            __obj301409))
        '#f))
  (define std/crypto/digest#sha384-digest?
    (if std/crypto/digest#digest::sha384
        (lambda (_obj174271_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174271_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174271_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha384))
              '#f))
        '#f))
  (define std/crypto/digest#sha384
    (if std/crypto/digest#digest::sha384
        (lambda _args174265_
          (let ((_digest174268_ (std/crypto/digest#make-sha384-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174268_
                   _args174265_)
            (std/crypto/digest#digest-final!__0 _digest174268_)))
        '#f))
  (define std/crypto/digest#digest::sha512 (std/crypto/libcrypto#EVP_sha512))
  (define std/crypto/digest#make-sha512-digest
    (if std/crypto/digest#digest::sha512
        (lambda ()
          (let ((__obj301410 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301410
             std/crypto/digest#digest::sha512)
            __obj301410))
        '#f))
  (define std/crypto/digest#sha512-digest?
    (if std/crypto/digest#digest::sha512
        (lambda (_obj174261_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174261_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174261_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha512))
              '#f))
        '#f))
  (define std/crypto/digest#sha512
    (if std/crypto/digest#digest::sha512
        (lambda _args174255_
          (let ((_digest174258_ (std/crypto/digest#make-sha512-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174258_
                   _args174255_)
            (std/crypto/digest#digest-final!__0 _digest174258_)))
        '#f))
  (define std/crypto/digest#digest::ripemd160
    (std/crypto/libcrypto#EVP_ripemd160))
  (define std/crypto/digest#make-ripemd160-digest
    (if std/crypto/digest#digest::ripemd160
        (lambda ()
          (let ((__obj301411 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301411
             std/crypto/digest#digest::ripemd160)
            __obj301411))
        '#f))
  (define std/crypto/digest#ripemd160-digest?
    (if std/crypto/digest#digest::ripemd160
        (lambda (_obj174251_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174251_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174251_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::ripemd160))
              '#f))
        '#f))
  (define std/crypto/digest#ripemd160
    (if std/crypto/digest#digest::ripemd160
        (lambda _args174245_
          (let ((_digest174248_ (std/crypto/digest#make-ripemd160-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174248_
                   _args174245_)
            (std/crypto/digest#digest-final!__0 _digest174248_)))
        '#f))
  (define std/crypto/digest#digest::whirlpool
    (std/crypto/libcrypto#EVP_whirlpool))
  (define std/crypto/digest#make-whirlpool-digest
    (if std/crypto/digest#digest::whirlpool
        (lambda ()
          (let ((__obj301412 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301412
             std/crypto/digest#digest::whirlpool)
            __obj301412))
        '#f))
  (define std/crypto/digest#whirlpool-digest?
    (if std/crypto/digest#digest::whirlpool
        (lambda (_obj174241_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174241_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174241_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::whirlpool))
              '#f))
        '#f))
  (define std/crypto/digest#whirlpool
    (if std/crypto/digest#digest::whirlpool
        (lambda _args174235_
          (let ((_digest174238_ (std/crypto/digest#make-whirlpool-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174238_
                   _args174235_)
            (std/crypto/digest#digest-final!__0 _digest174238_)))
        '#f))
  (define std/crypto/digest#digest::blake2s256
    (std/crypto/libcrypto#EVP_blake2s256))
  (define std/crypto/digest#make-blake2s256-digest
    (if std/crypto/digest#digest::blake2s256
        (lambda ()
          (let ((__obj301413 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301413
             std/crypto/digest#digest::blake2s256)
            __obj301413))
        '#f))
  (define std/crypto/digest#blake2s256-digest?
    (if std/crypto/digest#digest::blake2s256
        (lambda (_obj174231_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174231_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174231_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::blake2s256))
              '#f))
        '#f))
  (define std/crypto/digest#blake2s256
    (if std/crypto/digest#digest::blake2s256
        (lambda _args174225_
          (let ((_digest174228_ (std/crypto/digest#make-blake2s256-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174228_
                   _args174225_)
            (std/crypto/digest#digest-final!__0 _digest174228_)))
        '#f))
  (define std/crypto/digest#digest::blake2b512
    (std/crypto/libcrypto#EVP_blake2b512))
  (define std/crypto/digest#make-blake2b512-digest
    (if std/crypto/digest#digest::blake2b512
        (lambda ()
          (let ((__obj301414 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301414
             std/crypto/digest#digest::blake2b512)
            __obj301414))
        '#f))
  (define std/crypto/digest#blake2b512-digest?
    (if std/crypto/digest#digest::blake2b512
        (lambda (_obj174221_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174221_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174221_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::blake2b512))
              '#f))
        '#f))
  (define std/crypto/digest#blake2b512
    (if std/crypto/digest#digest::blake2b512
        (lambda _args174215_
          (let ((_digest174218_ (std/crypto/digest#make-blake2b512-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174218_
                   _args174215_)
            (std/crypto/digest#digest-final!__0 _digest174218_)))
        '#f))
  (define std/crypto/digest#digest::sha3_224
    (std/crypto/libcrypto#EVP_sha3_224))
  (define std/crypto/digest#make-sha3_224-digest
    (if std/crypto/digest#digest::sha3_224
        (lambda ()
          (let ((__obj301415 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301415
             std/crypto/digest#digest::sha3_224)
            __obj301415))
        '#f))
  (define std/crypto/digest#sha3_224-digest?
    (if std/crypto/digest#digest::sha3_224
        (lambda (_obj174211_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174211_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174211_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha3_224))
              '#f))
        '#f))
  (define std/crypto/digest#sha3_224
    (if std/crypto/digest#digest::sha3_224
        (lambda _args174205_
          (let ((_digest174208_ (std/crypto/digest#make-sha3_224-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174208_
                   _args174205_)
            (std/crypto/digest#digest-final!__0 _digest174208_)))
        '#f))
  (define std/crypto/digest#digest::sha3_256
    (std/crypto/libcrypto#EVP_sha3_256))
  (define std/crypto/digest#make-sha3_256-digest
    (if std/crypto/digest#digest::sha3_256
        (lambda ()
          (let ((__obj301416 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301416
             std/crypto/digest#digest::sha3_256)
            __obj301416))
        '#f))
  (define std/crypto/digest#sha3_256-digest?
    (if std/crypto/digest#digest::sha3_256
        (lambda (_obj174201_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174201_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174201_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha3_256))
              '#f))
        '#f))
  (define std/crypto/digest#sha3_256
    (if std/crypto/digest#digest::sha3_256
        (lambda _args174195_
          (let ((_digest174198_ (std/crypto/digest#make-sha3_256-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174198_
                   _args174195_)
            (std/crypto/digest#digest-final!__0 _digest174198_)))
        '#f))
  (define std/crypto/digest#digest::sha3_384
    (std/crypto/libcrypto#EVP_sha3_384))
  (define std/crypto/digest#make-sha3_384-digest
    (if std/crypto/digest#digest::sha3_384
        (lambda ()
          (let ((__obj301417 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301417
             std/crypto/digest#digest::sha3_384)
            __obj301417))
        '#f))
  (define std/crypto/digest#sha3_384-digest?
    (if std/crypto/digest#digest::sha3_384
        (lambda (_obj174191_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174191_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174191_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha3_384))
              '#f))
        '#f))
  (define std/crypto/digest#sha3_384
    (if std/crypto/digest#digest::sha3_384
        (lambda _args174185_
          (let ((_digest174188_ (std/crypto/digest#make-sha3_384-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174188_
                   _args174185_)
            (std/crypto/digest#digest-final!__0 _digest174188_)))
        '#f))
  (define std/crypto/digest#digest::sha3_512
    (std/crypto/libcrypto#EVP_sha3_512))
  (define std/crypto/digest#make-sha3_512-digest
    (if std/crypto/digest#digest::sha3_512
        (lambda ()
          (let ((__obj301418 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301418
             std/crypto/digest#digest::sha3_512)
            __obj301418))
        '#f))
  (define std/crypto/digest#sha3_512-digest?
    (if std/crypto/digest#digest::sha3_512
        (lambda (_obj174181_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174181_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174181_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::sha3_512))
              '#f))
        '#f))
  (define std/crypto/digest#sha3_512
    (if std/crypto/digest#digest::sha3_512
        (lambda _args174175_
          (let ((_digest174178_ (std/crypto/digest#make-sha3_512-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174178_
                   _args174175_)
            (std/crypto/digest#digest-final!__0 _digest174178_)))
        '#f))
  (define std/crypto/digest#digest::shake128
    (std/crypto/libcrypto#EVP_shake128))
  (define std/crypto/digest#make-shake128-digest
    (if std/crypto/digest#digest::shake128
        (lambda ()
          (let ((__obj301419 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301419
             std/crypto/digest#digest::shake128)
            __obj301419))
        '#f))
  (define std/crypto/digest#shake128-digest?
    (if std/crypto/digest#digest::shake128
        (lambda (_obj174171_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174171_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174171_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::shake128))
              '#f))
        '#f))
  (define std/crypto/digest#shake128
    (if std/crypto/digest#digest::shake128
        (lambda _args174165_
          (let ((_digest174168_ (std/crypto/digest#make-shake128-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174168_
                   _args174165_)
            (std/crypto/digest#digest-final!__0 _digest174168_)))
        '#f))
  (define std/crypto/digest#digest::shake256
    (std/crypto/libcrypto#EVP_shake256))
  (define std/crypto/digest#make-shake256-digest
    (if std/crypto/digest#digest::shake256
        (lambda ()
          (let ((__obj301420 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301420
             std/crypto/digest#digest::shake256)
            __obj301420))
        '#f))
  (define std/crypto/digest#shake256-digest?
    (if std/crypto/digest#digest::shake256
        (lambda (_obj174161_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174161_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174161_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::shake256))
              '#f))
        '#f))
  (define std/crypto/digest#shake256
    (if std/crypto/digest#digest::shake256
        (lambda _args174155_
          (let ((_digest174158_ (std/crypto/digest#make-shake256-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174158_
                   _args174155_)
            (std/crypto/digest#digest-final!__0 _digest174158_)))
        '#f))
  (define std/crypto/digest#digest::keccak256
    (std/crypto/libcrypto#EVP_keccak256))
  (define std/crypto/digest#make-keccak256-digest
    (if std/crypto/digest#digest::keccak256
        (lambda ()
          (let ((__obj301421 (make-object std/crypto/digest#digest::t '2)))
            (std/crypto/digest#digest:::init!
             __obj301421
             std/crypto/digest#digest::keccak256)
            __obj301421))
        '#f))
  (define std/crypto/digest#keccak256-digest?
    (if std/crypto/digest#digest::keccak256
        (lambda (_obj174151_)
          (if (let ()
                (declare (not safe))
                (##structure-instance-of? _obj174151_ 'std/crypto#digest::t))
              (eq? (std/crypto/libcrypto#EVP_MD_type
                    (##structure-ref
                     _obj174151_
                     '1
                     std/crypto/digest#digest::t
                     '#f))
                   (std/crypto/libcrypto#EVP_MD_type
                    std/crypto/digest#digest::keccak256))
              '#f))
        '#f))
  (define std/crypto/digest#keccak256
    (if std/crypto/digest#digest::keccak256
        (lambda _args174145_
          (let ((_digest174148_ (std/crypto/digest#make-keccak256-digest)))
            (apply std/crypto/digest#digest-update*
                   _digest174148_
                   _args174145_)
            (std/crypto/digest#digest-final!__0 _digest174148_)))
        '#f)))
