(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/crypto/hmac#hmac::t
    (make-struct-type 'std/crypto#hmac::t '#f '2 'hmac '() ':init! '(md ctx)))
  (define std/crypto/hmac#hmac?
    (make-struct-predicate std/crypto/hmac#hmac::t))
  (define std/crypto/hmac#make-hmac
    (lambda _$args210101_
      (apply make-struct-instance std/crypto/hmac#hmac::t _$args210101_)))
  (define std/crypto/hmac#hmac-md
    (make-struct-field-accessor std/crypto/hmac#hmac::t '0))
  (define std/crypto/hmac#hmac-ctx
    (make-struct-field-accessor std/crypto/hmac#hmac::t '1))
  (define std/crypto/hmac#hmac-md-set!
    (make-struct-field-mutator std/crypto/hmac#hmac::t '0))
  (define std/crypto/hmac#hmac-ctx-set!
    (make-struct-field-mutator std/crypto/hmac#hmac::t '1))
  (define std/crypto/hmac#hmac:::init!
    (lambda (_self210096_ _md210097_)
      (if (std/crypto/libcrypto#EVP_MD? _md210097_)
          '#!void
          (error '"Invalid digest type" _md210097_))
      (let ((_ctx210099_ (std/crypto/libcrypto#HMAC_CTX_create)))
        (if _ctx210099_ '#!void (error '"Failed to allocate hmac context"))
        (if (let ((__tmp301597
                   (let ()
                     (declare (not safe))
                     (##vector-length _self210096_))))
              (declare (not safe))
              (##fx< '2 __tmp301597))
            (begin
              (let ()
                (declare (not safe))
                (##vector-set! _self210096_ '1 _md210097_))
              (let ()
                (declare (not safe))
                (##vector-set! _self210096_ '2 _ctx210099_)))
            (error '"struct-instance-init!: too many arguments for struct"
                   _self210096_)))))
  (bind-method!
   std/crypto/hmac#hmac::t
   ':init!
   std/crypto/hmac#hmac:::init!
   '#f)
  (define std/crypto/hmac#hmac-init!
    (lambda (_hmac209968_ _key209969_)
      (let ((_res209971_
             (std/crypto/libcrypto#HMAC_Init
              (##structure-ref _hmac209968_ '2 std/crypto/hmac#hmac::t '#f)
              _key209969_
              (##structure-ref _hmac209968_ '1 std/crypto/hmac#hmac::t '#f))))
        (if (let () (declare (not safe)) (##fxzero? _res209971_))
            (apply std/crypto/etc#raise-libcrypto-error '())
            '#!void))))
  (define std/crypto/hmac#hmac-update!__%
    (lambda (_hmac209928_ _bytes209929_ _start209930_ _end209931_)
      (let* ((_start209936_
              (let ((_$e209933_ _start209930_)) (if _$e209933_ _$e209933_ '0)))
             (_end209941_
              (let ((_$e209938_ _end209931_))
                (if _$e209938_ _$e209938_ (u8vector-length _bytes209929_)))))
        (let ((_res209944_
               (std/crypto/libcrypto#HMAC_Update
                (##structure-ref _hmac209928_ '2 std/crypto/hmac#hmac::t '#f)
                _bytes209929_
                _start209936_
                _end209941_)))
          (if (let () (declare (not safe)) (##fxzero? _res209944_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void)))))
  (define std/crypto/hmac#hmac-update!__0
    (lambda (_hmac209950_ _bytes209951_)
      (let* ((_start209953_ '#f) (_end209955_ '#f))
        (std/crypto/hmac#hmac-update!__%
         _hmac209950_
         _bytes209951_
         _start209953_
         _end209955_))))
  (define std/crypto/hmac#hmac-update!__1
    (lambda (_hmac209957_ _bytes209958_ _start209959_)
      (let ((_end209961_ '#f))
        (std/crypto/hmac#hmac-update!__%
         _hmac209957_
         _bytes209958_
         _start209959_
         _end209961_))))
  (define std/crypto/hmac#hmac-update!
    (lambda _g301599_
      (let ((_g301598_ (let () (declare (not safe)) (##length _g301599_))))
        (cond ((let () (declare (not safe)) (##fx= _g301598_ 2))
               (apply std/crypto/hmac#hmac-update!__0 _g301599_))
              ((let () (declare (not safe)) (##fx= _g301598_ 3))
               (apply std/crypto/hmac#hmac-update!__1 _g301599_))
              ((let () (declare (not safe)) (##fx= _g301598_ 4))
               (apply std/crypto/hmac#hmac-update!__% _g301599_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-update!
                _g301599_))))))
  (define std/crypto/hmac#hmac-final!__%
    (lambda (_hmac209903_ _bytes209904_)
      (let* ((_size209906_
              (std/crypto/libcrypto#EVP_MD_size
               (##structure-ref _hmac209903_ '1 std/crypto/hmac#hmac::t '#f)))
             (_bytes209911_
              (let ((_$e209908_ _bytes209904_))
                (if _$e209908_ _$e209908_ (make-u8vector _size209906_)))))
        (let ((_res209914_
               (std/crypto/libcrypto#HMAC_Final
                (##structure-ref _hmac209903_ '2 std/crypto/hmac#hmac::t '#f)
                _bytes209911_)))
          (if (let () (declare (not safe)) (##fxzero? _res209914_))
              (apply std/crypto/etc#raise-libcrypto-error '())
              '#!void))
        _bytes209911_)))
  (define std/crypto/hmac#hmac-final!__0
    (lambda (_hmac209920_)
      (let ((_bytes209922_ '#f))
        (std/crypto/hmac#hmac-final!__% _hmac209920_ _bytes209922_))))
  (define std/crypto/hmac#hmac-final!
    (lambda _g301601_
      (let ((_g301600_ (let () (declare (not safe)) (##length _g301601_))))
        (cond ((let () (declare (not safe)) (##fx= _g301600_ 1))
               (apply std/crypto/hmac#hmac-final!__0 _g301601_))
              ((let () (declare (not safe)) (##fx= _g301600_ 2))
               (apply std/crypto/hmac#hmac-final!__% _g301601_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-final!
                _g301601_))))))
  (define std/crypto/hmac#hmac-digest__%
    (lambda (_md209857_ _key209858_ _bytes209859_ _start209860_ _end209861_)
      (if (std/crypto/libcrypto#EVP_MD? _md209857_)
          '#!void
          (error '"Bad digest type" _md209857_))
      (let* ((_start209866_
              (let ((_$e209863_ _start209860_)) (if _$e209863_ _$e209863_ '0)))
             (_end209871_
              (let ((_$e209868_ _end209861_))
                (if _$e209868_ _$e209868_ (u8vector-length _bytes209859_))))
             (_size209873_ (std/crypto/libcrypto#EVP_MD_size _md209857_))
             (_digest209875_ (make-u8vector _size209873_)))
        (std/crypto/libcrypto#HMAC
         _md209857_
         _key209858_
         _bytes209859_
         _start209866_
         _end209871_
         _digest209875_)
        _digest209875_)))
  (define std/crypto/hmac#hmac-digest__0
    (lambda (_md209881_ _key209882_ _bytes209883_)
      (let* ((_start209885_ '#f) (_end209887_ '#f))
        (std/crypto/hmac#hmac-digest__%
         _md209881_
         _key209882_
         _bytes209883_
         _start209885_
         _end209887_))))
  (define std/crypto/hmac#hmac-digest__1
    (lambda (_md209889_ _key209890_ _bytes209891_ _start209892_)
      (let ((_end209894_ '#f))
        (std/crypto/hmac#hmac-digest__%
         _md209889_
         _key209890_
         _bytes209891_
         _start209892_
         _end209894_))))
  (define std/crypto/hmac#hmac-digest
    (lambda _g301603_
      (let ((_g301602_ (let () (declare (not safe)) (##length _g301603_))))
        (cond ((let () (declare (not safe)) (##fx= _g301602_ 3))
               (apply std/crypto/hmac#hmac-digest__0 _g301603_))
              ((let () (declare (not safe)) (##fx= _g301602_ 4))
               (apply std/crypto/hmac#hmac-digest__1 _g301603_))
              ((let () (declare (not safe)) (##fx= _g301602_ 5))
               (apply std/crypto/hmac#hmac-digest__% _g301603_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-digest
                _g301603_))))))
  (define std/crypto/hmac#hmac-md5__%
    (lambda (_key209826_ _bytes209828_ _start209830_ _end209832_)
      (std/crypto/hmac#hmac-digest__%
       std/crypto/digest#digest::md5
       _key209826_
       _bytes209828_
       _start209830_
       _end209832_)))
  (define std/crypto/hmac#hmac-md5__0
    (lambda (_key209838_ _bytes209839_)
      (let* ((_start209841_ '#f) (_end209843_ '#f))
        (std/crypto/hmac#hmac-md5__%
         _key209838_
         _bytes209839_
         _start209841_
         _end209843_))))
  (define std/crypto/hmac#hmac-md5__1
    (lambda (_key209845_ _bytes209846_ _start209847_)
      (let ((_end209849_ '#f))
        (std/crypto/hmac#hmac-md5__%
         _key209845_
         _bytes209846_
         _start209847_
         _end209849_))))
  (define std/crypto/hmac#hmac-md5
    (lambda _g301605_
      (let ((_g301604_ (let () (declare (not safe)) (##length _g301605_))))
        (cond ((let () (declare (not safe)) (##fx= _g301604_ 2))
               (apply std/crypto/hmac#hmac-md5__0 _g301605_))
              ((let () (declare (not safe)) (##fx= _g301604_ 3))
               (apply std/crypto/hmac#hmac-md5__1 _g301605_))
              ((let () (declare (not safe)) (##fx= _g301604_ 4))
               (apply std/crypto/hmac#hmac-md5__% _g301605_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-md5
                _g301605_))))))
  (define std/crypto/hmac#hmac-sha1__%
    (lambda (_key209795_ _bytes209797_ _start209799_ _end209801_)
      (std/crypto/hmac#hmac-digest__%
       std/crypto/digest#digest::sha1
       _key209795_
       _bytes209797_
       _start209799_
       _end209801_)))
  (define std/crypto/hmac#hmac-sha1__0
    (lambda (_key209807_ _bytes209808_)
      (let* ((_start209810_ '#f) (_end209812_ '#f))
        (std/crypto/hmac#hmac-sha1__%
         _key209807_
         _bytes209808_
         _start209810_
         _end209812_))))
  (define std/crypto/hmac#hmac-sha1__1
    (lambda (_key209814_ _bytes209815_ _start209816_)
      (let ((_end209818_ '#f))
        (std/crypto/hmac#hmac-sha1__%
         _key209814_
         _bytes209815_
         _start209816_
         _end209818_))))
  (define std/crypto/hmac#hmac-sha1
    (lambda _g301607_
      (let ((_g301606_ (let () (declare (not safe)) (##length _g301607_))))
        (cond ((let () (declare (not safe)) (##fx= _g301606_ 2))
               (apply std/crypto/hmac#hmac-sha1__0 _g301607_))
              ((let () (declare (not safe)) (##fx= _g301606_ 3))
               (apply std/crypto/hmac#hmac-sha1__1 _g301607_))
              ((let () (declare (not safe)) (##fx= _g301606_ 4))
               (apply std/crypto/hmac#hmac-sha1__% _g301607_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-sha1
                _g301607_))))))
  (define std/crypto/hmac#hmac-sha256__%
    (lambda (_key209764_ _bytes209766_ _start209768_ _end209770_)
      (std/crypto/hmac#hmac-digest__%
       std/crypto/digest#digest::sha256
       _key209764_
       _bytes209766_
       _start209768_
       _end209770_)))
  (define std/crypto/hmac#hmac-sha256__0
    (lambda (_key209776_ _bytes209777_)
      (let* ((_start209779_ '#f) (_end209781_ '#f))
        (std/crypto/hmac#hmac-sha256__%
         _key209776_
         _bytes209777_
         _start209779_
         _end209781_))))
  (define std/crypto/hmac#hmac-sha256__1
    (lambda (_key209783_ _bytes209784_ _start209785_)
      (let ((_end209787_ '#f))
        (std/crypto/hmac#hmac-sha256__%
         _key209783_
         _bytes209784_
         _start209785_
         _end209787_))))
  (define std/crypto/hmac#hmac-sha256
    (lambda _g301609_
      (let ((_g301608_ (let () (declare (not safe)) (##length _g301609_))))
        (cond ((let () (declare (not safe)) (##fx= _g301608_ 2))
               (apply std/crypto/hmac#hmac-sha256__0 _g301609_))
              ((let () (declare (not safe)) (##fx= _g301608_ 3))
               (apply std/crypto/hmac#hmac-sha256__1 _g301609_))
              ((let () (declare (not safe)) (##fx= _g301608_ 4))
               (apply std/crypto/hmac#hmac-sha256__% _g301609_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-sha256
                _g301609_))))))
  (define std/crypto/hmac#hmac-sha384__%
    (lambda (_key209733_ _bytes209735_ _start209737_ _end209739_)
      (std/crypto/hmac#hmac-digest__%
       std/crypto/digest#digest::sha384
       _key209733_
       _bytes209735_
       _start209737_
       _end209739_)))
  (define std/crypto/hmac#hmac-sha384__0
    (lambda (_key209745_ _bytes209746_)
      (let* ((_start209748_ '#f) (_end209750_ '#f))
        (std/crypto/hmac#hmac-sha384__%
         _key209745_
         _bytes209746_
         _start209748_
         _end209750_))))
  (define std/crypto/hmac#hmac-sha384__1
    (lambda (_key209752_ _bytes209753_ _start209754_)
      (let ((_end209756_ '#f))
        (std/crypto/hmac#hmac-sha384__%
         _key209752_
         _bytes209753_
         _start209754_
         _end209756_))))
  (define std/crypto/hmac#hmac-sha384
    (lambda _g301611_
      (let ((_g301610_ (let () (declare (not safe)) (##length _g301611_))))
        (cond ((let () (declare (not safe)) (##fx= _g301610_ 2))
               (apply std/crypto/hmac#hmac-sha384__0 _g301611_))
              ((let () (declare (not safe)) (##fx= _g301610_ 3))
               (apply std/crypto/hmac#hmac-sha384__1 _g301611_))
              ((let () (declare (not safe)) (##fx= _g301610_ 4))
               (apply std/crypto/hmac#hmac-sha384__% _g301611_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-sha384
                _g301611_))))))
  (define std/crypto/hmac#hmac-sha512__%
    (lambda (_key209702_ _bytes209704_ _start209706_ _end209708_)
      (std/crypto/hmac#hmac-digest__%
       std/crypto/digest#digest::sha512
       _key209702_
       _bytes209704_
       _start209706_
       _end209708_)))
  (define std/crypto/hmac#hmac-sha512__0
    (lambda (_key209714_ _bytes209715_)
      (let* ((_start209717_ '#f) (_end209719_ '#f))
        (std/crypto/hmac#hmac-sha512__%
         _key209714_
         _bytes209715_
         _start209717_
         _end209719_))))
  (define std/crypto/hmac#hmac-sha512__1
    (lambda (_key209721_ _bytes209722_ _start209723_)
      (let ((_end209725_ '#f))
        (std/crypto/hmac#hmac-sha512__%
         _key209721_
         _bytes209722_
         _start209723_
         _end209725_))))
  (define std/crypto/hmac#hmac-sha512
    (lambda _g301613_
      (let ((_g301612_ (let () (declare (not safe)) (##length _g301613_))))
        (cond ((let () (declare (not safe)) (##fx= _g301612_ 2))
               (apply std/crypto/hmac#hmac-sha512__0 _g301613_))
              ((let () (declare (not safe)) (##fx= _g301612_ 3))
               (apply std/crypto/hmac#hmac-sha512__1 _g301613_))
              ((let () (declare (not safe)) (##fx= _g301612_ 4))
               (apply std/crypto/hmac#hmac-sha512__% _g301613_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/hmac#hmac-sha512
                _g301613_)))))))
