(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/crypto/pkey#keygen/ed25519
    (lambda ()
      (letrec* ((_ctx210331_
                 (std/crypto/libcrypto#EVP_PKEY_CTX_new_id
                  std/crypto/libcrypto#EVP_PKEY_ED25519
                  '#f)))
        (if (and _ctx210331_
                 (< '0
                    (std/crypto/libcrypto#EVP_PKEY_keygen_init _ctx210331_)))
            '#!void
            (error '"Can't create ED25519 keygen context"))
        (std/crypto/libcrypto#EVP_PKEY_keygen _ctx210331_))))
  (define std/crypto/pkey#bytes->private-key__%
    (lambda (_g301624_ _engine210306210309_ _type210311_ _bytes210312_)
      (let ((_engine210314_
             (if (eq? _engine210306210309_ absent-value)
                 '#f
                 _engine210306210309_)))
        (std/crypto/libcrypto#EVP_PKEY_new_raw_private_key
         _type210311_
         _engine210314_
         _bytes210312_))))
  (define std/crypto/pkey#bytes->private-key__@
    (lambda (_keys210305210319_ . _args210321_)
      (apply std/crypto/pkey#bytes->private-key__%
             _keys210305210319_
             (table-ref _keys210305210319_ 'engine: absent-value)
             _args210321_)))
  (define std/crypto/pkey#bytes->private-key
    (lambda _args210307210327_
      (apply keyword-dispatch
             '#(engine:)
             std/crypto/pkey#bytes->private-key__@
             _args210307210327_)))
  (define std/crypto/pkey#bytes->public-key__%
    (lambda (_g301625_ _engine210280210283_ _type210285_ _bytes210286_)
      (let ((_engine210288_
             (if (eq? _engine210280210283_ absent-value)
                 '#f
                 _engine210280210283_)))
        (std/crypto/libcrypto#EVP_PKEY_new_raw_public_key
         _type210285_
         _engine210288_
         _bytes210286_))))
  (define std/crypto/pkey#bytes->public-key__@
    (lambda (_keys210279210293_ . _args210295_)
      (apply std/crypto/pkey#bytes->public-key__%
             _keys210279210293_
             (table-ref _keys210279210293_ 'engine: absent-value)
             _args210295_)))
  (define std/crypto/pkey#bytes->public-key
    (lambda _args210281210301_
      (apply keyword-dispatch
             '#(engine:)
             std/crypto/pkey#bytes->public-key__@
             _args210281210301_)))
  (define std/crypto/pkey#bytes-argument
    (lambda (_bytes210276_)
      (if (u8vector? _bytes210276_)
          _bytes210276_
          (if (fixnum? _bytes210276_)
              (make-u8vector _bytes210276_)
              (if (not _bytes210276_)
                  '#f
                  (error '"invalid bytes argument" _bytes210276_))))))
  (define std/crypto/pkey#bytes-result
    (lambda (_bytes210273_ _len210274_)
      (if (zero? _len210274_)
          '#f
          (if (= _len210274_ (u8vector-length _bytes210273_))
              _bytes210273_
              (if (< _len210274_ (u8vector-length _bytes210273_))
                  (subu8vector _bytes210273_ '0 _len210274_)
                  '#f)))))
  (define std/crypto/pkey#key->bytes
    (lambda (_pkey210263_ _bytes210264_ _get_raw210265_)
      (letrec* ((_b210267_
                 (let ((_$e210270_
                        (std/crypto/pkey#bytes-argument _bytes210264_)))
                   (if _$e210270_
                       _$e210270_
                       (make-u8vector (_get_raw210265_ _pkey210263_ '#f)))))
                (_len210268_ (_get_raw210265_ _pkey210263_ _b210267_)))
        (std/crypto/pkey#bytes-result _b210267_ _len210268_))))
  (define std/crypto/pkey#private-key->bytes__%
    (lambda (_pkey210250_ _bytes210251_)
      (std/crypto/pkey#key->bytes
       _pkey210250_
       _bytes210251_
       std/crypto/libcrypto#EVP_PKEY_get_raw_private_key)))
  (define std/crypto/pkey#private-key->bytes__0
    (lambda (_pkey210256_)
      (let ((_bytes210258_ '#f))
        (std/crypto/pkey#private-key->bytes__% _pkey210256_ _bytes210258_))))
  (define std/crypto/pkey#private-key->bytes
    (lambda _g301627_
      (let ((_g301626_ (let () (declare (not safe)) (##length _g301627_))))
        (cond ((let () (declare (not safe)) (##fx= _g301626_ 1))
               (apply std/crypto/pkey#private-key->bytes__0 _g301627_))
              ((let () (declare (not safe)) (##fx= _g301626_ 2))
               (apply std/crypto/pkey#private-key->bytes__% _g301627_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/pkey#private-key->bytes
                _g301627_))))))
  (define std/crypto/pkey#public-key->bytes__%
    (lambda (_pkey210236_ _bytes210237_)
      (std/crypto/pkey#key->bytes
       _pkey210236_
       _bytes210237_
       std/crypto/libcrypto#EVP_PKEY_get_raw_public_key)))
  (define std/crypto/pkey#public-key->bytes__0
    (lambda (_pkey210242_)
      (let ((_bytes210244_ '#f))
        (std/crypto/pkey#public-key->bytes__% _pkey210242_ _bytes210244_))))
  (define std/crypto/pkey#public-key->bytes
    (lambda _g301629_
      (let ((_g301628_ (let () (declare (not safe)) (##length _g301629_))))
        (cond ((let () (declare (not safe)) (##fx= _g301628_ 1))
               (apply std/crypto/pkey#public-key->bytes__0 _g301629_))
              ((let () (declare (not safe)) (##fx= _g301628_ 2))
               (apply std/crypto/pkey#public-key->bytes__% _g301629_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/crypto/pkey#public-key->bytes
                _g301629_))))))
  (define std/crypto/pkey#digest-sign__%
    (lambda (_g301630_
             _engine210198210202_
             _sig210199210204_
             _pkey210206_
             _bytes210207_)
      (let* ((_engine210209_
              (if (eq? _engine210198210202_ absent-value)
                  '#f
                  _engine210198210202_))
             (_sig210211_
              (if (eq? _sig210199210204_ absent-value) '#f _sig210199210204_)))
        (letrec* ((_mctx210213_ (std/crypto/libcrypto#EVP_MD_CTX_create))
                  (_pctx210214_
                   (std/crypto/libcrypto#EVP_PKEY_CTX_new
                    _pkey210206_
                    _engine210209_))
                  (_g301631_
                   (let ((_g301632_
                          (if (and _mctx210213_ _pctx210214_)
                              (std/crypto/libcrypto#EVP_MD_CTX_set_pkey_ctx
                               _mctx210213_
                               _pctx210214_)
                              (error '"Can't create signing context"))))
                     #!void
                     _g301632_))
                  (_s210215_
                   (let ((_$e210218_
                          (std/crypto/pkey#bytes-argument _sig210211_)))
                     (if _$e210218_ _$e210218_ (make-u8vector '8192))))
                  (_len210216_
                   (std/crypto/libcrypto#EVP_DigestSign
                    _mctx210213_
                    _s210215_
                    _bytes210207_)))
          (std/crypto/pkey#bytes-result _s210215_ _len210216_)))))
  (define std/crypto/pkey#digest-sign__@
    (lambda (_keys210197210224_ . _args210226_)
      (apply std/crypto/pkey#digest-sign__%
             _keys210197210224_
             (table-ref _keys210197210224_ 'engine: absent-value)
             (table-ref _keys210197210224_ 'sig: absent-value)
             _args210226_)))
  (define std/crypto/pkey#digest-sign
    (lambda _args210200210232_
      (apply keyword-dispatch
             '#(sig: engine:)
             std/crypto/pkey#digest-sign__@
             _args210200210232_)))
  (define std/crypto/pkey#digest-verify__%
    (lambda (_g301634_
             _engine210168210171_
             _pkey210173_
             _sig210174_
             _bytes210175_)
      (let ((_engine210177_
             (if (eq? _engine210168210171_ absent-value)
                 '#f
                 _engine210168210171_)))
        (letrec* ((_mctx210179_ (std/crypto/libcrypto#EVP_MD_CTX_create))
                  (_pctx210180_
                   (std/crypto/libcrypto#EVP_PKEY_CTX_new
                    _pkey210173_
                    _engine210177_)))
          (if (and _mctx210179_ _pctx210180_)
              (std/crypto/libcrypto#EVP_MD_CTX_set_pkey_ctx
               _mctx210179_
               _pctx210180_)
              (error '"Can't create verification context"))
          (= '1
             (std/crypto/libcrypto#EVP_DigestVerify
              _mctx210179_
              _sig210174_
              _bytes210175_))))))
  (define std/crypto/pkey#digest-verify__@
    (lambda (_keys210167210185_ . _args210187_)
      (apply std/crypto/pkey#digest-verify__%
             _keys210167210185_
             (table-ref _keys210167210185_ 'engine: absent-value)
             _args210187_)))
  (define std/crypto/pkey#digest-verify
    (lambda _args210169210193_
      (apply keyword-dispatch
             '#(engine:)
             std/crypto/pkey#digest-verify__@
             _args210169210193_))))
