(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/misc/bytes#big 'big)
  (define std/misc/bytes#little 'little)
  (define std/misc/bytes#native 'native)
  (define std/misc/bytes#u8vector-s8-ref
    (lambda (_v166973_ _i166974_)
      (if (u8vector? _v166973_) '#!void (error '"Expected u8vector" _v166973_))
      (if (and (fixnum? _i166974_)
               (fx<= '0
                     _i166974_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166973_))
                          '1)))
          '#!void
          (error '"Bad index" _v166973_ _i166974_))
      (if (and (fixnum? '1)
               (fx<= '0
                     '1
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166973_))
                          _i166974_)))
          '#!void
          (error '"Bad integer size" _v166973_ _i166974_ '1))
      (std/misc/bytes#&u8vector-s8-ref _v166973_ _i166974_)))
  (define std/misc/bytes#&u8vector-s8-ref
    (lambda (_v166967_ _i166968_)
      (declare (not safe))
      (let ((_u8166971_ (u8vector-ref _v166967_ _i166968_)))
        (if (fx> _u8166971_ '127) (fx- _u8166971_ '256) _u8166971_))))
  (define std/misc/bytes#u8vector-s8-set!
    (lambda (_v166963_ _i166964_ _s8166965_)
      (if (u8vector? _v166963_) '#!void (error '"Expected u8vector" _v166963_))
      (if (and (fixnum? _i166964_)
               (fx<= '0
                     _i166964_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166963_))
                          '1)))
          '#!void
          (error '"Bad index" _v166963_ _i166964_))
      (if (and (fixnum? '1)
               (fx<= '0
                     '1
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166963_))
                          _i166964_)))
          '#!void
          (error '"Bad integer size" _v166963_ _i166964_ '1))
      (if (fixnum? _s8166965_) '#!void (error '"expected fixnum" _s8166965_))
      (std/misc/bytes#&u8vector-s8-set! _v166963_ _i166964_ _s8166965_)))
  (define std/misc/bytes#&u8vector-s8-set!
    (lambda (_v166956_ _i166957_ _s8166958_)
      (declare (not safe))
      (let ((_u8166961_
             (if (fx< _s8166958_ '0) (fx+ _s8166958_ '256) _s8166958_)))
        (u8vector-set! _v166956_ _i166957_ _u8166961_))))
  (define std/misc/bytes#u8vector-uint-ref
    (lambda (_v166948_ _k166949_ _endianness166950_ _size166951_)
      (if (u8vector? _v166948_) '#!void (error '"Expected u8vector" _v166948_))
      (if (and (fixnum? _k166949_)
               (fx<= '0
                     _k166949_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166948_))
                          '1)))
          '#!void
          (error '"Bad index" _v166948_ _k166949_))
      (if (and (fixnum? _size166951_)
               (fx<= '0
                     _size166951_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166948_))
                          _k166949_)))
          '#!void
          (error '"Bad integer size" _v166948_ _k166949_ _size166951_))
      (let ((_$e166953_ _endianness166950_))
        (if (eq? 'big _$e166953_)
            (std/misc/bytes#&u8vector-uint-ref/be
             _v166948_
             _k166949_
             _size166951_)
            (if (eq? 'little _$e166953_)
                (std/misc/bytes#&u8vector-uint-ref/le
                 _v166948_
                 _k166949_
                 _size166951_)
                (if (eq? 'native _$e166953_)
                    (if (eq? std/misc/bytes#native-endianness
                             std/misc/bytes#little)
                        (std/misc/bytes#&u8vector-uint-ref/le
                         _v166948_
                         _k166949_
                         _size166951_)
                        (std/misc/bytes#&u8vector-uint-ref/be
                         _v166948_
                         _k166949_
                         _size166951_))
                    (error '"Bad endianness" _endianness166950_)))))))
  (define std/misc/bytes#&u8vector-uint-ref/be
    (lambda (_v166934_ _k166935_ _size166936_)
      (declare (not safe))
      (let ((_k+size166939_ (fx+ _k166935_ _size166936_)))
        (let _lp166941_ ((_i166943_ _k166935_) (_r166944_ '0))
          (if (fx< _i166943_ _k+size166939_)
              (let ((_u8166946_ (u8vector-ref _v166934_ _i166943_)))
                (_lp166941_
                 (fx+ _i166943_ '1)
                 (bitwise-ior (arithmetic-shift _r166944_ '8) _u8166946_)))
              _r166944_)))))
  (define std/misc/bytes#&u8vector-uint-ref/le
    (lambda (_v166920_ _k166921_ _size166922_)
      (declare (not safe))
      (let ((_k+size-1166925_ (fx- (fx+ _k166921_ _size166922_) '1)))
        (let _lp166927_ ((_i166929_ _k+size-1166925_) (_r166930_ '0))
          (if (fx>= _i166929_ _k166921_)
              (let ((_u8166932_ (u8vector-ref _v166920_ _i166929_)))
                (_lp166927_
                 (fx- _i166929_ '1)
                 (bitwise-ior (arithmetic-shift _r166930_ '8) _u8166932_)))
              _r166930_)))))
  (define std/misc/bytes#u8vector-uint-set!
    (lambda (_v166911_ _k166912_ _uint166913_ _endianness166914_ _size166915_)
      (if (u8vector? _v166911_) '#!void (error '"Expected u8vector" _v166911_))
      (if (and (fixnum? _k166912_)
               (fx<= '0
                     _k166912_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166911_))
                          '1)))
          '#!void
          (error '"Bad index" _v166911_ _k166912_))
      (if (and (fixnum? _size166915_)
               (fx<= '0
                     _size166915_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166911_))
                          _k166912_)))
          '#!void
          (error '"Bad integer size" _v166911_ _k166912_ _size166915_))
      (let ((_$e166917_ _endianness166914_))
        (if (eq? 'big _$e166917_)
            (std/misc/bytes#&u8vector-uint-set!/be
             _v166911_
             _k166912_
             _uint166913_
             _size166915_)
            (if (eq? 'little _$e166917_)
                (std/misc/bytes#&u8vector-uint-set!/le
                 _v166911_
                 _k166912_
                 _uint166913_
                 _size166915_)
                (if (eq? 'native _$e166917_)
                    (if (eq? std/misc/bytes#native-endianness
                             std/misc/bytes#little)
                        (std/misc/bytes#&u8vector-uint-set!/le
                         _v166911_
                         _k166912_
                         _uint166913_
                         _size166915_)
                        (std/misc/bytes#&u8vector-uint-set!/be
                         _v166911_
                         _k166912_
                         _uint166913_
                         _size166915_))
                    (error '"Bad endianness" _endianness166914_)))))))
  (define std/misc/bytes#&u8vector-uint-set!/be
    (lambda (_v166896_ _k166897_ _uint166898_ _size166899_)
      (declare (not safe))
      (let ((_k+size-1166902_ (fx- (fx+ _k166897_ _size166899_) '1)))
        (let _lp166904_ ((_i166906_ _k+size-1166902_)
                         (_uint166907_ _uint166898_))
          (if (fx>= _i166906_ _k166897_)
              (let ((_u8166909_ (bitwise-and _uint166907_ '255)))
                (u8vector-set! _v166896_ _i166906_ _u8166909_)
                (_lp166904_
                 (fx- _i166906_ '1)
                 (arithmetic-shift _uint166907_ '-8)))
              '#!void)))))
  (define std/misc/bytes#&u8vector-uint-set!/le
    (lambda (_v166881_ _k166882_ _uint166883_ _size166884_)
      (declare (not safe))
      (let ((_k+size166887_ (fx+ _k166882_ _size166884_)))
        (let _lp166889_ ((_i166891_ _k166882_) (_uint166892_ _uint166883_))
          (if (fx< _i166891_ _k+size166887_)
              (let ((_u8166894_ (bitwise-and _uint166892_ '255)))
                (u8vector-set! _v166881_ _i166891_ _u8166894_)
                (_lp166889_
                 (fx+ _i166891_ '1)
                 (arithmetic-shift _uint166892_ '-8)))
              '#!void)))))
  (define std/misc/bytes#u8vector-sint-ref
    (lambda (_v166873_ _k166874_ _endianness166875_ _size166876_)
      (if (u8vector? _v166873_) '#!void (error '"Expected u8vector" _v166873_))
      (if (and (fixnum? _k166874_)
               (fx<= '0
                     _k166874_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166873_))
                          '1)))
          '#!void
          (error '"Bad index" _v166873_ _k166874_))
      (if (and (fixnum? _size166876_)
               (fx<= '0
                     _size166876_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166873_))
                          _k166874_)))
          '#!void
          (error '"Bad integer size" _v166873_ _k166874_ _size166876_))
      (let ((_$e166878_ _endianness166875_))
        (if (eq? 'big _$e166878_)
            (std/misc/bytes#&u8vector-sint-ref/be
             _v166873_
             _k166874_
             _size166876_)
            (if (eq? 'little _$e166878_)
                (std/misc/bytes#&u8vector-sint-ref/le
                 _v166873_
                 _k166874_
                 _size166876_)
                (if (eq? 'native _$e166878_)
                    (if (eq? std/misc/bytes#native-endianness
                             std/misc/bytes#little)
                        (std/misc/bytes#&u8vector-sint-ref/le
                         _v166873_
                         _k166874_
                         _size166876_)
                        (std/misc/bytes#&u8vector-sint-ref/be
                         _v166873_
                         _k166874_
                         _size166876_))
                    (error '"Bad endianness" _endianness166875_)))))))
  (define std/misc/bytes#&u8vector-sint-ref/be
    (lambda (_v166866_ _k166867_ _size166868_)
      (let ((_uint166870_
             (std/misc/bytes#&u8vector-uint-ref/be
              _v166866_
              _k166867_
              _size166868_)))
        (if (> _uint166870_ (- (expt '2 (- (fx* _size166868_ '8) '1)) '1))
            (- _uint166870_ (expt '2 (fx* _size166868_ '8)))
            _uint166870_))))
  (define std/misc/bytes#&u8vector-sint-ref/le
    (lambda (_v166859_ _k166860_ _size166861_)
      (let ((_uint166863_
             (std/misc/bytes#&u8vector-uint-ref/le
              _v166859_
              _k166860_
              _size166861_)))
        (if (> _uint166863_ (- (expt '2 (- (fx* _size166861_ '8) '1)) '1))
            (- _uint166863_ (expt '2 (fx* _size166861_ '8)))
            _uint166863_))))
  (define std/misc/bytes#u8vector-sint-set!
    (lambda (_v166850_ _k166851_ _sint166852_ _endianness166853_ _size166854_)
      (if (u8vector? _v166850_) '#!void (error '"Expected u8vector" _v166850_))
      (if (and (fixnum? _k166851_)
               (fx<= '0
                     _k166851_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166850_))
                          '1)))
          '#!void
          (error '"Bad index" _v166850_ _k166851_))
      (if (and (fixnum? _size166854_)
               (fx<= '0
                     _size166854_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166850_))
                          _k166851_)))
          '#!void
          (error '"Bad integer size" _v166850_ _k166851_ _size166854_))
      (let ((_$e166856_ _endianness166853_))
        (if (eq? 'big _$e166856_)
            (std/misc/bytes#&u8vector-sint-set!/be
             _v166850_
             _k166851_
             _sint166852_
             _size166854_)
            (if (eq? 'little _$e166856_)
                (std/misc/bytes#&u8vector-sint-set!/le
                 _v166850_
                 _k166851_
                 _sint166852_
                 _size166854_)
                (if (eq? 'native _$e166856_)
                    (if (eq? std/misc/bytes#native-endianness
                             std/misc/bytes#little)
                        (std/misc/bytes#&u8vector-sint-set!/le
                         _v166850_
                         _k166851_
                         _sint166852_
                         _size166854_)
                        (std/misc/bytes#&u8vector-sint-set!/be
                         _v166850_
                         _k166851_
                         _sint166852_
                         _size166854_))
                    (error '"Bad endianness" _endianness166853_)))))))
  (define std/misc/bytes#&u8vector-sint-set!/be
    (lambda (_v166843_ _k166844_ _sint166845_ _size166846_)
      (let ((_uint166848_
             (if (< _sint166845_ '0)
                 (+ _sint166845_ (expt '2 (fx* _size166846_ '8)))
                 _sint166845_)))
        (std/misc/bytes#&u8vector-uint-set!/be
         _v166843_
         _k166844_
         _uint166848_
         _size166846_))))
  (define std/misc/bytes#&u8vector-sint-set!/le
    (lambda (_v166836_ _k166837_ _sint166838_ _size166839_)
      (let ((_uint166841_
             (if (< _sint166838_ '0)
                 (+ _sint166838_ (expt '2 (fx* _size166839_ '8)))
                 _sint166838_)))
        (std/misc/bytes#&u8vector-uint-set!/le
         _v166836_
         _k166837_
         _uint166841_
         _size166839_))))
  (define std/misc/bytes#u8vector->uint-list
    (lambda (_v166829_ _endianness166830_ _size166831_)
      (if (u8vector? _v166829_) '#!void (error '"Expected u8vector" _v166829_))
      (if (and (fixnum? _size166831_)
               (fx> _size166831_ '0)
               (fxzero? (fxremainder
                         (let ()
                           (declare (not safe))
                           (##u8vector-length _v166829_))
                         _size166831_)))
          '#!void
          (error '"Bad size" _v166829_ _size166831_))
      (let ((_$e166833_ _endianness166830_))
        (if (eq? 'big _$e166833_)
            (std/misc/bytes#&u8vector->int-list
             _v166829_
             _size166831_
             std/misc/bytes#&u8vector-uint-ref/be)
            (if (eq? 'little _$e166833_)
                (std/misc/bytes#&u8vector->int-list
                 _v166829_
                 _size166831_
                 std/misc/bytes#&u8vector-uint-ref/le)
                (if (eq? 'native _$e166833_)
                    (if (eq? std/misc/bytes#native-endianness
                             std/misc/bytes#little)
                        (std/misc/bytes#&u8vector->int-list
                         _v166829_
                         _size166831_
                         std/misc/bytes#&u8vector-uint-ref/le)
                        (std/misc/bytes#&u8vector->int-list
                         _v166829_
                         _size166831_
                         std/misc/bytes#&u8vector-uint-ref/be))
                    (error '"Bad endianness" _endianness166830_)))))))
  (define std/misc/bytes#u8vector->sint-list
    (lambda (_v166822_ _endianness166823_ _size166824_)
      (if (u8vector? _v166822_) '#!void (error '"Expected u8vector" _v166822_))
      (if (and (fixnum? _size166824_)
               (fx> _size166824_ '0)
               (fxzero? (fxremainder
                         (let ()
                           (declare (not safe))
                           (##u8vector-length _v166822_))
                         _size166824_)))
          '#!void
          (error '"Bad size" _v166822_ _size166824_))
      (let ((_$e166826_ _endianness166823_))
        (if (eq? 'big _$e166826_)
            (std/misc/bytes#&u8vector->int-list
             _v166822_
             _size166824_
             std/misc/bytes#&u8vector-sint-ref/be)
            (if (eq? 'little _$e166826_)
                (std/misc/bytes#&u8vector->int-list
                 _v166822_
                 _size166824_
                 std/misc/bytes#&u8vector-sint-ref/le)
                (if (eq? 'native _$e166826_)
                    (if (eq? std/misc/bytes#native-endianness
                             std/misc/bytes#little)
                        (std/misc/bytes#&u8vector->int-list
                         _v166822_
                         _size166824_
                         std/misc/bytes#&u8vector-sint-ref/le)
                        (std/misc/bytes#&u8vector->int-list
                         _v166822_
                         _size166824_
                         std/misc/bytes#&u8vector-sint-ref/be))
                    (error '"Bad endianness" _endianness166823_)))))))
  (define std/misc/bytes#&u8vector->int-list
    (lambda (_v166808_ _size166809_ _getf166810_)
      (declare (fixnum) (not safe))
      (let ((_len166813_ (u8vector-length _v166808_)))
        (let _lp166815_ ((_i166817_ '0) (_r166818_ '()))
          (if (< _i166817_ _len166813_)
              (let ((_next166820_
                     (_getf166810_ _v166808_ _i166817_ _size166809_)))
                (_lp166815_
                 (+ _i166817_ _size166809_)
                 (cons _next166820_ _r166818_)))
              (reverse _r166818_))))))
  (define std/misc/bytes#uint-list->u8vector
    (lambda (_lst166801_ _endianness166802_ _size166803_)
      (if (and (list? _lst166801_) (andmap1 exact-integer? _lst166801_))
          '#!void
          (error '"Expected list of exact integers" _lst166801_))
      (if (and (fixnum? _size166803_) (fx> _size166803_ '0))
          '#!void
          (error '"Bad size" _size166803_))
      (let ((_$e166805_ _endianness166802_))
        (if (eq? 'big _$e166805_)
            (std/misc/bytes#&int-list->u8vector
             _lst166801_
             _size166803_
             std/misc/bytes#&u8vector-uint-set!/be)
            (if (eq? 'little _$e166805_)
                (std/misc/bytes#&int-list->u8vector
                 _lst166801_
                 _size166803_
                 std/misc/bytes#&u8vector-uint-set!/le)
                (if (eq? 'native _$e166805_)
                    (if (eq? std/misc/bytes#native-endianness
                             std/misc/bytes#little)
                        (std/misc/bytes#&int-list->u8vector
                         _lst166801_
                         _size166803_
                         std/misc/bytes#&u8vector-uint-set!/le)
                        (std/misc/bytes#&int-list->u8vector
                         _lst166801_
                         _size166803_
                         std/misc/bytes#&u8vector-uint-set!/be))
                    (error '"Bad endianness" _endianness166802_)))))))
  (define std/misc/bytes#sint-list->u8vector
    (lambda (_lst166794_ _endianness166795_ _size166796_)
      (if (and (list? _lst166794_) (andmap1 exact-integer? _lst166794_))
          '#!void
          (error '"Expected list of exact integers" _lst166794_))
      (if (and (fixnum? _size166796_) (fx> _size166796_ '0))
          '#!void
          (error '"Bad size" _size166796_))
      (let ((_$e166798_ _endianness166795_))
        (if (eq? 'big _$e166798_)
            (std/misc/bytes#&int-list->u8vector
             _lst166794_
             _size166796_
             std/misc/bytes#&u8vector-sint-set!/be)
            (if (eq? 'little _$e166798_)
                (std/misc/bytes#&int-list->u8vector
                 _lst166794_
                 _size166796_
                 std/misc/bytes#&u8vector-sint-set!/le)
                (if (eq? 'native _$e166798_)
                    (if (eq? std/misc/bytes#native-endianness
                             std/misc/bytes#little)
                        (std/misc/bytes#&int-list->u8vector
                         _lst166794_
                         _size166796_
                         std/misc/bytes#&u8vector-sint-set!/le)
                        (std/misc/bytes#&int-list->u8vector
                         _lst166794_
                         _size166796_
                         std/misc/bytes#&u8vector-sint-set!/be))
                    (error '"Bad endianness" _endianness166795_)))))))
  (define std/misc/bytes#&int-list->u8vector
    (lambda (_lst166746_ _size166747_ _setf166748_)
      (declare (fixnum) (not safe))
      (let* ((_len166751_ (* (length _lst166746_) _size166747_))
             (_v166753_ (make-u8vector _len166751_)))
        (let _lp166756_ ((_rest166758_ _lst166746_) (_i166759_ '0))
          (let* ((_rest166760166768_ _rest166758_)
                 (_else166762166776_ (lambda () _v166753_))
                 (_K166764166782_
                  (lambda (_rest166779_ _int166780_)
                    (_setf166748_ _v166753_ _i166759_ _int166780_ _size166747_)
                    (_lp166756_ _rest166779_ (+ _i166759_ _size166747_)))))
            (if (##pair? _rest166760166768_)
                (let ((_hd166765166785_ (##car _rest166760166768_))
                      (_tl166766166787_ (##cdr _rest166760166768_)))
                  (let* ((_int166790_ _hd166765166785_)
                         (_rest166792_ _tl166766166787_))
                    (_K166764166782_ _rest166792_ _int166790_)))
                (_else166762166776_)))))))
  (define std/misc/bytes#u8vector-u16-ref
    (lambda (_v166739_ _k166740_ _endianness166741_)
      (if (u8vector? _v166739_) '#!void (error '"Expected u8vector" _v166739_))
      (if (and (fixnum? _k166740_)
               (fx<= '0
                     _k166740_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166739_))
                          '1)))
          '#!void
          (error '"Bad index" _v166739_ _k166740_))
      (if (and (fixnum? '2)
               (fx<= '0
                     '2
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166739_))
                          _k166740_)))
          '#!void
          (error '"Bad integer size" _v166739_ _k166740_ '2))
      (if (eq? _endianness166741_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-u16-ref/native _v166739_ _k166740_)
          (let ((_$e166743_ _endianness166741_))
            (if (eq? 'big _$e166743_)
                (std/misc/bytes#&u8vector-uint-ref/be _v166739_ _k166740_ '2)
                (if (eq? 'little _$e166743_)
                    (std/misc/bytes#&u8vector-uint-ref/le
                     _v166739_
                     _k166740_
                     '2)
                    (if (eq? 'native _$e166743_)
                        (std/misc/bytes#&u8vector-u16-ref/native
                         _v166739_
                         _k166740_)
                        (error '"Bad endianness" _endianness166741_))))))))
  (define std/misc/bytes#u8vector-u16-set!
    (lambda (_v166731_ _k166732_ _n166733_ _endianness166734_)
      (if (u8vector? _v166731_) '#!void (error '"Expected u8vector" _v166731_))
      (if (and (fixnum? _k166732_)
               (fx<= '0
                     _k166732_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166731_))
                          '1)))
          '#!void
          (error '"Bad index" _v166731_ _k166732_))
      (if (and (fixnum? '2)
               (fx<= '0
                     '2
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166731_))
                          _k166732_)))
          '#!void
          (error '"Bad integer size" _v166731_ _k166732_ '2))
      (if (eq? _endianness166734_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-u16-set!/native
           _v166731_
           _k166732_
           _n166733_)
          (let ((_$e166736_ _endianness166734_))
            (if (eq? 'big _$e166736_)
                (std/misc/bytes#&u8vector-uint-set!/be
                 _v166731_
                 _k166732_
                 _n166733_
                 '2)
                (if (eq? 'little _$e166736_)
                    (std/misc/bytes#&u8vector-uint-set!/le
                     _v166731_
                     _k166732_
                     _n166733_
                     '2)
                    (if (eq? 'native _$e166736_)
                        (std/misc/bytes#&u8vector-u16-set!/native
                         _v166731_
                         _k166732_
                         _n166733_)
                        (error '"Bad endianness" _endianness166734_))))))))
  (define std/misc/bytes#u8vector-u16-native-ref
    (lambda (_v166728_ _k166729_)
      (if (u8vector? _v166728_) '#!void (error '"Expected u8vector" _v166728_))
      (if (and (fixnum? _k166729_)
               (fx<= '0
                     _k166729_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166728_))
                          '1)))
          '#!void
          (error '"Bad index" _v166728_ _k166729_))
      (if (and (fixnum? '2)
               (fx<= '0
                     '2
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166728_))
                          _k166729_)))
          '#!void
          (error '"Bad integer size" _v166728_ _k166729_ '2))
      (std/misc/bytes#&u8vector-u16-ref/native _v166728_ _k166729_)))
  (define std/misc/bytes#u8vector-u16-native-set!
    (lambda (_v166724_ _k166725_ _n166726_)
      (if (u8vector? _v166724_) '#!void (error '"Expected u8vector" _v166724_))
      (if (and (fixnum? _k166725_)
               (fx<= '0
                     _k166725_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166724_))
                          '1)))
          '#!void
          (error '"Bad index" _v166724_ _k166725_))
      (if (and (fixnum? '2)
               (fx<= '0
                     '2
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166724_))
                          _k166725_)))
          '#!void
          (error '"Bad integer size" _v166724_ _k166725_ '2))
      (std/misc/bytes#&u8vector-u16-set!/native
       _v166724_
       _k166725_
       _n166726_)))
  (define std/misc/bytes#u8vector-s16-ref
    (lambda (_v166717_ _k166718_ _endianness166719_)
      (if (u8vector? _v166717_) '#!void (error '"Expected u8vector" _v166717_))
      (if (and (fixnum? _k166718_)
               (fx<= '0
                     _k166718_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166717_))
                          '1)))
          '#!void
          (error '"Bad index" _v166717_ _k166718_))
      (if (and (fixnum? '2)
               (fx<= '0
                     '2
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166717_))
                          _k166718_)))
          '#!void
          (error '"Bad integer size" _v166717_ _k166718_ '2))
      (if (eq? _endianness166719_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-s16-ref/native _v166717_ _k166718_)
          (let ((_$e166721_ _endianness166719_))
            (if (eq? 'big _$e166721_)
                (std/misc/bytes#&u8vector-sint-ref/be _v166717_ _k166718_ '2)
                (if (eq? 'little _$e166721_)
                    (std/misc/bytes#&u8vector-sint-ref/le
                     _v166717_
                     _k166718_
                     '2)
                    (if (eq? 'native _$e166721_)
                        (std/misc/bytes#&u8vector-s16-ref/native
                         _v166717_
                         _k166718_)
                        (error '"Bad endianness" _endianness166719_))))))))
  (define std/misc/bytes#u8vector-s16-set!
    (lambda (_v166709_ _k166710_ _n166711_ _endianness166712_)
      (if (u8vector? _v166709_) '#!void (error '"Expected u8vector" _v166709_))
      (if (and (fixnum? _k166710_)
               (fx<= '0
                     _k166710_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166709_))
                          '1)))
          '#!void
          (error '"Bad index" _v166709_ _k166710_))
      (if (and (fixnum? '2)
               (fx<= '0
                     '2
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166709_))
                          _k166710_)))
          '#!void
          (error '"Bad integer size" _v166709_ _k166710_ '2))
      (if (eq? _endianness166712_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-s16-set!/native
           _v166709_
           _k166710_
           _n166711_)
          (let ((_$e166714_ _endianness166712_))
            (if (eq? 'big _$e166714_)
                (std/misc/bytes#&u8vector-sint-set!/be
                 _v166709_
                 _k166710_
                 _n166711_
                 '2)
                (if (eq? 'little _$e166714_)
                    (std/misc/bytes#&u8vector-sint-set!/le
                     _v166709_
                     _k166710_
                     _n166711_
                     '2)
                    (if (eq? 'native _$e166714_)
                        (std/misc/bytes#&u8vector-s16-set!/native
                         _v166709_
                         _k166710_
                         _n166711_)
                        (error '"Bad endianness" _endianness166712_))))))))
  (define std/misc/bytes#u8vector-s16-native-ref
    (lambda (_v166706_ _k166707_)
      (if (u8vector? _v166706_) '#!void (error '"Expected u8vector" _v166706_))
      (if (and (fixnum? _k166707_)
               (fx<= '0
                     _k166707_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166706_))
                          '1)))
          '#!void
          (error '"Bad index" _v166706_ _k166707_))
      (if (and (fixnum? '2)
               (fx<= '0
                     '2
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166706_))
                          _k166707_)))
          '#!void
          (error '"Bad integer size" _v166706_ _k166707_ '2))
      (std/misc/bytes#&u8vector-s16-ref/native _v166706_ _k166707_)))
  (define std/misc/bytes#u8vector-s16-native-set!
    (lambda (_v166702_ _k166703_ _n166704_)
      (if (u8vector? _v166702_) '#!void (error '"Expected u8vector" _v166702_))
      (if (and (fixnum? _k166703_)
               (fx<= '0
                     _k166703_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166702_))
                          '1)))
          '#!void
          (error '"Bad index" _v166702_ _k166703_))
      (if (and (fixnum? '2)
               (fx<= '0
                     '2
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166702_))
                          _k166703_)))
          '#!void
          (error '"Bad integer size" _v166702_ _k166703_ '2))
      (std/misc/bytes#&u8vector-s16-set!/native
       _v166702_
       _k166703_
       _n166704_)))
  (define std/misc/bytes#u8vector-u32-ref
    (lambda (_v166695_ _k166696_ _endianness166697_)
      (if (u8vector? _v166695_) '#!void (error '"Expected u8vector" _v166695_))
      (if (and (fixnum? _k166696_)
               (fx<= '0
                     _k166696_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166695_))
                          '1)))
          '#!void
          (error '"Bad index" _v166695_ _k166696_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166695_))
                          _k166696_)))
          '#!void
          (error '"Bad integer size" _v166695_ _k166696_ '4))
      (if (eq? _endianness166697_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-u32-ref/native _v166695_ _k166696_)
          (let ((_$e166699_ _endianness166697_))
            (if (eq? 'big _$e166699_)
                (std/misc/bytes#&u8vector-uint-ref/be _v166695_ _k166696_ '4)
                (if (eq? 'little _$e166699_)
                    (std/misc/bytes#&u8vector-uint-ref/le
                     _v166695_
                     _k166696_
                     '4)
                    (if (eq? 'native _$e166699_)
                        (std/misc/bytes#&u8vector-u32-ref/native
                         _v166695_
                         _k166696_)
                        (error '"Bad endianness" _endianness166697_))))))))
  (define std/misc/bytes#u8vector-u32-set!
    (lambda (_v166687_ _k166688_ _n166689_ _endianness166690_)
      (if (u8vector? _v166687_) '#!void (error '"Expected u8vector" _v166687_))
      (if (and (fixnum? _k166688_)
               (fx<= '0
                     _k166688_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166687_))
                          '1)))
          '#!void
          (error '"Bad index" _v166687_ _k166688_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166687_))
                          _k166688_)))
          '#!void
          (error '"Bad integer size" _v166687_ _k166688_ '4))
      (if (eq? _endianness166690_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-u32-set!/native
           _v166687_
           _k166688_
           _n166689_)
          (let ((_$e166692_ _endianness166690_))
            (if (eq? 'big _$e166692_)
                (std/misc/bytes#&u8vector-uint-set!/be
                 _v166687_
                 _k166688_
                 _n166689_
                 '4)
                (if (eq? 'little _$e166692_)
                    (std/misc/bytes#&u8vector-uint-set!/le
                     _v166687_
                     _k166688_
                     _n166689_
                     '4)
                    (if (eq? 'native _$e166692_)
                        (std/misc/bytes#&u8vector-u32-set!/native
                         _v166687_
                         _k166688_
                         _n166689_)
                        (error '"Bad endianness" _endianness166690_))))))))
  (define std/misc/bytes#u8vector-u32-native-ref
    (lambda (_v166684_ _k166685_)
      (if (u8vector? _v166684_) '#!void (error '"Expected u8vector" _v166684_))
      (if (and (fixnum? _k166685_)
               (fx<= '0
                     _k166685_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166684_))
                          '1)))
          '#!void
          (error '"Bad index" _v166684_ _k166685_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166684_))
                          _k166685_)))
          '#!void
          (error '"Bad integer size" _v166684_ _k166685_ '4))
      (std/misc/bytes#&u8vector-u32-ref/native _v166684_ _k166685_)))
  (define std/misc/bytes#u8vector-u32-native-set!
    (lambda (_v166680_ _k166681_ _n166682_)
      (if (u8vector? _v166680_) '#!void (error '"Expected u8vector" _v166680_))
      (if (and (fixnum? _k166681_)
               (fx<= '0
                     _k166681_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166680_))
                          '1)))
          '#!void
          (error '"Bad index" _v166680_ _k166681_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166680_))
                          _k166681_)))
          '#!void
          (error '"Bad integer size" _v166680_ _k166681_ '4))
      (std/misc/bytes#&u8vector-u32-set!/native
       _v166680_
       _k166681_
       _n166682_)))
  (define std/misc/bytes#u8vector-s32-ref
    (lambda (_v166673_ _k166674_ _endianness166675_)
      (if (u8vector? _v166673_) '#!void (error '"Expected u8vector" _v166673_))
      (if (and (fixnum? _k166674_)
               (fx<= '0
                     _k166674_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166673_))
                          '1)))
          '#!void
          (error '"Bad index" _v166673_ _k166674_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166673_))
                          _k166674_)))
          '#!void
          (error '"Bad integer size" _v166673_ _k166674_ '4))
      (if (eq? _endianness166675_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-s32-ref/native _v166673_ _k166674_)
          (let ((_$e166677_ _endianness166675_))
            (if (eq? 'big _$e166677_)
                (std/misc/bytes#&u8vector-sint-ref/be _v166673_ _k166674_ '4)
                (if (eq? 'little _$e166677_)
                    (std/misc/bytes#&u8vector-sint-ref/le
                     _v166673_
                     _k166674_
                     '4)
                    (if (eq? 'native _$e166677_)
                        (std/misc/bytes#&u8vector-s32-ref/native
                         _v166673_
                         _k166674_)
                        (error '"Bad endianness" _endianness166675_))))))))
  (define std/misc/bytes#u8vector-s32-set!
    (lambda (_v166665_ _k166666_ _n166667_ _endianness166668_)
      (if (u8vector? _v166665_) '#!void (error '"Expected u8vector" _v166665_))
      (if (and (fixnum? _k166666_)
               (fx<= '0
                     _k166666_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166665_))
                          '1)))
          '#!void
          (error '"Bad index" _v166665_ _k166666_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166665_))
                          _k166666_)))
          '#!void
          (error '"Bad integer size" _v166665_ _k166666_ '4))
      (if (eq? _endianness166668_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-s32-set!/native
           _v166665_
           _k166666_
           _n166667_)
          (let ((_$e166670_ _endianness166668_))
            (if (eq? 'big _$e166670_)
                (std/misc/bytes#&u8vector-sint-set!/be
                 _v166665_
                 _k166666_
                 _n166667_
                 '4)
                (if (eq? 'little _$e166670_)
                    (std/misc/bytes#&u8vector-sint-set!/le
                     _v166665_
                     _k166666_
                     _n166667_
                     '4)
                    (if (eq? 'native _$e166670_)
                        (std/misc/bytes#&u8vector-s32-set!/native
                         _v166665_
                         _k166666_
                         _n166667_)
                        (error '"Bad endianness" _endianness166668_))))))))
  (define std/misc/bytes#u8vector-s32-native-ref
    (lambda (_v166662_ _k166663_)
      (if (u8vector? _v166662_) '#!void (error '"Expected u8vector" _v166662_))
      (if (and (fixnum? _k166663_)
               (fx<= '0
                     _k166663_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166662_))
                          '1)))
          '#!void
          (error '"Bad index" _v166662_ _k166663_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166662_))
                          _k166663_)))
          '#!void
          (error '"Bad integer size" _v166662_ _k166663_ '4))
      (std/misc/bytes#&u8vector-s32-ref/native _v166662_ _k166663_)))
  (define std/misc/bytes#u8vector-s32-native-set!
    (lambda (_v166658_ _k166659_ _n166660_)
      (if (u8vector? _v166658_) '#!void (error '"Expected u8vector" _v166658_))
      (if (and (fixnum? _k166659_)
               (fx<= '0
                     _k166659_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166658_))
                          '1)))
          '#!void
          (error '"Bad index" _v166658_ _k166659_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166658_))
                          _k166659_)))
          '#!void
          (error '"Bad integer size" _v166658_ _k166659_ '4))
      (std/misc/bytes#&u8vector-s32-set!/native
       _v166658_
       _k166659_
       _n166660_)))
  (define std/misc/bytes#u8vector-u64-ref
    (lambda (_v166651_ _k166652_ _endianness166653_)
      (if (u8vector? _v166651_) '#!void (error '"Expected u8vector" _v166651_))
      (if (and (fixnum? _k166652_)
               (fx<= '0
                     _k166652_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166651_))
                          '1)))
          '#!void
          (error '"Bad index" _v166651_ _k166652_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166651_))
                          _k166652_)))
          '#!void
          (error '"Bad integer size" _v166651_ _k166652_ '8))
      (if (eq? _endianness166653_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-u64-ref/native _v166651_ _k166652_)
          (let ((_$e166655_ _endianness166653_))
            (if (eq? 'big _$e166655_)
                (std/misc/bytes#&u8vector-uint-ref/be _v166651_ _k166652_ '8)
                (if (eq? 'little _$e166655_)
                    (std/misc/bytes#&u8vector-uint-ref/le
                     _v166651_
                     _k166652_
                     '8)
                    (if (eq? 'native _$e166655_)
                        (std/misc/bytes#&u8vector-u64-ref/native
                         _v166651_
                         _k166652_)
                        (error '"Bad endianness" _endianness166653_))))))))
  (define std/misc/bytes#u8vector-u64-set!
    (lambda (_v166643_ _k166644_ _n166645_ _endianness166646_)
      (if (u8vector? _v166643_) '#!void (error '"Expected u8vector" _v166643_))
      (if (and (fixnum? _k166644_)
               (fx<= '0
                     _k166644_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166643_))
                          '1)))
          '#!void
          (error '"Bad index" _v166643_ _k166644_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166643_))
                          _k166644_)))
          '#!void
          (error '"Bad integer size" _v166643_ _k166644_ '8))
      (if (eq? _endianness166646_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-u64-set!/native
           _v166643_
           _k166644_
           _n166645_)
          (let ((_$e166648_ _endianness166646_))
            (if (eq? 'big _$e166648_)
                (std/misc/bytes#&u8vector-uint-set!/be
                 _v166643_
                 _k166644_
                 _n166645_
                 '8)
                (if (eq? 'little _$e166648_)
                    (std/misc/bytes#&u8vector-uint-set!/le
                     _v166643_
                     _k166644_
                     _n166645_
                     '8)
                    (if (eq? 'native _$e166648_)
                        (std/misc/bytes#&u8vector-u64-set!/native
                         _v166643_
                         _k166644_
                         _n166645_)
                        (error '"Bad endianness" _endianness166646_))))))))
  (define std/misc/bytes#u8vector-u64-native-ref
    (lambda (_v166640_ _k166641_)
      (if (u8vector? _v166640_) '#!void (error '"Expected u8vector" _v166640_))
      (if (and (fixnum? _k166641_)
               (fx<= '0
                     _k166641_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166640_))
                          '1)))
          '#!void
          (error '"Bad index" _v166640_ _k166641_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166640_))
                          _k166641_)))
          '#!void
          (error '"Bad integer size" _v166640_ _k166641_ '8))
      (std/misc/bytes#&u8vector-u64-ref/native _v166640_ _k166641_)))
  (define std/misc/bytes#u8vector-u64-native-set!
    (lambda (_v166636_ _k166637_ _n166638_)
      (if (u8vector? _v166636_) '#!void (error '"Expected u8vector" _v166636_))
      (if (and (fixnum? _k166637_)
               (fx<= '0
                     _k166637_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166636_))
                          '1)))
          '#!void
          (error '"Bad index" _v166636_ _k166637_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166636_))
                          _k166637_)))
          '#!void
          (error '"Bad integer size" _v166636_ _k166637_ '8))
      (std/misc/bytes#&u8vector-u64-set!/native
       _v166636_
       _k166637_
       _n166638_)))
  (define std/misc/bytes#u8vector-s64-ref
    (lambda (_v166629_ _k166630_ _endianness166631_)
      (if (u8vector? _v166629_) '#!void (error '"Expected u8vector" _v166629_))
      (if (and (fixnum? _k166630_)
               (fx<= '0
                     _k166630_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166629_))
                          '1)))
          '#!void
          (error '"Bad index" _v166629_ _k166630_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166629_))
                          _k166630_)))
          '#!void
          (error '"Bad integer size" _v166629_ _k166630_ '8))
      (if (eq? _endianness166631_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-s64-ref/native _v166629_ _k166630_)
          (let ((_$e166633_ _endianness166631_))
            (if (eq? 'big _$e166633_)
                (std/misc/bytes#&u8vector-sint-ref/be _v166629_ _k166630_ '8)
                (if (eq? 'little _$e166633_)
                    (std/misc/bytes#&u8vector-sint-ref/le
                     _v166629_
                     _k166630_
                     '8)
                    (if (eq? 'native _$e166633_)
                        (std/misc/bytes#&u8vector-s64-ref/native
                         _v166629_
                         _k166630_)
                        (error '"Bad endianness" _endianness166631_))))))))
  (define std/misc/bytes#u8vector-s64-set!
    (lambda (_v166620_ _k166621_ _n166622_ _endianness166623_)
      (if (u8vector? _v166620_) '#!void (error '"Expected u8vector" _v166620_))
      (if (and (fixnum? _k166621_)
               (fx<= '0
                     _k166621_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166620_))
                          '1)))
          '#!void
          (error '"Bad index" _v166620_ _k166621_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166620_))
                          _k166621_)))
          '#!void
          (error '"Bad integer size" _v166620_ _k166621_ '8))
      (if (eq? _endianness166623_ std/misc/bytes#native-endianness)
          (std/misc/bytes#&u8vector-s64-set!/native
           _v166620_
           _k166621_
           _n166622_)
          (let ((_$e166626_ _endianness166623_))
            (if (eq? 'big _$e166626_)
                (std/misc/bytes#&u8vector-sint-set!/be
                 _v166620_
                 _k166621_
                 _n166622_
                 '8)
                (if (eq? 'little _$e166626_)
                    (std/misc/bytes#&u8vector-sint-set!/le
                     _v166620_
                     _k166621_
                     _n166622_
                     '8)
                    (if (eq? 'native _$e166626_)
                        (std/misc/bytes#&u8vector-s64-set!/native
                         _v166620_
                         _k166621_
                         _n166622_)
                        (error '"Bad endianness" _endianness166623_))))))))
  (define std/misc/bytes#u8vector-s64-native-ref
    (lambda (_v166617_ _k166618_)
      (if (u8vector? _v166617_) '#!void (error '"Expected u8vector" _v166617_))
      (if (and (fixnum? _k166618_)
               (fx<= '0
                     _k166618_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166617_))
                          '1)))
          '#!void
          (error '"Bad index" _v166617_ _k166618_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166617_))
                          _k166618_)))
          '#!void
          (error '"Bad integer size" _v166617_ _k166618_ '8))
      (std/misc/bytes#&u8vector-s64-ref/native _v166617_ _k166618_)))
  (define std/misc/bytes#u8vector-s64-native-set!
    (lambda (_v166610_ _k166612_ _n166614_)
      (if (u8vector? _v166610_) '#!void (error '"Expected u8vector" _v166610_))
      (if (and (fixnum? _k166612_)
               (fx<= '0
                     _k166612_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166610_))
                          '1)))
          '#!void
          (error '"Bad index" _v166610_ _k166612_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166610_))
                          _k166612_)))
          '#!void
          (error '"Bad integer size" _v166610_ _k166612_ '8))
      (std/misc/bytes#&u8vector-s64-set!/native
       _v166610_
       _k166612_
       _n166614_)))
  (define std/misc/bytes#u8vector-float-ref
    (lambda (_v166591_ _k166592_ _endianness166593_)
      (if (u8vector? _v166591_) '#!void (error '"Expected u8vector" _v166591_))
      (if (and (fixnum? _k166592_)
               (fx<= '0
                     _k166592_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166591_))
                          '1)))
          '#!void
          (error '"Bad index" _v166591_ _k166592_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166591_))
                          _k166592_)))
          '#!void
          (error '"Bad integer size" _v166591_ _k166592_ '4))
      (if (or (eq? _endianness166593_ std/misc/bytes#native-endianness)
              (eq? _endianness166593_ std/misc/bytes#native))
          (std/misc/bytes#&u8vector-float-ref/native _v166591_ _k166592_)
          (let ((_v*166598_ (make-u8vector '4)))
            (declare (fixnum) (not safe))
            (begin
              (let _$loop166602_ ((_i166605_ (- (+ _k166592_ '4) '1))
                                  (_j166607_ '0))
                (if (= _j166607_ '4)
                    '#!void
                    (begin
                      (u8vector-set!
                       _v*166598_
                       _j166607_
                       (u8vector-ref _v166591_ _i166605_))
                      (_$loop166602_ (- _i166605_ '1) (+ _j166607_ '1)))))
              (std/misc/bytes#&u8vector-float-ref/native _v*166598_ '0))))))
  (define std/misc/bytes#u8vector-float-set!
    (lambda (_v166583_ _k166584_ _x166585_ _endianness166586_)
      (if (u8vector? _v166583_) '#!void (error '"Expected u8vector" _v166583_))
      (if (and (fixnum? _k166584_)
               (fx<= '0
                     _k166584_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166583_))
                          '1)))
          '#!void
          (error '"Bad index" _v166583_ _k166584_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166583_))
                          _k166584_)))
          '#!void
          (error '"Bad integer size" _v166583_ _k166584_ '4))
      (if (or (eq? _endianness166586_ std/misc/bytes#native-endianness)
              (eq? _endianness166586_ std/misc/bytes#native))
          (std/misc/bytes#&u8vector-float-set!/native
           _v166583_
           _k166584_
           _x166585_)
          (begin
            (std/misc/bytes#&u8vector-float-set!/native
             _v166583_
             _k166584_
             _x166585_)
            (std/misc/bytes#&u8vector-reverse! _v166583_ _k166584_ '4)))))
  (define std/misc/bytes#u8vector-float-native-ref
    (lambda (_v166580_ _k166581_)
      (if (u8vector? _v166580_) '#!void (error '"Expected u8vector" _v166580_))
      (if (and (fixnum? _k166581_)
               (fx<= '0
                     _k166581_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166580_))
                          '1)))
          '#!void
          (error '"Bad index" _v166580_ _k166581_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166580_))
                          _k166581_)))
          '#!void
          (error '"Bad integer size" _v166580_ _k166581_ '4))
      (std/misc/bytes#&u8vector-float-ref/native _v166580_ _k166581_)))
  (define std/misc/bytes#u8vector-float-native-set!
    (lambda (_v166576_ _k166577_ _x166578_)
      (if (u8vector? _v166576_) '#!void (error '"Expected u8vector" _v166576_))
      (if (and (fixnum? _k166577_)
               (fx<= '0
                     _k166577_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166576_))
                          '1)))
          '#!void
          (error '"Bad index" _v166576_ _k166577_))
      (if (and (fixnum? '4)
               (fx<= '0
                     '4
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166576_))
                          _k166577_)))
          '#!void
          (error '"Bad integer size" _v166576_ _k166577_ '4))
      (std/misc/bytes#&u8vector-float-set!/native
       _v166576_
       _k166577_
       _x166578_)))
  (define std/misc/bytes#u8vector-double-ref
    (lambda (_v166557_ _k166558_ _endianness166559_)
      (if (u8vector? _v166557_) '#!void (error '"Expected u8vector" _v166557_))
      (if (and (fixnum? _k166558_)
               (fx<= '0
                     _k166558_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166557_))
                          '1)))
          '#!void
          (error '"Bad index" _v166557_ _k166558_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166557_))
                          _k166558_)))
          '#!void
          (error '"Bad integer size" _v166557_ _k166558_ '8))
      (if (or (eq? _endianness166559_ std/misc/bytes#native-endianness)
              (eq? _endianness166559_ std/misc/bytes#native))
          (std/misc/bytes#&u8vector-double-ref/native _v166557_ _k166558_)
          (let ((_v*166564_ (make-u8vector '8)))
            (declare (fixnum) (not safe))
            (begin
              (let _$loop166568_ ((_i166571_ (- (+ _k166558_ '8) '1))
                                  (_j166573_ '0))
                (if (= _j166573_ '8)
                    '#!void
                    (begin
                      (u8vector-set!
                       _v*166564_
                       _j166573_
                       (u8vector-ref _v166557_ _i166571_))
                      (_$loop166568_ (- _i166571_ '1) (+ _j166573_ '1)))))
              (std/misc/bytes#&u8vector-double-ref/native _v*166564_ '0))))))
  (define std/misc/bytes#u8vector-double-set!
    (lambda (_v166549_ _k166550_ _x166551_ _endianness166552_)
      (if (u8vector? _v166549_) '#!void (error '"Expected u8vector" _v166549_))
      (if (and (fixnum? _k166550_)
               (fx<= '0
                     _k166550_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166549_))
                          '1)))
          '#!void
          (error '"Bad index" _v166549_ _k166550_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166549_))
                          _k166550_)))
          '#!void
          (error '"Bad integer size" _v166549_ _k166550_ '8))
      (if (or (eq? _endianness166552_ std/misc/bytes#native-endianness)
              (eq? _endianness166552_ std/misc/bytes#native))
          (std/misc/bytes#&u8vector-double-set!/native
           _v166549_
           _k166550_
           _x166551_)
          (begin
            (std/misc/bytes#&u8vector-double-set!/native
             _v166549_
             _k166550_
             _x166551_)
            (std/misc/bytes#&u8vector-reverse! _v166549_ _k166550_ '8)))))
  (define std/misc/bytes#u8vector-double-native-ref
    (lambda (_v166546_ _k166547_)
      (if (u8vector? _v166546_) '#!void (error '"Expected u8vector" _v166546_))
      (if (and (fixnum? _k166547_)
               (fx<= '0
                     _k166547_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166546_))
                          '1)))
          '#!void
          (error '"Bad index" _v166546_ _k166547_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166546_))
                          _k166547_)))
          '#!void
          (error '"Bad integer size" _v166546_ _k166547_ '8))
      (std/misc/bytes#&u8vector-double-ref/native _v166546_ _k166547_)))
  (define std/misc/bytes#u8vector-double-native-set!
    (lambda (_v166542_ _k166543_ _x166544_)
      (if (u8vector? _v166542_) '#!void (error '"Expected u8vector" _v166542_))
      (if (and (fixnum? _k166543_)
               (fx<= '0
                     _k166543_
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166542_))
                          '1)))
          '#!void
          (error '"Bad index" _v166542_ _k166543_))
      (if (and (fixnum? '8)
               (fx<= '0
                     '8
                     (fx- (let ()
                            (declare (not safe))
                            (##u8vector-length _v166542_))
                          _k166543_)))
          '#!void
          (error '"Bad integer size" _v166542_ _k166543_ '8))
      (std/misc/bytes#&u8vector-double-set!/native
       _v166542_
       _k166543_
       _x166544_)))
  (define std/misc/bytes#u8vector-swap!
    (lambda (_v166536_ _j166537_ _k166538_)
      (if (u8vector? _v166536_) '#!void (error '"Expected u8vector" _v166536_))
      (let ((_len-1166540_
             (fx- (let () (declare (not safe)) (##u8vector-length _v166536_))
                  '1)))
        (if (fx<= '0 _j166537_ _len-1166540_)
            '#!void
            (error '"Index out of range" _v166536_ _j166537_))
        (if (fx<= '0 _k166538_ _len-1166540_)
            '#!void
            (error '"Index out of range" _v166536_ _k166538_)))
      (std/misc/bytes#&u8vector-swap! _v166536_ _j166537_ _k166538_)))
  (define std/misc/bytes#&u8vector-swap!
    (lambda (_v166528_ _j166529_ _k166530_)
      (declare (not safe))
      (let ((_j-val166533_ (u8vector-ref _v166528_ _j166529_))
            (_k-val166534_ (u8vector-ref _v166528_ _k166530_)))
        (u8vector-set! _v166528_ _j166529_ _k-val166534_)
        (u8vector-set! _v166528_ _k166530_ _j-val166533_))))
  (define std/misc/bytes#u8vector-reverse!
    (lambda (_v166526_)
      (if (u8vector? _v166526_) '#!void (error '"Expected u8vector" _v166526_))
      (std/misc/bytes#&u8vector-reverse!
       _v166526_
       '0
       (u8vector-length _v166526_))))
  (define std/misc/bytes#&u8vector-reverse!
    (lambda (_v166515_ _k166516_ _size166517_)
      (declare (fixnum) (not safe))
      (let _$loop166520_ ((_left-index166523_ _k166516_)
                          (_right-index166524_
                           (- (+ _k166516_ _size166517_) '1)))
        (if (<= _right-index166524_ _left-index166523_)
            '#!void
            (begin
              (std/misc/bytes#&u8vector-swap!
               _v166515_
               _left-index166523_
               _right-index166524_)
              (_$loop166520_
               (+ _left-index166523_ '1)
               (- _right-index166524_ '1)))))))
  (define std/misc/bytes#u8vector-reverse
    (lambda (_v166500_)
      (declare (fixnum) (not safe))
      (begin
        (if (u8vector? _v166500_)
            '#!void
            (error '"Expected u8vector" _v166500_))
        (let* ((_len166503_ (u8vector-length _v166500_))
               (_len-1166505_ (- _len166503_ '1))
               (_u166507_ (make-u8vector _len166503_)))
          (let _$loop166510_ ((_i166513_ _len-1166505_))
            (if (= _i166513_ '-1)
                '#!void
                (begin
                  (u8vector-set!
                   _u166507_
                   (- _len-1166505_ _i166513_)
                   (u8vector-ref _v166500_ _i166513_))
                  (_$loop166510_ (- _i166513_ '1)))))
          _u166507_))))
  (define std/misc/bytes#u8vector->bytestring__%
    (lambda (_v166471_ _delim166472_)
      (declare (fixnum) (not safe))
      (begin
        (if (u8vector? _v166471_)
            '#!void
            (error '"Expected u8vector" _v166471_))
        (if (or (not _delim166472_) (char? _delim166472_))
            '#!void
            (error '"Expected character or #f" _delim166472_))
        (let* ((_len166478_ (u8vector-length _v166471_))
               (_s166480_
                (make-string
                 (+ _len166478_
                    _len166478_
                    (if (and (< '0 _len166478_) _delim166472_)
                        (- _len166478_ '1)
                        '0)))))
          (let _lp166483_ ((_i166485_ '0) (_j166486_ '0))
            (if (< _i166485_ _len166478_)
                (let ((_next166488_ (u8vector-ref _v166471_ _i166485_)))
                  (if (and (< '0 _i166485_) _delim166472_)
                      (string-set! _s166480_ (- _j166486_ '1) _delim166472_)
                      '#!void)
                  (string-set!
                   _s166480_
                   _j166486_
                   (char-upcase
                    (std/text/hex#hex (fxarithmetic-shift _next166488_ '-4))))
                  (string-set!
                   _s166480_
                   (+ _j166486_ '1)
                   (char-upcase (std/text/hex#hex (fxand _next166488_ '15))))
                  (_lp166483_
                   (+ _i166485_ '1)
                   (+ _j166486_ '2 (if _delim166472_ '1 '0))))
                '#!void))
          _s166480_))))
  (define std/misc/bytes#u8vector->bytestring__0
    (lambda (_v166493_)
      (let ((_delim166495_ '#\space))
        (std/misc/bytes#u8vector->bytestring__% _v166493_ _delim166495_))))
  (define std/misc/bytes#u8vector->bytestring
    (lambda _g304019_
      (let ((_g304018_ (let () (declare (not safe)) (##length _g304019_))))
        (cond ((let () (declare (not safe)) (##fx= _g304018_ 1))
               (apply std/misc/bytes#u8vector->bytestring__0 _g304019_))
              ((let () (declare (not safe)) (##fx= _g304018_ 2))
               (apply std/misc/bytes#u8vector->bytestring__% _g304019_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/bytes#u8vector->bytestring
                _g304019_))))))
  (define std/misc/bytes#bytestring->u8vector__%
    (lambda (_bs166446_ _delim166447_)
      (declare (fixnum) (not safe))
      (if _delim166447_
          (let ()
            (letrec* ((_invalid166451_
                       (lambda ()
                         (error '"Invalid bytestring"
                                _bs166446_
                                _delim166447_)))
                      (_blen166452_ (string-length _bs166446_))
                      (_g304020_
                       (let ((_g304021_
                              (if (and (< '0 _blen166452_)
                                       (not (zero? (modulo (+ _blen166452_ '1)
                                                           '3))))
                                  (_invalid166451_)
                                  '#!void)))
                         #!void
                         _g304021_))
                      (_parse-byte166453_
                       (lambda (_i166455_)
                         (letrec* ((_offset166457_ (* _i166455_ '3)))
                           (if (and (< '0 _offset166457_)
                                    (not (eq? _delim166447_
                                              (string-ref
                                               _bs166446_
                                               (- _offset166457_ '1)))))
                               (_invalid166451_)
                               '#!void)
                           (std/text/hex#hex-decode-byte
                            _bs166446_
                            _offset166457_)))))
              (std/misc/bytes#u8vector-init!
               (quotient (+ _blen166452_ '1) '3)
               _parse-byte166453_)))
          (std/text/hex#hex-decode__0 _bs166446_))))
  (define std/misc/bytes#bytestring->u8vector__0
    (lambda (_bs166463_)
      (let ((_delim166465_ '#\space))
        (std/misc/bytes#bytestring->u8vector__% _bs166463_ _delim166465_))))
  (define std/misc/bytes#bytestring->u8vector
    (lambda _g304024_
      (let ((_g304023_ (let () (declare (not safe)) (##length _g304024_))))
        (cond ((let () (declare (not safe)) (##fx= _g304023_ 1))
               (apply std/misc/bytes#bytestring->u8vector__0 _g304024_))
              ((let () (declare (not safe)) (##fx= _g304023_ 2))
               (apply std/misc/bytes#bytestring->u8vector__% _g304024_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/bytes#bytestring->u8vector
                _g304024_))))))
  (define std/misc/bytes#u8vector->uint__%
    (lambda (_v166429_ _endianness166430_)
      (if (u8vector? _v166429_) '#!void (error '"Expected u8vector" _v166429_))
      (let ((_$e166432_ _endianness166430_))
        (if (eq? 'big _$e166432_)
            (std/misc/bytes#&u8vector->uint/be _v166429_)
            (if (eq? 'little _$e166432_)
                (std/misc/bytes#&u8vector->uint/le _v166429_)
                (if (eq? 'native _$e166432_)
                    (if (eq? std/misc/bytes#native-endianness
                             std/misc/bytes#little)
                        (std/misc/bytes#&u8vector->uint/le _v166429_)
                        (std/misc/bytes#&u8vector->uint/be _v166429_))
                    (error '"Bad endianness" _endianness166430_)))))))
  (define std/misc/bytes#u8vector->uint__0
    (lambda (_v166438_)
      (let ((_endianness166440_ std/misc/bytes#big))
        (std/misc/bytes#u8vector->uint__% _v166438_ _endianness166440_))))
  (define std/misc/bytes#u8vector->uint
    (lambda _g304026_
      (let ((_g304025_ (let () (declare (not safe)) (##length _g304026_))))
        (cond ((let () (declare (not safe)) (##fx= _g304025_ 1))
               (apply std/misc/bytes#u8vector->uint__0 _g304026_))
              ((let () (declare (not safe)) (##fx= _g304025_ 2))
               (apply std/misc/bytes#u8vector->uint__% _g304026_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/bytes#u8vector->uint
                _g304026_))))))
  (define std/misc/bytes#&u8vector->uint/be
    (lambda (_v166418_)
      (declare (not safe))
      (let ((_len166421_ (u8vector-length _v166418_)))
        (let _lp166423_ ((_i166425_ '0) (_r166426_ '0))
          (if (fx< _i166425_ _len166421_)
              (_lp166423_
               (fx+ _i166425_ '1)
               (bitwise-ior
                (arithmetic-shift _r166426_ '8)
                (u8vector-ref _v166418_ _i166425_)))
              _r166426_)))))
  (define std/misc/bytes#&u8vector->uint/le
    (lambda (_v166408_)
      (declare (not safe))
      (let ((_len166411_ (u8vector-length _v166408_)))
        (let _lp166413_ ((_i166415_ (fx- _len166411_ '1)) (_r166416_ '0))
          (if (fx>= _i166415_ '0)
              (_lp166413_
               (fx- _i166415_ '1)
               (bitwise-ior
                (arithmetic-shift _r166416_ '8)
                (u8vector-ref _v166408_ _i166415_)))
              _r166416_)))))
  (define std/misc/bytes#uint->u8vector__%
    (lambda (_uint166392_ _endianness166393_)
      (if (and (exact-integer? _uint166392_) (>= _uint166392_ '0))
          '#!void
          (error '"Non-negative exact integer expected" _uint166392_))
      (let ((_$e166395_ _endianness166393_))
        (if (eq? 'big _$e166395_)
            (std/misc/bytes#&uint->u8vector/be _uint166392_)
            (if (eq? 'little _$e166395_)
                (std/misc/bytes#&uint->u8vector/le _uint166392_)
                (if (eq? 'native _$e166395_)
                    (if (eq? std/misc/bytes#native-endianness
                             std/misc/bytes#little)
                        (std/misc/bytes#&uint->u8vector/le _uint166392_)
                        (std/misc/bytes#&uint->u8vector/be _uint166392_))
                    (error '"Bad endianness" _endianness166393_)))))))
  (define std/misc/bytes#uint->u8vector__0
    (lambda (_uint166401_)
      (let ((_endianness166403_ std/misc/bytes#big))
        (std/misc/bytes#uint->u8vector__% _uint166401_ _endianness166403_))))
  (define std/misc/bytes#uint->u8vector
    (lambda _g304028_
      (let ((_g304027_ (let () (declare (not safe)) (##length _g304028_))))
        (cond ((let () (declare (not safe)) (##fx= _g304027_ 1))
               (apply std/misc/bytes#uint->u8vector__0 _g304028_))
              ((let () (declare (not safe)) (##fx= _g304027_ 2))
               (apply std/misc/bytes#uint->u8vector__% _g304028_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/misc/bytes#uint->u8vector
                _g304028_))))))
  (define std/misc/bytes#&uint->u8vector/be
    (lambda (_uint166376_)
      (declare (not safe))
      (let* ((_bits166379_ (integer-length _uint166376_))
             (_bytes166381_
              (fx+ (fxquotient _bits166379_ '8)
                   (if (fx> (fxremainder _bits166379_ '8) '0) '1 '0)))
             (_res166383_ (make-u8vector _bytes166381_)))
        (let _lp166386_ ((_uint166388_ _uint166376_)
                         (_i166389_ (fx- _bytes166381_ '1)))
          (if (> _uint166388_ '0)
              (begin
                (u8vector-set!
                 _res166383_
                 _i166389_
                 (bitwise-and _uint166388_ '255))
                (_lp166386_
                 (arithmetic-shift _uint166388_ '-8)
                 (fx- _i166389_ '1)))
              _res166383_)))))
  (define std/misc/bytes#&uint->u8vector/le
    (lambda (_uint166361_)
      (declare (not safe))
      (let* ((_bits166364_ (integer-length _uint166361_))
             (_bytes166366_
              (fx+ (fxquotient _bits166364_ '8)
                   (if (fx> (fxremainder _bits166364_ '8) '0) '1 '0)))
             (_res166368_ (make-u8vector _bytes166366_)))
        (let _lp166371_ ((_uint166373_ _uint166361_) (_i166374_ '0))
          (if (> _uint166373_ '0)
              (begin
                (u8vector-set!
                 _res166368_
                 _i166374_
                 (bitwise-and _uint166373_ '255))
                (_lp166371_
                 (arithmetic-shift _uint166373_ '-8)
                 (fx+ _i166374_ '1)))
              _res166368_)))))
  (define std/misc/bytes#u8vector-init!
    (lambda (_len166352_ _fun166353_)
      (declare (fixnum) (not safe))
      (letrec* ((_s166355_ (make-u8vector _len166352_)))
        (let _lp166357_ ((_i166359_ '0))
          (if (< _i166359_ _len166352_)
              (begin
                (u8vector-set! _s166355_ _i166359_ (_fun166353_ _i166359_))
                (_lp166357_ (+ _i166359_ '1)))
              '#!void))
        _s166355_)))
  (define-macro (define-guard guard defn)
    (if (eval `(cond-expand (,guard #t) (else #f)))
        '(begin)
        (begin (eval `(define-cond-expand-feature ,guard)) defn)))
  (define-macro (define-c-lambda id args ret #!optional (name #f))
    (let ((name (or name (symbol->string id))))
      `(define ,id (c-lambda ,args ,ret ,name))))
  (define-macro (define-const symbol)
    (let* ((str (symbol->string symbol))
           (ref (string-append "___return (" str ");")))
      `(define ,symbol ((c-lambda () int ,ref)))))
  (define-macro (define-const* symbol #!optional (ccond #f))
    (let* ((str (symbol->string symbol))
           (code (string-append
                  "#if "
                  (or ccond (string-append "defined(" str ")"))
                  "\n"
                  "___return (___FIX ("
                  str
                  "));\n"
                  "#else \n"
                  "___return (___FAL);\n"
                  "#endif")))
      `(define ,symbol ((c-lambda () scheme-object ,code)))))
  (define-macro (define-with-errno symbol ffi-symbol args)
    `(define (,symbol ,@args)
       (declare (not interrupts-enabled))
       (let ((r (,ffi-symbol ,@args)))
         (if (##fx< r 0) (##fx- (##c-code "___RESULT = ___FIX (errno);")) r))))
  (define-macro (define-c-struct
                 struct
                 #!optional
                 (members '())
                 release-function)
    (let* ((struct-str (symbol->string struct))
           (struct-ptr (string->symbol (string-append struct-str "*")))
           (shallow-ptr
            (string->symbol (string-append struct-str "-shallow-ptr*")))
           (borrowed-ptr
            (string->symbol (string-append struct-str "-borrowed-ptr*")))
           (string-types
            '(char-string
              nonull-char-string
              UTF-8-string
              nonnull-UTF-8-string
              UTF-16-string
              nonnull-UTF16-string))
           (string-compat-required?
            (let loop ((m members))
              (cond ((null? m) #f)
                    ((member (cdr (car m)) string-types) #t)
                    (else (loop (cdr m))))))
           (string-setter-body
            (lambda (member-name)
              (let ((m (string-append "___arg1->" member-name)))
                (string-append
                 "if("
                 m
                 " == NULL)"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "else if (strcmp("
                 m
                 ", ___arg2) != 0) {"
                 "\n"
                 "free("
                 m
                 ");"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "}"
                 "\n"
                 "___return;"
                 "\n"))))
           (default-free-body
            (and string-compat-required?
                 (string-append
                  "___SCMOBJ "
                  struct-str
                  "_ffi_free (void *ptr) {"
                  "\n"
                  "struct "
                  struct-str
                  " *obj = (struct "
                  struct-str
                  "*) ptr;"
                  "\n"
                  (apply string-append
                         (map (lambda (m)
                                (cond ((memq (cdr m) string-types)
                                       (let ((mem-name
                                              (symbol->string (car m))))
                                         (string-append
                                          "if(obj->"
                                          mem-name
                                          ") "
                                          "free(obj->"
                                          mem-name
                                          ");"
                                          "\n")))
                                      (else "")))
                              members))
                  "free(obj);"
                  "\n"
                  "return ___FIX (___NO_ERR);"
                  "\n"
                  "}")))
           (release-function
            (or release-function
                (if string-compat-required?
                    (string-append struct-str "_ffi_free")
                    "ffi_free")))
           (string-compat-types
            (if string-compat-required?
                `((c-declare ,default-free-body)
                  (c-define-type
                   ,shallow-ptr
                   (pointer ,struct (,struct-ptr) "ffi_free")))
                '())))
      `(begin
         (c-define-type ,struct (struct ,struct-str))
         (c-define-type
          ,struct-ptr
          (pointer ,struct (,struct-ptr) ,release-function))
         (c-define-type ,borrowed-ptr (pointer ,struct (,struct-ptr)))
         ,@string-compat-types
         (define ,(string->symbol (string-append struct-str "-ptr?"))
           (lambda (obj)
             (and (foreign? obj) (equal? (foreign-tags obj) '(,struct-ptr)))))
         ,@(apply append
                  (map (lambda (m)
                         (let* ((member-name (symbol->string (car m)))
                                (member-type (cdr m))
                                (getter-name
                                 (string-append struct-str "-" member-name))
                                (setter-body
                                 (cond ((member member-type string-types)
                                        (string-setter-body member-name))
                                       (else
                                        (string-append
                                         "___arg1->"
                                         member-name
                                         " = ___arg2;"
                                         "\n"
                                         "___return;"
                                         "\n")))))
                           `((define ,(string->symbol getter-name)
                               (c-lambda
                                (,struct-ptr)
                                ,member-type
                                ,(string-append
                                  "___return(___arg1->"
                                  member-name
                                  ");")))
                             (define ,(string->symbol
                                       (string-append getter-name "-set!"))
                               (c-lambda
                                (,struct-ptr ,member-type)
                                void
                                ,setter-body)))))
                       members))
         (define ,(string->symbol (string-append "malloc-" struct-str))
           (c-lambda
            ()
            ,struct-ptr
            ,(string-append
              "struct "
              struct-str
              "* var = (struct "
              struct-str
              " *) malloc(sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(var, 0, sizeof(struct "
              struct-str
              "));"
              "___return(var);")))
         (define ,(string->symbol (string-append "ptr->" struct-str))
           (c-lambda (,struct-ptr) ,struct "___return(*___arg1);"))
         (define ,(string->symbol
                   (string-append "malloc-" struct-str "-array"))
           (c-lambda
            (unsigned-int32)
            ,(if string-compat-required? shallow-ptr struct-ptr)
            ,(string-append
              "struct "
              struct-str
              " *arr_var=(struct "
              struct-str
              " *) malloc(___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (arr_var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(arr_var, 0, ___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "___return(arr_var);")))
         (define ,(string->symbol (string-append struct-str "-array-ref"))
           (c-lambda
            (,struct-ptr unsigned-int32)
            ,borrowed-ptr
            "___return (___arg1 + ___arg2);"))
         (define ,(string->symbol (string-append struct-str "-array-set!"))
           (c-lambda
            (,struct-ptr unsigned-int32 ,struct-ptr)
            void
            "*(___arg1 + ___arg2) = *___arg3; ___return;")))))
  (c-declare "#include <stdlib.h>")
  (c-declare "#include <string.h>")
  (c-declare "#include <errno.h>")
  (c-declare "static ___SCMOBJ ffi_free (void *ptr);")
  (c-declare
   "#ifndef ___HAVE_FFI_U8VECTOR\n#define ___HAVE_FFI_U8VECTOR\n#define U8_DATA(obj) ___CAST (___U8*, ___BODY_AS (obj, ___tSUBTYPED))\n#define U8_LEN(obj) ___HD_BYTES (___HEADER (obj))\n#endif")
  (namespace
   ("std/misc/bytes#"
    &u8vector-double-set!/native
    &u8vector-double-ref/native
    &u8vector-float-set!/native
    &u8vector-float-ref/native
    &u8vector-s64-set!/native
    &u8vector-s64-ref/native
    &u8vector-u64-set!/native
    &u8vector-u64-ref/native
    &u8vector-s32-set!/native
    &u8vector-s32-ref/native
    &u8vector-u32-set!/native
    &u8vector-u32-ref/native
    &u8vector-s16-set!/native
    &u8vector-s16-ref/native
    &u8vector-u16-set!/native
    &u8vector-u16-ref/native
    native-endianness))
  (c-declare "#include <stdint.h>")
  (define native-endianness
    (if ((c-lambda
          ()
          scheme-object
          "#ifdef ___LITTLE_ENDIAN\n___return(___TRU);\n#else\n___return(___FAL);\n#endif"))
        'little
        'big))
  (define-c-lambda
   &u8vector-u16-ref/native
   (scheme-object int)
   unsigned-int16
   "uint16_t res = *(uint16_t*)(U8_DATA(___arg1) + ___arg2); ___return(res);")
  (define-c-lambda
   &u8vector-u16-set!/native
   (scheme-object int unsigned-int16)
   void
   "*(uint16_t*)(U8_DATA(___arg1) + ___arg2) = ___arg3; ___return;")
  (define-c-lambda
   &u8vector-s16-ref/native
   (scheme-object int)
   int16
   "int16_t res = *(int16_t*)(U8_DATA(___arg1) + ___arg2); ___return(res);")
  (define-c-lambda
   &u8vector-s16-set!/native
   (scheme-object int int16)
   void
   "*(int16_t*)(U8_DATA(___arg1) + ___arg2) = ___arg3; ___return;")
  (define-c-lambda
   &u8vector-u32-ref/native
   (scheme-object int)
   unsigned-int32
   "uint32_t res = *(uint32_t*)(U8_DATA(___arg1) + ___arg2); ___return(res);")
  (define-c-lambda
   &u8vector-u32-set!/native
   (scheme-object int unsigned-int32)
   void
   "*(uint32_t*)(U8_DATA(___arg1) + ___arg2) = ___arg3; ___return;")
  (define-c-lambda
   &u8vector-s32-ref/native
   (scheme-object int)
   int32
   "int32_t res = *(int32_t*)(U8_DATA(___arg1) + ___arg2); ___return(res);")
  (define-c-lambda
   &u8vector-s32-set!/native
   (scheme-object int int32)
   void
   "*(int32_t*)(U8_DATA(___arg1) + ___arg2) = ___arg3; ___return;")
  (define-c-lambda
   &u8vector-u64-ref/native
   (scheme-object int)
   unsigned-int64
   "uint64_t res = *(uint64_t*)(U8_DATA(___arg1) + ___arg2); ___return(res);")
  (define-c-lambda
   &u8vector-u64-set!/native
   (scheme-object int unsigned-int64)
   void
   "*(uint64_t*)(U8_DATA(___arg1) + ___arg2) = ___arg3; ___return;")
  (define-c-lambda
   &u8vector-s64-ref/native
   (scheme-object int)
   int64
   "int64_t res = *(int64_t*)(U8_DATA(___arg1) + ___arg2); ___return(res);")
  (define-c-lambda
   &u8vector-s64-set!/native
   (scheme-object int int64)
   void
   "*(int64_t*)(U8_DATA(___arg1) + ___arg2) = ___arg3; ___return;")
  (define-c-lambda
   &u8vector-float-ref/native
   (scheme-object int)
   float
   "float res = *(float*)(U8_DATA(___arg1) + ___arg2); ___return(res);")
  (define-c-lambda
   &u8vector-float-set!/native
   (scheme-object int float)
   void
   "*(float*)(U8_DATA(___arg1) + ___arg2) = ___arg3; ___return;")
  (define-c-lambda
   &u8vector-double-ref/native
   (scheme-object int)
   double
   "double res = *(double*)(U8_DATA(___arg1) + ___arg2); ___return(res);")
  (define-c-lambda
   &u8vector-double-set!/native
   (scheme-object int double)
   void
   "*(double*)(U8_DATA(___arg1) + ___arg2) = ___arg3; ___return;")
  (c-declare
   "#ifndef ___HAVE_FFI_FREE\n#define ___HAVE_FFI_FREE\n___SCMOBJ ffi_free (void *ptr)\n{\n free (ptr);\n return ___FIX (___NO_ERR);\n}\n#endif"))
