(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/misc/uuid#uuid-length '16)
  (define std/misc/uuid#uuid::t
    (make-struct-type
     'std/misc/uuid#uuid::t
     '#f
     '2
     'uuid
     '((equal: bytes) (final: . #t))
     '#f
     '(bytes str)))
  (define std/misc/uuid#uuid? (make-struct-predicate std/misc/uuid#uuid::t))
  (define std/misc/uuid#make-uuid
    (lambda _$args177983_
      (apply make-struct-instance std/misc/uuid#uuid::t _$args177983_)))
  (define std/misc/uuid#uuid-bytes
    (make-struct-field-accessor std/misc/uuid#uuid::t '0))
  (define std/misc/uuid#uuid-str
    (make-struct-field-accessor std/misc/uuid#uuid::t '1))
  (define std/misc/uuid#uuid-bytes-set!
    (make-struct-field-mutator std/misc/uuid#uuid::t '0))
  (define std/misc/uuid#uuid-str-set!
    (make-struct-field-mutator std/misc/uuid#uuid::t '1))
  (define std/misc/uuid#uuid=?
    (lambda (_a177980_ _b177981_)
      (equal? (##direct-structure-ref _a177980_ '1 std/misc/uuid#uuid::t '#f)
              (##direct-structure-ref
               _b177981_
               '1
               std/misc/uuid#uuid::t
               '#f))))
  (define std/misc/uuid#uuid-hash
    (lambda (_uuid177978_)
      (equal?-hash
       (##direct-structure-ref _uuid177978_ '1 std/misc/uuid#uuid::t '#f))))
  (define std/misc/uuid#UUID
    (lambda (_obj177976_)
      (if (let ()
            (declare (not safe))
            (##structure-direct-instance-of?
             _obj177976_
             'std/misc/uuid#uuid::t))
          _obj177976_
          (if (string? _obj177976_)
              (std/misc/uuid#text->uuid _obj177976_)
              (if (symbol? _obj177976_)
                  (std/misc/uuid#text->uuid (symbol->string _obj177976_))
                  (if (u8vector? _obj177976_)
                      (std/misc/uuid#u8vector->uuid _obj177976_)
                      (error '"bad uuid identifier" _obj177976_)))))))
  (define std/misc/uuid#random-uuid
    (lambda ()
      (let ((_bytes177974_ (make-u8vector std/misc/uuid#uuid-length)))
        (std/crypto/etc#random-bytes!__0 _bytes177974_)
        (let ()
          (declare (not safe))
          (##structure std/misc/uuid#uuid::t _bytes177974_ '#f)))))
  (define std/misc/uuid#content-uuid
    (lambda (_str177966_)
      (let* ((_bytes177968_ (std/text/utf8#string->utf8__0 _str177966_))
             (_hash177970_ (std/crypto/digest#md5 _bytes177968_)))
        (let ()
          (declare (not safe))
          (##structure std/misc/uuid#uuid::t _hash177970_ '#f)))))
  (define std/misc/uuid#uuid-re
    (std/pregexp#pregexp
     '"[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}"))
  (define std/misc/uuid#uuid-re-capture
    (std/pregexp#pregexp
     '"([0-9a-fA-F]{8})-([0-9a-fA-F]{4})-([0-9a-fA-F]{4})-([0-9a-fA-F]{4})-([0-9a-fA-F]{12})"))
  (define std/misc/uuid#text->uuid
    (lambda (_str177964_)
      (if (std/pregexp#pregexp-match std/misc/uuid#uuid-re _str177964_)
          (std/misc/uuid#string->uuid _str177964_)
          (std/misc/uuid#content-uuid _str177964_))))
  (define std/misc/uuid#u8vector->uuid
    (lambda (_u8v177962_)
      (if (let ((__tmp301927 (u8vector-length _u8v177962_)))
            (declare (not safe))
            (##fx= __tmp301927 std/misc/uuid#uuid-length))
          (let ()
            (declare (not safe))
            (##structure std/misc/uuid#uuid::t _u8v177962_ '#f))
          (error '"Bad argument; invalid u8vector length" _u8v177962_))))
  (define std/misc/uuid#uuid->u8vector
    (lambda (_uuid177960_)
      (##direct-structure-ref _uuid177960_ '1 std/misc/uuid#uuid::t '#f)))
  (define std/misc/uuid#string->uuid
    (lambda (_str177883_)
      (let* ((_g177884177902_
              (std/pregexp#pregexp-match
               std/misc/uuid#uuid-re-capture
               _str177883_))
             (_else177886177910_
              (lambda () (error '"Bad argument; malformed uuid" _str177883_)))
             (_K177888177919_
              (lambda (_e177913_ _d177914_ _c177915_ _b177916_ _a177917_)
                (let ((__tmp301928
                       (u8vector-append
                        (std/text/hex#hex-decode__0 _a177917_)
                        (std/text/hex#hex-decode__0 _b177916_)
                        (std/text/hex#hex-decode__0 _c177915_)
                        (std/text/hex#hex-decode__0 _d177914_)
                        (std/text/hex#hex-decode__0 _e177913_))))
                  (declare (not safe))
                  (##structure
                   std/misc/uuid#uuid::t
                   __tmp301928
                   _str177883_)))))
        (if (let () (declare (not safe)) (##pair? _g177884177902_))
            (let ((_tl177890177922_
                   (let () (declare (not safe)) (##cdr _g177884177902_))))
              (if (let () (declare (not safe)) (##pair? _tl177890177922_))
                  (let ((_hd177891177925_
                         (let ()
                           (declare (not safe))
                           (##car _tl177890177922_)))
                        (_tl177892177927_
                         (let ()
                           (declare (not safe))
                           (##cdr _tl177890177922_))))
                    (let ((_a177930_ _hd177891177925_))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _tl177892177927_))
                          (let ((_hd177893177932_
                                 (let ()
                                   (declare (not safe))
                                   (##car _tl177892177927_)))
                                (_tl177894177934_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _tl177892177927_))))
                            (let ((_b177937_ _hd177893177932_))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _tl177894177934_))
                                  (let ((_hd177895177939_
                                         (let ()
                                           (declare (not safe))
                                           (##car _tl177894177934_)))
                                        (_tl177896177941_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _tl177894177934_))))
                                    (let ((_c177944_ _hd177895177939_))
                                      (if (let ()
                                            (declare (not safe))
                                            (##pair? _tl177896177941_))
                                          (let ((_hd177897177946_
                                                 (let ()
                                                   (declare (not safe))
                                                   (##car _tl177896177941_)))
                                                (_tl177898177948_
                                                 (let ()
                                                   (declare (not safe))
                                                   (##cdr _tl177896177941_))))
                                            (let ((_d177951_ _hd177897177946_))
                                              (if (let ()
                                                    (declare (not safe))
                                                    (##pair? _tl177898177948_))
                                                  (let ((_hd177899177953_
                                                         (let ()
                                                           (declare (not safe))
                                                           (##car _tl177898177948_)))
                                                        (_tl177900177955_
                                                         (let ()
                                                           (declare (not safe))
                                                           (##cdr _tl177898177948_))))
                                                    (let ((_e177958_
                                                           _hd177899177953_))
                                                      (if (let ()
                                                            (declare
                                                              (not safe))
                                                            (##null? _tl177900177955_))
                                                          (_K177888177919_
                                                           _e177958_
                                                           _d177951_
                                                           _c177944_
                                                           _b177937_
                                                           _a177930_)
                                                          (_else177886177910_))))
                                                  (_else177886177910_))))
                                          (_else177886177910_))))
                                  (_else177886177910_))))
                          (_else177886177910_))))
                  (_else177886177910_)))
            (_else177886177910_)))))
  (define std/misc/uuid#uuid->string
    (lambda (_uuid177863_)
      (let ((_$e177865_
             (##direct-structure-ref
              _uuid177863_
              '2
              std/misc/uuid#uuid::t
              '#f)))
        (if _$e177865_
            (values _$e177865_)
            (let* ((_bytes177868_
                    (##direct-structure-ref
                     _uuid177863_
                     '1
                     std/misc/uuid#uuid::t
                     '#f))
                   (_a177870_ (std/text/hex#hex-encode__% _bytes177868_ '0 '4))
                   (_b177872_ (std/text/hex#hex-encode__% _bytes177868_ '4 '6))
                   (_c177874_ (std/text/hex#hex-encode__% _bytes177868_ '6 '8))
                   (_d177876_
                    (std/text/hex#hex-encode__% _bytes177868_ '8 '10))
                   (_e177878_
                    (std/text/hex#hex-encode__% _bytes177868_ '10 '16))
                   (_str177880_
                    (string-append
                     _a177870_
                     '"-"
                     _b177872_
                     '"-"
                     _c177874_
                     '"-"
                     _d177876_
                     '"-"
                     _e177878_)))
              (##direct-structure-set!
               _uuid177863_
               _str177880_
               '2
               std/misc/uuid#uuid::t
               '#f)
              _str177880_))))))
