(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/address#ip4-address
    (lambda (_obj171531_)
      (if (std/net/address#ip4-address? _obj171531_)
          _obj171531_
          (if (std/net/address#ip4-address-string? _obj171531_)
              (std/net/address#string->ip4-address _obj171531_)
              (error '"Malformed ip4 address" _obj171531_)))))
  (define std/net/address#ip4-address?
    (lambda (_obj171529_)
      (if (let () (declare (not safe)) (##u8vector? _obj171529_))
          (let ((__tmp300830
                 (let ()
                   (declare (not safe))
                   (##u8vector-length _obj171529_))))
            (declare (not safe))
            (##fx= __tmp300830 '4))
          '#f)))
  (define std/net/address#ip4-address-string?
    (lambda (_obj171527_)
      (if (string? _obj171527_)
          (if (std/pregexp#pregexp-match
               std/net/address#ip4-address-rx
               _obj171527_)
              '#t
              '#f)
          '#f)))
  (define std/net/address#ip4-address-rx
    (std/pregexp#pregexp
     '"^(\\d{1,3})\\.(\\d{1,3})\\.(\\d{1,3})\\.(\\d{1,3})$"))
  (define std/net/address#string->ip4-address
    (lambda (_str171502_)
      (let* ((_g171503171510_
              (std/pregexp#pregexp-match
               std/net/address#ip4-address-rx
               _str171502_))
             (_E171505171514_
              (lambda () (error '"No clause matching" _g171503171510_)))
             (_K171506171519_
              (lambda (_octets171517_)
                (apply ##u8vector (map string->number _octets171517_)))))
        (if (let () (declare (not safe)) (##pair? _g171503171510_))
            (let* ((_tl171508171522_
                    (let () (declare (not safe)) (##cdr _g171503171510_)))
                   (_octets171525_ _tl171508171522_))
              (_K171506171519_ _octets171525_))
            (_E171505171514_)))))
  (define std/net/address#ip4-address->string
    (lambda (_ip4171500_)
      (if (std/net/address#ip4-address? _ip4171500_)
          (apply std/format#format
                 '"~a.~a.~a.~a"
                 (let () (declare (not safe)) (##u8vector->list _ip4171500_)))
          (if (std/net/address#ip4-address-string? _ip4171500_)
              _ip4171500_
              (error '"Malformed ip4 address" _ip4171500_)))))
  (define std/net/address#ip6-address
    (lambda (_obj171498_)
      (if (std/net/address#ip6-address? _obj171498_)
          _obj171498_
          (if (std/net/address#ip6-address-string? _obj171498_)
              (std/net/address#string->ip6-address _obj171498_)
              (error '"Malformed ip6 address" _obj171498_)))))
  (define std/net/address#ip6-address?
    (lambda (_obj171496_)
      (if (let () (declare (not safe)) (##u8vector? _obj171496_))
          (let ((__tmp300831
                 (let ()
                   (declare (not safe))
                   (##u8vector-length _obj171496_))))
            (declare (not safe))
            (##fx= __tmp300831 '16))
          '#f)))
  (define std/net/address#ip6-address-rx
    (std/pregexp#pregexp '"^[0-9a-fA-F:]+$"))
  (define std/net/address#ip6-address-string?
    (lambda (_obj171494_)
      (if (string? _obj171494_)
          (if (std/pregexp#pregexp-match
               std/net/address#ip6-address-rx
               _obj171494_)
              '#t
              '#f)
          '#f)))
  (define std/net/address#string->ip6-address
    (lambda (_str171381_)
      (letrec ((_hex-e171383_
                (lambda (_str171486_ _k171487_)
                  (let* ((_char171489_ (string-ref _str171486_ _k171487_))
                         (_$e171491_ (std/text/hex#unhex* _char171489_)))
                    (if _$e171491_
                        (values _$e171491_)
                        (error '"Malformed address; not a hex digit"
                               _str171486_
                               _char171489_)))))
               (_loop171384_
                (lambda (_rest171436_ _bytes171437_ _have-zeros171438_)
                  (let* ((_rest171439171447_ _rest171436_)
                         (_else171441171455_
                          (lambda ()
                            (_check171385_
                             (list->u8vector (reverse _bytes171437_)))))
                         (_K171443171474_
                          (lambda (_rest171458_ _hex171459_)
                            (let ((_$e171461_ (string-length _hex171459_)))
                              (if (eq? '0 _$e171461_)
                                  (if _have-zeros171438_
                                      (error '"Malformed address" _str171381_)
                                      (let* ((_count171464_
                                              (length _rest171458_))
                                             (_count171466_
                                              (let ((__tmp300832
                                                     (let ()
                                                       (declare (not safe))
                                                       (##fx- '8
                                                              _count171464_))))
                                                (declare (not safe))
                                                (##fx* __tmp300832 '2)))
                                             (_count171468_
                                              (let ((__tmp300833
                                                     (length _bytes171437_)))
                                                (declare (not safe))
                                                (##fx- _count171466_
                                                       __tmp300833)))
                                             (_g300834_
                                              (if (let ()
                                                    (declare (not safe))
                                                    (##fxnegative?
                                                     _count171468_))
                                                  (error '"Malformed address; too many bits"
                                                         _str171381_)
                                                  '#!void))
                                             (_block171471_
                                              (make-list _count171468_ '0)))
                                        (_loop171384_
                                         _rest171458_
                                         (foldl1 cons
                                                 _bytes171437_
                                                 _block171471_)
                                         '#t)))
                                  (if (eq? '1 _$e171461_)
                                      (_loop171384_
                                       _rest171458_
                                       (cons (_hex-e171383_ _hex171459_ '0)
                                             (cons '0 _bytes171437_))
                                       _have-zeros171438_)
                                      (if (eq? '2 _$e171461_)
                                          (_loop171384_
                                           _rest171458_
                                           (cons (let ((__tmp300836
                                                        (let ((__tmp300837
                                                               (_hex-e171383_
                                                                _hex171459_
                                                                '0)))
                                                          (declare (not safe))
                                                          (##fxarithmetic-shift
                                                           __tmp300837
                                                           '4)))
                                                       (__tmp300835
                                                        (_hex-e171383_
                                                         _hex171459_
                                                         '1)))
                                                   (declare (not safe))
                                                   (##fxior __tmp300836
                                                            __tmp300835))
                                                 (cons '0 _bytes171437_))
                                           _have-zeros171438_)
                                          (if (eq? '3 _$e171461_)
                                              (_loop171384_
                                               _rest171458_
                                               (cons (let ((__tmp300839
                                                            (let ((__tmp300840
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                           (_hex-e171383_ _hex171459_ '1)))
                      (declare (not safe))
                      (##fxarithmetic-shift __tmp300840 '4)))
                   (__tmp300838 (_hex-e171383_ _hex171459_ '2)))
               (declare (not safe))
               (##fxior __tmp300839 __tmp300838))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                     (cons (_hex-e171383_
                                                            _hex171459_
                                                            '0)
                                                           _bytes171437_))
                                               _have-zeros171438_)
                                              (if (eq? '4 _$e171461_)
                                                  (_loop171384_
                                                   _rest171458_
                                                   (cons (let ((__tmp300842
                                                                (let ((__tmp300843
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                               (_hex-e171383_ _hex171459_ '2)))
                          (declare (not safe))
                          (##fxarithmetic-shift __tmp300843 '4)))
                       (__tmp300841 (_hex-e171383_ _hex171459_ '3)))
                   (declare (not safe))
                   (##fxior __tmp300842 __tmp300841))
                 (cons (let ((__tmp300845
                              (let ((__tmp300846
                                     (_hex-e171383_ _hex171459_ '0)))
                                (declare (not safe))
                                (##fxarithmetic-shift __tmp300846 '4)))
                             (__tmp300844 (_hex-e171383_ _hex171459_ '1)))
                         (declare (not safe))
                         (##fxior __tmp300845 __tmp300844))
                       _bytes171437_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                   _have-zeros171438_)
                                                  _hex171459_)))))))))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _rest171439171447_))
                        (let ((_hd171444171477_
                               (let ()
                                 (declare (not safe))
                                 (##car _rest171439171447_)))
                              (_tl171445171479_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _rest171439171447_))))
                          (let* ((_hex171482_ _hd171444171477_)
                                 (_rest171484_ _tl171445171479_))
                            (_K171443171474_ _rest171484_ _hex171482_)))
                        (_else171441171455_)))))
               (_check171385_
                (lambda (_bytes171434_)
                  (if (let ((__tmp300847 (u8vector-length _bytes171434_)))
                        (declare (not safe))
                        (##fx= __tmp300847 '16))
                      _bytes171434_
                      (if (let ((__tmp300848 (u8vector-length _bytes171434_)))
                            (declare (not safe))
                            (##fx< __tmp300848 '16))
                          (error '"Malformed address; not enough bits"
                                 _str171381_
                                 _bytes171434_)
                          (error '"malformed address; too many bits"
                                 _str171381_
                                 _bytes171434_))))))
        (let* ((_hexes171387_ (string-split _str171381_ '#\:))
               (_hexes171388171398_ _hexes171387_)
               (_else171390171406_
                (lambda () (_loop171384_ _hexes171387_ '() '#f)))
               (_K171392171419_
                (lambda (_rest171409_)
                  (let* ((_count171411_ (length _rest171409_))
                         (_count171413_
                          (let ((__tmp300849
                                 (let ()
                                   (declare (not safe))
                                   (##fx- '8 _count171411_))))
                            (declare (not safe))
                            (##fx* __tmp300849 '2)))
                         (_g300850_
                          (if (let ()
                                (declare (not safe))
                                (##fxnegative? _count171413_))
                              (error '"Malformed address; too many bits"
                                     _str171381_)
                              '#!void))
                         (_bytes171416_ (make-list _count171413_ '0)))
                    (_loop171384_ _rest171409_ _bytes171416_ '#t)))))
          (if (let () (declare (not safe)) (##pair? _hexes171388171398_))
              (let ((_hd171393171422_
                     (let () (declare (not safe)) (##car _hexes171388171398_)))
                    (_tl171394171424_
                     (let ()
                       (declare (not safe))
                       (##cdr _hexes171388171398_))))
                (if (equal? _hd171393171422_ '"")
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl171394171424_))
                        (let ((_hd171395171427_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl171394171424_)))
                              (_tl171396171429_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl171394171424_))))
                          (if (equal? _hd171395171427_ '"")
                              (let ((_rest171432_ _tl171396171429_))
                                (_K171392171419_ _rest171432_))
                              (_else171390171406_)))
                        (_else171390171406_))
                    (_else171390171406_)))
              (_else171390171406_))))))
  (define std/net/address#ip6-address->string
    (lambda (_ip6171146_)
      (letrec ((_compress-zeros171148_
                (lambda (_hexes171379_)
                  (_compress-leading-trailing171149_
                   (_compress171150_ _hexes171379_))))
               (_compress-leading-trailing171149_
                (lambda (_hexes171377_)
                  (if (equal? (car _hexes171377_) '"")
                      (cons '"" _hexes171377_)
                      (if (equal? (last _hexes171377_) '"")
                          (begin
                            (set-cdr! (last-pair _hexes171377_) '(""))
                            _hexes171377_)
                          _hexes171377_))))
               (_compress171150_
                (lambda (_hexes171315_)
                  (let* ((_hexes171316171330_ _hexes171315_)
                         (_else171319171338_ (lambda () '())))
                    (let ((_K171324171362_
                           (lambda (_rest171360_)
                             (cons '"" (_compress*171151_ _rest171360_))))
                          (_K171321171345_
                           (lambda (_rest171342_ _hd171343_)
                             (cons _hd171343_
                                   (_compress171150_ _rest171342_)))))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _hexes171316171330_))
                          (let ((_tl171326171367_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _hexes171316171330_)))
                                (_hd171325171365_
                                 (let ()
                                   (declare (not safe))
                                   (##car _hexes171316171330_))))
                            (if (equal? _hd171325171365_ '"0")
                                (if (let ()
                                      (declare (not safe))
                                      (##pair? _tl171326171367_))
                                    (let ((_tl171328171372_
                                           (let ()
                                             (declare (not safe))
                                             (##cdr _tl171326171367_)))
                                          (_hd171327171370_
                                           (let ()
                                             (declare (not safe))
                                             (##car _tl171326171367_))))
                                      (if (equal? _hd171327171370_ '"0")
                                          (let ((_rest171375_
                                                 _tl171328171372_))
                                            (_K171324171362_ _rest171375_))
                                          (let ((_hd171353_ _hd171325171365_)
                                                (_rest171355_
                                                 _tl171326171367_))
                                            (_K171321171345_
                                             _rest171355_
                                             _hd171353_))))
                                    (let ((_hd171353_ _hd171325171365_)
                                          (_rest171355_ _tl171326171367_))
                                      (_K171321171345_
                                       _rest171355_
                                       _hd171353_)))
                                (let ((_hd171353_ _hd171325171365_)
                                      (_rest171355_ _tl171326171367_))
                                  (_K171321171345_ _rest171355_ _hd171353_))))
                          (_else171319171338_))))))
               (_compress*171151_
                (lambda (_hexes171283_)
                  (let* ((_hexes171284171292_ _hexes171283_)
                         (_else171286171300_ (lambda () _hexes171283_))
                         (_K171288171305_
                          (lambda (_rest171303_)
                            (_compress*171151_ _rest171303_))))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _hexes171284171292_))
                        (let ((_hd171289171308_
                               (let ()
                                 (declare (not safe))
                                 (##car _hexes171284171292_)))
                              (_tl171290171310_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _hexes171284171292_))))
                          (if (equal? _hd171289171308_ '"0")
                              (let ((_rest171313_ _tl171290171310_))
                                (_compress*171151_ _rest171313_))
                              (_else171286171300_)))
                        (_else171286171300_))))))
        (let _lp171153_ ((_rest171155_ (u8vector->list _ip6171146_))
                         (_hexes171156_ '()))
          (let* ((_rest171157171167_ _rest171155_)
                 (_else171159171175_
                  (lambda ()
                    (string-join
                     (_compress-zeros171148_ (reverse _hexes171156_))
                     '#\:)))
                 (_K171161171264_
                  (lambda (_rest171178_ _b1171179_ _b0171180_)
                    (let ((_b0h171182_
                           (let ((__tmp300851
                                  (let ()
                                    (declare (not safe))
                                    (##fxarithmetic-shift _b0171180_ '-4))))
                             (declare (not safe))
                             (##fxand __tmp300851 '15)))
                          (_b0l171183_
                           (let ()
                             (declare (not safe))
                             (##fxand _b0171180_ '15)))
                          (_b1h171184_
                           (let ((__tmp300852
                                  (let ()
                                    (declare (not safe))
                                    (##fxarithmetic-shift _b1171179_ '-4))))
                             (declare (not safe))
                             (##fxand __tmp300852 '15)))
                          (_b1l171185_
                           (let ()
                             (declare (not safe))
                             (##fxand _b1171179_ '15))))
                      (let ((_b0h171186171201_ _b0h171182_)
                            (_b0l171187171203_ _b0l171183_)
                            (_b1h171188171205_ _b1h171184_)
                            (_b1l171189171207_ _b1l171185_))
                        (let ((_else171194171215_
                               (lambda ()
                                 (_lp171153_
                                  _rest171178_
                                  (cons (string (std/text/hex#hex _b0h171182_)
                                                (std/text/hex#hex _b0l171183_)
                                                (std/text/hex#hex _b1h171184_)
                                                (std/text/hex#hex _b1l171185_))
                                        _hexes171156_)))))
                          (let ((_K171199171261_
                                 (lambda ()
                                   (_lp171153_
                                    _rest171178_
                                    (cons '"0" _hexes171156_))))
                                (_K171198171252_
                                 (lambda (_b1l171250_)
                                   (_lp171153_
                                    _rest171178_
                                    (cons (string (std/text/hex#hex
                                                   _b1l171250_))
                                          _hexes171156_))))
                                (_K171197171239_
                                 (lambda (_b1h171236_ _b1l171237_)
                                   (_lp171153_
                                    _rest171178_
                                    (cons (string (std/text/hex#hex
                                                   _b1h171236_)
                                                  (std/text/hex#hex
                                                   _b1l171237_))
                                          _hexes171156_))))
                                (_K171196171223_
                                 (lambda (_b0l171219_ _b1h171220_ _b1l171221_)
                                   (_lp171153_
                                    _rest171178_
                                    (cons (string (std/text/hex#hex
                                                   _b0l171219_)
                                                  (std/text/hex#hex
                                                   _b1h171220_)
                                                  (std/text/hex#hex
                                                   _b1l171221_))
                                          _hexes171156_)))))
                            (if (let ()
                                  (declare (not safe))
                                  (##eq? _b0h171186171201_ '0))
                                (if (let ()
                                      (declare (not safe))
                                      (##eq? _b0l171187171203_ '0))
                                    (if (let ()
                                          (declare (not safe))
                                          (##eq? _b1h171188171205_ '0))
                                        (if (let ()
                                              (declare (not safe))
                                              (##eq? _b1l171189171207_ '0))
                                            (_K171199171261_)
                                            (let ((_b1l171255_
                                                   _b1l171189171207_))
                                              (_K171198171252_ _b1l171255_)))
                                        (let ((_b1h171242_ _b1h171188171205_)
                                              (_b1l171244_ _b1l171189171207_))
                                          (_K171197171239_
                                           _b1h171242_
                                           _b1l171244_)))
                                    (let ((_b0l171226_ _b0l171187171203_)
                                          (_b1h171228_ _b1h171188171205_)
                                          (_b1l171230_ _b1l171189171207_))
                                      (_K171196171223_
                                       _b0l171226_
                                       _b1h171228_
                                       _b1l171230_)))
                                (_else171194171215_)))))))))
            (if (let () (declare (not safe)) (##pair? _rest171157171167_))
                (let ((_hd171162171267_
                       (let ()
                         (declare (not safe))
                         (##car _rest171157171167_)))
                      (_tl171163171269_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest171157171167_))))
                  (let ((_b0171272_ _hd171162171267_))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _tl171163171269_))
                        (let ((_hd171164171274_
                               (let ()
                                 (declare (not safe))
                                 (##car _tl171163171269_)))
                              (_tl171165171276_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _tl171163171269_))))
                          (let* ((_b1171279_ _hd171164171274_)
                                 (_rest171281_ _tl171165171276_))
                            (_K171161171264_
                             _rest171281_
                             _b1171279_
                             _b0171272_)))
                        (_else171159171175_))))
                (_else171159171175_)))))))
  (define std/net/address#inet-address
    (lambda (_obj171144_)
      (if (std/net/address#inet-address? _obj171144_)
          (std/net/address#inet-address-normalize _obj171144_)
          (if (std/net/address#inet-address-string? _obj171144_)
              (std/net/address#string->inet-address _obj171144_)
              (error '"Malformed inet address" _obj171144_)))))
  (define std/net/address#inet-address-normalize
    (lambda (_addr171111_)
      (let* ((_addr171112171119_ _addr171111_)
             (_E171114171123_
              (lambda () (error '"No clause matching" _addr171112171119_)))
             (_K171115171132_
              (lambda (_port171126_ _host171127_)
                (if (or (std/net/address#ip4-address? _host171127_)
                        (std/net/address#ip6-address? _host171127_))
                    _addr171111_
                    (if (std/net/address#ip4-address-string? _host171127_)
                        (cons (std/net/address#string->ip4-address
                               _host171127_)
                              _port171126_)
                        (if (std/net/address#ip6-address-string? _host171127_)
                            (cons (std/net/address#string->ip6-address
                                   _host171127_)
                                  _port171126_)
                            _addr171111_))))))
        (if (let () (declare (not safe)) (##pair? _addr171112171119_))
            (let ((_hd171116171135_
                   (let () (declare (not safe)) (##car _addr171112171119_)))
                  (_tl171117171137_
                   (let () (declare (not safe)) (##cdr _addr171112171119_))))
              (let* ((_host171140_ _hd171116171135_)
                     (_port171142_ _tl171117171137_))
                (_K171115171132_ _port171142_ _host171140_)))
            (_E171114171123_)))))
  (define std/net/address#inet-address?
    (lambda (_obj171076_)
      (let* ((_obj171077171085_ _obj171076_)
             (_else171079171093_ (lambda () '#f))
             (_K171081171099_
              (lambda (_port171096_ _host171097_)
                (if (std/net/address#inet-host-address? _host171097_)
                    (fixnum? _port171096_)
                    '#f))))
        (if (let () (declare (not safe)) (##pair? _obj171077171085_))
            (let ((_hd171082171102_
                   (let () (declare (not safe)) (##car _obj171077171085_)))
                  (_tl171083171104_
                   (let () (declare (not safe)) (##cdr _obj171077171085_))))
              (let* ((_host171107_ _hd171082171102_)
                     (_port171109_ _tl171083171104_))
                (_K171081171099_ _port171109_ _host171107_)))
            (_else171079171093_)))))
  (define std/net/address#inet-address-string?
    (lambda (_obj171030_)
      (let ((_$e171032_
             (if (string? _obj171030_)
                 (std/net/address#inet-address-split__% _obj171030_ false)
                 '#f)))
        (if _$e171032_
            ((lambda (_e171034171036_)
               (let* ((_g171038171046_ _e171034171036_)
                      (_else171040171054_ (lambda () '#f))
                      (_K171042171063_
                       (lambda (_port171057_ _host171058_)
                         (let ((_$e171060_ (string-empty? _host171058_)))
                           (if _$e171060_
                               _$e171060_
                               (std/net/address#inet-host-address-string?
                                _host171058_))))))
                 (if (let ((__tmp300853
                            (if (let ()
                                  (declare (not safe))
                                  (##values? _g171038171046_))
                                (let ()
                                  (declare (not safe))
                                  (##vector-length _g171038171046_))
                                '1)))
                       (declare (not safe))
                       (##fx= __tmp300853 '2))
                     (let* ((_e171043171066_
                             (let ()
                               (declare (not safe))
                               (##vector-ref _g171038171046_ '0)))
                            (_host171069_ _e171043171066_)
                            (_e171044171071_
                             (let ()
                               (declare (not safe))
                               (##vector-ref _g171038171046_ '1)))
                            (_port171074_ _e171044171071_))
                       (_K171042171063_ _port171074_ _host171069_))
                     (_else171040171054_))))
             _$e171032_)
            '#f))))
  (define std/net/address#inet-address-split__%
    (lambda (_str171012_ _E171013_)
      (let ((_$e171015_ (string-rindex _str171012_ '#\:)))
        (if _$e171015_
            ((lambda (_ix171018_)
               (values (substring _str171012_ '0 _ix171018_)
                       (substring
                        _str171012_
                        (let () (declare (not safe)) (##fx+ _ix171018_ '1))
                        (string-length _str171012_))))
             _$e171015_)
            (_E171013_ '"Malformed address; no port separator" _str171012_)))))
  (define std/net/address#inet-address-split__0
    (lambda (_str171023_)
      (let ((_E171025_ error))
        (std/net/address#inet-address-split__% _str171023_ _E171025_))))
  (define std/net/address#inet-address-split
    (lambda _g300855_
      (let ((_g300854_ (let () (declare (not safe)) (##length _g300855_))))
        (cond ((let () (declare (not safe)) (##fx= _g300854_ 1))
               (apply std/net/address#inet-address-split__0 _g300855_))
              ((let () (declare (not safe)) (##fx= _g300854_ 2))
               (apply std/net/address#inet-address-split__% _g300855_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/address#inet-address-split
                _g300855_))))))
  (define std/net/address#inet-host-address?
    (lambda (_obj171003_)
      (let ((_$e171005_ (std/net/address#ip4-address? _obj171003_)))
        (if _$e171005_
            _$e171005_
            (let ((_$e171008_ (std/net/address#ip6-address? _obj171003_)))
              (if _$e171008_
                  _$e171008_
                  (std/net/address#inet-host-address-string? _obj171003_)))))))
  (define std/net/address#inet-host-address-string?
    (lambda (_obj170995_)
      (let ((_$e170997_ (std/net/address#ip4-address-string? _obj170995_)))
        (if _$e170997_
            _$e170997_
            (let ((_$e171000_
                   (std/net/address#ip6-address-string? _obj170995_)))
              (if _$e171000_
                  _$e171000_
                  (std/net/address#inet-host-name? _obj170995_)))))))
  (define std/net/address#inet-host-name?
    (lambda (_obj170993_)
      (if (string? _obj170993_)
          (std/pregexp#pregexp-match
           std/net/address#inet-host-name-rx
           _obj170993_)
          '#f)))
  (define std/net/address#inet-host-name-rx
    (std/pregexp#pregexp
     '"^[a-zA-Z0-9](?:[a-zA-Z0-9-]*[a-zA-Z0-9])?(?:\\.[a-zA-Z0-9](?:[a-zA-Z0-9-]*[a-zA-Z0-9])?)*$"))
  (define std/net/address#string->inet-address
    (lambda (_str170953_)
      (letrec ((_string->host170955_
                (lambda (_host170991_)
                  (if (std/net/address#ip4-address-string? _host170991_)
                      (std/net/address#string->ip4-address _host170991_)
                      (if (std/net/address#ip6-address-string? _host170991_)
                          (std/net/address#string->ip6-address _host170991_)
                          (if (std/net/address#inet-host-name? _host170991_)
                              _host170991_
                              (if (string-empty? _host170991_)
                                  '#u8(0 0 0 0)
                                  (error '"Malformed address; bad host"
                                         _str170953_
                                         _host170991_)))))))
               (_string->port170956_
                (lambda (_port170987_)
                  (let ((_port170989_ (string->number _port170987_)))
                    (if (and (fixnum? _port170989_)
                             (let ()
                               (declare (not safe))
                               (##fx<= '0 _port170989_ '65535)))
                        _port170989_
                        (error '"Malformed address; bad port"
                               _str170953_
                               _port170989_))))))
        (let* ((_g170957170964_
                (std/net/address#inet-address-split__0 _str170953_))
               (_E170959170968_
                (lambda () (error '"No clause matching" _g170957170964_)))
               (_K170960170974_
                (lambda (_port170971_ _host170972_)
                  (cons (_string->host170955_ _host170972_)
                        (_string->port170956_ _port170971_)))))
          (if (let ((__tmp300856
                     (if (let ()
                           (declare (not safe))
                           (##values? _g170957170964_))
                         (let ()
                           (declare (not safe))
                           (##vector-length _g170957170964_))
                         '1)))
                (declare (not safe))
                (##fx= __tmp300856 '2))
              (let* ((_e170961170977_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _g170957170964_ '0)))
                     (_host170980_ _e170961170977_)
                     (_e170962170982_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _g170957170964_ '1)))
                     (_port170985_ _e170962170982_))
                (_K170960170974_ _port170985_ _host170980_))
              (_E170959170968_))))))
  (define std/net/address#inet-address->string
    (lambda (_obj170923_)
      (if (std/net/address#inet-address? _obj170923_)
          (let* ((_obj170924170931_ _obj170923_)
                 (_E170926170935_
                  (lambda () (error '"No clause matching" _obj170924170931_)))
                 (_K170927170941_
                  (lambda (_port170938_ _host170939_)
                    (std/format#format
                     '"~a:~a"
                     (std/net/address#inet-host-address->string _host170939_)
                     _port170938_))))
            (if (let () (declare (not safe)) (##pair? _obj170924170931_))
                (let ((_hd170928170944_
                       (let () (declare (not safe)) (##car _obj170924170931_)))
                      (_tl170929170946_
                       (let ()
                         (declare (not safe))
                         (##cdr _obj170924170931_))))
                  (let* ((_host170949_ _hd170928170944_)
                         (_port170951_ _tl170929170946_))
                    (_K170927170941_ _port170951_ _host170949_)))
                (_E170926170935_)))
          (if (std/net/address#inet-address-string? _obj170923_)
              _obj170923_
              (error '"Malformed inet address")))))
  (define std/net/address#inet-host-address->string
    (lambda (_host170921_)
      (if (string? _host170921_)
          _host170921_
          (if (std/net/address#ip4-address? _host170921_)
              (std/net/address#ip4-address->string _host170921_)
              (if (std/net/address#ip6-address? _host170921_)
                  (std/net/address#ip6-address->string _host170921_)
                  (error '"Malformed inet host address" _host170921_))))))
  (define std/net/address#resolve-address
    (lambda (_addr170851_)
      (let* ((_addr170853_ (std/net/address#inet-address _addr170851_))
             (_addr170854170861_ _addr170853_)
             (_E170856170865_
              (lambda () (error '"No clause matching" _addr170854170861_)))
             (_K170857170909_
              (lambda (_port170868_ _host170869_)
                (if (or (std/net/address#ip4-address? _host170869_)
                        (std/net/address#ip6-address? _host170869_))
                    _addr170853_
                    (let* ((_info170874_ (host-info _host170869_))
                           (_g170875170883_ (host-info-addresses _info170874_))
                           (_else170877170891_
                            (lambda ()
                              (error '"Failed to resolve address"
                                     _addr170853_)))
                           (_K170879170897_
                            (lambda (_rest170894_ _ip170895_)
                              (cons _ip170895_ _port170868_))))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _g170875170883_))
                          (let ((_hd170880170900_
                                 (let ()
                                   (declare (not safe))
                                   (##car _g170875170883_)))
                                (_tl170881170902_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _g170875170883_))))
                            (let* ((_ip170905_ _hd170880170900_)
                                   (_rest170907_ _tl170881170902_))
                              (_K170879170897_ _rest170907_ _ip170905_)))
                          (_else170877170891_)))))))
        (if (let () (declare (not safe)) (##pair? _addr170854170861_))
            (let ((_hd170858170912_
                   (let () (declare (not safe)) (##car _addr170854170861_)))
                  (_tl170859170914_
                   (let () (declare (not safe)) (##cdr _addr170854170861_))))
              (let* ((_host170917_ _hd170858170912_)
                     (_port170919_ _tl170859170914_))
                (_K170857170909_ _port170919_ _host170917_)))
            (_E170856170865_)))))
  (define std/net/address#resolved-address?
    (lambda (_obj170813_)
      (let* ((_obj170814170822_ _obj170813_)
             (_else170816170830_ (lambda () '#f))
             (_K170818170839_
              (lambda (_port170833_ _host170834_)
                (if (or (std/net/address#ip4-address? _host170834_)
                        (std/net/address#ip6-address? _host170834_))
                    (fixnum? _port170833_)
                    '#f))))
        (if (let () (declare (not safe)) (##pair? _obj170814170822_))
            (let ((_hd170819170842_
                   (let () (declare (not safe)) (##car _obj170814170822_)))
                  (_tl170820170844_
                   (let () (declare (not safe)) (##cdr _obj170814170822_))))
              (let* ((_host170847_ _hd170819170842_)
                     (_port170849_ _tl170820170844_))
                (_K170818170839_ _port170849_ _host170847_)))
            (_else170816170830_))))))
