(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/repl#errorf
    (lambda (_fmt197782_ . _args197783_)
      (std/logger#log-message 'repl '0 _fmt197782_ _args197783_)))
  (define std/net/repl#warnf
    (lambda (_fmt197779_ . _args197780_)
      (std/logger#log-message 'repl '1 _fmt197779_ _args197780_)))
  (define std/net/repl#infof
    (lambda (_fmt197776_ . _args197777_)
      (std/logger#log-message 'repl '2 _fmt197776_ _args197777_)))
  (define std/net/repl#debugf
    (lambda (_fmt197773_ . _args197774_)
      (std/logger#log-message 'repl '3 _fmt197773_ _args197774_)))
  (define std/net/repl#verbosef
    (lambda (_fmt197768_ . _args197770_)
      (std/logger#log-message 'repl '4 _fmt197768_ _args197770_)))
  (define std/net/repl#repl-state::t
    (make-struct-type
     'std/net/repl#repl-state::t
     '#f
     '4
     'repl-state
     '((final: . #t))
     '#f
     '(client channel reader eof)))
  (define std/net/repl#repl-state?
    (make-struct-predicate std/net/repl#repl-state::t))
  (define std/net/repl#make-repl-state
    (lambda _$args197765_
      (apply make-struct-instance std/net/repl#repl-state::t _$args197765_)))
  (define std/net/repl#repl-state-client
    (make-struct-field-accessor std/net/repl#repl-state::t '0))
  (define std/net/repl#repl-state-channel
    (make-struct-field-accessor std/net/repl#repl-state::t '1))
  (define std/net/repl#repl-state-reader
    (make-struct-field-accessor std/net/repl#repl-state::t '2))
  (define std/net/repl#repl-state-eof
    (make-struct-field-accessor std/net/repl#repl-state::t '3))
  (define std/net/repl#repl-state-client-set!
    (make-struct-field-mutator std/net/repl#repl-state::t '0))
  (define std/net/repl#repl-state-channel-set!
    (make-struct-field-mutator std/net/repl#repl-state::t '1))
  (define std/net/repl#repl-state-reader-set!
    (make-struct-field-mutator std/net/repl#repl-state::t '2))
  (define std/net/repl#repl-state-eof-set!
    (make-struct-field-mutator std/net/repl#repl-state::t '3))
  (define std/net/repl#start-repl-server!__%
    (lambda (_g303074_ _passwd197733197737_ _address197734197739_)
      (let* ((_passwd197742_
              (if (eq? _passwd197733197737_ absent-value)
                  '#f
                  _passwd197733197737_))
             (_address197744_
              (if (eq? _address197734197739_ absent-value)
                  '"127.0.0.1:7000"
                  _address197734197739_)))
        (std/logger#start-logger!__0)
        (let* ((_sock197746_
                (open-tcp-server
                 (cons 'server-address:
                       (cons _address197744_
                             (cons 'eol-encoding:
                                   (cons 'cr-lf
                                         (cons 'reuse-address:
                                               (cons '#t '()))))))))
               (_server197748_
                (gerbil/gambit/threads#spawn/group
                 'repl-server
                 std/net/repl#repl-server
                 _sock197746_
                 _passwd197742_)))
          (thread-specific-set! _server197748_ _sock197746_)
          _server197748_))))
  (define std/net/repl#start-repl-server!__@
    (lambda (_keys197732197754_ . _args197756_)
      (apply std/net/repl#start-repl-server!__%
             _keys197732197754_
             (table-ref _keys197732197754_ 'password: absent-value)
             (table-ref _keys197732197754_ 'address: absent-value)
             _args197756_)))
  (define std/net/repl#start-repl-server!
    (lambda _args197735197762_
      (apply keyword-dispatch
             '#(password: address:)
             std/net/repl#start-repl-server!__@
             _args197735197762_)))
  (define std/net/repl#stop-repl-server!
    (lambda (_server197714_)
      (let ((_tgroup197716_ (thread-thread-group _server197714_))
            (_port197717_ (thread-specific _server197714_)))
        (with-unwind-protect
         (lambda ()
           (with-exception-catcher
            (lambda (_g197718197721_)
              (if ((lambda (_$obj197724_) (uncaught-exception? _$obj197724_))
                   _g197718197721_)
                  (let ((_e197727_ _g197718197721_))
                    (if (os-exception? (uncaught-exception-reason _e197727_))
                        '#!void
                        (raise _e197727_)))
                  (raise _g197718197721_)))
            (lambda ()
              (close-port _port197717_)
              (std/misc/threads#thread-async! _server197714_ void)
              (thread-join! _server197714_))))
         (lambda () (std/misc/threads#thread-group-kill! _tgroup197716_))))))
  (define std/net/repl#repl-server
    (lambda (_sock197694_ _passwd197695_)
      (let _lp197697_ ()
        (let ((_client197700_ (read _sock197694_)))
          (if (eof-object? _client197700_)
              '#!void
              (begin
                (let ((_sinfo197702_
                       (tcp-client-peer-socket-info _client197700_)))
                  (std/net/repl#debugf
                   '"accepted repl connection from ~a"
                   (std/net/address#inet-address->string
                    (cons (socket-info-address _sinfo197702_)
                          (socket-info-port-number _sinfo197702_)))))
                (output-port-readtable-set!
                 _client197700_
                 (readtable-sharing-allowed?-set
                  (output-port-readtable _client197700_)
                  '#t))
                (let* ((_tgroup197704_ (make-thread-group 'repl-client))
                       (_thread197707_
                        (make-thread
                         (lambda ()
                           (std/net/repl#repl-client
                            _client197700_
                            _passwd197695_))
                         'repl
                         _tgroup197704_))
                       (_state197709_
                        (std/net/repl#make-repl-client-state
                         _client197700_
                         _thread197707_)))
                  (thread-group-specific-set! _tgroup197704_ _state197709_)
                  (thread-start! _thread197707_)
                  (let ((_monitor197712_
                         (gerbil/gambit/threads#spawn/name
                          'repl-client-monitor
                          std/net/repl#repl-client-monitor
                          _thread197707_
                          _tgroup197704_)))
                    (thread-specific-set! _monitor197712_ _tgroup197704_))
                  (_lp197697_))))))))
  (define std/net/repl#repl-client-monitor
    (lambda (_thread197679_ _tgroup197680_)
      (with-unwind-protect
       (lambda ()
         (with-exception-catcher
          (lambda (_g197681197684_)
            (if ((lambda (_$obj197687_) (uncaught-exception? _$obj197687_))
                 _g197681197684_)
                (let ((_e197690_ _g197681197684_))
                  (std/net/repl#errorf
                   '"repl client error: ~a"
                   (uncaught-exception-reason _e197690_)))
                (raise _g197681197684_)))
          (lambda () (thread-join! _thread197679_))))
       (lambda () (std/misc/threads#thread-group-kill! _tgroup197680_)))))
  (define std/net/repl#repl-client
    (lambda (_client197667_ _passwd197668_)
      (if _passwd197668_
          (let _lp197670_ ()
            (display '"Password: " _client197667_)
            (force-output _client197667_)
            (let ((_pw197673_ (read-line _client197667_)))
              (if (equal? _pw197673_ _passwd197668_) '#!void (_lp197670_))))
          '#!void)
      (let ((_state197675_ (std/net/repl#repl-client-state__0)))
        (thread-start!
         (##direct-structure-ref
          _state197675_
          '3
          std/net/repl#repl-state::t
          '#f))
        (call-with-parameters
         (lambda () (replx))
         current-input-port
         (let () (declare (not safe)) (##repl-input-port))
         current-output-port
         (let () (declare (not safe)) (##repl-output-port))
         current-error-port
         (let () (declare (not safe)) (##repl-output-port))
         ##current-user-interrupt-handler
         (lambda () (let () (declare (not safe)) (##handle-interrupt '#f))))
        (close-port _client197667_)
        (thread-terminate!
         (##direct-structure-ref
          _state197675_
          '3
          std/net/repl#repl-state::t
          '#f)))))
  (define std/net/repl#repl-client-reader
    (lambda (_state197626_ _in197627_ _out197628_ _repl-thread197629_)
      (letrec ((_loop197631_
                (lambda (_mode197640_)
                  (let ((_c197642_ (read-char _in197627_)))
                    (if (eof-object? _c197642_)
                        (begin
                          (##direct-structure-set!
                           _state197626_
                           '#t
                           '4
                           std/net/repl#repl-state::t
                           '#f)
                          (close-output-port _out197628_))
                        (let ((_$e197644_ _mode197640_))
                          (if (eq? 'input _$e197644_)
                              (if (char=? _c197642_ '#\ÿ)
                                  (_loop197631_ _c197642_)
                                  (if (char=? _c197642_ '#\x4)
                                      (begin
                                        (close-output-port _out197628_)
                                        (_loop197631_ _mode197640_))
                                      (begin
                                        (write-char _c197642_ _out197628_)
                                        (force-output _out197628_)
                                        (_loop197631_ _mode197640_))))
                              (if (or (eq? '#\û _$e197644_)
                                      (eq? '#\ü _$e197644_)
                                      (eq? '#\þ _$e197644_))
                                  (_loop197631_ 'input)
                                  (if (eq? '#\ý _$e197644_)
                                      (begin
                                        (if (char=? _c197642_ '#\x6)
                                            (let ((_client197653_
                                                   (##direct-structure-ref
                                                    _state197626_
                                                    '1
                                                    std/net/repl#repl-state::t
                                                    '#f)))
                                              (gerbil/gambit/ports#write-u8vector__%
                                               '#u8(255 251 6)
                                               _client197653_)
                                              (force-output _client197653_))
                                            '#!void)
                                        (_loop197631_ 'input))
                                      (if (eq? '#\ÿ _$e197644_)
                                          (let ((_$e197655_ _c197642_))
                                            (if (eq? '#\ô _$e197655_)
                                                (begin
                                                  (std/misc/threads#thread-async!
                                                   _repl-thread197629_
                                                   ##user-interrupt!)
                                                  (_loop197631_ 'input))
                                                (if (or (eq? '#\û _$e197655_)
                                                        (eq? '#\ü _$e197655_)
                                                        (eq? '#\ý _$e197655_)
                                                        (eq? '#\þ _$e197655_))
                                                    (_loop197631_ _c197642_)
                                                    (_loop197631_ 'input))))
                                          (_loop197631_ 'input)))))))))))
        (with-exception-catcher
         (lambda (_g197632197634_)
           (if '#t
               (let ((_e197637_ _g197632197634_))
                 (std/net/repl#errorf '"repl reader error: ~a" _e197637_)
                 (##direct-structure-set!
                  _state197626_
                  '#t
                  '4
                  std/net/repl#repl-state::t
                  '#f)
                 (close-output-port _out197628_))
               (raise _g197632197634_)))
         (lambda () (_loop197631_ 'input))))))
  (define std/net/repl#make-repl-client-state
    (lambda (_client197608_ _thread197609_)
      (let ((_g303075_
             (open-string-pipe '(direction: input permanent-close: #f))))
        (begin
          (let ((_g303076_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g303075_) (##vector-length _g303075_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g303076_ 2)))
                (error "Context expects 2 values" _g303076_)))
          (let ((_in-rd197611_
                 (let () (declare (not safe)) (##vector-ref _g303075_ 0)))
                (_in-wr197612_
                 (let () (declare (not safe)) (##vector-ref _g303075_ 1))))
            (let* ((_g303077_
                    (macro-port-name-set!
                     _in-rd197611_
                     (lambda (_port197614_) '(repl))))
                   (_channel197617_
                    (let ()
                      (declare (not safe))
                      (##make-repl-channel-ports
                       _in-rd197611_
                       _client197608_)))
                   (_g303078_
                    (macro-repl-channel-last-owner-set!
                     _channel197617_
                     _thread197609_))
                   (_state197620_
                    (let ()
                      (declare (not safe))
                      (##structure
                       std/net/repl#repl-state::t
                       _client197608_
                       _channel197617_
                       '#f
                       '#f)))
                   (_reader197623_
                    (make-thread
                     (lambda ()
                       (std/net/repl#repl-client-reader
                        _state197620_
                        _client197608_
                        _in-wr197612_
                        _thread197609_))
                     'repl-client-reader)))
              (##direct-structure-set!
               _state197620_
               _reader197623_
               '3
               std/net/repl#repl-state::t
               '#f)
              _state197620_))))))
  (define std/net/repl#repl-context-command
    (lambda (_repl-context197600_ _src197601_)
      (if (eof-object? _src197601_)
          (let ((_$e197603_ (std/net/repl#repl-client-state__0)))
            (if _$e197603_
                ((lambda (_state197606_)
                   (if (##direct-structure-ref
                        _state197606_
                        '4
                        std/net/repl#repl-state::t
                        '#f)
                       (let ()
                         (declare (not safe))
                         (##repl-context-return _repl-context197600_ '#!void))
                       (begin
                         (let () (declare (not safe)) (##repl-channel-newline))
                         (if (fx< '0
                                  (macro-repl-context-level
                                   _repl-context197600_))
                             (let ()
                               (declare (not safe))
                               (##repl-cmd-d _repl-context197600_))
                             (if (let ()
                                   (declare (not safe))
                                   (##repl-channel-really-exit?))
                                 (let ()
                                   (declare (not safe))
                                   (##repl-context-return
                                    _repl-context197600_
                                    '#!void))
                                 (let ()
                                   (declare (not safe))
                                   (##repl-context-prompt
                                    _repl-context197600_)))))))
                 _$e197603_)
                (let ()
                  (declare (not safe))
                  (##default-repl-context-command
                   _repl-context197600_
                   _src197601_))))
          (let ()
            (declare (not safe))
            (##default-repl-context-command
             _repl-context197600_
             _src197601_)))))
  (let ()
    (declare (not safe))
    (##repl-context-command-set! std/net/repl#repl-context-command))
  (define std/net/repl#make-repl-channel
    (lambda (_thread197595_)
      (let ((_$e197597_ (std/net/repl#repl-client-state__% _thread197595_)))
        (if _$e197597_
            (##direct-structure-ref
             _$e197597_
             '2
             std/net/repl#repl-state::t
             '#f)
            (let ()
              (declare (not safe))
              (##default-thread-make-repl-channel _thread197595_))))))
  (let ()
    (declare (not safe))
    (##thread-make-repl-channel-set! std/net/repl#make-repl-channel))
  (define std/net/repl#repl-client-state__%
    (lambda (_thread197576_)
      (let _lp197578_ ((_tgroup197580_ (thread-thread-group _thread197576_)))
        (if (not _tgroup197580_)
            '#f
            (let ((_$e197582_ (thread-group-specific _tgroup197580_)))
              (if _$e197582_
                  ((lambda (_state197585_)
                     (if (let ()
                           (declare (not safe))
                           (##structure-direct-instance-of?
                            _state197585_
                            'std/net/repl#repl-state::t))
                         _state197585_
                         (_lp197578_ (thread-group-parent _tgroup197580_))))
                   _$e197582_)
                  (_lp197578_ (thread-group-parent _tgroup197580_))))))))
  (define std/net/repl#repl-client-state__0
    (lambda ()
      (let ((_thread197591_ (current-thread)))
        (std/net/repl#repl-client-state__% _thread197591_))))
  (define std/net/repl#repl-client-state
    (lambda _g303080_
      (let ((_g303079_ (let () (declare (not safe)) (##length _g303080_))))
        (cond ((let () (declare (not safe)) (##fx= _g303079_ 0))
               (apply std/net/repl#repl-client-state__0 _g303080_))
              ((let () (declare (not safe)) (##fx= _g303079_ 1))
               (apply std/net/repl#repl-client-state__% _g303080_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/repl#repl-client-state
                _g303080_))))))
  (define std/net/repl#taint!__%
    (lambda (_tgroup197552_)
      (let ((_$e197554_ (std/net/repl#repl-client-state__0)))
        (if _$e197554_
            ((lambda (_state197557_)
               (let* ((_tgroup197562_
                       (let ((_$e197559_ _tgroup197552_))
                         (if _$e197559_
                             _$e197559_
                             (std/misc/threads#primordial-thread-group))))
                      (_ostate197564_ (thread-group-specific _tgroup197562_)))
                 (thread-group-specific-set! _tgroup197562_ _state197557_)
                 _ostate197564_))
             _$e197554_)
            (error '"No repl state")))))
  (define std/net/repl#taint!__0
    (lambda ()
      (let ((_tgroup197571_ '#f)) (std/net/repl#taint!__% _tgroup197571_))))
  (define std/net/repl#taint!
    (lambda _g303082_
      (let ((_g303081_ (let () (declare (not safe)) (##length _g303082_))))
        (cond ((let () (declare (not safe)) (##fx= _g303081_ 0))
               (apply std/net/repl#taint!__0 _g303082_))
              ((let () (declare (not safe)) (##fx= _g303081_ 1))
               (apply std/net/repl#taint!__% _g303082_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/repl#taint!
                _g303082_))))))
  (define std/net/repl#untaint!__%
    (lambda (_tgroup197528_ _state197529_)
      (let ((_tgroup197534_
             (let ((_$e197531_ _tgroup197528_))
               (if _$e197531_
                   _$e197531_
                   (std/misc/threads#primordial-thread-group)))))
        (if (let ((__tmp303083 (thread-group-specific _tgroup197534_)))
              (declare (not safe))
              (##structure-direct-instance-of?
               __tmp303083
               'std/net/repl#repl-state::t))
            (thread-group-specific-set! _tgroup197534_ _state197529_)
            (error '"No tainted repl state in thread-group" _tgroup197534_)))))
  (define std/net/repl#untaint!__0
    (lambda ()
      (let* ((_tgroup197540_ '#f) (_state197542_ '#f))
        (std/net/repl#untaint!__% _tgroup197540_ _state197542_))))
  (define std/net/repl#untaint!__1
    (lambda (_tgroup197544_)
      (let ((_state197546_ '#f))
        (std/net/repl#untaint!__% _tgroup197544_ _state197546_))))
  (define std/net/repl#untaint!
    (lambda _g303085_
      (let ((_g303084_ (let () (declare (not safe)) (##length _g303085_))))
        (cond ((let () (declare (not safe)) (##fx= _g303084_ 0))
               (apply std/net/repl#untaint!__0 _g303085_))
              ((let () (declare (not safe)) (##fx= _g303084_ 1))
               (apply std/net/repl#untaint!__1 _g303085_))
              ((let () (declare (not safe)) (##fx= _g303084_ 2))
               (apply std/net/repl#untaint!__% _g303085_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/repl#untaint!
                _g303085_)))))))
