(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/request#request::t
    (make-struct-type
     'std/net#request::t
     '#f
     '8
     'request
     '()
     ':init!
     '(port url history status status-text headers body encoding)))
  (define std/net/request#request?
    (make-struct-predicate std/net/request#request::t))
  (define std/net/request#make-request
    (lambda _$args173486_
      (apply make-struct-instance std/net/request#request::t _$args173486_)))
  (define std/net/request#request-port
    (make-struct-field-accessor std/net/request#request::t '0))
  (define std/net/request#request-url
    (make-struct-field-accessor std/net/request#request::t '1))
  (define std/net/request#request-history
    (make-struct-field-accessor std/net/request#request::t '2))
  (define std/net/request#request-status
    (make-struct-field-accessor std/net/request#request::t '3))
  (define std/net/request#request-status-text
    (make-struct-field-accessor std/net/request#request::t '4))
  (define std/net/request#request-headers
    (make-struct-field-accessor std/net/request#request::t '5))
  (define std/net/request#request-body
    (make-struct-field-accessor std/net/request#request::t '6))
  (define std/net/request#request-encoding
    (make-struct-field-accessor std/net/request#request::t '7))
  (define std/net/request#request-port-set!
    (make-struct-field-mutator std/net/request#request::t '0))
  (define std/net/request#request-url-set!
    (make-struct-field-mutator std/net/request#request::t '1))
  (define std/net/request#request-history-set!
    (make-struct-field-mutator std/net/request#request::t '2))
  (define std/net/request#request-status-set!
    (make-struct-field-mutator std/net/request#request::t '3))
  (define std/net/request#request-status-text-set!
    (make-struct-field-mutator std/net/request#request::t '4))
  (define std/net/request#request-headers-set!
    (make-struct-field-mutator std/net/request#request::t '5))
  (define std/net/request#request-body-set!
    (make-struct-field-mutator std/net/request#request::t '6))
  (define std/net/request#request-encoding-set!
    (make-struct-field-mutator std/net/request#request::t '7))
  (define std/net/request#request:::init!
    (lambda (_self173481_ _port173482_ _url173483_ _history173484_)
      (if (let ((__tmp300901
                 (let () (declare (not safe)) (##vector-length _self173481_))))
            (declare (not safe))
            (##fx< '3 __tmp300901))
          (begin
            (let ()
              (declare (not safe))
              (##vector-set! _self173481_ '1 _port173482_))
            (let ()
              (declare (not safe))
              (##vector-set! _self173481_ '2 _url173483_))
            (let ()
              (declare (not safe))
              (##vector-set! _self173481_ '3 _history173484_)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self173481_))))
  (bind-method!
   std/net/request#request::t
   ':init!
   std/net/request#request:::init!
   '#f)
  (define std/net/request#url-target-e
    (lambda (_url173356_ _params173357_)
      (if _params173357_
          (string-append
           _url173356_
           '"?"
           (std/net/uri#form-url-encode__% _params173357_ '#f))
          _url173356_)))
  (define std/net/request#header-string-e
    (lambda (_str173354_)
      (if (string? _str173354_)
          _str173354_
          (if (symbol? _str173354_)
              (symbol->string _str173354_)
              (if (keyword? _str173354_)
                  (keyword->string _str173354_)
                  (error '"bad header key" _str173354_))))))
  (define std/net/request#make-http/1.1-headers
    (lambda (_headers173347_ _cookies173348_ _auth173349_)
      (std/net/request#http-headers-cons!
       _headers173347_
       (std/net/request#http-headers-cons
        (std/net/request#http-headers-cons
         std/net/request#http/1.1-base-headers
         (std/net/request#http-headers-cookies
          (let ((_$e173351_ _cookies173348_)) (if _$e173351_ _$e173351_ '()))))
        (std/net/request#http-headers-auth _auth173349_)))))
  (define std/net/request#http/1.1-base-headers
    '(("User-Agent" . "Mozilla/5.0 (compatible; gerbil/1.0)")
      ("Connection" . "close")
      ("Accept" . "*/*")
      ("Accept-Encoding" . "gzip, deflate, identity")))
  (define std/net/request#http-headers-auth
    (lambda (_auth173275_)
      (letrec ((_basic-auth-header173277_
                (lambda (_user173341_ _password173342_)
                  (let ((_credentials173345_
                         (std/text/base64#u8vector->base64-string
                          (with-output-to-u8vector
                           (lambda ()
                             (display _user173341_)
                             (display '":")
                             (display _password173342_))))))
                    (cons '"Authorization"
                          (string-append '"Basic " _credentials173345_))))))
        (let* ((_auth173278173293_ _auth173275_)
               (_E173282173297_
                (lambda () (error '"No clause matching" _auth173278173293_))))
          (let ((_K173285173319_
                 (lambda (_password173316_ _user173317_)
                   (cons (_basic-auth-header173277_
                          _user173317_
                          _password173316_)
                         '())))
                (_K173284173310_ (lambda () '()))
                (_K173283173302_
                 (lambda () (error '"unknown auth value" _auth173275_))))
            (let ((_try-match173280173313_
                   (lambda ()
                     (if (let ()
                           (declare (not safe))
                           (##eq? _auth173278173293_ '#f))
                         (_K173284173310_)
                         (_K173283173302_)))))
              (if (let () (declare (not safe)) (##pair? _auth173278173293_))
                  (let ((_tl173287173324_
                         (let ()
                           (declare (not safe))
                           (##cdr _auth173278173293_)))
                        (_hd173286173322_
                         (let ()
                           (declare (not safe))
                           (##car _auth173278173293_))))
                    (if (let ()
                          (declare (not safe))
                          (##eq? _hd173286173322_ 'basic:))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl173287173324_))
                            (let ((_tl173289173329_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl173287173324_)))
                                  (_hd173288173327_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl173287173324_))))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _tl173289173329_))
                                  (let ((_tl173291173336_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _tl173289173329_)))
                                        (_hd173290173334_
                                         (let ()
                                           (declare (not safe))
                                           (##car _tl173289173329_))))
                                    (if (let ()
                                          (declare (not safe))
                                          (##null? _tl173291173336_))
                                        (let ((_user173332_ _hd173288173327_)
                                              (_password173339_
                                               _hd173290173334_))
                                          (_K173285173319_
                                           _password173339_
                                           _user173332_))
                                        (_try-match173280173313_)))
                                  (_try-match173280173313_)))
                            (_try-match173280173313_))
                        (_try-match173280173313_)))
                  (_try-match173280173313_))))))))
  (define std/net/request#http-headers-cookies
    (lambda (_cookies173240_)
      (letrec ((_fold-e173242_
                (lambda (_cookie173244_ _str173245_)
                  (let* ((_cookie173246173253_ _cookie173244_)
                         (_E173248173257_
                          (lambda ()
                            (error '"No clause matching"
                                   _cookie173246173253_)))
                         (_K173249173263_
                          (lambda (_value173260_ _key173261_)
                            (if (string-empty? _str173245_)
                                (std/format#format
                                 '"~a=~a"
                                 _key173261_
                                 _value173260_)
                                (std/format#format
                                 '"~a; ~a=~a"
                                 _str173245_
                                 _key173261_
                                 _value173260_)))))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _cookie173246173253_))
                        (let ((_hd173250173266_
                               (let ()
                                 (declare (not safe))
                                 (##car _cookie173246173253_)))
                              (_tl173251173268_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _cookie173246173253_))))
                          (let* ((_key173271_ _hd173250173266_)
                                 (_value173273_ _tl173251173268_))
                            (_K173249173263_ _value173273_ _key173271_)))
                        (_E173248173257_))))))
        (if (null? _cookies173240_)
            '()
            (cons (cons '"Cookie" (foldr1 _fold-e173242_ _cookies173240_ '""))
                  '())))))
  (define std/net/request#http-headers-cons
    (lambda (_new-headers173200_ _headers173201_)
      (letrec ((_fold-e173203_
                (lambda (_header173205_ _headers173206_)
                  (let* ((_header173207173214_ _header173205_)
                         (_E173209173218_
                          (lambda ()
                            (error '"No clause matching"
                                   _header173207173214_)))
                         (_K173210173228_
                          (lambda (_value173221_ _key173222_)
                            (let ((_key173224_
                                   (std/srfi/13#string-titlecase__0
                                    (std/net/request#header-string-e
                                     _key173222_))))
                              (if (assoc _key173224_ _headers173206_)
                                  _headers173206_
                                  (let ((_value173226_
                                         (std/format#format
                                          '"~a"
                                          _value173221_)))
                                    (cons (cons _key173224_ _value173226_)
                                          _headers173206_)))))))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _header173207173214_))
                        (let ((_hd173211173231_
                               (let ()
                                 (declare (not safe))
                                 (##car _header173207173214_)))
                              (_tl173212173233_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _header173207173214_))))
                          (let* ((_key173236_ _hd173211173231_)
                                 (_value173238_ _tl173212173233_))
                            (_K173210173228_ _value173238_ _key173236_)))
                        (_E173209173218_))))))
        (foldr1 _fold-e173203_ _headers173201_ _new-headers173200_))))
  (define std/net/request#http-headers-cons!
    (lambda (_new-headers173156_ _headers173157_)
      (letrec ((_fold-e173159_
                (lambda (_header173161_ _headers173162_)
                  (let* ((_header173163173170_ _header173161_)
                         (_E173165173174_
                          (lambda ()
                            (error '"No clause matching"
                                   _header173163173170_)))
                         (_K173166173188_
                          (lambda (_value173177_ _key173178_)
                            (let ((_key173180_
                                   (std/srfi/13#string-titlecase__0
                                    (std/net/request#header-string-e
                                     _key173178_)))
                                  (_value173181_
                                   (std/format#format '"~a" _value173177_)))
                              (let ((_$e173183_
                                     (assoc _key173180_ _headers173162_)))
                                (if _$e173183_
                                    ((lambda (_pair173186_)
                                       (set-cdr! _pair173186_ _value173181_)
                                       _headers173162_)
                                     _$e173183_)
                                    (cons (cons _key173180_ _value173181_)
                                          _headers173162_)))))))
                    (if (let ()
                          (declare (not safe))
                          (##pair? _header173163173170_))
                        (let ((_hd173167173191_
                               (let ()
                                 (declare (not safe))
                                 (##car _header173163173170_)))
                              (_tl173168173193_
                               (let ()
                                 (declare (not safe))
                                 (##cdr _header173163173170_))))
                          (let* ((_key173196_ _hd173167173191_)
                                 (_value173198_ _tl173168173193_))
                            (_K173166173188_ _value173198_ _key173196_)))
                        (_E173165173174_))))))
        (foldr1 _fold-e173159_ _headers173157_ _new-headers173156_))))
  (define std/net/request#http-get__%
    (lambda (_g300902_
             _redirect173105173113_
             _headers173106173115_
             _cookies173107173117_
             _params173108173119_
             _data173109173121_
             _auth173110173123_
             _url173125_)
      (let* ((_redirect173127_
              (if (eq? _redirect173105173113_ absent-value)
                  '#t
                  _redirect173105173113_))
             (_headers173129_
              (if (eq? _headers173106173115_ absent-value)
                  '#f
                  _headers173106173115_))
             (_cookies173131_
              (if (eq? _cookies173107173117_ absent-value)
                  '#f
                  _cookies173107173117_))
             (_params173133_
              (if (eq? _params173108173119_ absent-value)
                  '#f
                  _params173108173119_))
             (_data173135_
              (if (eq? _data173109173121_ absent-value)
                  '#f
                  _data173109173121_))
             (_auth173137_
              (if (eq? _auth173110173123_ absent-value)
                  '#f
                  _auth173110173123_)))
        (let ((_url173139_
               (std/net/request#url-target-e _url173125_ _params173133_))
              (_headers173140_
               (std/net/request#make-http/1.1-headers
                _headers173129_
                _cookies173131_
                _auth173137_)))
          (std/net/request#http-request
           'GET
           _url173139_
           _headers173140_
           _data173135_
           '()
           _redirect173127_)))))
  (define std/net/request#http-get__@
    (lambda (_keys173104173145_ . _args173147_)
      (apply std/net/request#http-get__%
             _keys173104173145_
             (table-ref _keys173104173145_ 'redirect: absent-value)
             (table-ref _keys173104173145_ 'headers: absent-value)
             (table-ref _keys173104173145_ 'cookies: absent-value)
             (table-ref _keys173104173145_ 'params: absent-value)
             (table-ref _keys173104173145_ 'data: absent-value)
             (table-ref _keys173104173145_ 'auth: absent-value)
             _args173147_)))
  (define std/net/request#http-get
    (lambda _args173111173153_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                data:
                #f
                #f
                #f
                headers:
                #f
                params:
                #f
                redirect:
                #f
                #f
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                auth:
                #f
                #f
                #f
                #f)
             std/net/request#http-get__@
             _args173111173153_)))
  (define std/net/request#http-head__%
    (lambda (_g300903_
             _redirect173052173060_
             _headers173053173062_
             _cookies173054173064_
             _params173055173066_
             _data173056173068_
             _auth173057173070_
             _url173072_)
      (let* ((_redirect173074_
              (if (eq? _redirect173052173060_ absent-value)
                  '#t
                  _redirect173052173060_))
             (_headers173076_
              (if (eq? _headers173053173062_ absent-value)
                  '#f
                  _headers173053173062_))
             (_cookies173078_
              (if (eq? _cookies173054173064_ absent-value)
                  '#f
                  _cookies173054173064_))
             (_params173080_
              (if (eq? _params173055173066_ absent-value)
                  '#f
                  _params173055173066_))
             (_data173082_
              (if (eq? _data173056173068_ absent-value)
                  '#f
                  _data173056173068_))
             (_auth173084_
              (if (eq? _auth173057173070_ absent-value)
                  '#f
                  _auth173057173070_)))
        (let ((_url173086_
               (std/net/request#url-target-e _url173072_ _params173080_))
              (_headers173087_
               (std/net/request#make-http/1.1-headers
                _headers173076_
                _cookies173078_
                _auth173084_)))
          (std/net/request#http-request
           'HEAD
           _url173086_
           _headers173087_
           _data173082_
           '()
           _redirect173074_)))))
  (define std/net/request#http-head__@
    (lambda (_keys173051173092_ . _args173094_)
      (apply std/net/request#http-head__%
             _keys173051173092_
             (table-ref _keys173051173092_ 'redirect: absent-value)
             (table-ref _keys173051173092_ 'headers: absent-value)
             (table-ref _keys173051173092_ 'cookies: absent-value)
             (table-ref _keys173051173092_ 'params: absent-value)
             (table-ref _keys173051173092_ 'data: absent-value)
             (table-ref _keys173051173092_ 'auth: absent-value)
             _args173094_)))
  (define std/net/request#http-head
    (lambda _args173058173100_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                data:
                #f
                #f
                #f
                headers:
                #f
                params:
                #f
                redirect:
                #f
                #f
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                auth:
                #f
                #f
                #f
                #f)
             std/net/request#http-head__@
             _args173058173100_)))
  (define std/net/request#http-post__%
    (lambda (_g300904_
             _redirect172997173005_
             _headers172998173007_
             _cookies172999173009_
             _params173000173011_
             _data173001173013_
             _auth173002173015_
             _url173017_)
      (let* ((_redirect173019_
              (if (eq? _redirect172997173005_ absent-value)
                  '#t
                  _redirect172997173005_))
             (_headers173021_
              (if (eq? _headers172998173007_ absent-value)
                  '#f
                  _headers172998173007_))
             (_cookies173023_
              (if (eq? _cookies172999173009_ absent-value)
                  '#f
                  _cookies172999173009_))
             (_params173025_
              (if (eq? _params173000173011_ absent-value)
                  '#f
                  _params173000173011_))
             (_data173027_
              (if (eq? _data173001173013_ absent-value)
                  '#f
                  _data173001173013_))
             (_auth173029_
              (if (eq? _auth173002173015_ absent-value)
                  '#f
                  _auth173002173015_))
             (_g300905_
              (if _params173025_
                  (let ((_form-data173031_
                         (std/net/uri#form-url-encode__% _params173025_ '#t)))
                    (values (std/net/request#http-headers-cons
                             '(("Content-Type"
                                .
                                "application/x-www-form-urlencoded"))
                             (std/net/request#make-http/1.1-headers
                              _headers173021_
                              _cookies173023_
                              _auth173029_))
                            _form-data173031_))
                  (values (std/net/request#make-http/1.1-headers
                           _headers173021_
                           _cookies173023_
                           _auth173029_)
                          _data173027_))))
        (begin
          #!void
          (let ((_headers173033_
                 (let () (declare (not safe)) (##vector-ref _g300905_ 0)))
                (_data173034_
                 (let () (declare (not safe)) (##vector-ref _g300905_ 1))))
            (std/net/request#http-request
             'POST
             _url173017_
             _headers173033_
             _data173034_
             '()
             _redirect173019_))))))
  (define std/net/request#http-post__@
    (lambda (_keys172996173039_ . _args173041_)
      (apply std/net/request#http-post__%
             _keys172996173039_
             (table-ref _keys172996173039_ 'redirect: absent-value)
             (table-ref _keys172996173039_ 'headers: absent-value)
             (table-ref _keys172996173039_ 'cookies: absent-value)
             (table-ref _keys172996173039_ 'params: absent-value)
             (table-ref _keys172996173039_ 'data: absent-value)
             (table-ref _keys172996173039_ 'auth: absent-value)
             _args173041_)))
  (define std/net/request#http-post
    (lambda _args173003173047_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                data:
                #f
                #f
                #f
                headers:
                #f
                params:
                #f
                redirect:
                #f
                #f
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                auth:
                #f
                #f
                #f
                #f)
             std/net/request#http-post__@
             _args173003173047_)))
  (define std/net/request#http-put__%
    (lambda (_g300906_
             _redirect172944172952_
             _headers172945172954_
             _cookies172946172956_
             _params172947172958_
             _data172948172960_
             _auth172949172962_
             _url172964_)
      (let* ((_redirect172966_
              (if (eq? _redirect172944172952_ absent-value)
                  '#t
                  _redirect172944172952_))
             (_headers172968_
              (if (eq? _headers172945172954_ absent-value)
                  '#f
                  _headers172945172954_))
             (_cookies172970_
              (if (eq? _cookies172946172956_ absent-value)
                  '#f
                  _cookies172946172956_))
             (_params172972_
              (if (eq? _params172947172958_ absent-value)
                  '#f
                  _params172947172958_))
             (_data172974_
              (if (eq? _data172948172960_ absent-value)
                  '#f
                  _data172948172960_))
             (_auth172976_
              (if (eq? _auth172949172962_ absent-value)
                  '#f
                  _auth172949172962_)))
        (let ((_url172978_
               (std/net/request#url-target-e _url172964_ _params172972_))
              (_headers172979_
               (std/net/request#make-http/1.1-headers
                _headers172968_
                _cookies172970_
                _auth172976_)))
          (std/net/request#http-request
           'PUT
           _url172978_
           _headers172979_
           _data172974_
           '()
           _redirect172966_)))))
  (define std/net/request#http-put__@
    (lambda (_keys172943172984_ . _args172986_)
      (apply std/net/request#http-put__%
             _keys172943172984_
             (table-ref _keys172943172984_ 'redirect: absent-value)
             (table-ref _keys172943172984_ 'headers: absent-value)
             (table-ref _keys172943172984_ 'cookies: absent-value)
             (table-ref _keys172943172984_ 'params: absent-value)
             (table-ref _keys172943172984_ 'data: absent-value)
             (table-ref _keys172943172984_ 'auth: absent-value)
             _args172986_)))
  (define std/net/request#http-put
    (lambda _args172950172992_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                data:
                #f
                #f
                #f
                headers:
                #f
                params:
                #f
                redirect:
                #f
                #f
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                auth:
                #f
                #f
                #f
                #f)
             std/net/request#http-put__@
             _args172950172992_)))
  (define std/net/request#http-delete__%
    (lambda (_g300907_
             _redirect172891172899_
             _headers172892172901_
             _cookies172893172903_
             _params172894172905_
             _data172895172907_
             _auth172896172909_
             _url172911_)
      (let* ((_redirect172913_
              (if (eq? _redirect172891172899_ absent-value)
                  '#t
                  _redirect172891172899_))
             (_headers172915_
              (if (eq? _headers172892172901_ absent-value)
                  '#f
                  _headers172892172901_))
             (_cookies172917_
              (if (eq? _cookies172893172903_ absent-value)
                  '#f
                  _cookies172893172903_))
             (_params172919_
              (if (eq? _params172894172905_ absent-value)
                  '#f
                  _params172894172905_))
             (_data172921_
              (if (eq? _data172895172907_ absent-value)
                  '#f
                  _data172895172907_))
             (_auth172923_
              (if (eq? _auth172896172909_ absent-value)
                  '#f
                  _auth172896172909_)))
        (let ((_url172925_
               (std/net/request#url-target-e _url172911_ _params172919_))
              (_headers172926_
               (std/net/request#make-http/1.1-headers
                _headers172915_
                _cookies172917_
                _auth172923_)))
          (std/net/request#http-request
           'DELETE
           _url172925_
           _headers172926_
           _data172921_
           '()
           _redirect172913_)))))
  (define std/net/request#http-delete__@
    (lambda (_keys172890172931_ . _args172933_)
      (apply std/net/request#http-delete__%
             _keys172890172931_
             (table-ref _keys172890172931_ 'redirect: absent-value)
             (table-ref _keys172890172931_ 'headers: absent-value)
             (table-ref _keys172890172931_ 'cookies: absent-value)
             (table-ref _keys172890172931_ 'params: absent-value)
             (table-ref _keys172890172931_ 'data: absent-value)
             (table-ref _keys172890172931_ 'auth: absent-value)
             _args172933_)))
  (define std/net/request#http-delete
    (lambda _args172897172939_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                data:
                #f
                #f
                #f
                headers:
                #f
                params:
                #f
                redirect:
                #f
                #f
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                auth:
                #f
                #f
                #f
                #f)
             std/net/request#http-delete__@
             _args172897172939_)))
  (define std/net/request#http-options__%
    (lambda (_g300908_
             _redirect172838172846_
             _headers172839172848_
             _cookies172840172850_
             _params172841172852_
             _data172842172854_
             _auth172843172856_
             _url172858_)
      (let* ((_redirect172860_
              (if (eq? _redirect172838172846_ absent-value)
                  '#t
                  _redirect172838172846_))
             (_headers172862_
              (if (eq? _headers172839172848_ absent-value)
                  '#f
                  _headers172839172848_))
             (_cookies172864_
              (if (eq? _cookies172840172850_ absent-value)
                  '#f
                  _cookies172840172850_))
             (_params172866_
              (if (eq? _params172841172852_ absent-value)
                  '#f
                  _params172841172852_))
             (_data172868_
              (if (eq? _data172842172854_ absent-value)
                  '#f
                  _data172842172854_))
             (_auth172870_
              (if (eq? _auth172843172856_ absent-value)
                  '#f
                  _auth172843172856_)))
        (let ((_url172872_
               (std/net/request#url-target-e _url172858_ _params172866_))
              (_headers172873_
               (std/net/request#make-http/1.1-headers
                _headers172862_
                _cookies172864_
                _auth172870_)))
          (std/net/request#http-request
           'OPTIONS
           _url172872_
           _headers172873_
           _data172868_
           '()
           _redirect172860_)))))
  (define std/net/request#http-options__@
    (lambda (_keys172837172878_ . _args172880_)
      (apply std/net/request#http-options__%
             _keys172837172878_
             (table-ref _keys172837172878_ 'redirect: absent-value)
             (table-ref _keys172837172878_ 'headers: absent-value)
             (table-ref _keys172837172878_ 'cookies: absent-value)
             (table-ref _keys172837172878_ 'params: absent-value)
             (table-ref _keys172837172878_ 'data: absent-value)
             (table-ref _keys172837172878_ 'auth: absent-value)
             _args172880_)))
  (define std/net/request#http-options
    (lambda _args172844172886_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                data:
                #f
                #f
                #f
                headers:
                #f
                params:
                #f
                redirect:
                #f
                #f
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                auth:
                #f
                #f
                #f
                #f)
             std/net/request#http-options__@
             _args172844172886_)))
  (define std/net/request#url-rx
    (std/pregexp#pregexp '"(?:(https?)://)?([^/:]+)(:[0-9]+)?(/.*)?"))
  (define std/net/request#+tls-context+
    (make-promise (lambda () (make-tls-context))))
  (define std/net/request#http-request
    (lambda (_method172703_
             _url172704_
             _user-headers172705_
             _body172706_
             _history172707_
             _redirect172708_)
      (let* ((_g172709172724_
              (std/pregexp#pregexp-match std/net/request#url-rx _url172704_))
             (_E172711172728_
              (lambda () (error '"No clause matching" _g172709172724_)))
             (_K172712172801_
              (lambda (_target172731_ _port172732_ _host172733_ _scheme172734_)
                (let* ((_scheme172739_
                        (let ((_$e172736_ _scheme172734_))
                          (if _$e172736_ _$e172736_ '"http")))
                       (_port172741_
                        (if _port172732_
                            (string->number
                             (substring
                              _port172732_
                              '1
                              (string-length _port172732_)))
                            (if (equal? _scheme172739_ '"https") '443 '80)))
                       (_target172746_
                        (let ((_$e172743_ _target172731_))
                          (if _$e172743_ _$e172743_ '"/")))
                       (_host-header172754_
                        (let ((_$e172748_ _port172741_))
                          (if (or (eq? '80 _$e172748_) (eq? '443 _$e172748_))
                              _host172733_
                              (std/format#format
                               '"~a:~a"
                               _host172733_
                               _port172741_))))
                       (_headers172756_
                        (std/net/request#http-headers-cons
                         (cons (cons '"Host" _host-header172754_) '())
                         _user-headers172705_))
                       (_body172758_
                        (if (not _body172706_)
                            '#f
                            (if (u8vector? _body172706_)
                                _body172706_
                                (if (string? _body172706_)
                                    (std/text/utf8#string->utf8__0
                                     _body172706_)
                                    (error '"bad request body"
                                           _body172706_)))))
                       (_headers172760_
                        (if _body172758_
                            (std/net/request#http-headers-cons!
                             (cons (cons '"Content-Length"
                                         (u8vector-length _body172758_))
                                   '())
                             _headers172756_)
                            _headers172756_))
                       (_tcp-client-options172762_
                        (cons 'server-address:
                              (cons _host172733_
                                    (cons 'port-number:
                                          (cons _port172741_
                                                (cons 'eol-encoding:
                                                      (cons 'cr-lf '())))))))
                       (_tcp-client-options172764_
                        (if (equal? _scheme172739_ '"https")
                            (cons 'tls-context:
                                  (cons (force std/net/request#+tls-context+)
                                        _tcp-client-options172762_))
                            _tcp-client-options172762_))
                       (_sock172766_
                        (open-tcp-client _tcp-client-options172764_))
                       (_req172768_
                        (let ((__obj300900
                               (make-object std/net/request#request::t '8)))
                          (if (let ((__tmp300909
                                     (let ()
                                       (declare (not safe))
                                       (##vector-length __obj300900))))
                                (declare (not safe))
                                (##fx< '3 __tmp300909))
                              (begin
                                (let ()
                                  (declare (not safe))
                                  (##vector-set! __obj300900 '1 _sock172766_))
                                (let ()
                                  (declare (not safe))
                                  (##vector-set! __obj300900 '2 _url172704_))
                                (let ()
                                  (declare (not safe))
                                  (##vector-set!
                                   __obj300900
                                   '3
                                   _history172707_)))
                              (error '"struct-instance-init!: too many arguments for struct"
                                     __obj300900))
                          __obj300900)))
                  (std/net/request#http-request-write
                   _sock172766_
                   _method172703_
                   _target172746_
                   _headers172760_
                   _body172758_)
                  (std/net/request#http-request-read-response! _req172768_)
                  (let ((_$e172771_
                         (if _redirect172708_
                             (if (memv (##structure-ref
                                        _req172768_
                                        '4
                                        std/net/request#request::t
                                        '#f)
                                       '(301 302 303 307))
                                 (if (memq _method172703_ '(GET HEAD))
                                     (assoc '"Location"
                                            (##structure-ref
                                             _req172768_
                                             '6
                                             std/net/request#request::t
                                             '#f))
                                     '#f)
                                 '#f)
                             '#f)))
                    (if _$e172771_
                        ((lambda (_e172773172775_)
                           (let* ((_g172777172784_ _e172773172775_)
                                  (_E172779172788_
                                   (lambda ()
                                     (error '"No clause matching"
                                            _g172777172784_)))
                                  (_K172780172793_
                                   (lambda (_new-url172791_)
                                     (if (member _new-url172791_
                                                 _history172707_)
                                         (error '"URL redirection loop"
                                                _url172704_)
                                         (begin
                                           (std/net/request#request-close
                                            _req172768_)
                                           (std/net/request#http-request
                                            _method172703_
                                            _new-url172791_
                                            _user-headers172705_
                                            _body172758_
                                            (cons _url172704_ _history172707_)
                                            '#t))))))
                             (if (let ()
                                   (declare (not safe))
                                   (##pair? _g172777172784_))
                                 (let* ((_tl172782172796_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _g172777172784_)))
                                        (_new-url172799_ _tl172782172796_))
                                   (_K172780172793_ _new-url172799_))
                                 (_E172779172788_))))
                         _$e172771_)
                        _req172768_))))))
        (if (let () (declare (not safe)) (##pair? _g172709172724_))
            (let ((_tl172714172804_
                   (let () (declare (not safe)) (##cdr _g172709172724_))))
              (if (let () (declare (not safe)) (##pair? _tl172714172804_))
                  (let ((_hd172715172807_
                         (let ()
                           (declare (not safe))
                           (##car _tl172714172804_)))
                        (_tl172716172809_
                         (let ()
                           (declare (not safe))
                           (##cdr _tl172714172804_))))
                    (let ((_scheme172812_ _hd172715172807_))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _tl172716172809_))
                          (let ((_hd172717172814_
                                 (let ()
                                   (declare (not safe))
                                   (##car _tl172716172809_)))
                                (_tl172718172816_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _tl172716172809_))))
                            (let ((_host172819_ _hd172717172814_))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _tl172718172816_))
                                  (let ((_hd172719172821_
                                         (let ()
                                           (declare (not safe))
                                           (##car _tl172718172816_)))
                                        (_tl172720172823_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _tl172718172816_))))
                                    (let ((_port172826_ _hd172719172821_))
                                      (if (let ()
                                            (declare (not safe))
                                            (##pair? _tl172720172823_))
                                          (let ((_hd172721172828_
                                                 (let ()
                                                   (declare (not safe))
                                                   (##car _tl172720172823_)))
                                                (_tl172722172830_
                                                 (let ()
                                                   (declare (not safe))
                                                   (##cdr _tl172720172823_))))
                                            (let ((_target172833_
                                                   _hd172721172828_))
                                              (if (let ()
                                                    (declare (not safe))
                                                    (##null? _tl172722172830_))
                                                  (_K172712172801_
                                                   _target172833_
                                                   _port172826_
                                                   _host172819_
                                                   _scheme172812_)
                                                  (_E172711172728_))))
                                          (_E172711172728_))))
                                  (_E172711172728_))))
                          (_E172711172728_))))
                  (_E172711172728_)))
            (_E172711172728_)))))
  (define std/net/request#http-request-write
    (lambda (_port172665_
             _method172666_
             _target172667_
             _headers172668_
             _body172669_)
      (std/format#fprintf
       _port172665_
       '"~a ~a HTTP/1.1~n"
       _method172666_
       _target172667_)
      (for-each
       (lambda (_e172670172672_)
         (let* ((_g172674172681_ _e172670172672_)
                (_E172676172685_
                 (lambda () (error '"No clause matching" _g172674172681_)))
                (_K172677172691_
                 (lambda (_val172688_ _key172689_)
                   (std/format#fprintf
                    _port172665_
                    '"~a: ~a~n"
                    _key172689_
                    _val172688_))))
           (if (let () (declare (not safe)) (##pair? _g172674172681_))
               (let ((_hd172678172694_
                      (let () (declare (not safe)) (##car _g172674172681_)))
                     (_tl172679172696_
                      (let () (declare (not safe)) (##cdr _g172674172681_))))
                 (let* ((_key172699_ _hd172678172694_)
                        (_val172701_ _tl172679172696_))
                   (_K172677172691_ _val172701_ _key172699_)))
               (_E172676172685_))))
       _headers172668_)
      (newline _port172665_)
      (if _body172669_
          (write-subu8vector
           _body172669_
           '0
           (u8vector-length _body172669_)
           _port172665_)
          '#!void)
      (force-output _port172665_)))
  (define std/net/request#status-line-rx
    (std/pregexp#pregexp '"([0-9]{3})\\s+(.*)"))
  (define std/net/request#header-line-rx
    (std/pregexp#pregexp '"([^:]+):\\s*(.*)?"))
  (define std/net/request#http-request-read-response!
    (lambda (_req172558_)
      (let* ((_port172560_
              (##structure-ref _req172558_ '1 std/net/request#request::t '#f))
             (_status-line172562_
              (std/net/request#read-response-line _port172560_)))
        (let* ((_g172564172576_
                (std/pregexp#pregexp-match
                 std/net/request#status-line-rx
                 _status-line172562_))
               (_else172566172584_
                (lambda ()
                  (std/error#raise-io-error
                   'http-request-read-response!
                   '"malformed status line"
                   _port172560_
                   _status-line172562_)))
               (_K172568172645_
                (lambda (_status-text172587_ _status172588_)
                  (##structure-set!
                   _req172558_
                   (string->number _status172588_)
                   '4
                   std/net/request#request::t
                   '#f)
                  (##structure-set!
                   _req172558_
                   (std/srfi/13#string-trim-both__0 _status-text172587_)
                   '5
                   std/net/request#request::t
                   '#f)
                  (let ((_root172590_ (cons '#f '())))
                    (let _lp172592_ ((_tl172594_ _root172590_))
                      (let ((_next172596_
                             (std/net/request#read-response-line
                              _port172560_)))
                        (if (string-empty? _next172596_)
                            (##structure-set!
                             _req172558_
                             (cdr _root172590_)
                             '6
                             std/net/request#request::t
                             '#f)
                            (let* ((_g172597172609_
                                    (std/pregexp#pregexp-match
                                     std/net/request#header-line-rx
                                     _next172596_))
                                   (_else172599172617_
                                    (lambda ()
                                      (std/error#raise-io-error
                                       'http-request-read-response!
                                       '"Malformed header"
                                       _port172560_
                                       _next172596_)))
                                   (_K172601172625_
                                    (lambda (_value172620_ _key172621_)
                                      (let ((_tl*172623_
                                             (cons (cons (std/srfi/13#string-titlecase__0
                                                          _key172621_)
                                                         (std/srfi/13#string-trim-both__0
                                                          _value172620_))
                                                   '())))
                                        (set-cdr! _tl172594_ _tl*172623_)
                                        (_lp172592_ _tl*172623_)))))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _g172597172609_))
                                  (let ((_tl172603172628_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _g172597172609_))))
                                    (if (let ()
                                          (declare (not safe))
                                          (##pair? _tl172603172628_))
                                        (let ((_hd172604172631_
                                               (let ()
                                                 (declare (not safe))
                                                 (##car _tl172603172628_)))
                                              (_tl172605172633_
                                               (let ()
                                                 (declare (not safe))
                                                 (##cdr _tl172603172628_))))
                                          (let ((_key172636_ _hd172604172631_))
                                            (if (let ()
                                                  (declare (not safe))
                                                  (##pair? _tl172605172633_))
                                                (let ((_hd172606172638_
                                                       (let ()
                                                         (declare (not safe))
                                                         (##car _tl172605172633_)))
                                                      (_tl172607172640_
                                                       (let ()
                                                         (declare (not safe))
                                                         (##cdr _tl172605172633_))))
                                                  (let ((_value172643_
                                                         _hd172606172638_))
                                                    (if (let ()
                                                          (declare (not safe))
                                                          (##null? _tl172607172640_))
                                                        (_K172601172625_
                                                         _value172643_
                                                         _key172636_)
                                                        (_else172599172617_))))
                                                (_else172599172617_))))
                                        (_else172599172617_)))
                                  (_else172599172617_))))))))))
          (if (let () (declare (not safe)) (##pair? _g172564172576_))
              (let ((_tl172570172648_
                     (let () (declare (not safe)) (##cdr _g172564172576_))))
                (if (let () (declare (not safe)) (##pair? _tl172570172648_))
                    (let ((_hd172571172651_
                           (let ()
                             (declare (not safe))
                             (##car _tl172570172648_)))
                          (_tl172572172653_
                           (let ()
                             (declare (not safe))
                             (##cdr _tl172570172648_))))
                      (let ((_status172656_ _hd172571172651_))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _tl172572172653_))
                            (let ((_hd172573172658_
                                   (let ()
                                     (declare (not safe))
                                     (##car _tl172572172653_)))
                                  (_tl172574172660_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _tl172572172653_))))
                              (let ((_status-text172663_ _hd172573172658_))
                                (if (let ()
                                      (declare (not safe))
                                      (##null? _tl172574172660_))
                                    (_K172568172645_
                                     _status-text172663_
                                     _status172656_)
                                    (_else172566172584_))))
                            (_else172566172584_))))
                    (_else172566172584_)))
              (_else172566172584_))))))
  (define std/net/request#http-request-read-body
    (lambda (_port172543_ _headers172544_)
      (letrec ((_length-e172546_
                (lambda (_headers172553_)
                  (let ((_$e172555_
                         (assget '"Content-Length" _headers172553_)))
                    (if _$e172555_ (string->number _$e172555_) '#f)))))
        (let ((_$e172548_ (assget '"Transfer-Encoding" _headers172544_)))
          (if _$e172548_
              ((lambda (_tenc172551_)
                 (if (not (equal? '"identity" _tenc172551_))
                     (std/net/request#http-request-read-chunked-body
                      _port172543_)
                     (std/net/request#http-request-read-simple-body
                      _port172543_
                      (_length-e172546_ _headers172544_))))
               _$e172548_)
              (std/net/request#http-request-read-simple-body
               _port172543_
               (_length-e172546_ _headers172544_)))))))
  (define std/net/request#http-request-read-chunked-body
    (lambda (_port172523_)
      (let ((_root172525_ (cons '#f '())))
        (let _lp172527_ ((_tl172529_ _root172525_))
          (let* ((_line172531_
                  (std/net/request#read-response-line _port172523_))
                 (_clen172533_
                  (string->number
                   (car (string-split _line172531_ '#\space))
                   '16)))
            (if (fxzero? _clen172533_)
                (u8vector-concatenate (cdr _root172525_))
                (let* ((_chunk172536_ (make-u8vector _clen172533_))
                       (_rd172538_
                        (read-subu8vector
                         _chunk172536_
                         '0
                         _clen172533_
                         _port172523_)))
                  (if (let ()
                        (declare (not safe))
                        (##fx< _rd172538_ _clen172533_))
                      (std/error#raise-io-error
                       'http-request-read-body
                       '"error reading chunk; premature end of port")
                      '#!void)
                  (std/net/request#read-response-line _port172523_)
                  (let ((_tl*172541_ (cons _chunk172536_ '())))
                    (set-cdr! _tl172529_ _tl*172541_)
                    (_lp172527_ _tl*172541_)))))))))
  (define std/net/request#http-request-read-simple-body
    (lambda (_port172492_ _length172493_)
      (letrec ((_read/length172495_
                (lambda (_port172515_ _length172516_)
                  (let* ((_data172518_ (make-u8vector _length172516_))
                         (_rd172520_
                          (read-subu8vector
                           _data172518_
                           '0
                           _length172516_
                           _port172515_)))
                    (if (let ()
                          (declare (not safe))
                          (##fx< _rd172520_ _length172516_))
                        (begin
                          (u8vector-shrink! _data172518_ _rd172520_)
                          _data172518_)
                        _data172518_))))
               (_read/end172496_
                (lambda (_port172498_)
                  (let ((_root172500_ (cons '#f '())))
                    (let _lp172502_ ((_tl172504_ _root172500_))
                      (let* ((_buflen172506_ '4096)
                             (_buf172508_ (make-u8vector _buflen172506_))
                             (_rd172510_
                              (read-subu8vector
                               _buf172508_
                               '0
                               _buflen172506_
                               _port172498_)))
                        (if (let ()
                              (declare (not safe))
                              (##fxzero? _rd172510_))
                            (u8vector-concatenate (cdr _root172500_))
                            (if (let ()
                                  (declare (not safe))
                                  (##fx< _rd172510_ _buflen172506_))
                                (begin
                                  (u8vector-shrink! _buf172508_ _rd172510_)
                                  (set-cdr! _tl172504_ (cons _buf172508_ '()))
                                  (u8vector-concatenate (cdr _root172500_)))
                                (let ((_tl*172513_ (cons _buf172508_ '())))
                                  (set-cdr! _tl172504_ _tl*172513_)
                                  (_lp172502_ _tl*172513_))))))))))
        (if _length172493_
            (_read/length172495_ _port172492_ _length172493_)
            (_read/end172496_ _port172492_)))))
  (define std/net/request#cr (char->integer '#\return))
  (define std/net/request#lf (char->integer '#\newline))
  (define std/net/request#crlf
    (u8vector std/net/request#cr std/net/request#lf))
  (define std/net/request#read-response-line
    (lambda (_port172476_)
      (let ((_root172478_ (cons '#f '())))
        (let _lp172480_ ((_tl172482_ _root172478_))
          (let ((_next172484_ (read-u8 _port172476_)))
            (if (eof-object? _next172484_)
                (std/error#raise-io-error
                 'request-read-response-line
                 '"Incomplete response; connection closed"
                 _port172476_)
                (if (eq? _next172484_ std/net/request#cr)
                    (let ((_next172486_ (read-u8 _port172476_)))
                      (if (eof-object? _next172486_)
                          (std/error#raise-io-error
                           'request-read-response-line
                           '"Incomplete response; connection closed"
                           _port172476_)
                          (if (eq? _next172486_ std/net/request#lf)
                              (std/text/utf8#utf8->string__0
                               (list->u8vector (cdr _root172478_)))
                              (let ((_tl*172488_
                                     (cons std/net/request#cr
                                           (cons _next172486_ '()))))
                                (set-cdr! _tl172482_ _tl*172488_)
                                (_lp172480_ (cdr _tl*172488_))))))
                    (let ((_tl*172490_ (cons _next172484_ '())))
                      (set-cdr! _tl172482_ _tl*172490_)
                      (_lp172480_ _tl*172490_)))))))))
  (define std/net/request#request-close
    (lambda (_req172467_)
      (let ((_port172468172470_
             (##structure-ref _req172467_ '1 std/net/request#request::t '#f)))
        (if _port172468172470_
            (let ((_port172473_ _port172468172470_))
              (with-exception-catcher
               void
               (lambda () (close-port _port172473_)))
              (##structure-set!
               _req172467_
               '#f
               '1
               std/net/request#request::t
               '#f))
            '#f))))
  (define std/net/request#request::destroy std/net/request#request-close)
  (bind-method!
   std/net/request#request::t
   'destroy
   std/net/request#request::destroy
   '#f)
  (define std/net/request#request-content
    (lambda (_req172315_)
      (let ((_$e172317_
             (##structure-ref _req172315_ '7 std/net/request#request::t '#f)))
        (if _$e172317_
            (values _$e172317_)
            (let ((_$e172320_
                   (##structure-ref
                    _req172315_
                    '1
                    std/net/request#request::t
                    '#f)))
              (if _$e172320_
                  ((lambda (_port172323_)
                     (let ((_headers172325_
                            (##structure-ref
                             _req172315_
                             '6
                             std/net/request#request::t
                             '#f)))
                       (with-unwind-protect
                        (lambda ()
                          (let* ((_body172328_
                                  (std/net/request#http-request-read-body
                                   _port172323_
                                   _headers172325_))
                                 (_body172341_
                                  (let ((_$e172330_
                                         (assoc '"Content-Encoding"
                                                _headers172325_)))
                                    (if _$e172330_
                                        ((lambda (_enc172333_)
                                           (let ((_$e172335_
                                                  (cdr _enc172333_)))
                                             (if (or (equal? '"gzip"
                                                             _$e172335_)
                                                     (equal? '"deflate"
                                                             _$e172335_))
                                                 (std/text/zlib#uncompress
                                                  _body172328_)
                                                 (if (equal? '"identity"
                                                             _$e172335_)
                                                     _body172328_
                                                     (error '"Unsupported content encoding"
                                                            _enc172333_)))))
                                         _$e172330_)
                                        _body172328_))))
                            (##structure-set!
                             _req172315_
                             _body172341_
                             '7
                             std/net/request#request::t
                             '#f)
                            _body172341_))
                        (lambda ()
                          (close-port _port172323_)
                          (##structure-set!
                           _req172315_
                           '#f
                           '1
                           std/net/request#request::t
                           '#f)))))
                   _$e172320_)
                  '#f))))))
  (define std/net/request#request-text
    (lambda (_req172306_)
      (letrec ((_get-text172308_
                (lambda (_enc172313_)
                  (if (eq? _enc172313_ 'UTF-8)
                      (std/text/utf8#utf8->string__0
                       (std/net/request#request-content _req172306_))
                      (bytes->string
                       (std/net/request#request-content _req172306_)
                       _enc172313_)))))
        (let ((_$e172310_
               (##structure-ref
                _req172306_
                '8
                std/net/request#request::t
                '#f)))
          (if _$e172310_
              (_get-text172308_ _$e172310_)
              (_get-text172308_ 'UTF-8))))))
  (define std/net/request#request-json
    (lambda (_req172304_)
      (std/text/json#string->json-object
       (std/net/request#request-text _req172304_))))
  (define std/net/request#request-cookies
    (lambda (_req172069_)
      (let* ((_head172071_ (cons '#f '())) (_tail172074_ _head172071_))
        (let _lp172234_ ((_rest172236_
                          (##structure-ref
                           _req172069_
                           '6
                           std/net/request#request::t
                           '#f)))
          (let* ((_rest172237172245_ _rest172236_)
                 (_else172239172253_ (lambda () '#!void))
                 (_K172241172292_
                  (lambda (_rest172256_ _hd172257_)
                    (let* ((_hd172258172266_ _hd172257_)
                           (_else172260172274_
                            (lambda () (_lp172234_ _rest172256_)))
                           (_K172262172282_
                            (lambda (_cookie172277_)
                              (let ((_new-tail172279_
                                     (cons _cookie172277_ '())))
                                (let ()
                                  (declare (not safe))
                                  (##set-cdr! _tail172074_ _new-tail172279_))
                                (set! _tail172074_ _new-tail172279_))
                              (_lp172234_ _rest172256_))))
                      (if (let ()
                            (declare (not safe))
                            (##pair? _hd172258172266_))
                          (let ((_hd172263172285_
                                 (let ()
                                   (declare (not safe))
                                   (##car _hd172258172266_)))
                                (_tl172264172287_
                                 (let ()
                                   (declare (not safe))
                                   (##cdr _hd172258172266_))))
                            (if (equal? _hd172263172285_ '"Set-Cookie")
                                (let ((_cookie172290_ _tl172264172287_))
                                  (_K172262172282_ _cookie172290_))
                                (_else172260172274_)))
                          (_else172260172274_))))))
            (if (let () (declare (not safe)) (##pair? _rest172237172245_))
                (let ((_hd172242172295_
                       (let ()
                         (declare (not safe))
                         (##car _rest172237172245_)))
                      (_tl172243172297_
                       (let ()
                         (declare (not safe))
                         (##cdr _rest172237172245_))))
                  (let* ((_hd172300_ _hd172242172295_)
                         (_rest172302_ _tl172243172297_))
                    (_K172241172292_ _rest172302_ _hd172300_)))
                '#!void)))
        (let () (declare (not safe)) (##cdr _head172071_))))))
