(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/socks#open-socks-client
    (lambda (_proxy172057_ _server172058_ _open172059_ _connect172060_)
      (let ((_sock172062_
             (open-tcp-client
              (std/net/address#inet-address->string
               (std/net/address#inet-address _proxy172057_)))))
        (with-exception-catcher
         (lambda (_e172064_)
           (with-exception-catcher void (lambda () (close-port _sock172062_)))
           (raise _e172064_))
         (lambda ()
           (_open172059_ _sock172062_)
           (_connect172060_ _sock172062_ _server172058_)
           _sock172062_)))))
  (define std/net/socks#open-socks4-client
    (lambda (_proxy172054_ _server172055_)
      (std/net/socks#open-socks-client
       _proxy172054_
       _server172055_
       void
       std/net/socks#socks4-connect)))
  (define std/net/socks#open-socks5-client
    (lambda (_proxy172051_ _server172052_)
      (std/net/socks#open-socks-client
       _proxy172051_
       _server172052_
       std/net/socks#socks5-open
       std/net/socks#socks5-connect)))
  (define std/net/socks#socks5-open
    (lambda (_sock172043_)
      (std/net/socks#send-msg _sock172043_ '#u8(5 1 0))
      (let ((_in172045_ (let () (declare (not safe)) (##make-u8vector '2 '0))))
        (std/net/socks#recv-msg _sock172043_ _in172045_)
        (let ((_proto172047_
               (let () (declare (not safe)) (##u8vector-ref _in172045_ '0))))
          (if (eq? _proto172047_ '5)
              '#!void
              (std/error#raise-io-error
               'socks5-open
               '"SOCKS5 handshake error; protocol version mismatch"
               _proto172047_)))
        (let ((_rep172049_
               (let () (declare (not safe)) (##u8vector-ref _in172045_ '1))))
          (if (eq? _rep172049_ '0)
              '#!void
              (std/error#raise-io-error
               'socks5-open
               '"SOCKS5 handshake error; negotiation failed"
               _rep172049_))))))
  (define std/net/socks#socks5-connect
    (lambda (_sock172040_ _address172041_)
      (std/net/socks#socks-connect
       std/net/socks#socks5-send-request
       std/net/socks#socks5-recv-reply
       _sock172040_
       _address172041_)))
  (define std/net/socks#socks5-bind__%
    (lambda (_sock172027_ _address172028_)
      (std/net/socks#socks-bind
       std/net/socks#socks5-send-request
       std/net/socks#socks5-recv-reply
       _sock172027_
       _address172028_)))
  (define std/net/socks#socks5-bind__0
    (lambda (_sock172033_)
      (let ((_address172035_ '#f))
        (std/net/socks#socks5-bind__% _sock172033_ _address172035_))))
  (define std/net/socks#socks5-bind
    (lambda _g300858_
      (let ((_g300857_ (let () (declare (not safe)) (##length _g300858_))))
        (cond ((let () (declare (not safe)) (##fx= _g300857_ 1))
               (apply std/net/socks#socks5-bind__0 _g300858_))
              ((let () (declare (not safe)) (##fx= _g300857_ 2))
               (apply std/net/socks#socks5-bind__% _g300858_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socks#socks5-bind
                _g300858_))))))
  (define std/net/socks#socks5-accept
    (lambda (_sock172024_) (std/net/socks#socks5-recv-reply _sock172024_)))
  (define std/net/socks#socks4-connect__%
    (lambda (_sock172008_ _address172009_ _userid172010_)
      (std/net/socks#socks-connect
       std/net/socks#socks4-send-request
       std/net/socks#socks4-recv-reply
       _sock172008_
       _address172009_
       _userid172010_)))
  (define std/net/socks#socks4-connect__0
    (lambda (_sock172015_ _address172016_)
      (let ((_userid172018_ '#f))
        (std/net/socks#socks4-connect__%
         _sock172015_
         _address172016_
         _userid172018_))))
  (define std/net/socks#socks4-connect
    (lambda _g300860_
      (let ((_g300859_ (let () (declare (not safe)) (##length _g300860_))))
        (cond ((let () (declare (not safe)) (##fx= _g300859_ 2))
               (apply std/net/socks#socks4-connect__0 _g300860_))
              ((let () (declare (not safe)) (##fx= _g300859_ 3))
               (apply std/net/socks#socks4-connect__% _g300860_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socks#socks4-connect
                _g300860_))))))
  (define std/net/socks#socks4-bind__%
    (lambda (_sock171985_ _address171986_ _userid171987_)
      (std/net/socks#socks-bind
       std/net/socks#socks4-send-request
       std/net/socks#socks4-recv-reply
       _sock171985_
       _address171986_
       _userid171987_)))
  (define std/net/socks#socks4-bind__0
    (lambda (_sock171992_)
      (let* ((_address171994_ '#f) (_userid171996_ '#f))
        (std/net/socks#socks4-bind__%
         _sock171992_
         _address171994_
         _userid171996_))))
  (define std/net/socks#socks4-bind__1
    (lambda (_sock171998_ _address171999_)
      (let ((_userid172001_ '#f))
        (std/net/socks#socks4-bind__%
         _sock171998_
         _address171999_
         _userid172001_))))
  (define std/net/socks#socks4-bind
    (lambda _g300862_
      (let ((_g300861_ (let () (declare (not safe)) (##length _g300862_))))
        (cond ((let () (declare (not safe)) (##fx= _g300861_ 1))
               (apply std/net/socks#socks4-bind__0 _g300862_))
              ((let () (declare (not safe)) (##fx= _g300861_ 2))
               (apply std/net/socks#socks4-bind__1 _g300862_))
              ((let () (declare (not safe)) (##fx= _g300861_ 3))
               (apply std/net/socks#socks4-bind__% _g300862_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/socks#socks4-bind
                _g300862_))))))
  (define std/net/socks#socks4-accept
    (lambda (_sock171982_) (std/net/socks#socks4-recv-reply _sock171982_)))
  (define std/net/socks#socks-connect
    (lambda (_send171973_
             _recv171974_
             _sock171975_
             _address171976_
             .
             _args171977_)
      (let ((_g300863_ (std/net/socks#parse-address _address171976_)))
        (begin
          (let ((_g300864_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g300863_) (##vector-length _g300863_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g300864_ 2)))
                (error "Context expects 2 values" _g300864_)))
          (let ((_host171979_
                 (let () (declare (not safe)) (##vector-ref _g300863_ 0)))
                (_port171980_
                 (let () (declare (not safe)) (##vector-ref _g300863_ 1))))
            (apply _send171973_
                   _sock171975_
                   '1
                   _host171979_
                   _port171980_
                   _args171977_))))
      (_recv171974_ _sock171975_)))
  (define std/net/socks#socks-bind
    (lambda (_send171964_
             _recv171965_
             _sock171966_
             _address171967_
             .
             _args171968_)
      (let ((_g300865_
             (if _address171967_
                 (std/net/socks#parse-address _address171967_)
                 (values '#u8(0 0 0 0) '0))))
        (begin
          (let ((_g300866_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g300865_) (##vector-length _g300865_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g300866_ 2)))
                (error "Context expects 2 values" _g300866_)))
          (let ((_host171970_
                 (let () (declare (not safe)) (##vector-ref _g300865_ 0)))
                (_port171971_
                 (let () (declare (not safe)) (##vector-ref _g300865_ 1))))
            (begin
              (apply _send171964_
                     _sock171966_
                     '2
                     _host171970_
                     _port171971_
                     _args171968_)
              (_recv171965_ _sock171966_)))))))
  (define std/net/socks#parse-address
    (lambda (_addr171934_)
      (let* ((_g171935171942_ (std/net/address#inet-address _addr171934_))
             (_E171937171946_
              (lambda () (error '"No clause matching" _g171935171942_)))
             (_K171938171952_
              (lambda (_port171949_ _host171950_)
                (values _host171950_ _port171949_))))
        (if (let () (declare (not safe)) (##pair? _g171935171942_))
            (let ((_hd171939171955_
                   (let () (declare (not safe)) (##car _g171935171942_)))
                  (_tl171940171957_
                   (let () (declare (not safe)) (##cdr _g171935171942_))))
              (let* ((_host171960_ _hd171939171955_)
                     (_port171962_ _tl171940171957_))
                (_K171938171952_ _port171962_ _host171960_)))
            (_E171937171946_)))))
  (define std/net/socks#socks5-send-request
    (lambda (_sock171908_ _cmd171909_ _host171910_ _port171911_)
      (let* ((_porthi171913_
              (let ((__tmp300867
                     (let ()
                       (declare (not safe))
                       (##fxarithmetic-shift _port171911_ '-8))))
                (declare (not safe))
                (##fxand __tmp300867 '255)))
             (_portlo171915_
              (let () (declare (not safe)) (##fxand _port171911_ '255)))
             (_out171931_
              (if (string? _host171910_)
                  (let* ((_fqdn171917_
                          (std/text/utf8#string->utf8__0 _host171910_))
                         (_fqdnlen171919_
                          (let ()
                            (declare (not safe))
                            (##u8vector-length _fqdn171917_)))
                         (_g300868_
                          (if (let ()
                                (declare (not safe))
                                (##fx> _fqdnlen171919_ '255))
                              (error '"Domain name too long"
                                     _host171910_
                                     _fqdnlen171919_)
                              '#!void))
                         (_len171922_
                          (let ()
                            (declare (not safe))
                            (##fx+ '7 _fqdnlen171919_)))
                         (_out171924_
                          (let ()
                            (declare (not safe))
                            (##make-u8vector _len171922_ '0))))
                    (let ()
                      (declare (not safe))
                      (##u8vector-set! _out171924_ '3 '3))
                    (let ()
                      (declare (not safe))
                      (##u8vector-set! _out171924_ '4 _fqdnlen171919_))
                    (let ()
                      (declare (not safe))
                      (##subu8vector-move!
                       _fqdn171917_
                       '0
                       _fqdnlen171919_
                       _out171924_
                       '5))
                    (let ((__tmp300869
                           (let ()
                             (declare (not safe))
                             (##fx+ _fqdnlen171919_ '5))))
                      (declare (not safe))
                      (##u8vector-set! _out171924_ __tmp300869 _porthi171913_))
                    (let ((__tmp300870
                           (let ()
                             (declare (not safe))
                             (##fx+ _fqdnlen171919_ '6))))
                      (declare (not safe))
                      (##u8vector-set!
                       _out171924_
                       __tmp300870
                       _portlo171915_)))
                  (if (and (let ()
                             (declare (not safe))
                             (##u8vector? _host171910_))
                           (let ((__tmp300871
                                  (let ()
                                    (declare (not safe))
                                    (##u8vector-length _host171910_))))
                             (declare (not safe))
                             (##fx= __tmp300871 '4)))
                      (let ((_out171927_
                             (let ()
                               (declare (not safe))
                               (##make-u8vector '10 '0))))
                        (let ()
                          (declare (not safe))
                          (##u8vector-set! _out171927_ '3 '1))
                        (let ()
                          (declare (not safe))
                          (##subu8vector-move!
                           _host171910_
                           '0
                           '4
                           _out171927_
                           '4))
                        (let ()
                          (declare (not safe))
                          (##u8vector-set! _out171927_ '8 _porthi171913_))
                        (let ()
                          (declare (not safe))
                          (##u8vector-set! _out171927_ '9 _portlo171915_)))
                      (if (and (let ()
                                 (declare (not safe))
                                 (##u8vector? _host171910_))
                               (let ((__tmp300872
                                      (let ()
                                        (declare (not safe))
                                        (##u8vector-length _host171910_))))
                                 (declare (not safe))
                                 (##fx= __tmp300872 '16)))
                          (let ((_out171929_
                                 (let ()
                                   (declare (not safe))
                                   (##make-u8vector '22 '0))))
                            (let ()
                              (declare (not safe))
                              (##u8vector-set! _out171929_ '3 '4))
                            (let ()
                              (declare (not safe))
                              (##subu8vector-move!
                               _host171910_
                               '0
                               '4
                               _out171929_
                               '16))
                            (let ()
                              (declare (not safe))
                              (##u8vector-set! _out171929_ '20 _porthi171913_))
                            (let ()
                              (declare (not safe))
                              (##u8vector-set!
                               _out171929_
                               '21
                               _portlo171915_)))
                          (error '"Unexpected host address" _host171910_))))))
        (let () (declare (not safe)) (##u8vector-set! _out171931_ '0 '5))
        (let ()
          (declare (not safe))
          (##u8vector-set! _out171931_ '1 _cmd171909_))
        (std/net/socks#send-msg _sock171908_ _out171931_))))
  (define std/net/socks#socks5-recv-reply
    (lambda (_sock171878_)
      (letrec ((_recv-port171880_
                (lambda ()
                  (let* ((_porthi171903_
                          (let ()
                            (declare (not safe))
                            (##read-u8 _sock171878_)))
                         (_portlo171905_
                          (let ()
                            (declare (not safe))
                            (##read-u8 _sock171878_))))
                    (let ((__tmp300873
                           (let ()
                             (declare (not safe))
                             (##fxarithmetic-shift _porthi171903_ '8))))
                      (declare (not safe))
                      (##fxior __tmp300873 _portlo171905_)))))
               (_recv-address171881_
                (lambda (_atype171890_ _rep171891_)
                  (let ((_$e171893_ _atype171890_))
                    (if (eq? '1 _$e171893_)
                        (let ((_addr171896_
                               (let ()
                                 (declare (not safe))
                                 (##make-u8vector '4 '0))))
                          (std/net/socks#recv-msg _sock171878_ _addr171896_)
                          (cons _addr171896_ (_recv-port171880_)))
                        (if (eq? '3 _$e171893_)
                            (let ((_buf171898_
                                   (let ((__tmp300874
                                          (let ()
                                            (declare (not safe))
                                            (##read-u8 _sock171878_))))
                                     (declare (not safe))
                                     (##make-u8vector __tmp300874 '0))))
                              (std/net/socks#recv-msg _sock171878_ _buf171898_)
                              (cons (std/text/utf8#utf8->string__0 _buf171898_)
                                    (_recv-port171880_)))
                            (if (eq? '4 _$e171893_)
                                (let ((_addr171900_
                                       (let ()
                                         (declare (not safe))
                                         (##make-u8vector '16 '0))))
                                  (std/net/socks#recv-msg
                                   _sock171878_
                                   _addr171900_)
                                  (cons _addr171900_ (_recv-port171880_)))
                                (std/error#raise-io-error
                                 'socks5-recv-reply
                                 '"Unexpected SOCKS5 address type"
                                 _atype171890_
                                 _rep171891_))))))))
        (let ((_hdr171883_
               (let () (declare (not safe)) (##make-u8vector '4 '0))))
          (std/net/socks#recv-msg _sock171878_ _hdr171883_)
          (let ((_proto171885_
                 (let () (declare (not safe)) (##u8vector-ref _hdr171883_ '0)))
                (_rep171886_
                 (let ()
                   (declare (not safe))
                   (##u8vector-ref _hdr171883_ '1))))
            (if (eq? _proto171885_ '5)
                '#!void
                (std/error#raise-io-error
                 'socks5-recv-reply
                 '"Unexpected SOCKS5 reply; protocol mismatch"
                 _proto171885_))
            (let ((_addr171888_
                   (_recv-address171881_
                    (let ()
                      (declare (not safe))
                      (##u8vector-ref _hdr171883_ '3))
                    _rep171886_)))
              (if (eq? _rep171886_ '0)
                  _addr171888_
                  (std/error#raise-io-error
                   'socks5-recv-reply
                   '"SOCKS5 error response"
                   _rep171886_))))))))
  (define std/net/socks#socks4-send-request
    (lambda (_sock171847_ _cmd171848_ _host171849_ _port171850_ _userid171851_)
      (let* ((_porthi171853_
              (let ((__tmp300875
                     (let ()
                       (declare (not safe))
                       (##fxarithmetic-shift _port171850_ '-8))))
                (declare (not safe))
                (##fxand __tmp300875 '255)))
             (_portlo171855_
              (let () (declare (not safe)) (##fxand _port171850_ '255)))
             (_userid171857_
              (if _userid171851_
                  (std/text/utf8#string->utf8__0 _userid171851_)
                  '#f))
             (_userlen171859_
              (if _userid171857_
                  (let ()
                    (declare (not safe))
                    (##u8vector-length _userid171857_))
                  '0))
             (_out171875_
              (if (string? _host171849_)
                  (let* ((_fqdn171861_
                          (std/text/utf8#string->utf8__0 _host171849_))
                         (_fqdnlen171863_
                          (let ()
                            (declare (not safe))
                            (##u8vector-length _fqdn171861_)))
                         (_len171865_
                          (let ()
                            (declare (not safe))
                            (##fx+ '8 _userlen171859_ '1 _fqdnlen171863_ '1)))
                         (_out171867_
                          (let ()
                            (declare (not safe))
                            (##make-u8vector _len171865_ '0))))
                    (let ()
                      (declare (not safe))
                      (##u8vector-set! _out171867_ '7 '1))
                    (let ((__tmp300876
                           (let ()
                             (declare (not safe))
                             (##fx+ _userlen171859_ '9))))
                      (declare (not safe))
                      (##subu8vector-move!
                       _fqdn171861_
                       '0
                       _fqdnlen171863_
                       _out171867_
                       __tmp300876)))
                  (if (and (let ()
                             (declare (not safe))
                             (##u8vector? _host171849_))
                           (let ((__tmp300877
                                  (let ()
                                    (declare (not safe))
                                    (##u8vector-length _host171849_))))
                             (declare (not safe))
                             (##fx= __tmp300877 '4)))
                      (let* ((_len171870_
                              (let ()
                                (declare (not safe))
                                (##fx+ _userlen171859_ '9)))
                             (_out171872_
                              (let ()
                                (declare (not safe))
                                (##make-u8vector _len171870_ '0))))
                        (let ()
                          (declare (not safe))
                          (##subu8vector-move!
                           _host171849_
                           '0
                           '4
                           _out171872_
                           '4)))
                      (error '"Unexpected host address" _host171849_)))))
        (let () (declare (not safe)) (##u8vector-set! _out171875_ '0 '4))
        (let ()
          (declare (not safe))
          (##u8vector-set! _out171875_ '1 _cmd171848_))
        (let ()
          (declare (not safe))
          (##u8vector-set! _out171875_ '2 _porthi171853_))
        (let ()
          (declare (not safe))
          (##u8vector-set! _out171875_ '3 _portlo171855_))
        (if _userid171857_
            (let ()
              (declare (not safe))
              (##subu8vector-move!
               _userid171857_
               '0
               _userlen171859_
               _out171875_
               '8))
            '#!void)
        (std/net/socks#send-msg _sock171847_ _out171875_))))
  (define std/net/socks#socks4-recv-reply
    (lambda (_sock171839_)
      (let ((_buf171841_
             (let () (declare (not safe)) (##make-u8vector '8 '0))))
        (std/net/socks#recv-msg _sock171839_ _buf171841_)
        (let ((_vn171843_
               (let () (declare (not safe)) (##u8vector-ref _buf171841_ '0))))
          (if (eq? _vn171843_ '0)
              '#!void
              (std/error#raise-io-error
               'socks4-recv-reply
               '"Unexpected SOCKS4 reply; version mismatch"
               _vn171843_)))
        (let ((_rep171845_
               (let () (declare (not safe)) (##u8vector-ref _buf171841_ '1))))
          (if (eq? _rep171845_ '90)
              '#!void
              (std/error#raise-io-error
               'socks4-recv-reply
               '"SOCKS4 request rejected"
               _rep171845_)))
        (cons (let () (declare (not safe)) (##subu8vector _buf171841_ '4 '8))
              (let ((__tmp300879
                     (let ((__tmp300880
                            (let ()
                              (declare (not safe))
                              (##u8vector-ref _buf171841_ '2))))
                       (declare (not safe))
                       (##fxarithmetic-shift __tmp300880 '8)))
                    (__tmp300878
                     (let ()
                       (declare (not safe))
                       (##u8vector-ref _buf171841_ '3))))
                (declare (not safe))
                (##fxior __tmp300879 __tmp300878))))))
  (define std/net/socks#send-msg
    (lambda (_sock171834_ _buf171835_)
      (let ((_wr171837_
             (gerbil/gambit/ports#write-u8vector__% _buf171835_ _sock171834_)))
        (if (eq? _wr171837_
                 (let () (declare (not safe)) (##u8vector-length _buf171835_)))
            '#!void
            (std/error#raise-io-error
             'socks-send-message
             '"Failed to send message; incomplete write"
             _sock171834_
             _wr171837_))
        (force-output _sock171834_))))
  (define std/net/socks#recv-msg
    (lambda (_sock171829_ _buf171830_)
      (let ((_rd171832_
             (gerbil/gambit/ports#read-u8vector__% _buf171830_ _sock171829_)))
        (if (eq? _rd171832_
                 (let () (declare (not safe)) (##u8vector-length _buf171830_)))
            '#!void
            (std/error#raise-io-error
             'socks-recv-message
             '"Failed to receive message; incomplete read"
             _sock171829_
             _rd171832_))))))
