(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/net/websocket#errorf
    (lambda (_fmt175528_ . _args175529_)
      (std/logger#log-message 'websocket '0 _fmt175528_ _args175529_)))
  (define std/net/websocket#warnf
    (lambda (_fmt175525_ . _args175526_)
      (std/logger#log-message 'websocket '1 _fmt175525_ _args175526_)))
  (define std/net/websocket#infof
    (lambda (_fmt175522_ . _args175523_)
      (std/logger#log-message 'websocket '2 _fmt175522_ _args175523_)))
  (define std/net/websocket#debugf
    (lambda (_fmt175519_ . _args175520_)
      (std/logger#log-message 'websocket '3 _fmt175519_ _args175520_)))
  (define std/net/websocket#verbosef
    (lambda (_fmt175514_ . _args175516_)
      (std/logger#log-message 'websocket '4 _fmt175514_ _args175516_)))
  (define std/net/websocket#wsmagic '"258EAFA5-E914-47DA-95CA-C5AB0DC85B11")
  (define std/net/websocket#open-websocket-client__%
    (lambda (_g301999_
             _redirect175422175428_
             _headers175423175430_
             _cookies175424175432_
             _params175425175434_
             _url175436_)
      (let* ((_redirect175438_
              (if (eq? _redirect175422175428_ absent-value)
                  '#t
                  _redirect175422175428_))
             (_headers175440_
              (if (eq? _headers175423175430_ absent-value)
                  '#f
                  _headers175423175430_))
             (_cookies175442_
              (if (eq? _cookies175424175432_ absent-value)
                  '#f
                  _cookies175424175432_))
             (_params175444_
              (if (eq? _params175425175434_ absent-value)
                  '#f
                  _params175425175434_))
             (_url175446_ (std/net/websocket#url->request-url _url175436_))
             (_nonce175448_ (std/crypto/etc#random-bytes '16))
             (_nonce64175450_
              (std/text/base64#u8vector->base64-string _nonce175448_))
             (_headers175455_
              (cons (cons '"Upgrade" '"websocket")
                    (cons (cons '"Connection" '"Upgrade")
                          (cons (cons '"Sec-WebSocket-Key" _nonce64175450_)
                                (cons (cons '"Sec-WebSocket-Version" '13)
                                      (let ((_$e175452_ _headers175440_))
                                        (if _$e175452_ _$e175452_ '())))))))
             (_req175457_
              (std/net/request#http-get__%
               '#f
               _redirect175438_
               _headers175455_
               _cookies175442_
               _params175444_
               absent-value
               absent-value
               _url175446_)))
        (with-exception-catcher
         (lambda (_g175459175461_)
           (if '#t
               (let ((_e175464_ _g175459175461_))
                 (std/net/request#request-close _req175457_)
                 (raise _e175464_))
               (raise _g175459175461_)))
         (lambda ()
           (let ((_status175467_
                  (##structure-ref
                   _req175457_
                   '4
                   std/net/request#request::t
                   '#f)))
             (if (let () (declare (not safe)) (##fx= _status175467_ '101))
                 '#!void
                 (std/error#raise-io-error
                  'open-websocket-client
                  '"Unexpected server response"
                  _url175446_
                  _status175467_)))
           (let* ((_rheaders175469_
                   (##structure-ref
                    _req175457_
                    '6
                    std/net/request#request::t
                    '#f))
                  (_Connection175471_ (assoc '"Connection" _rheaders175469_))
                  (_Upgrade175473_ (assoc '"Upgrade" _rheaders175469_))
                  (_Sec-WebSocket-Accept175475_
                   (assoc '"Sec-Websocket-Accept" _rheaders175469_))
                  (_Sec-WebSocket-Extensions175477_
                   (assoc '"Sec-Websocket-Extensions" _rheaders175469_))
                  (_Sec-WebSocket-Protocol175479_
                   (assoc '"Sec-Websocket-Protocol" _rheaders175469_)))
             (if (and _Connection175471_
                      (equal? (std/srfi/13#string-downcase__0
                               (cdr _Connection175471_))
                              '"upgrade"))
                 '#!void
                 (std/error#raise-io-error
                  'open-websocket-client
                  '"Bad server response; no connection upgrade"
                  _url175446_
                  _Connection175471_))
             (if (and _Upgrade175473_
                      (equal? (std/srfi/13#string-downcase__0
                               (cdr _Upgrade175473_))
                              '"websocket"))
                 '#!void
                 (std/error#raise-io-error
                  'open-websocket-client
                  '"Bad server response; no websocket upgrade"
                  _url175446_
                  _Upgrade175473_))
             (let* ((_accept64175482_
                     (if _Sec-WebSocket-Accept175475_
                         (cdr _Sec-WebSocket-Accept175475_)
                         '#f))
                    (_digest175484_
                     (let ((__obj301996
                            (make-object std/crypto/digest#digest::t '2)))
                       (std/crypto/digest#digest:::init!
                        __obj301996
                        std/crypto/digest#digest::sha1)
                       __obj301996))
                    (_g302000_
                     (std/crypto/digest#digest-update!__0
                      _digest175484_
                      (std/text/utf8#string->utf8__0 _nonce64175450_)))
                    (_g302001_
                     (std/crypto/digest#digest-update!__0
                      _digest175484_
                      (std/text/utf8#string->utf8__0
                       std/net/websocket#wsmagic)))
                    (_verify175488_
                     (std/crypto/digest#digest-final!__0 _digest175484_))
                    (_verify64175490_
                     (std/text/base64#u8vector->base64-string _verify175488_)))
               (if (equal? _accept64175482_ _verify64175490_)
                   '#!void
                   (std/error#raise-io-error
                    'open-websocket-client
                    '"Bad server response; nonce verification failure"
                    _url175446_
                    _nonce64175450_
                    _accept64175482_
                    _verify64175490_)))
             (if _Sec-WebSocket-Extensions175477_
                 (std/error#raise-io-error
                  'open-websocket-client
                  '"Bad server response; includes unsupported exensions"
                  _url175446_
                  _Sec-WebSocket-Extensions175477_)
                 '#!void)
             (if _Sec-WebSocket-Protocol175479_
                 (let* ((_proto175493_ (cdr _Sec-WebSocket-Protocol175479_))
                        (_uproto175495_
                         (assoc '"Sec-WebSocket-Protocol" _headers175455_))
                        (_uproto175497_
                         (string-split
                          (if _uproto175495_ (cdr _uproto175495_) '#f)
                          '#\,)))
                   (if (member _proto175493_ _uproto175497_)
                       '#!void
                       (std/error#raise-io-error
                        'open-websocket-client
                        '"Bad server response; unexpected protocol"
                        _url175446_
                        _Sec-WebSocket-Protocol175479_)))
                 '#!void))
           (std/net/websocket#make-websocket-client
            (##structure-ref
             _req175457_
             '1
             std/net/request#request::t
             '#f)))))))
  (define std/net/websocket#open-websocket-client__@
    (lambda (_keys175421175503_ . _args175505_)
      (apply std/net/websocket#open-websocket-client__%
             _keys175421175503_
             (table-ref _keys175421175503_ 'redirect: absent-value)
             (table-ref _keys175421175503_ 'headers: absent-value)
             (table-ref _keys175421175503_ 'cookies: absent-value)
             (table-ref _keys175421175503_ 'params: absent-value)
             _args175505_)))
  (define std/net/websocket#open-websocket-client
    (lambda _args175426175511_
      (apply keyword-dispatch
             '#(params:
                cookies:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                redirect:
                headers:
                #f
                #f
                #f
                #f)
             std/net/websocket#open-websocket-client__@
             _args175426175511_)))
  (define std/net/websocket#url->request-url
    (lambda (_url175410_)
      (let ((_colon175412_ (std/srfi/13#string-index__0 _url175410_ '#\:)))
        (if _colon175412_
            (let* ((_scheme175415_ (substring _url175410_ '0 _colon175412_))
                   (_$e175417_ _scheme175415_))
              (if (equal? '"ws" _$e175417_)
                  (string-append
                   '"http"
                   (substring
                    _url175410_
                    _colon175412_
                    (string-length _url175410_)))
                  (if (equal? '"wss" _$e175417_)
                      (string-append
                       '"https"
                       (substring
                        _url175410_
                        _colon175412_
                        (string-length _url175410_)))
                      _url175410_)))
            _url175410_))))
  (define std/net/websocket#websocket::t
    (make-struct-type
     'std/net/websocket#websocket::t
     '#f
     '7
     'websocket
     '((final: . #t))
     ':init!
     '(port rd wr cs q mx cv)))
  (define std/net/websocket#websocket?
    (make-struct-predicate std/net/websocket#websocket::t))
  (define std/net/websocket#make-websocket
    (lambda _$args175407_
      (apply make-struct-instance
             std/net/websocket#websocket::t
             _$args175407_)))
  (define std/net/websocket#websocket-port
    (make-struct-field-accessor std/net/websocket#websocket::t '0))
  (define std/net/websocket#websocket-rd
    (make-struct-field-accessor std/net/websocket#websocket::t '1))
  (define std/net/websocket#websocket-wr
    (make-struct-field-accessor std/net/websocket#websocket::t '2))
  (define std/net/websocket#websocket-cs
    (make-struct-field-accessor std/net/websocket#websocket::t '3))
  (define std/net/websocket#websocket-q
    (make-struct-field-accessor std/net/websocket#websocket::t '4))
  (define std/net/websocket#websocket-mx
    (make-struct-field-accessor std/net/websocket#websocket::t '5))
  (define std/net/websocket#websocket-cv
    (make-struct-field-accessor std/net/websocket#websocket::t '6))
  (define std/net/websocket#websocket-port-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '0))
  (define std/net/websocket#websocket-rd-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '1))
  (define std/net/websocket#websocket-wr-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '2))
  (define std/net/websocket#websocket-cs-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '3))
  (define std/net/websocket#websocket-q-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '4))
  (define std/net/websocket#websocket-mx-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '5))
  (define std/net/websocket#websocket-cv-set!
    (make-struct-field-mutator std/net/websocket#websocket::t '6))
  (define std/net/websocket#websocket:::init!
    (lambda (_self175404_ _port175405_)
      (if (let ((__tmp302002
                 (let () (declare (not safe)) (##vector-length _self175404_))))
            (declare (not safe))
            (##fx< '7 __tmp302002))
          (begin
            (let ()
              (declare (not safe))
              (##vector-set! _self175404_ '1 _port175405_))
            (let () (declare (not safe)) (##vector-set! _self175404_ '2 '#f))
            (let () (declare (not safe)) (##vector-set! _self175404_ '3 '#f))
            (let () (declare (not safe)) (##vector-set! _self175404_ '4 '#f))
            (let ((__tmp302003
                   (let ((__obj301997
                          (make-object std/misc/queue#queue::t '3)))
                     (std/misc/queue#queue:::init! __obj301997)
                     __obj301997)))
              (declare (not safe))
              (##vector-set! _self175404_ '5 __tmp302003))
            (let ((__tmp302004 (make-mutex)))
              (declare (not safe))
              (##vector-set! _self175404_ '6 __tmp302004))
            (let ((__tmp302005 (make-condition-variable)))
              (declare (not safe))
              (##vector-set! _self175404_ '7 __tmp302005)))
          (error '"struct-instance-init!: too many arguments for struct"
                 _self175404_))))
  (bind-method!
   std/net/websocket#websocket::t
   ':init!
   std/net/websocket#websocket:::init!
   '#f)
  (define std/net/websocket#make-websocket-client
    (lambda (_port175272_)
      (std/logger#start-logger!__0)
      (let* ((_ws175274_
              (let ((__obj301998
                     (make-object std/net/websocket#websocket::t '7)))
                (std/net/websocket#websocket:::init! __obj301998 _port175272_)
                __obj301998))
             (_reader175276_
              (gerbil/gambit/threads#spawn/name
               'websocket-reader
               std/net/websocket#websocket-reader
               _ws175274_))
             (_writer175278_
              (gerbil/gambit/threads#spawn/name
               'websocket-writer
               std/net/websocket#websocket-writer
               _ws175274_)))
        (##direct-structure-set!
         _ws175274_
         _reader175276_
         '2
         std/net/websocket#websocket::t
         '#f)
        (##direct-structure-set!
         _ws175274_
         _writer175278_
         '3
         std/net/websocket#websocket::t
         '#f)
        _ws175274_)))
  (define std/net/websocket#websocket-send
    (lambda (_ws175260_ _bytes175261_ _type175262_)
      (if (not (u8vector? _bytes175261_))
          (error '"Bad argument; expected u8vector" _bytes175261_)
          (if (not (or (eq? _type175262_ 'binary) (eq? _type175262_ 'text)))
              (error '"Bad argument; expected 'binary or 'text" _type175262_)
              (let ((_$e175267_
                     (##direct-structure-ref
                      _ws175260_
                      '4
                      std/net/websocket#websocket::t
                      '#f)))
                (if _$e175267_
                    ((lambda (_how175270_)
                       (std/error#raise-io-error
                        'websocket-send
                        '"Websocket has been closed"
                        _ws175260_
                        _how175270_))
                     _$e175267_)
                    (thread-send
                     (##direct-structure-ref
                      _ws175260_
                      '3
                      std/net/websocket#websocket::t
                      '#f)
                     (cons _type175262_ _bytes175261_))))))))
  (define std/net/websocket#websocket-write
    (lambda (_ws175257_ _obj175258_)
      (if (string? _obj175258_)
          (std/net/websocket#websocket-send
           _ws175257_
           (std/text/utf8#string->utf8__0 _obj175258_)
           'text)
          (if (u8vector? _obj175258_)
              (std/net/websocket#websocket-send _ws175257_ _obj175258_ 'binary)
              (error '"Bad argument; expected bytes or string" _obj175258_)))))
  (define std/net/websocket#websocket-recv__%
    (lambda (_ws175145_ _timeo175146_ _raise?175147_)
      (let* ((_timeo175149_ (std/misc/timeout#make-timeout__0 _timeo175146_))
             (_ws175150175162_ _ws175145_)
             (_E175152175166_
              (lambda () (error '"No clause matching" _ws175150175162_)))
             (_K175153175209_
              (lambda (_cv175169_ _mx175170_ _q175171_)
                (let _lp175173_ ()
                  (mutex-lock! _mx175170_)
                  (if (not (std/misc/queue#queue-empty? _q175171_))
                      (let* ((_g175175175182_
                              (std/misc/queue#dequeue!__0 _q175171_))
                             (_E175177175186_
                              (lambda ()
                                (error '"No clause matching" _g175175175182_)))
                             (_K175178175192_
                              (lambda (_data175189_ _type175190_)
                                (mutex-unlock! _mx175170_)
                                (values _data175189_ _type175190_))))
                        (if (let ()
                              (declare (not safe))
                              (##pair? _g175175175182_))
                            (let ((_hd175179175195_
                                   (let ()
                                     (declare (not safe))
                                     (##car _g175175175182_)))
                                  (_tl175180175197_
                                   (let ()
                                     (declare (not safe))
                                     (##cdr _g175175175182_))))
                              (let* ((_type175200_ _hd175179175195_)
                                     (_data175202_ _tl175180175197_))
                                (_K175178175192_ _data175202_ _type175200_)))
                            (_E175177175186_)))
                      (let ((_$e175204_
                             (##direct-structure-ref
                              _ws175145_
                              '4
                              std/net/websocket#websocket::t
                              '#f)))
                        (if _$e175204_
                            ((lambda (_how175207_)
                               (mutex-unlock! _mx175170_)
                               (if _raise?175147_
                                   (std/error#raise-io-error
                                    'websocket-recv
                                    '"Websocket has been closed"
                                    _ws175145_
                                    _how175207_)
                                   '#!eof))
                             _$e175204_)
                            (if (mutex-unlock!
                                 _mx175170_
                                 _cv175169_
                                 _timeo175149_)
                                (_lp175173_)
                                (if _raise?175147_
                                    (std/error#raise-timeout
                                     'websocket-recv
                                     '"timeout"
                                     _ws175145_)
                                    '#f)))))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ws175150175162_
               'std/net/websocket#websocket::t))
            (let* ((_e175154175212_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws175150175162_ '1)))
                   (_e175155175215_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws175150175162_ '2)))
                   (_e175156175218_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws175150175162_ '3)))
                   (_e175157175221_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws175150175162_ '4)))
                   (_e175158175224_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws175150175162_ '5)))
                   (_q175227_ _e175158175224_)
                   (_e175159175229_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws175150175162_ '6)))
                   (_mx175232_ _e175159175229_)
                   (_e175160175234_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws175150175162_ '7)))
                   (_cv175237_ _e175160175234_))
              (_K175153175209_ _cv175237_ _mx175232_ _q175227_))
            (_E175152175166_)))))
  (define std/net/websocket#websocket-recv__0
    (lambda (_ws175242_)
      (let* ((_timeo175244_ '#f) (_raise?175246_ '#t))
        (std/net/websocket#websocket-recv__%
         _ws175242_
         _timeo175244_
         _raise?175246_))))
  (define std/net/websocket#websocket-recv__1
    (lambda (_ws175248_ _timeo175249_)
      (let ((_raise?175251_ '#t))
        (std/net/websocket#websocket-recv__%
         _ws175248_
         _timeo175249_
         _raise?175251_))))
  (define std/net/websocket#websocket-recv
    (lambda _g302007_
      (let ((_g302006_ (let () (declare (not safe)) (##length _g302007_))))
        (cond ((let () (declare (not safe)) (##fx= _g302006_ 1))
               (apply std/net/websocket#websocket-recv__0 _g302007_))
              ((let () (declare (not safe)) (##fx= _g302006_ 2))
               (apply std/net/websocket#websocket-recv__1 _g302007_))
              ((let () (declare (not safe)) (##fx= _g302006_ 3))
               (apply std/net/websocket#websocket-recv__% _g302007_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/websocket#websocket-recv
                _g302007_))))))
  (define std/net/websocket#websocket-read__%
    (lambda (_ws175062_ _timeo175063_ _raise?175064_)
      (let* ((_g175065175078_
              (std/net/websocket#websocket-recv__%
               _ws175062_
               _timeo175063_
               _raise?175064_))
             (_E175069175082_
              (lambda () (error '"No clause matching" _g175065175078_))))
        (let ((_K175074175115_ (lambda (_data175113_) _data175113_))
              (_K175071175099_
               (lambda (_data175097_)
                 (std/text/utf8#utf8->string__0 _data175097_)))
              (_K175070175088_ (lambda (_r175086_) _r175086_)))
          (if (let ((__tmp302008
                     (if (let ()
                           (declare (not safe))
                           (##values? _g175065175078_))
                         (let ()
                           (declare (not safe))
                           (##vector-length _g175065175078_))
                         '1)))
                (declare (not safe))
                (##fx= __tmp302008 '2))
              (let* ((_e175075175118_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _g175065175078_ '0)))
                     (_e175076175123_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _g175065175078_ '1))))
                (if (let ()
                      (declare (not safe))
                      (##eq? _e175076175123_ 'binary))
                    (let ((_data175121_ _e175075175118_))
                      (_K175074175115_ _data175121_))
                    (if (let ()
                          (declare (not safe))
                          (##eq? _e175076175123_ 'text))
                        (let ((_data175105_ _e175075175118_))
                          (std/text/utf8#utf8->string__0 _data175105_))
                        (let ((_r175091_ _g175065175078_))
                          (_K175070175088_ _r175091_)))))
              (let ((_r175091_ _g175065175078_))
                (_K175070175088_ _r175091_)))))))
  (define std/net/websocket#websocket-read__0
    (lambda (_ws175129_)
      (let* ((_timeo175131_ '#f) (_raise?175133_ '#f))
        (std/net/websocket#websocket-read__%
         _ws175129_
         _timeo175131_
         _raise?175133_))))
  (define std/net/websocket#websocket-read__1
    (lambda (_ws175135_ _timeo175136_)
      (let ((_raise?175138_ '#f))
        (std/net/websocket#websocket-read__%
         _ws175135_
         _timeo175136_
         _raise?175138_))))
  (define std/net/websocket#websocket-read
    (lambda _g302010_
      (let ((_g302009_ (let () (declare (not safe)) (##length _g302010_))))
        (cond ((let () (declare (not safe)) (##fx= _g302009_ 1))
               (apply std/net/websocket#websocket-read__0 _g302010_))
              ((let () (declare (not safe)) (##fx= _g302009_ 2))
               (apply std/net/websocket#websocket-read__1 _g302010_))
              ((let () (declare (not safe)) (##fx= _g302009_ 3))
               (apply std/net/websocket#websocket-read__% _g302010_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/websocket#websocket-read
                _g302010_))))))
  (define std/net/websocket#websocket-close__%__%
    (lambda (__174958174961_ _hard?174956174963_ _ws174965_ _how174966_)
      (let* ((_hard?174968_
              (if (eq? _hard?174956174963_ absent-value)
                  '#f
                  _hard?174956174963_))
             (_ws174969174981_ _ws174965_)
             (_E174971174985_
              (lambda () (error '"No clause matching" _ws174969174981_)))
             (_K174972174997_
              (lambda (_cv174988_
                       _mx174989_
                       _q174990_
                       _cs174991_
                       _writer174992_
                       _port174993_)
                (if _hard?174968_ (close-port _port174993_) '#!void)
                (if _cs174991_
                    '#!void
                    (begin
                      (mutex-lock! _mx174989_)
                      (if (##direct-structure-ref
                           _ws174965_
                           '4
                           std/net/websocket#websocket::t
                           '#f)
                          (mutex-unlock! _mx174989_)
                          (let ((_how174995_
                                 (if _hard?174968_ 'abort _how174966_)))
                            (##direct-structure-set!
                             _ws174965_
                             _how174995_
                             '4
                             std/net/websocket#websocket::t
                             '#f)
                            (thread-send
                             _writer174992_
                             (cons 'close _how174995_))
                            (condition-variable-broadcast! _cv174988_)
                            (mutex-unlock! _mx174989_))))))))
        (if (let ()
              (declare (not safe))
              (##structure-direct-instance-of?
               _ws174969174981_
               'std/net/websocket#websocket::t))
            (let* ((_e174973175000_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174969174981_ '1)))
                   (_port175003_ _e174973175000_)
                   (_e174974175005_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174969174981_ '2)))
                   (_e174975175008_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174969174981_ '3)))
                   (_writer175011_ _e174975175008_)
                   (_e174976175013_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174969174981_ '4)))
                   (_cs175016_ _e174976175013_)
                   (_e174977175018_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174969174981_ '5)))
                   (_q175021_ _e174977175018_)
                   (_e174978175023_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174969174981_ '6)))
                   (_mx175026_ _e174978175023_)
                   (_e174979175028_
                    (let ()
                      (declare (not safe))
                      (##vector-ref _ws174969174981_ '7)))
                   (_cv175031_ _e174979175028_))
              (_K174972174997_
               _cv175031_
               _mx175026_
               _q175021_
               _cs175016_
               _writer175011_
               _port175003_))
            (_E174971174985_)))))
  (define std/net/websocket#websocket-close__%__0
    (lambda (__174958175036_ _hard?174956175037_ _ws175038_)
      (let ((_how175040_ '1000))
        (std/net/websocket#websocket-close__%__%
         __174958175036_
         _hard?174956175037_
         _ws175038_
         _how175040_))))
  (define std/net/websocket#websocket-close__%
    (lambda _g302012_
      (let ((_g302011_ (let () (declare (not safe)) (##length _g302012_))))
        (cond ((let () (declare (not safe)) (##fx= _g302011_ 3))
               (apply std/net/websocket#websocket-close__%__0 _g302012_))
              ((let () (declare (not safe)) (##fx= _g302011_ 4))
               (apply std/net/websocket#websocket-close__%__% _g302012_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/net/websocket#websocket-close__%
                _g302012_))))))
  (define std/net/websocket#websocket-close__@
    (lambda (_keys174955175050_ . _args175052_)
      (apply std/net/websocket#websocket-close__%
             _keys174955175050_
             (table-ref _keys174955175050_ 'hard: absent-value)
             _args175052_)))
  (define std/net/websocket#websocket-close
    (lambda _args174957175058_
      (apply keyword-dispatch
             '#(hard:)
             std/net/websocket#websocket-close__@
             _args174957175058_)))
  (define std/net/websocket#max-frame-size (expt '2 '20))
  (define std/net/websocket#max-message-size (expt '2 '20))
  (define std/net/websocket#set-websocket-max-frame-size!
    (lambda (_sz174952_) (set! std/net/websocket#max-frame-size _sz174952_)))
  (define std/net/websocket#set-websocket-max-message-size!
    (lambda (_sz174950_) (set! std/net/websocket#max-message-size _sz174950_)))
  (define std/net/websocket#websocket-reader
    (lambda (_ws174753_)
      (letrec* ((_buf174755_ (make-u8vector '1024))
                (_skip-to-eof174756_
                 (lambda (_port174941_)
                   (let ((_len174943_ (u8vector-length _buf174755_)))
                     (let _lp174945_ ()
                       (let ((_rd174948_
                              (read-subu8vector
                               _buf174755_
                               '0
                               _len174943_
                               _port174941_)))
                         (if (let ()
                               (declare (not safe))
                               (##fx= _len174943_ _rd174948_))
                             (_lp174945_)
                             '#!void))))))
                (_skip-payload174757_
                 (lambda (_port174925_ _plen174926_)
                   (let ((_len174928_ (u8vector-length _buf174755_)))
                     (let _lp174930_ ((_need174932_ _plen174926_))
                       (let ((_$e174934_
                              (let ()
                                (declare (not safe))
                                (##fxzero? _need174932_))))
                         (if _$e174934_
                             _$e174934_
                             (if (let ()
                                   (declare (not safe))
                                   (##fx<= _need174932_ _len174928_))
                                 (let ((_rd174937_
                                        (read-subu8vector
                                         _buf174755_
                                         '0
                                         _need174932_
                                         _port174925_)))
                                   (if (let ()
                                         (declare (not safe))
                                         (##fx< _rd174937_ _need174932_))
                                       (_read-eof174762_)
                                       '#!void))
                                 (let ((_rd174939_
                                        (read-subu8vector
                                         _buf174755_
                                         '0
                                         _len174928_
                                         _port174925_)))
                                   (if (let ()
                                         (declare (not safe))
                                         (##fx< _rd174939_ _len174928_))
                                       (_read-eof174762_)
                                       (_lp174930_
                                        (let ()
                                          (declare (not safe))
                                          (##fx- _need174932_
                                                 _len174928_))))))))))))
                (_read-header174758_
                 (lambda (_port174916_)
                   (let* ((_b0174918_ (read-u8 _port174916_))
                          (_g302013_
                           (if (eof-object? _b0174918_)
                               (_read-eof174762_)
                               '#!void))
                          (_b1174921_ (read-u8 _port174916_))
                          (_g302014_
                           (if (eof-object? _b1174921_)
                               (_read-eof174762_)
                               '#!void)))
                     (values (let ()
                               (declare (not safe))
                               (##fxand _b0174918_ '128))
                             (let ()
                               (declare (not safe))
                               (##fxand _b0174918_ '15))
                             (let ()
                               (declare (not safe))
                               (##fxand _b1174921_ '128))
                             (let ()
                               (declare (not safe))
                               (##fxand _b1174921_ '127))))))
                (_read-payload174759_
                 (lambda (_port174908_ _plen174909_)
                   (if (let () (declare (not safe)) (##fxzero? _plen174909_))
                       '#u8()
                       (let* ((_data174911_ (make-u8vector _plen174909_))
                              (_rd174913_
                               (read-subu8vector
                                _data174911_
                                '0
                                _plen174909_
                                _port174908_)))
                         (if (let ()
                               (declare (not safe))
                               (##fx< _rd174913_ _plen174909_))
                             (_read-eof174762_)
                             _data174911_)))))
                (_read-u16174760_
                 (lambda (_port174899_)
                   (let* ((_b0174901_ (read-u8 _port174899_))
                          (_g302015_
                           (if (eof-object? _b0174901_)
                               (_read-eof174762_)
                               '#!void))
                          (_b1174904_ (read-u8 _port174899_))
                          (_g302016_
                           (if (eof-object? _b1174904_)
                               (_read-eof174762_)
                               '#!void)))
                     (let ((__tmp302017
                            (let ()
                              (declare (not safe))
                              (##fxarithmetic-shift _b0174901_ '8))))
                       (declare (not safe))
                       (##fxior __tmp302017 _b1174904_)))))
                (_read-u64174761_
                 (lambda (_port174890_)
                   (let ((_rd174892_
                          (read-subu8vector _buf174755_ '0 '8 _port174890_)))
                     (if (let () (declare (not safe)) (##fx= _rd174892_ '8))
                         (let _lp174894_ ((_k174896_ '0) (_r174897_ '0))
                           (if (let ()
                                 (declare (not safe))
                                 (##fx< _k174896_ '8))
                               (_lp174894_
                                (let ()
                                  (declare (not safe))
                                  (##fx+ _k174896_ '1))
                                (bitwise-ior
                                 (arithmetic-shift _r174897_ '8)
                                 (let ()
                                   (declare (not safe))
                                   (##u8vector-ref _buf174755_ _k174896_))))
                               _r174897_))
                         (_read-eof174762_)))))
                (_read-eof174762_ (lambda () (raise 'eof))))
        (let* ((_ws174763174775_ _ws174753_)
               (_E174765174779_
                (lambda () (error '"No clause matching" _ws174763174775_)))
               (_K174766174855_
                (lambda (_cv174782_
                         _mx174783_
                         _q174784_
                         _writer174785_
                         _port174786_)
                  (letrec ((_receive174788_
                            (lambda (_type174852_ _data174853_)
                              (mutex-lock! _mx174783_)
                              (if (##direct-structure-ref
                                   _ws174753_
                                   '4
                                   std/net/websocket#websocket::t
                                   '#f)
                                  (begin
                                    (mutex-unlock! _mx174783_)
                                    (raise 'abort))
                                  (begin
                                    (std/misc/queue#enqueue!
                                     _q174784_
                                     (cons _type174852_ _data174853_))
                                    (condition-variable-broadcast! _cv174782_)
                                    (mutex-unlock! _mx174783_))))))
                    (with-unwind-protect
                     (lambda ()
                       (with-exception-catcher
                        (lambda (_g174789174792_)
                          (if '#t
                              (let ((_e174795_ _g174789174792_))
                                (let ((_$e174797_ _e174795_))
                                  (if (eq? 'eof _$e174797_)
                                      (std/net/websocket#websocket-close__%__%
                                       '#f
                                       absent-value
                                       _ws174753_
                                       'eof)
                                      (if (eq? 'abort _$e174797_)
                                          '#!void
                                          (begin
                                            (std/net/websocket#errorf
                                             '"unhandled exception: ~a"
                                             _e174795_)
                                            (std/net/websocket#websocket-close__%__%
                                             '#f
                                             absent-value
                                             _ws174753_
                                             'abort)
                                            (raise _e174795_)))))
                                _e174795_)
                              (raise _g174789174792_)))
                        (lambda ()
                          (let _lp174801_ ((_type174803_ '#f)
                                           (_frags174804_ '()))
                            (let ((_g302018_
                                   (_read-header174758_ _port174786_)))
                              (begin
                                (let ((_g302019_
                                       (let ()
                                         (declare (not safe))
                                         (if (##values? _g302018_)
                                             (##vector-length _g302018_)
                                             1))))
                                  (if (not (let ()
                                             (declare (not safe))
                                             (##fx= _g302019_ 4)))
                                      (error "Context expects 4 values"
                                             _g302019_)))
                                (let ((_fin174806_
                                       (let ()
                                         (declare (not safe))
                                         (##vector-ref _g302018_ 0)))
                                      (_opcode174807_
                                       (let ()
                                         (declare (not safe))
                                         (##vector-ref _g302018_ 1)))
                                      (_mask174808_
                                       (let ()
                                         (declare (not safe))
                                         (##vector-ref _g302018_ 2)))
                                      (_plen174809_
                                       (let ()
                                         (declare (not safe))
                                         (##vector-ref _g302018_ 3))))
                                  (let ((_plen174814_
                                         (let ((_$e174811_ _plen174809_))
                                           (if (eq? '126 _$e174811_)
                                               (_read-u16174760_ _port174786_)
                                               (if (eq? '127 _$e174811_)
                                                   (_read-u64174761_
                                                    _port174786_)
                                                   _plen174809_)))))
                                    (if (not (let ()
                                               (declare (not safe))
                                               (##fxzero? _mask174808_)))
                                        (begin
                                          (std/net/websocket#warnf
                                           '"server sent masked frame; closing websocket connection")
                                          (std/net/websocket#websocket-close__%__%
                                           '#f
                                           absent-value
                                           _ws174753_
                                           '1002)
                                          (_skip-to-eof174756_ _port174786_))
                                        (if (> _plen174814_
                                               std/net/websocket#max-frame-size)
                                            (begin
                                              (std/net/websocket#warnf
                                               '"frame size ~a exceeds max frame size; closing websocket connection"
                                               _plen174814_)
                                              (std/net/websocket#websocket-close__%__%
                                               '#f
                                               absent-value
                                               _ws174753_
                                               '1009)
                                              (_skip-to-eof174756_
                                               _port174786_))
                                            (let ((_$e174817_ _opcode174807_))
                                              (let ((_default174819174823_
                                                     (lambda ()
                                                       (std/net/websocket#warnf
                                                        '"unexpected frame ~x from server; closing websocket connection"
                                                        _opcode174807_)
                                                       (std/net/websocket#websocket-close__%__%
                                                        '#f
                                                        absent-value
                                                        _ws174753_
                                                        '1002)
                                                       (_skip-to-eof174756_
                                                        _port174786_)))
                                                    (_table174820174825_
                                                     '#(0
                                                        1
                                                        1
                                                        #f
                                                        #f
                                                        #f
                                                        #f
                                                        #f
                                                        2
                                                        3
                                                        4)))
                                                (if (fixnum? _$e174817_)
                                                    (if (and (let ()
                                                               (declare
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         (not safe))
                       (##fx>= _$e174817_ '0))
                     (let () (declare (not safe)) (##fx< _$e174817_ '11)))
                (let ((_x174828_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _table174820174825_ _$e174817_))))
                  (if _x174828_
                      (if (let () (declare (not safe)) (##fx< _x174828_ '2))
                          (if (let ()
                                (declare (not safe))
                                (##fx= _x174828_ '0))
                              (let ((_dlen174831_
                                     (foldl1 ##fx+
                                             _plen174814_
                                             (map u8vector-length
                                                  _frags174804_))))
                                (if (not _type174803_)
                                    (begin
                                      (std/net/websocket#warnf
                                       '"unexpected continuation frame from server; closing websocket connection")
                                      (std/net/websocket#websocket-close__%__%
                                       '#f
                                       absent-value
                                       _ws174753_
                                       '1002)
                                      (_skip-to-eof174756_ _port174786_))
                                    (if (let ()
                                          (declare (not safe))
                                          (##fx> _dlen174831_
                                                 std/net/websocket#max-message-size))
                                        (begin
                                          (std/net/websocket#warnf
                                           '"message length ~a exceeds max message size; closing websocket connection"
                                           _dlen174831_)
                                          (std/net/websocket#websocket-close__%__%
                                           '#f
                                           absent-value
                                           _ws174753_
                                           '1009)
                                          (_skip-to-eof174756_ _port174786_))
                                        (if (let ()
                                              (declare (not safe))
                                              (##fxzero? _fin174806_))
                                            (if (let ()
                                                  (declare (not safe))
                                                  (##fxzero? _plen174814_))
                                                (_lp174801_
                                                 _type174803_
                                                 _frags174804_)
                                                (let ((_data174833_
                                                       (_read-payload174759_
                                                        _port174786_
                                                        _plen174814_)))
                                                  (_lp174801_
                                                   _type174803_
                                                   (cons _data174833_
                                                         _frags174804_))))
                                            (let* ((_data174835_
                                                    (_read-payload174759_
                                                     _port174786_
                                                     _plen174814_))
                                                   (_message174837_
                                                    (u8vector-concatenate
                                                     (reverse (cons _data174835_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            _frags174804_)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (_receive174788_
                                               _type174803_
                                               _message174837_)
                                              (_lp174801_ '#f '()))))))
                              (let ((_xtype174840_
                                     (if (let ()
                                           (declare (not safe))
                                           (##fx= _opcode174807_ '1))
                                         'text
                                         'binary)))
                                (if _type174803_
                                    (begin
                                      (std/net/websocket#warnf
                                       '"unexpected frame ~x from server; closing websocket connection"
                                       _opcode174807_)
                                      (std/net/websocket#websocket-close__%__%
                                       '#f
                                       absent-value
                                       _ws174753_
                                       '1002)
                                      (_skip-to-eof174756_ _port174786_))
                                    (if (let ()
                                          (declare (not safe))
                                          (##fxzero? _fin174806_))
                                        (let ((_data174842_
                                               (_read-payload174759_
                                                _port174786_
                                                _plen174814_)))
                                          (_lp174801_
                                           _xtype174840_
                                           (cons _data174842_ '())))
                                        (let ((_data174844_
                                               (_read-payload174759_
                                                _port174786_
                                                _plen174814_)))
                                          (_receive174788_
                                           _xtype174840_
                                           _data174844_)
                                          (_lp174801_ '#f '()))))))
                          (if (let ()
                                (declare (not safe))
                                (##fx= _x174828_ '2))
                              (let ((_how174846_
                                     (_read-u16174760_ _port174786_)))
                                (std/net/websocket#websocket-close__%__%
                                 '#f
                                 absent-value
                                 _ws174753_
                                 _how174846_)
                                (_skip-to-eof174756_ _port174786_))
                              (if (let ()
                                    (declare (not safe))
                                    (##fx= _x174828_ '3))
                                  (let ((_data174848_
                                         (_read-payload174759_
                                          _port174786_
                                          _plen174814_)))
                                    (thread-send
                                     _writer174785_
                                     (cons 'pong _data174848_))
                                    (_lp174801_ _type174803_ _frags174804_))
                                  (begin
                                    (_skip-payload174757_
                                     _port174786_
                                     _plen174814_)
                                    (_lp174801_ _type174803_ _frags174804_)))))
                      (_default174819174823_)))
                (_default174819174823_))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                                    (_default174819174823_))))))))))))))
                     (lambda ()
                       (with-exception-catcher
                        void
                        (lambda () (close-input-port _port174786_)))))))))
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _ws174763174775_
                 'std/net/websocket#websocket::t))
              (let* ((_e174767174858_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174763174775_ '1)))
                     (_port174861_ _e174767174858_)
                     (_e174768174863_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174763174775_ '2)))
                     (_e174769174866_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174763174775_ '3)))
                     (_writer174869_ _e174769174866_)
                     (_e174770174871_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174763174775_ '4)))
                     (_e174771174874_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174763174775_ '5)))
                     (_q174877_ _e174771174874_)
                     (_e174772174879_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174763174775_ '6)))
                     (_mx174882_ _e174772174879_)
                     (_e174773174884_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174763174775_ '7)))
                     (_cv174887_ _e174773174884_))
                (_K174766174855_
                 _cv174887_
                 _mx174882_
                 _q174877_
                 _writer174869_
                 _port174861_))
              (_E174765174779_))))))
  (define std/net/websocket#websocket-writer
    (lambda (_ws174561_)
      (letrec* ((_buf174563_ (make-u8vector '65535))
                (_mask-bytes174564_ (make-u8vector '4))
                (_write-u16174565_
                 (lambda (_plen174750_ _port174751_)
                   (write-u8
                    (let ((__tmp302020
                           (let ()
                             (declare (not safe))
                             (##fxarithmetic-shift _plen174750_ '-8))))
                      (declare (not safe))
                      (##fxand __tmp302020 '255))
                    _port174751_)
                   (write-u8
                    (let () (declare (not safe)) (##fxand _plen174750_ '255))
                    _port174751_)))
                (_write-payload174566_
                 (lambda (_mask174739_
                          _data174740_
                          _start174741_
                          _end174742_
                          _port174743_)
                   (let _lp174745_ ((_k174747_ _start174741_) (_x174748_ '0))
                     (if (let ()
                           (declare (not safe))
                           (##fx< _k174747_ _end174742_))
                         (begin
                           (let ((__tmp302021
                                  (let ((__tmp302024
                                         (let ()
                                           (declare (not safe))
                                           (##u8vector-ref
                                            _data174740_
                                            _k174747_)))
                                        (__tmp302022
                                         (let ((__tmp302023
                                                (let ()
                                                  (declare (not safe))
                                                  (##fxmodulo _x174748_ '4))))
                                           (declare (not safe))
                                           (##u8vector-ref
                                            _mask174739_
                                            __tmp302023))))
                                    (declare (not safe))
                                    (##fxxor __tmp302024 __tmp302022))))
                             (declare (not safe))
                             (##u8vector-set!
                              _buf174563_
                              _x174748_
                              __tmp302021))
                           (_lp174745_
                            (let () (declare (not safe)) (##fx+ _k174747_ '1))
                            (let ()
                              (declare (not safe))
                              (##fx+ _x174748_ '1))))
                         (write-subu8vector
                          _buf174563_
                          '0
                          _x174748_
                          _port174743_)))))
                (_send-frame174567_
                 (lambda (_port174721_
                          _fin174722_
                          _opcode174723_
                          _data174724_
                          _start174725_
                          _end174726_)
                   (let* ((_plen174728_
                           (let ()
                             (declare (not safe))
                             (##fx- _end174726_ _start174725_)))
                          (_fin174730_
                           (let ()
                             (declare (not safe))
                             (##fxarithmetic-shift _fin174722_ '7)))
                          (_b0174732_
                           (let ()
                             (declare (not safe))
                             (##fxior _fin174730_ _opcode174723_)))
                          (_mask174734_
                           (let ()
                             (declare (not safe))
                             (##fxarithmetic-shift '1 '7)))
                          (_b1174736_
                           (let ((__tmp302025
                                  (if (let ()
                                        (declare (not safe))
                                        (##fx< _plen174728_ '126))
                                      _plen174728_
                                      '126)))
                             (declare (not safe))
                             (##fxior _mask174734_ __tmp302025))))
                     (std/crypto/etc#random-bytes!__0 _mask-bytes174564_)
                     (write-u8 _b0174732_ _port174721_)
                     (write-u8 _b1174736_ _port174721_)
                     (if (let ()
                           (declare (not safe))
                           (##fx< _plen174728_ '126))
                         '#!void
                         (_write-u16174565_ _plen174728_ _port174721_))
                     (write-subu8vector _mask-bytes174564_ '0 '4 _port174721_)
                     (_write-payload174566_
                      _mask-bytes174564_
                      _data174724_
                      _start174725_
                      _end174726_
                      _port174721_)
                     (force-output _port174721_))))
                (_send174568_
                 (lambda (_port174706_ _opcode174707_ _data174708_)
                   (let ((_end174710_ (u8vector-length _data174708_)))
                     (let _lp174712_ ((_start174714_ '0)
                                      (_opcode174715_ _opcode174707_))
                       (let ((_have174717_
                              (let ()
                                (declare (not safe))
                                (##fx- _end174710_ _start174714_))))
                         (if (let ()
                               (declare (not safe))
                               (##fx< _have174717_ '65536))
                             (_send-frame174567_
                              _port174706_
                              '1
                              _opcode174715_
                              _data174708_
                              _start174714_
                              _end174710_)
                             (let ((_xend174719_
                                    (let ()
                                      (declare (not safe))
                                      (##fx+ _start174714_ '65535))))
                               (_send-frame174567_
                                _port174706_
                                '0
                                _opcode174715_
                                _data174708_
                                _start174714_
                                _xend174719_)
                               (_lp174712_ _xend174719_ '0)))))))))
        (let* ((_ws174569174575_ _ws174561_)
               (_E174571174579_
                (lambda () (error '"No clause matching" _ws174569174575_)))
               (_K174572174698_
                (lambda (_port174582_)
                  (with-unwind-protect
                   (lambda ()
                     (with-exception-catcher
                      (lambda (_g174583174586_)
                        (if '#t
                            (let ((_e174589_ _g174583174586_))
                              (std/net/websocket#errorf
                               '"unhandled exception: ~a"
                               _e174589_)
                              (std/net/websocket#websocket-close__%__%
                               '#f
                               absent-value
                               _ws174561_
                               'abort)
                              (with-exception-catcher
                               void
                               (lambda () (close-port _port174582_))))
                            (raise _g174583174586_)))
                      (lambda ()
                        (let _lp174593_ ()
                          (let* ((_g174595174616_ (thread-receive))
                                 (_E174601174620_
                                  (lambda ()
                                    (error '"No clause matching"
                                           _g174595174616_))))
                            (let ((_K174612174686_
                                   (lambda (_data174684_)
                                     (_send174568_
                                      _port174582_
                                      '1
                                      _data174684_)
                                     (_lp174593_)))
                                  (_K174609174671_
                                   (lambda (_data174669_)
                                     (_send174568_
                                      _port174582_
                                      '2
                                      _data174669_)
                                     (_lp174593_)))
                                  (_K174606174655_
                                   (lambda (_data174653_)
                                     (_send174568_
                                      _port174582_
                                      '10
                                      _data174653_)
                                     (_lp174593_)))
                                  (_K174603174639_
                                   (lambda (_how174635_)
                                     (if (fixnum? _how174635_)
                                         (let ((_bytes174637_
                                                (make-u8vector '2)))
                                           (let ((__tmp302026
                                                  (let ((__tmp302027
                                                         (let ()
                                                           (declare (not safe))
                                                           (##fxarithmetic-shift
                                                            _how174635_
                                                            '-8))))
                                                    (declare (not safe))
                                                    (##fxand __tmp302027
                                                             '255))))
                                             (declare (not safe))
                                             (##u8vector-set!
                                              _bytes174637_
                                              '0
                                              __tmp302026))
                                           (let ((__tmp302028
                                                  (let ()
                                                    (declare (not safe))
                                                    (##fxand _how174635_
                                                             '255))))
                                             (declare (not safe))
                                             (##u8vector-set!
                                              _bytes174637_
                                              '1
                                              __tmp302028))
                                           (_send174568_
                                            _port174582_
                                            '8
                                            _bytes174637_))
                                         '#!void)))
                                  (_K174602174626_
                                   (lambda (_bogus174624_)
                                     (std/net/websocket#warnf
                                      '"unexpected message ~a"
                                      _bogus174624_)
                                     (_lp174593_))))
                              (if (let ()
                                    (declare (not safe))
                                    (##pair? _g174595174616_))
                                  (let ((_tl174614174691_
                                         (let ()
                                           (declare (not safe))
                                           (##cdr _g174595174616_)))
                                        (_hd174613174689_
                                         (let ()
                                           (declare (not safe))
                                           (##car _g174595174616_))))
                                    (if (let ()
                                          (declare (not safe))
                                          (##eq? _hd174613174689_ 'text))
                                        (let ((_data174694_ _tl174614174691_))
                                          (_K174612174686_ _data174694_))
                                        (if (let ()
                                              (declare (not safe))
                                              (##eq? _hd174613174689_ 'binary))
                                            (let ((_data174679_
                                                   _tl174614174691_))
                                              (_K174609174671_ _data174679_))
                                            (if (let ()
                                                  (declare (not safe))
                                                  (##eq? _hd174613174689_
                                                         'pong))
                                                (let ((_data174663_
                                                       _tl174614174691_))
                                                  (_K174606174655_
                                                   _data174663_))
                                                (if (let ()
                                                      (declare (not safe))
                                                      (##eq? _hd174613174689_
                                                             'close))
                                                    (let ((_how174647_
                                                           _tl174614174691_))
                                                      (_K174603174639_
                                                       _how174647_))
                                                    (let ((_bogus174629_
                                                           _g174595174616_))
                                                      (_K174602174626_
                                                       _bogus174629_)))))))
                                  (let ((_bogus174629_ _g174595174616_))
                                    (_K174602174626_ _bogus174629_)))))))))
                   (lambda ()
                     (with-exception-catcher
                      void
                      (lambda () (close-output-port _port174582_))))))))
          (if (let ()
                (declare (not safe))
                (##structure-direct-instance-of?
                 _ws174569174575_
                 'std/net/websocket#websocket::t))
              (let* ((_e174573174701_
                      (let ()
                        (declare (not safe))
                        (##vector-ref _ws174569174575_ '1)))
                     (_port174704_ _e174573174701_))
                (_K174572174698_ _port174704_))
              (_E174571174579_)))))))
