(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/os/flock#flock
    (lambda (_raw198060_ _op198061_)
      (let ((_fd198063_
             (if (std/os/fd#fd? _raw198060_)
                 (std/os/fd#fd-e _raw198060_)
                 _raw198060_))
            (_op198064_ (fxior _op198061_ std/os/flock#LOCK_NB)))
        (let _lp198066_ ()
          (let ((_r198070_ (std/os/flock#_flock _fd198063_ _op198064_)))
            (if (not (let () (declare (not safe)) (##fxnegative? _r198070_)))
                _r198070_
                (let ((_errno198073_
                       (let () (declare (not safe)) (##fx- _r198070_))))
                  (if (or (eq? _errno198073_ std/os/error#EAGAIN)
                          (eq? _errno198073_ std/os/error#EWOULDBLOCK))
                      '#f
                      (if (eq? _errno198073_ std/os/error#EINTR)
                          (_lp198066_)
                          (std/os/error#raise-os-error
                           _errno198073_
                           std/os/flock#flock
                           _raw198060_
                           _op198064_))))))))))
  (define std/os/flock#flock/block__%
    (lambda (_raw-or-fd198039_ _op198040_ _timeout198041_)
      (letrec* ((_deadline198043_
                 (if (not _timeout198041_)
                     '#f
                     (if (time? _timeout198041_)
                         (time->seconds _timeout198041_)
                         (if (real? _timeout198041_)
                             (+ (let ()
                                  (declare (not safe))
                                  (##current-time-point))
                                _timeout198041_)
                             (error '"Bad argument; expected real, time or #f"
                                    _timeout198041_))))))
        (let _lp198045_ ()
          (if (std/os/flock#flock _raw-or-fd198039_ _op198040_)
              '#!void
              (begin
                (if _deadline198043_
                    (if (< _deadline198043_
                           (let ()
                             (declare (not safe))
                             (##current-time-point)))
                        '#!void
                        (std/error#raise-timeout
                         'flock
                         '"Deadline for flock operation exceeded"
                         _raw-or-fd198039_
                         _op198040_))
                    '#!void)
                (thread-sleep! (random-real))
                (_lp198045_)))))))
  (define std/os/flock#flock/block__0
    (lambda (_raw-or-fd198051_ _op198052_)
      (let ((_timeout198054_ '#f))
        (std/os/flock#flock/block__%
         _raw-or-fd198051_
         _op198052_
         _timeout198054_))))
  (define std/os/flock#flock/block
    (lambda _g300949_
      (let ((_g300948_ (let () (declare (not safe)) (##length _g300949_))))
        (cond ((let () (declare (not safe)) (##fx= _g300948_ 2))
               (apply std/os/flock#flock/block__0 _g300949_))
              ((let () (declare (not safe)) (##fx= _g300948_ 3))
               (apply std/os/flock#flock/block__% _g300949_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/flock#flock/block
                _g300949_))))))
  (define std/os/flock#open-input-file/lock__%__%
    (lambda (__197992197995_
             _op197989197997_
             _flags197990197999_
             _path198001_
             _timeout198002_)
      (let* ((_op198004_
              (if (eq? _op197989197997_ absent-value)
                  std/os/flock#LOCK_SH
                  _op197989197997_))
             (_flags198006_
              (if (eq? _flags197990197999_ absent-value)
                  std/os/fcntl#O_RDONLY
                  _flags197990197999_)))
        (std/os/flock#open-file/lock__%__%
         '#f
         'in
         _flags198006_
         '0
         _path198001_
         _op198004_
         _timeout198002_))))
  (define std/os/flock#open-input-file/lock__%__0
    (lambda (__197992198011_ _op197989198012_ _flags197990198013_ _path198014_)
      (let ((_timeout198016_ '#f))
        (std/os/flock#open-input-file/lock__%__%
         __197992198011_
         _op197989198012_
         _flags197990198013_
         _path198014_
         _timeout198016_))))
  (define std/os/flock#open-input-file/lock__%
    (lambda _g300951_
      (let ((_g300950_ (let () (declare (not safe)) (##length _g300951_))))
        (cond ((let () (declare (not safe)) (##fx= _g300950_ 4))
               (apply std/os/flock#open-input-file/lock__%__0 _g300951_))
              ((let () (declare (not safe)) (##fx= _g300950_ 5))
               (apply std/os/flock#open-input-file/lock__%__% _g300951_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/flock#open-input-file/lock__%
                _g300951_))))))
  (define std/os/flock#open-input-file/lock__@
    (lambda (_keys197988198027_ . _args198029_)
      (apply std/os/flock#open-input-file/lock__%
             _keys197988198027_
             (table-ref _keys197988198027_ 'op: absent-value)
             (table-ref _keys197988198027_ 'flags: absent-value)
             _args198029_)))
  (define std/os/flock#open-input-file/lock
    (lambda _args197991198035_
      (apply keyword-dispatch
             '#(flags: #f op: #f)
             std/os/flock#open-input-file/lock__@
             _args197991198035_)))
  (define std/os/flock#open-output-file/lock__%__%
    (lambda (__197935197938_
             _op197931197940_
             _flags197932197942_
             _mode197933197944_
             _path197946_
             _timeout197947_)
      (let* ((_op197949_
              (if (eq? _op197931197940_ absent-value)
                  std/os/flock#LOCK_EX
                  _op197931197940_))
             (_flags197951_
              (if (eq? _flags197932197942_ absent-value)
                  (fxior std/os/fcntl#O_WRONLY std/os/fcntl#O_CREAT)
                  _flags197932197942_))
             (_mode197953_
              (if (eq? _mode197933197944_ absent-value)
                  std/os/fdio#S_IRWXU
                  _mode197933197944_)))
        (std/os/flock#open-file/lock__%__%
         '#f
         'out
         _flags197951_
         _mode197953_
         _path197946_
         _op197949_
         _timeout197947_))))
  (define std/os/flock#open-output-file/lock__%__0
    (lambda (__197935197958_
             _op197931197959_
             _flags197932197960_
             _mode197933197961_
             _path197962_)
      (let ((_timeout197964_ '#f))
        (std/os/flock#open-output-file/lock__%__%
         __197935197958_
         _op197931197959_
         _flags197932197960_
         _mode197933197961_
         _path197962_
         _timeout197964_))))
  (define std/os/flock#open-output-file/lock__%
    (lambda _g300953_
      (let ((_g300952_ (let () (declare (not safe)) (##length _g300953_))))
        (cond ((let () (declare (not safe)) (##fx= _g300952_ 5))
               (apply std/os/flock#open-output-file/lock__%__0 _g300953_))
              ((let () (declare (not safe)) (##fx= _g300952_ 6))
               (apply std/os/flock#open-output-file/lock__%__% _g300953_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/flock#open-output-file/lock__%
                _g300953_))))))
  (define std/os/flock#open-output-file/lock__@
    (lambda (_keys197930197976_ . _args197978_)
      (apply std/os/flock#open-output-file/lock__%
             _keys197930197976_
             (table-ref _keys197930197976_ 'op: absent-value)
             (table-ref _keys197930197976_ 'flags: absent-value)
             (table-ref _keys197930197976_ 'mode: absent-value)
             _args197978_)))
  (define std/os/flock#open-output-file/lock
    (lambda _args197934197984_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                mode:
                #f
                flags:
                #f
                #f
                #f
                #f
                #f
                #f
                op:
                #f)
             std/os/flock#open-output-file/lock__@
             _args197934197984_)))
  (define std/os/flock#open-file/lock__%__%
    (lambda (__197860197863_
             _dir197856197865_
             _flags197857197867_
             _mode197858197869_
             _path197871_
             _op197872_
             _timeout197873_)
      (let* ((_dir197875_
              (if (eq? _dir197856197865_ absent-value)
                  (error '"Missing required keyword argument" 'direction:)
                  _dir197856197865_))
             (_flags197877_
              (if (eq? _flags197857197867_ absent-value)
                  (error '"Missing required keyword argument" 'flags:)
                  _flags197857197867_))
             (_mode197879_
              (if (eq? _mode197858197869_ absent-value)
                  (error '"Missing required keyword argument" 'mode:)
                  _mode197858197869_))
             (_fd197881_
              (std/os/flock#open/lock__%__%
               '#f
               _flags197877_
               _mode197879_
               _path197871_
               _op197872_
               _timeout197873_))
             (_port197883_
              (std/os/fd#fdopen-port _fd197881_ _dir197875_ _path197871_))
             (_close-it197885_ (macro-port-close _port197883_))
             (_unlocked?197887_ '#f))
        (letrec ((_close197890_
                  (lambda (_port197892_ . _args197893_)
                    (if _unlocked?197887_
                        '#!void
                        (begin
                          (std/os/flock#flock _fd197881_ std/os/flock#LOCK_UN)
                          (set! _unlocked?197887_ '#t)))
                    (apply _close-it197885_ _port197892_ _args197893_))))
          (macro-port-close-set! _port197883_ _close197890_)
          _port197883_))))
  (define std/os/flock#open-file/lock__%__0
    (lambda (__197860197898_
             _dir197856197899_
             _flags197857197900_
             _mode197858197901_
             _path197902_
             _op197903_)
      (let ((_timeout197905_ '#f))
        (std/os/flock#open-file/lock__%__%
         __197860197898_
         _dir197856197899_
         _flags197857197900_
         _mode197858197901_
         _path197902_
         _op197903_
         _timeout197905_))))
  (define std/os/flock#open-file/lock__%
    (lambda _g300955_
      (let ((_g300954_ (let () (declare (not safe)) (##length _g300955_))))
        (cond ((let () (declare (not safe)) (##fx= _g300954_ 6))
               (apply std/os/flock#open-file/lock__%__0 _g300955_))
              ((let () (declare (not safe)) (##fx= _g300954_ 7))
               (apply std/os/flock#open-file/lock__%__% _g300955_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/flock#open-file/lock__%
                _g300955_))))))
  (define std/os/flock#open-file/lock__@
    (lambda (_keys197855197918_ . _args197920_)
      (apply std/os/flock#open-file/lock__%
             _keys197855197918_
             (table-ref _keys197855197918_ 'direction: absent-value)
             (table-ref _keys197855197918_ 'flags: absent-value)
             (table-ref _keys197855197918_ 'mode: absent-value)
             _args197920_)))
  (define std/os/flock#open-file/lock
    (lambda _args197859197926_
      (apply keyword-dispatch
             '#(#f
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                mode:
                #f
                flags:
                #f
                #f
                #f
                #f
                #f
                #f
                #f
                direction:)
             std/os/flock#open-file/lock__@
             _args197859197926_)))
  (define std/os/flock#open/lock__%__%
    (lambda (__197790197793_
             _flags197787197795_
             _mode197788197797_
             _path197799_
             _op197800_
             _timeout197801_)
      (let* ((_flags197803_
              (if (eq? _flags197787197795_ absent-value)
                  (error '"Missing required keyword argument" 'flags:)
                  _flags197787197795_))
             (_mode197805_
              (if (eq? _mode197788197797_ absent-value)
                  (error '"Missing required keyword argument" 'mode:)
                  _mode197788197797_))
             (_flags197807_
              (fxior _flags197803_
                     std/os/fcntl#O_NONBLOCK
                     std/os/fcntl#O_CLOEXEC))
             (_fd197812_
              (let ((_r197809_
                     (std/os/fdio#_open
                      _path197799_
                      _flags197807_
                      _mode197805_)))
                (if (not (let ()
                           (declare (not safe))
                           (##fxnegative? _r197809_)))
                    _r197809_
                    (std/os/error#raise-os-error
                     (let () (declare (not safe)) (##fx- _r197809_))
                     std/os/fdio#open
                     _path197799_
                     _flags197807_
                     _mode197805_)))))
        (with-exception-catcher
         (lambda (_g197814197816_)
           (if '#t
               (let ((_e197819_ _g197814197816_))
                 (std/os/fdio#_close _fd197812_)
                 (raise _e197819_))
               (raise _g197814197816_)))
         (lambda ()
           (std/os/flock#flock/block__%
            _fd197812_
            _op197800_
            _timeout197801_)))
        _fd197812_)))
  (define std/os/flock#open/lock__%__0
    (lambda (__197790197825_
             _flags197787197826_
             _mode197788197827_
             _path197828_
             _op197829_)
      (let ((_timeout197831_ '#f))
        (std/os/flock#open/lock__%__%
         __197790197825_
         _flags197787197826_
         _mode197788197827_
         _path197828_
         _op197829_
         _timeout197831_))))
  (define std/os/flock#open/lock__%
    (lambda _g300957_
      (let ((_g300956_ (let () (declare (not safe)) (##length _g300957_))))
        (cond ((let () (declare (not safe)) (##fx= _g300956_ 5))
               (apply std/os/flock#open/lock__%__0 _g300957_))
              ((let () (declare (not safe)) (##fx= _g300956_ 6))
               (apply std/os/flock#open/lock__%__% _g300957_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/os/flock#open/lock__%
                _g300957_))))))
  (define std/os/flock#open/lock__@
    (lambda (_keys197786197843_ . _args197845_)
      (apply std/os/flock#open/lock__%
             _keys197786197843_
             (table-ref _keys197786197843_ 'flags: absent-value)
             (table-ref _keys197786197843_ 'mode: absent-value)
             _args197845_)))
  (define std/os/flock#open/lock
    (lambda _args197789197851_
      (apply keyword-dispatch
             '#(flags: mode: #f)
             std/os/flock#open/lock__@
             _args197789197851_)))
  (define-macro (define-guard guard defn)
    (if (eval `(cond-expand (,guard #t) (else #f)))
        '(begin)
        (begin (eval `(define-cond-expand-feature ,guard)) defn)))
  (define-macro (define-c-lambda id args ret #!optional (name #f))
    (let ((name (or name (symbol->string id))))
      `(define ,id (c-lambda ,args ,ret ,name))))
  (define-macro (define-const symbol)
    (let* ((str (symbol->string symbol))
           (ref (string-append "___return (" str ");")))
      `(define ,symbol ((c-lambda () int ,ref)))))
  (define-macro (define-const* symbol #!optional (ccond #f))
    (let* ((str (symbol->string symbol))
           (code (string-append
                  "#if "
                  (or ccond (string-append "defined(" str ")"))
                  "\n"
                  "___return (___FIX ("
                  str
                  "));\n"
                  "#else \n"
                  "___return (___FAL);\n"
                  "#endif")))
      `(define ,symbol ((c-lambda () scheme-object ,code)))))
  (define-macro (define-with-errno symbol ffi-symbol args)
    `(define (,symbol ,@args)
       (declare (not interrupts-enabled))
       (let ((r (,ffi-symbol ,@args)))
         (if (##fx< r 0) (##fx- (##c-code "___RESULT = ___FIX (errno);")) r))))
  (define-macro (define-c-struct
                 struct
                 #!optional
                 (members '())
                 release-function)
    (let* ((struct-str (symbol->string struct))
           (struct-ptr (string->symbol (string-append struct-str "*")))
           (shallow-ptr
            (string->symbol (string-append struct-str "-shallow-ptr*")))
           (borrowed-ptr
            (string->symbol (string-append struct-str "-borrowed-ptr*")))
           (string-types
            '(char-string
              nonull-char-string
              UTF-8-string
              nonnull-UTF-8-string
              UTF-16-string
              nonnull-UTF16-string))
           (string-compat-required?
            (let loop ((m members))
              (cond ((null? m) #f)
                    ((member (cdr (car m)) string-types) #t)
                    (else (loop (cdr m))))))
           (string-setter-body
            (lambda (member-name)
              (let ((m (string-append "___arg1->" member-name)))
                (string-append
                 "if("
                 m
                 " == NULL)"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "else if (strcmp("
                 m
                 ", ___arg2) != 0) {"
                 "\n"
                 "free("
                 m
                 ");"
                 "\n"
                 m
                 "= strdup(___arg2);"
                 "\n"
                 "}"
                 "\n"
                 "___return;"
                 "\n"))))
           (default-free-body
            (and string-compat-required?
                 (string-append
                  "___SCMOBJ "
                  struct-str
                  "_ffi_free (void *ptr) {"
                  "\n"
                  "struct "
                  struct-str
                  " *obj = (struct "
                  struct-str
                  "*) ptr;"
                  "\n"
                  (apply string-append
                         (map (lambda (m)
                                (cond ((memq (cdr m) string-types)
                                       (let ((mem-name
                                              (symbol->string (car m))))
                                         (string-append
                                          "if(obj->"
                                          mem-name
                                          ") "
                                          "free(obj->"
                                          mem-name
                                          ");"
                                          "\n")))
                                      (else "")))
                              members))
                  "free(obj);"
                  "\n"
                  "return ___FIX (___NO_ERR);"
                  "\n"
                  "}")))
           (release-function
            (or release-function
                (if string-compat-required?
                    (string-append struct-str "_ffi_free")
                    "ffi_free")))
           (string-compat-types
            (if string-compat-required?
                `((c-declare ,default-free-body)
                  (c-define-type
                   ,shallow-ptr
                   (pointer ,struct (,struct-ptr) "ffi_free")))
                '())))
      `(begin
         (c-define-type ,struct (struct ,struct-str))
         (c-define-type
          ,struct-ptr
          (pointer ,struct (,struct-ptr) ,release-function))
         (c-define-type ,borrowed-ptr (pointer ,struct (,struct-ptr)))
         ,@string-compat-types
         (define ,(string->symbol (string-append struct-str "-ptr?"))
           (lambda (obj)
             (and (foreign? obj) (equal? (foreign-tags obj) '(,struct-ptr)))))
         ,@(apply append
                  (map (lambda (m)
                         (let* ((member-name (symbol->string (car m)))
                                (member-type (cdr m))
                                (getter-name
                                 (string-append struct-str "-" member-name))
                                (setter-body
                                 (cond ((member member-type string-types)
                                        (string-setter-body member-name))
                                       (else
                                        (string-append
                                         "___arg1->"
                                         member-name
                                         " = ___arg2;"
                                         "\n"
                                         "___return;"
                                         "\n")))))
                           `((define ,(string->symbol getter-name)
                               (c-lambda
                                (,struct-ptr)
                                ,member-type
                                ,(string-append
                                  "___return(___arg1->"
                                  member-name
                                  ");")))
                             (define ,(string->symbol
                                       (string-append getter-name "-set!"))
                               (c-lambda
                                (,struct-ptr ,member-type)
                                void
                                ,setter-body)))))
                       members))
         (define ,(string->symbol (string-append "malloc-" struct-str))
           (c-lambda
            ()
            ,struct-ptr
            ,(string-append
              "struct "
              struct-str
              "* var = (struct "
              struct-str
              " *) malloc(sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(var, 0, sizeof(struct "
              struct-str
              "));"
              "___return(var);")))
         (define ,(string->symbol (string-append "ptr->" struct-str))
           (c-lambda (,struct-ptr) ,struct "___return(*___arg1);"))
         (define ,(string->symbol
                   (string-append "malloc-" struct-str "-array"))
           (c-lambda
            (unsigned-int32)
            ,(if string-compat-required? shallow-ptr struct-ptr)
            ,(string-append
              "struct "
              struct-str
              " *arr_var=(struct "
              struct-str
              " *) malloc(___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "if (arr_var == NULL)"
              "\n"
              "    ___return (NULL);"
              "\n"
              "memset(arr_var, 0, ___arg1*sizeof(struct "
              struct-str
              "));"
              "\n"
              "___return(arr_var);")))
         (define ,(string->symbol (string-append struct-str "-array-ref"))
           (c-lambda
            (,struct-ptr unsigned-int32)
            ,borrowed-ptr
            "___return (___arg1 + ___arg2);"))
         (define ,(string->symbol (string-append struct-str "-array-set!"))
           (c-lambda
            (,struct-ptr unsigned-int32 ,struct-ptr)
            void
            "*(___arg1 + ___arg2) = *___arg3; ___return;")))))
  (c-declare "#include <stdlib.h>")
  (c-declare "#include <string.h>")
  (c-declare "#include <errno.h>")
  (c-declare "static ___SCMOBJ ffi_free (void *ptr);")
  (c-declare
   "#ifndef ___HAVE_FFI_U8VECTOR\n#define ___HAVE_FFI_U8VECTOR\n#define U8_DATA(obj) ___CAST (___U8*, ___BODY_AS (obj, ___tSUBTYPED))\n#define U8_LEN(obj) ___HD_BYTES (___HEADER (obj))\n#endif")
  (namespace ("std/os/flock#" LOCK_NB LOCK_UN LOCK_EX LOCK_SH _flock))
  (c-declare "#include <sys/file.h>")
  (define-const LOCK_SH)
  (define-const LOCK_EX)
  (define-const LOCK_UN)
  (define-const LOCK_NB)
  (namespace ("std/os/flock#" __flock))
  (define-c-lambda __flock (int int) int "flock")
  (define-with-errno _flock __flock (fd op))
  (c-declare
   "#ifndef ___HAVE_FFI_FREE\n#define ___HAVE_FFI_FREE\n___SCMOBJ ffi_free (void *ptr)\n{\n free (ptr);\n return ___FIX (___NO_ERR);\n}\n#endif"))
