(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/19#time-tai 'time-tai)
  (define std/srfi/19#time-utc 'time-utc)
  (define std/srfi/19#time-monotonic 'time-monotonic)
  (define std/srfi/19#time-thread 'time-thread)
  (define std/srfi/19#time-process 'time-process)
  (define std/srfi/19#time-duration 'time-duration)
  (define std/srfi/19#tm:locale-number-separator '".")
  (define std/srfi/19#tm:locale-abbr-weekday-vector
    (vector '"Sun" '"Mon" '"Tue" '"Wed" '"Thu" '"Fri" '"Sat"))
  (define std/srfi/19#tm:locale-long-weekday-vector
    (vector '"Sunday"
            '"Monday"
            '"Tuesday"
            '"Wednesday"
            '"Thursday"
            '"Friday"
            '"Saturday"))
  (define std/srfi/19#tm:locale-abbr-month-vector
    (vector '""
            '"Jan"
            '"Feb"
            '"Mar"
            '"Apr"
            '"May"
            '"Jun"
            '"Jul"
            '"Aug"
            '"Sep"
            '"Oct"
            '"Nov"
            '"Dec"))
  (define std/srfi/19#tm:locale-long-month-vector
    (vector '""
            '"January"
            '"February"
            '"March"
            '"April"
            '"May"
            '"June"
            '"July"
            '"August"
            '"September"
            '"October"
            '"November"
            '"December"))
  (define std/srfi/19#tm:locale-pm '"PM")
  (define std/srfi/19#tm:locale-am '"AM")
  (define std/srfi/19#tm:locale-date-time-format '"~a ~b ~d ~H:~M:~S~z ~Y")
  (define std/srfi/19#tm:locale-short-date-format '"~m/~d/~y")
  (define std/srfi/19#tm:locale-time-format '"~H:~M:~S")
  (define std/srfi/19#tm:iso-8601-date-time-format '"~Y-~m-~dT~H:~M:~S~z")
  (define std/srfi/19#tm:nano (expt '10 '9))
  (define std/srfi/19#tm:sid '86400)
  (define std/srfi/19#tm:sihd '43200)
  (define std/srfi/19#tm:tai-epoch-in-jd '4881175/2)
  (define std/srfi/19#tm:time-error-types
    '(invalid-clock-type
      unsupported-clock-type
      incompatible-time-types
      not-duration
      dates-are-immutable
      bad-date-format-string
      bad-date-template-string
      invalid-month-specification))
  (define std/srfi/19#tm:time-error
    (lambda (_caller48691_ _type48692_ _value48693_)
      (if (member _type48692_ std/srfi/19#tm:time-error-types)
          (if _value48693_
              (error '"TIME-ERROR type" _caller48691_ _type48692_ _value48693_)
              (error '"TIME-ERROR type" _caller48691_ _type48692_))
          (error '"TIME-ERROR unsupported error type"
                 _caller48691_
                 _type48692_))))
  (define std/srfi/19#tm:read-tai-utc-data
    (lambda (_filename48666_)
      (letrec ((_convert-jd48668_
                (lambda (_jd48689_)
                  (* (- (inexact->exact _jd48689_)
                        std/srfi/19#tm:tai-epoch-in-jd)
                     std/srfi/19#tm:sid)))
               (_convert-sec48669_
                (lambda (_sec48687_) (inexact->exact _sec48687_))))
        (let ((_port48671_ (open-input-file _filename48666_))
              (_table48672_ '()))
          (let _loop48674_ ((_line48676_ (read-line _port48671_)))
            (if (not (eof-object? _line48676_))
                (let* ((_data48678_
                        (read (open-input-string
                               (string-append '"(" _line48676_ '")"))))
                       (_year48680_ (car _data48678_))
                       (_jd48682_ (cadddr (cdr _data48678_)))
                       (_secs48684_ (cadddr (cdddr _data48678_))))
                  (if (>= _year48680_ '1972)
                      (set! _table48672_
                            (cons (cons (_convert-jd48668_ _jd48682_)
                                        (inexact->exact _secs48684_))
                                  _table48672_))
                      '#!void)
                  (_loop48674_ (read-line _port48671_)))
                '#!void))
          _table48672_))))
  (define std/srfi/19#tm:leap-second-table
    '((1483228800 . 37)
      (1435708800 . 36)
      (1341100800 . 35)
      (1230768000 . 34)
      (1136073600 . 33)
      (915148800 . 32)
      (867715200 . 31)
      (820454400 . 30)
      (773020800 . 29)
      (741484800 . 28)
      (709948800 . 27)
      (662688000 . 26)
      (631152000 . 25)
      (567993600 . 24)
      (489024000 . 23)
      (425865600 . 22)
      (394329600 . 21)
      (362793600 . 20)
      (315532800 . 19)
      (283996800 . 18)
      (252460800 . 17)
      (220924800 . 16)
      (189302400 . 15)
      (157766400 . 14)
      (126230400 . 13)
      (94694400 . 12)
      (78796800 . 11)
      (63072000 . 10)))
  (define std/srfi/19#read-leap-second-table
    (lambda (_filename48664_)
      (set! std/srfi/19#tm:leap-second-table
            (std/srfi/19#tm:read-tai-utc-data _filename48664_))
      '#!void))
  (define std/srfi/19#tm:leap-second-delta
    (lambda (_utc-seconds48658_)
      (letrec ((_lsd48660_
                (lambda (_table48662_)
                  (if (>= _utc-seconds48658_ (caar _table48662_))
                      (cdar _table48662_)
                      (_lsd48660_ (cdr _table48662_))))))
        (if (< _utc-seconds48658_ (* (- '1972 '1970) '365 std/srfi/19#tm:sid))
            '0
            (_lsd48660_ std/srfi/19#tm:leap-second-table)))))
  (define std/srfi/19#tm:leap-second-neg-delta
    (lambda (_tai-seconds48652_)
      (letrec ((_lsd48654_
                (lambda (_table48656_)
                  (if (null? _table48656_)
                      '0
                      (if (<= (cdar _table48656_)
                              (- _tai-seconds48652_ (caar _table48656_)))
                          (cdar _table48656_)
                          (_lsd48654_ (cdr _table48656_)))))))
        (if (< _tai-seconds48652_ (* (- '1972 '1970) '365 std/srfi/19#tm:sid))
            '0
            (_lsd48654_ std/srfi/19#tm:leap-second-table)))))
  (define std/srfi/19#time::t
    (make-struct-type
     'std/srfi/19#time::t
     '#f
     '3
     'time
     '((transparent: . #t))
     '#f
     '(type nanosecond second)))
  (define std/srfi/19#time? (make-struct-predicate std/srfi/19#time::t))
  (define std/srfi/19#make-time
    (lambda _$args48649_
      (apply make-struct-instance std/srfi/19#time::t _$args48649_)))
  (define std/srfi/19#time-type
    (make-struct-field-accessor std/srfi/19#time::t '0))
  (define std/srfi/19#time-nanosecond
    (make-struct-field-accessor std/srfi/19#time::t '1))
  (define std/srfi/19#time-second
    (make-struct-field-accessor std/srfi/19#time::t '2))
  (define std/srfi/19#time-type-set!
    (make-struct-field-mutator std/srfi/19#time::t '0))
  (define std/srfi/19#time-nanosecond-set!
    (make-struct-field-mutator std/srfi/19#time::t '1))
  (define std/srfi/19#time-second-set!
    (make-struct-field-mutator std/srfi/19#time::t '2))
  (define std/srfi/19#make-time%
    (lambda (_type48627_ _nanosecond48628_ _second48629_)
      (let ((_$e48631_ _type48627_))
        (if (or (eq? 'time-tai _$e48631_)
                (eq? 'time-utc _$e48631_)
                (eq? 'time-monotonic _$e48631_)
                (eq? 'time-thread _$e48631_)
                (eq? 'time-process _$e48631_)
                (eq? 'time-duration _$e48631_))
            '#t
            (error '"Wrong time type" _type48627_)))
      (if (exact-integer? _second48629_)
          '#!void
          (error '"Invalid time second" _second48629_))
      (if (and (exact-integer? _nanosecond48628_)
               (<= (if (eq? _type48627_ std/srfi/19#time-duration)
                       '-999999999
                       '0)
                   _nanosecond48628_
                   '999999999))
          '#!void
          (error '"Invalid time nanosecond" _nanosecond48628_))
      (let ()
        (declare (not safe))
        (##structure
         std/srfi/19#time::t
         _type48627_
         _nanosecond48628_
         _second48629_))))
  (define std/srfi/19#copy-time
    (lambda (_time48625_)
      (let ((__tmp283522
             (##structure-ref _time48625_ '1 std/srfi/19#time::t '#f))
            (__tmp283521
             (##structure-ref _time48625_ '2 std/srfi/19#time::t '#f))
            (__tmp283520
             (##structure-ref _time48625_ '3 std/srfi/19#time::t '#f)))
        (declare (not safe))
        (##structure
         std/srfi/19#time::t
         __tmp283522
         __tmp283521
         __tmp283520))))
  (define std/srfi/19#current-seconds
    (lambda ()
      (inexact->exact
       (floor (let () (declare (not safe)) (##current-time-point))))))
  (define std/srfi/19#current-milliseconds
    (lambda ()
      (inexact->exact
       (floor (fl* '1000.
                   (let () (declare (not safe)) (##current-time-point)))))))
  (define std/srfi/19#tm:get-time-of-day
    (lambda ()
      (let* ((_now48618_ (let () (declare (not safe)) (##current-time-point)))
             (_sec48620_ (floor _now48618_)))
        (values (inexact->exact _sec48620_)
                (inexact->exact
                 (floor (fl* (fl- _now48618_ _sec48620_) '1000000000.)))))))
  (define std/srfi/19#tm:current-time-utc
    (lambda ()
      (let ((_g283523_ (std/srfi/19#tm:get-time-of-day)))
        (begin
          (let ((_g283524_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g283523_) (##vector-length _g283523_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g283524_ 2)))
                (error "Context expects 2 values" _g283524_)))
          (let ((_seconds48614_
                 (let () (declare (not safe)) (##vector-ref _g283523_ 0)))
                (_ns48615_
                 (let () (declare (not safe)) (##vector-ref _g283523_ 1))))
            (let ()
              (declare (not safe))
              (##structure
               std/srfi/19#time::t
               std/srfi/19#time-utc
               _ns48615_
               _seconds48614_)))))))
  (define std/srfi/19#tm:current-time-tai
    (lambda ()
      (let ((_g283525_ (std/srfi/19#tm:get-time-of-day)))
        (begin
          (let ((_g283526_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g283525_) (##vector-length _g283525_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g283526_ 2)))
                (error "Context expects 2 values" _g283526_)))
          (let ((_seconds48610_
                 (let () (declare (not safe)) (##vector-ref _g283525_ 0)))
                (_ns48611_
                 (let () (declare (not safe)) (##vector-ref _g283525_ 1))))
            (let ((__tmp283527
                   (+ _seconds48610_
                      (std/srfi/19#tm:leap-second-delta _seconds48610_))))
              (declare (not safe))
              (##structure
               std/srfi/19#time::t
               std/srfi/19#time-tai
               _ns48611_
               __tmp283527)))))))
  (define std/srfi/19#tm:current-time-monotonic
    (lambda ()
      (let ((_g283528_ (std/srfi/19#tm:get-time-of-day)))
        (begin
          (let ((_g283529_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g283528_) (##vector-length _g283528_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g283529_ 2)))
                (error "Context expects 2 values" _g283529_)))
          (let ((_seconds48606_
                 (let () (declare (not safe)) (##vector-ref _g283528_ 0)))
                (_ns48607_
                 (let () (declare (not safe)) (##vector-ref _g283528_ 1))))
            (let ((__tmp283530
                   (+ _seconds48606_
                      (std/srfi/19#tm:leap-second-delta _seconds48606_))))
              (declare (not safe))
              (##structure
               std/srfi/19#time::t
               std/srfi/19#time-monotonic
               _ns48607_
               __tmp283530)))))))
  (define std/srfi/19#tm:current-time-thread
    (lambda () (error '"Unimplemented")))
  (define std/srfi/19#tm:current-time-process
    (lambda () (error '"Unimplemented")))
  (define std/srfi/19#current-time
    (lambda _clock-type48596_
      (let ((_clock-type48601_
             (let ((_maybe-arg48598_ _clock-type48596_))
               (if (null? _maybe-arg48598_)
                   std/srfi/19#time-utc
                   (if (null? (cdr _maybe-arg48598_))
                       (car _maybe-arg48598_)
                       (error '"too many optional arguments"
                              _maybe-arg48598_))))))
        (if (eq? _clock-type48601_ std/srfi/19#time-tai)
            (std/srfi/19#tm:current-time-tai)
            (if (eq? _clock-type48601_ std/srfi/19#time-utc)
                (std/srfi/19#tm:current-time-utc)
                (if (eq? _clock-type48601_ std/srfi/19#time-monotonic)
                    (std/srfi/19#tm:current-time-monotonic)
                    (if (eq? _clock-type48601_ std/srfi/19#time-thread)
                        (std/srfi/19#tm:current-time-thread)
                        (if (eq? _clock-type48601_ std/srfi/19#time-process)
                            (std/srfi/19#tm:current-time-process)
                            (std/srfi/19#tm:time-error
                             'current-time
                             'invalid-clock-type
                             _clock-type48601_)))))))))
  (define std/srfi/19#time-resolution
    (lambda _clock-type48589_
      (let ((_clock-type48594_
             (let ((_maybe-arg48591_ _clock-type48589_))
               (if (null? _maybe-arg48591_)
                   std/srfi/19#time-utc
                   (if (null? (cdr _maybe-arg48591_))
                       (car _maybe-arg48591_)
                       (error '"too many optional arguments"
                              _maybe-arg48591_))))))
        (if (eq? _clock-type48594_ std/srfi/19#time-tai)
            '1
            (if (eq? _clock-type48594_ std/srfi/19#time-utc)
                '1
                (if (eq? _clock-type48594_ std/srfi/19#time-monotonic)
                    '1
                    (if (eq? _clock-type48594_ std/srfi/19#time-thread)
                        '1000
                        (if (eq? _clock-type48594_ std/srfi/19#time-process)
                            '1000
                            (std/srfi/19#tm:time-error
                             'time-resolution
                             'invalid-clock-type
                             _clock-type48594_)))))))))
  (define std/srfi/19#tm:time-compare-check
    (lambda (_time148582_ _time248583_ _caller48584_)
      (if (or (not (and (let ()
                          (declare (not safe))
                          (##structure-instance-of?
                           _time148582_
                           'std/srfi/19#time::t))
                        (let ()
                          (declare (not safe))
                          (##structure-instance-of?
                           _time248583_
                           'std/srfi/19#time::t))))
              (not (eq? (##structure-ref
                         _time148582_
                         '1
                         std/srfi/19#time::t
                         '#f)
                        (##structure-ref
                         _time248583_
                         '1
                         std/srfi/19#time::t
                         '#f))))
          (std/srfi/19#tm:time-error
           _caller48584_
           'incompatible-time-types
           '#f)
          '#t)))
  (define std/srfi/19#time=?
    (lambda (_time148579_ _time248580_)
      (std/srfi/19#tm:time-compare-check _time148579_ _time248580_ 'time=?)
      (if (= (##structure-ref _time148579_ '3 std/srfi/19#time::t '#f)
             (##structure-ref _time248580_ '3 std/srfi/19#time::t '#f))
          (= (##structure-ref _time148579_ '2 std/srfi/19#time::t '#f)
             (##structure-ref _time248580_ '2 std/srfi/19#time::t '#f))
          '#f)))
  (define std/srfi/19#time>?
    (lambda (_time148573_ _time248574_)
      (std/srfi/19#tm:time-compare-check _time148573_ _time248574_ 'time>?)
      (let ((_$e48576_
             (> (##structure-ref _time148573_ '3 std/srfi/19#time::t '#f)
                (##structure-ref _time248574_ '3 std/srfi/19#time::t '#f))))
        (if _$e48576_
            _$e48576_
            (if (= (##structure-ref _time148573_ '3 std/srfi/19#time::t '#f)
                   (##structure-ref _time248574_ '3 std/srfi/19#time::t '#f))
                (> (##structure-ref _time148573_ '2 std/srfi/19#time::t '#f)
                   (##structure-ref _time248574_ '2 std/srfi/19#time::t '#f))
                '#f)))))
  (define std/srfi/19#time<?
    (lambda (_time148567_ _time248568_)
      (std/srfi/19#tm:time-compare-check _time148567_ _time248568_ 'time<?)
      (let ((_$e48570_
             (< (##structure-ref _time148567_ '3 std/srfi/19#time::t '#f)
                (##structure-ref _time248568_ '3 std/srfi/19#time::t '#f))))
        (if _$e48570_
            _$e48570_
            (if (= (##structure-ref _time148567_ '3 std/srfi/19#time::t '#f)
                   (##structure-ref _time248568_ '3 std/srfi/19#time::t '#f))
                (< (##structure-ref _time148567_ '2 std/srfi/19#time::t '#f)
                   (##structure-ref _time248568_ '2 std/srfi/19#time::t '#f))
                '#f)))))
  (define std/srfi/19#time>=?
    (lambda (_time148561_ _time248562_)
      (std/srfi/19#tm:time-compare-check _time148561_ _time248562_ 'time>=?)
      (let ((_$e48564_
             (>= (##structure-ref _time148561_ '3 std/srfi/19#time::t '#f)
                 (##structure-ref _time248562_ '3 std/srfi/19#time::t '#f))))
        (if _$e48564_
            _$e48564_
            (if (= (##structure-ref _time148561_ '3 std/srfi/19#time::t '#f)
                   (##structure-ref _time248562_ '3 std/srfi/19#time::t '#f))
                (>= (##structure-ref _time148561_ '2 std/srfi/19#time::t '#f)
                    (##structure-ref _time248562_ '2 std/srfi/19#time::t '#f))
                '#f)))))
  (define std/srfi/19#time<=?
    (lambda (_time148555_ _time248556_)
      (std/srfi/19#tm:time-compare-check _time148555_ _time248556_ 'time<=?)
      (let ((_$e48558_
             (<= (##structure-ref _time148555_ '3 std/srfi/19#time::t '#f)
                 (##structure-ref _time248556_ '3 std/srfi/19#time::t '#f))))
        (if _$e48558_
            _$e48558_
            (if (= (##structure-ref _time148555_ '3 std/srfi/19#time::t '#f)
                   (##structure-ref _time248556_ '3 std/srfi/19#time::t '#f))
                (<= (##structure-ref _time148555_ '2 std/srfi/19#time::t '#f)
                    (##structure-ref _time248556_ '2 std/srfi/19#time::t '#f))
                '#f)))))
  (define std/srfi/19#tm:time->nanoseconds
    (lambda (_time48549_)
      (letrec ((_sign148551_
                (lambda (_n48553_) (if (negative? _n48553_) '-1 '1))))
        (+ (* (##structure-ref _time48549_ '3 std/srfi/19#time::t '#f)
              std/srfi/19#tm:nano)
           (##structure-ref _time48549_ '2 std/srfi/19#time::t '#f)))))
  (define std/srfi/19#tm:nanoseconds->time
    (lambda (_time-type48546_ _nanoseconds48547_)
      (let ((__tmp283532 (remainder _nanoseconds48547_ std/srfi/19#tm:nano))
            (__tmp283531 (quotient _nanoseconds48547_ std/srfi/19#tm:nano)))
        (declare (not safe))
        (##structure
         std/srfi/19#time::t
         _time-type48546_
         __tmp283532
         __tmp283531))))
  (define std/srfi/19#tm:nanoseconds->values
    (lambda (_nanoseconds48544_)
      (values (abs (remainder _nanoseconds48544_ std/srfi/19#tm:nano))
              (quotient _nanoseconds48544_ std/srfi/19#tm:nano))))
  (define std/srfi/19#tm:time-difference
    (lambda (_time148534_ _time248535_ _time348536_)
      (if (or (not (and (let ()
                          (declare (not safe))
                          (##structure-instance-of?
                           _time148534_
                           'std/srfi/19#time::t))
                        (let ()
                          (declare (not safe))
                          (##structure-instance-of?
                           _time248535_
                           'std/srfi/19#time::t))))
              (not (eq? (##structure-ref
                         _time148534_
                         '1
                         std/srfi/19#time::t
                         '#f)
                        (##structure-ref
                         _time248535_
                         '1
                         std/srfi/19#time::t
                         '#f))))
          (std/srfi/19#tm:time-error
           'time-difference
           'incompatible-time-types
           '#f)
          '#!void)
      (##structure-set!
       _time348536_
       std/srfi/19#time-duration
       '1
       std/srfi/19#time::t
       '#f)
      (if (std/srfi/19#time=? _time148534_ _time248535_)
          (begin
            (##structure-set! _time348536_ '0 '3 std/srfi/19#time::t '#f)
            (##structure-set! _time348536_ '0 '2 std/srfi/19#time::t '#f))
          (let ((_g283533_
                 (std/srfi/19#tm:nanoseconds->values
                  (- (std/srfi/19#tm:time->nanoseconds _time148534_)
                     (std/srfi/19#tm:time->nanoseconds _time248535_)))))
            (begin
              (let ((_g283534_
                     (let ()
                       (declare (not safe))
                       (if (##values? _g283533_)
                           (##vector-length _g283533_)
                           1))))
                (if (not (let () (declare (not safe)) (##fx= _g283534_ 2)))
                    (error "Context expects 2 values" _g283534_)))
              (let ((_nanos48541_
                     (let () (declare (not safe)) (##vector-ref _g283533_ 0)))
                    (_secs48542_
                     (let () (declare (not safe)) (##vector-ref _g283533_ 1))))
                (begin
                  (##structure-set!
                   _time348536_
                   _secs48542_
                   '3
                   std/srfi/19#time::t
                   '#f)
                  (##structure-set!
                   _time348536_
                   _nanos48541_
                   '2
                   std/srfi/19#time::t
                   '#f))))))
      _time348536_))
  (define std/srfi/19#time-difference
    (lambda (_time148531_ _time248532_)
      (std/srfi/19#tm:time-difference
       _time148531_
       _time248532_
       (let ()
         (declare (not safe))
         (##structure std/srfi/19#time::t '#f '#f '#f)))))
  (define std/srfi/19#time-difference!
    (lambda (_time148528_ _time248529_)
      (std/srfi/19#tm:time-difference _time148528_ _time248529_ _time148528_)))
  (define std/srfi/19#tm:add-duration
    (lambda (_time148518_ _duration48519_ _time348520_)
      (if (not (and (let ()
                      (declare (not safe))
                      (##structure-instance-of?
                       _time148518_
                       'std/srfi/19#time::t))
                    (let ()
                      (declare (not safe))
                      (##structure-instance-of?
                       _duration48519_
                       'std/srfi/19#time::t))))
          (std/srfi/19#tm:time-error
           'add-duration
           'incompatible-time-types
           '#f)
          '#!void)
      (if (not (eq? (##structure-ref
                     _duration48519_
                     '1
                     std/srfi/19#time::t
                     '#f)
                    std/srfi/19#time-duration))
          (std/srfi/19#tm:time-error
           'add-duration
           'not-duration
           _duration48519_)
          (let ((_sec-plus48522_
                 (+ (##structure-ref _time148518_ '3 std/srfi/19#time::t '#f)
                    (##structure-ref
                     _duration48519_
                     '3
                     std/srfi/19#time::t
                     '#f)))
                (_nsec-plus48523_
                 (+ (##structure-ref _time148518_ '2 std/srfi/19#time::t '#f)
                    (##structure-ref
                     _duration48519_
                     '2
                     std/srfi/19#time::t
                     '#f))))
            (let ((_r48525_ (remainder _nsec-plus48523_ std/srfi/19#tm:nano))
                  (_q48526_ (quotient _nsec-plus48523_ std/srfi/19#tm:nano)))
              (if (negative? _r48525_)
                  (begin
                    (##structure-set!
                     _time348520_
                     (+ _sec-plus48522_ _q48526_ '-1)
                     '3
                     std/srfi/19#time::t
                     '#f)
                    (##structure-set!
                     _time348520_
                     (+ std/srfi/19#tm:nano _r48525_)
                     '2
                     std/srfi/19#time::t
                     '#f))
                  (begin
                    (##structure-set!
                     _time348520_
                     (+ _sec-plus48522_ _q48526_)
                     '3
                     std/srfi/19#time::t
                     '#f)
                    (##structure-set!
                     _time348520_
                     _r48525_
                     '2
                     std/srfi/19#time::t
                     '#f)))
              _time348520_)))))
  (define std/srfi/19#add-duration
    (lambda (_time148515_ _duration48516_)
      (std/srfi/19#tm:add-duration
       _time148515_
       _duration48516_
       (let ((__tmp283535
              (##structure-ref _time148515_ '1 std/srfi/19#time::t '#f)))
         (declare (not safe))
         (##structure std/srfi/19#time::t __tmp283535 '#f '#f)))))
  (define std/srfi/19#add-duration!
    (lambda (_time148512_ _duration48513_)
      (std/srfi/19#tm:add-duration _time148512_ _duration48513_ _time148512_)))
  (define std/srfi/19#tm:subtract-duration
    (lambda (_time148502_ _duration48503_ _time348504_)
      (if (not (and (let ()
                      (declare (not safe))
                      (##structure-instance-of?
                       _time148502_
                       'std/srfi/19#time::t))
                    (let ()
                      (declare (not safe))
                      (##structure-instance-of?
                       _duration48503_
                       'std/srfi/19#time::t))))
          (std/srfi/19#tm:time-error
           'add-duration
           'incompatible-time-types
           '#f)
          '#!void)
      (if (not (eq? (##structure-ref
                     _duration48503_
                     '1
                     std/srfi/19#time::t
                     '#f)
                    std/srfi/19#time-duration))
          (std/srfi/19#tm:time-error
           'tm:subtract-duration
           'not-duration
           _duration48503_)
          (let ((_sec-minus48506_
                 (- (##structure-ref _time148502_ '3 std/srfi/19#time::t '#f)
                    (##structure-ref
                     _duration48503_
                     '3
                     std/srfi/19#time::t
                     '#f)))
                (_nsec-minus48507_
                 (- (##structure-ref _time148502_ '2 std/srfi/19#time::t '#f)
                    (##structure-ref
                     _duration48503_
                     '2
                     std/srfi/19#time::t
                     '#f))))
            (let ((_r48509_ (remainder _nsec-minus48507_ std/srfi/19#tm:nano))
                  (_q48510_ (quotient _nsec-minus48507_ std/srfi/19#tm:nano)))
              (if (negative? _r48509_)
                  (begin
                    (##structure-set!
                     _time348504_
                     (- _sec-minus48506_ _q48510_ '1)
                     '3
                     std/srfi/19#time::t
                     '#f)
                    (##structure-set!
                     _time348504_
                     (+ std/srfi/19#tm:nano _r48509_)
                     '2
                     std/srfi/19#time::t
                     '#f))
                  (begin
                    (##structure-set!
                     _time348504_
                     (- _sec-minus48506_ _q48510_)
                     '3
                     std/srfi/19#time::t
                     '#f)
                    (##structure-set!
                     _time348504_
                     _r48509_
                     '2
                     std/srfi/19#time::t
                     '#f)))
              _time348504_)))))
  (define std/srfi/19#subtract-duration
    (lambda (_time148499_ _duration48500_)
      (std/srfi/19#tm:subtract-duration
       _time148499_
       _duration48500_
       (let ((__tmp283536
              (##structure-ref _time148499_ '1 std/srfi/19#time::t '#f)))
         (declare (not safe))
         (##structure std/srfi/19#time::t __tmp283536 '#f '#f)))))
  (define std/srfi/19#subtract-duration!
    (lambda (_time148496_ _duration48497_)
      (std/srfi/19#tm:subtract-duration
       _time148496_
       _duration48497_
       _time148496_)))
  (define std/srfi/19#tm:time-tai->time-utc!
    (lambda (_time-in48492_ _time-out48493_ _caller48494_)
      (if (not (eq? (##structure-ref _time-in48492_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-tai))
          (std/srfi/19#tm:time-error
           _caller48494_
           'incompatible-time-types
           _time-in48492_)
          '#!void)
      (##structure-set!
       _time-out48493_
       std/srfi/19#time-utc
       '1
       std/srfi/19#time::t
       '#f)
      (##structure-set!
       _time-out48493_
       (##structure-ref _time-in48492_ '2 std/srfi/19#time::t '#f)
       '2
       std/srfi/19#time::t
       '#f)
      (##structure-set!
       _time-out48493_
       (- (##structure-ref _time-in48492_ '3 std/srfi/19#time::t '#f)
          (std/srfi/19#tm:leap-second-neg-delta
           (##structure-ref _time-in48492_ '3 std/srfi/19#time::t '#f)))
       '3
       std/srfi/19#time::t
       '#f)
      _time-out48493_))
  (define std/srfi/19#time-tai->time-utc
    (lambda (_time-in48490_)
      (std/srfi/19#tm:time-tai->time-utc!
       _time-in48490_
       (let ()
         (declare (not safe))
         (##structure std/srfi/19#time::t '#f '#f '#f))
       'time-tai->time-utc)))
  (define std/srfi/19#time-tai->time-utc!
    (lambda (_time-in48488_)
      (std/srfi/19#tm:time-tai->time-utc!
       _time-in48488_
       _time-in48488_
       'time-tai->time-utc!)))
  (define std/srfi/19#tm:time-utc->time-tai!
    (lambda (_time-in48484_ _time-out48485_ _caller48486_)
      (if (not (eq? (##structure-ref _time-in48484_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-utc))
          (std/srfi/19#tm:time-error
           _caller48486_
           'incompatible-time-types
           _time-in48484_)
          '#!void)
      (##structure-set!
       _time-out48485_
       std/srfi/19#time-tai
       '1
       std/srfi/19#time::t
       '#f)
      (##structure-set!
       _time-out48485_
       (##structure-ref _time-in48484_ '2 std/srfi/19#time::t '#f)
       '2
       std/srfi/19#time::t
       '#f)
      (##structure-set!
       _time-out48485_
       (+ (##structure-ref _time-in48484_ '3 std/srfi/19#time::t '#f)
          (std/srfi/19#tm:leap-second-delta
           (##structure-ref _time-in48484_ '3 std/srfi/19#time::t '#f)))
       '3
       std/srfi/19#time::t
       '#f)
      _time-out48485_))
  (define std/srfi/19#time-utc->time-tai
    (lambda (_time-in48482_)
      (std/srfi/19#tm:time-utc->time-tai!
       _time-in48482_
       (let ()
         (declare (not safe))
         (##structure std/srfi/19#time::t '#f '#f '#f))
       'time-utc->time-tai)))
  (define std/srfi/19#time-utc->time-tai!
    (lambda (_time-in48480_)
      (std/srfi/19#tm:time-utc->time-tai!
       _time-in48480_
       _time-in48480_
       'time-utc->time-tai!)))
  (define std/srfi/19#time-monotonic->time-utc
    (lambda (_time-in48476_)
      (if (not (eq? (##structure-ref _time-in48476_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-monotonic))
          (std/srfi/19#tm:time-error
           'time-monotonic->time-utc
           'incompatible-time-types
           _time-in48476_)
          '#!void)
      (let ((_ntime48478_ (std/srfi/19#copy-time _time-in48476_)))
        (##structure-set!
         _ntime48478_
         std/srfi/19#time-tai
         '1
         std/srfi/19#time::t
         '#f)
        (std/srfi/19#tm:time-tai->time-utc!
         _ntime48478_
         _ntime48478_
         'time-monotonic->time-utc))))
  (define std/srfi/19#time-monotonic->time-utc!
    (lambda (_time-in48474_)
      (if (not (eq? (##structure-ref _time-in48474_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-monotonic))
          (std/srfi/19#tm:time-error
           'time-monotonic->time-utc!
           'incompatible-time-types
           _time-in48474_)
          '#!void)
      (##structure-set!
       _time-in48474_
       std/srfi/19#time-tai
       '1
       std/srfi/19#time::t
       '#f)
      (std/srfi/19#tm:time-tai->time-utc!
       _time-in48474_
       _time-in48474_
       'time-monotonic->time-utc)))
  (define std/srfi/19#time-monotonic->time-tai
    (lambda (_time-in48470_)
      (if (not (eq? (##structure-ref _time-in48470_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-monotonic))
          (std/srfi/19#tm:time-error
           'time-monotonic->time-tai
           'incompatible-time-types
           _time-in48470_)
          '#!void)
      (let ((_ntime48472_ (std/srfi/19#copy-time _time-in48470_)))
        (##structure-set!
         _ntime48472_
         std/srfi/19#time-tai
         '1
         std/srfi/19#time::t
         '#f)
        _ntime48472_)))
  (define std/srfi/19#time-monotonic->time-tai!
    (lambda (_time-in48468_)
      (if (not (eq? (##structure-ref _time-in48468_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-monotonic))
          (std/srfi/19#tm:time-error
           'time-monotonic->time-tai!
           'incompatible-time-types
           _time-in48468_)
          '#!void)
      (##structure-set!
       _time-in48468_
       std/srfi/19#time-tai
       '1
       std/srfi/19#time::t
       '#f)
      _time-in48468_))
  (define std/srfi/19#time-utc->time-monotonic
    (lambda (_time-in48464_)
      (if (not (eq? (##structure-ref _time-in48464_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-utc))
          (std/srfi/19#tm:time-error
           'time-utc->time-monotonic
           'incompatible-time-types
           _time-in48464_)
          '#!void)
      (let ((_ntime48466_
             (std/srfi/19#tm:time-utc->time-tai!
              _time-in48464_
              (let ()
                (declare (not safe))
                (##structure std/srfi/19#time::t '#f '#f '#f))
              'time-utc->time-monotonic)))
        (##structure-set!
         _ntime48466_
         std/srfi/19#time-monotonic
         '1
         std/srfi/19#time::t
         '#f)
        _ntime48466_)))
  (define std/srfi/19#time-utc->time-monotonic!
    (lambda (_time-in48460_)
      (if (not (eq? (##structure-ref _time-in48460_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-utc))
          (std/srfi/19#tm:time-error
           'time-utc->time-montonic!
           'incompatible-time-types
           _time-in48460_)
          '#!void)
      (let ((_ntime48462_
             (std/srfi/19#tm:time-utc->time-tai!
              _time-in48460_
              _time-in48460_
              'time-utc->time-monotonic!)))
        (##structure-set!
         _ntime48462_
         std/srfi/19#time-monotonic
         '1
         std/srfi/19#time::t
         '#f)
        _ntime48462_)))
  (define std/srfi/19#time-tai->time-monotonic
    (lambda (_time-in48456_)
      (if (not (eq? (##structure-ref _time-in48456_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-tai))
          (std/srfi/19#tm:time-error
           'time-tai->time-monotonic
           'incompatible-time-types
           _time-in48456_)
          '#!void)
      (let ((_ntime48458_ (std/srfi/19#copy-time _time-in48456_)))
        (##structure-set!
         _ntime48458_
         std/srfi/19#time-monotonic
         '1
         std/srfi/19#time::t
         '#f)
        _ntime48458_)))
  (define std/srfi/19#time-tai->time-monotonic!
    (lambda (_time-in48454_)
      (if (not (eq? (##structure-ref _time-in48454_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-tai))
          (std/srfi/19#tm:time-error
           'time-tai->time-monotonic!
           'incompatible-time-types
           _time-in48454_)
          '#!void)
      (##structure-set!
       _time-in48454_
       std/srfi/19#time-monotonic
       '1
       std/srfi/19#time::t
       '#f)
      _time-in48454_))
  (define std/srfi/19#date::t
    (make-struct-type
     'std/srfi/19#date::t
     '#f
     '8
     'date
     '((transparent: . #t))
     '#f
     '(nanosecond second minute hour day month year zone-offset)))
  (define std/srfi/19#date? (make-struct-predicate std/srfi/19#date::t))
  (define std/srfi/19#make-date
    (lambda _$args48451_
      (apply make-struct-instance std/srfi/19#date::t _$args48451_)))
  (define std/srfi/19#date-nanosecond
    (make-struct-field-accessor std/srfi/19#date::t '0))
  (define std/srfi/19#date-second
    (make-struct-field-accessor std/srfi/19#date::t '1))
  (define std/srfi/19#date-minute
    (make-struct-field-accessor std/srfi/19#date::t '2))
  (define std/srfi/19#date-hour
    (make-struct-field-accessor std/srfi/19#date::t '3))
  (define std/srfi/19#date-day
    (make-struct-field-accessor std/srfi/19#date::t '4))
  (define std/srfi/19#date-month
    (make-struct-field-accessor std/srfi/19#date::t '5))
  (define std/srfi/19#date-year
    (make-struct-field-accessor std/srfi/19#date::t '6))
  (define std/srfi/19#date-zone-offset
    (make-struct-field-accessor std/srfi/19#date::t '7))
  (define std/srfi/19#date-nanosecond-set!
    (make-struct-field-mutator std/srfi/19#date::t '0))
  (define std/srfi/19#date-second-set!
    (make-struct-field-mutator std/srfi/19#date::t '1))
  (define std/srfi/19#date-minute-set!
    (make-struct-field-mutator std/srfi/19#date::t '2))
  (define std/srfi/19#date-hour-set!
    (make-struct-field-mutator std/srfi/19#date::t '3))
  (define std/srfi/19#date-day-set!
    (make-struct-field-mutator std/srfi/19#date::t '4))
  (define std/srfi/19#date-month-set!
    (make-struct-field-mutator std/srfi/19#date::t '5))
  (define std/srfi/19#date-year-set!
    (make-struct-field-mutator std/srfi/19#date::t '6))
  (define std/srfi/19#date-zone-offset-set!
    (make-struct-field-mutator std/srfi/19#date::t '7))
  (define std/srfi/19#tm:encode-julian-day-number
    (lambda (_day48440_ _month48441_ _year48442_)
      (let* ((_a48444_ (quotient (- '14 _month48441_) '12))
             (_y48446_
              (- (- (+ _year48442_ '4800) _a48444_)
                 (if (negative? _year48442_) '-1 '0)))
             (_m48448_ (- (+ _month48441_ (* '12 _a48444_)) '3)))
        (+ _day48440_
           (quotient (+ (* '153 _m48448_) '2) '5)
           (* '365 _y48446_)
           (quotient _y48446_ '4)
           (- (quotient _y48446_ '100))
           (quotient _y48446_ '400)
           '-32045))))
  (define std/srfi/19#tm:char-pos
    (lambda (_char48435_ _str48436_ _index48437_ _len48438_)
      (if (>= _index48437_ _len48438_)
          '#f
          (if (char=? (string-ref _str48436_ _index48437_) _char48435_)
              _index48437_
              (std/srfi/19#tm:char-pos
               _char48435_
               _str48436_
               (+ _index48437_ '1)
               _len48438_)))))
  (define std/srfi/19#tm:fractional-part
    (lambda (_r48429_)
      (if (integer? _r48429_)
          '"0"
          (let* ((_str48431_ (number->string (exact->inexact _r48429_)))
                 (_ppos48433_
                  (std/srfi/19#tm:char-pos
                   '#\.
                   _str48431_
                   '0
                   (string-length _str48431_))))
            (substring
             _str48431_
             (+ _ppos48433_ '1)
             (string-length _str48431_))))))
  (define std/srfi/19#tm:decode-julian-day-number
    (lambda (_jdn48410_)
      (let* ((_days48412_ (truncate _jdn48410_))
             (_a48414_ (+ _days48412_ '32044))
             (_b48416_ (quotient (+ (* '4 _a48414_) '3) '146097))
             (_c48418_ (- _a48414_ (quotient (* '146097 _b48416_) '4)))
             (_d48420_ (quotient (+ (* '4 _c48418_) '3) '1461))
             (_e48422_ (- _c48418_ (quotient (* '1461 _d48420_) '4)))
             (_m48424_ (quotient (+ (* '5 _e48422_) '2) '153))
             (_y48426_
              (+ (* '100 _b48416_) _d48420_ '-4800 (quotient _m48424_ '10))))
        (values (* (- _jdn48410_ _days48412_) std/srfi/19#tm:sid)
                (+ _e48422_ (- (quotient (+ (* '153 _m48424_) '2) '5)) '1)
                (+ _m48424_ '3 (* '-12 (quotient _m48424_ '10)))
                (if (>= '0 _y48426_) (- _y48426_ '1) _y48426_)))))
  (define std/srfi/19#tm:local-tz-offset (lambda () '0))
  (define std/srfi/19#tm:time->julian-day-number
    (lambda (_seconds48406_ _tz-offset48407_)
      (+ (/ (+ _seconds48406_ _tz-offset48407_ std/srfi/19#tm:sihd)
            std/srfi/19#tm:sid)
         std/srfi/19#tm:tai-epoch-in-jd)))
  (define std/srfi/19#tm:find
    (lambda (_proc48403_ _l48404_)
      (if (null? _l48404_)
          '#f
          (if (_proc48403_ (car _l48404_))
              '#t
              (std/srfi/19#tm:find _proc48403_ (cdr _l48404_))))))
  (define std/srfi/19#tm:tai-before-leap-second?
    (lambda (_second48399_)
      (std/srfi/19#tm:find
       (lambda (_x48401_)
         (= _second48399_ (- (+ (car _x48401_) (cdr _x48401_)) '1)))
       std/srfi/19#tm:leap-second-table)))
  (define std/srfi/19#tm:time->date
    (lambda (_time48375_ _tz-offset48376_ _ttype48377_)
      (if (not (eq? (##structure-ref _time48375_ '1 std/srfi/19#time::t '#f)
                    _ttype48377_))
          (std/srfi/19#tm:time-error
           'time->date
           'incompatible-time-types
           _time48375_)
          '#!void)
      (let ((_offset48382_
             (let ((_maybe-arg48379_ _tz-offset48376_))
               (if (null? _maybe-arg48379_)
                   (std/srfi/19#tm:local-tz-offset)
                   (if (null? (cdr _maybe-arg48379_))
                       (car _maybe-arg48379_)
                       (error '"too many optional arguments"
                              _maybe-arg48379_))))))
        (let ((_g283537_
               (std/srfi/19#tm:decode-julian-day-number
                (std/srfi/19#tm:time->julian-day-number
                 (##structure-ref _time48375_ '3 std/srfi/19#time::t '#f)
                 _offset48382_))))
          (begin
            (let ((_g283538_
                   (let ()
                     (declare (not safe))
                     (if (##values? _g283537_)
                         (##vector-length _g283537_)
                         1))))
              (if (not (let () (declare (not safe)) (##fx= _g283538_ 4)))
                  (error "Context expects 4 values" _g283538_)))
            (let ((_secs48385_
                   (let () (declare (not safe)) (##vector-ref _g283537_ 0)))
                  (_date48386_
                   (let () (declare (not safe)) (##vector-ref _g283537_ 1)))
                  (_month48387_
                   (let () (declare (not safe)) (##vector-ref _g283537_ 2)))
                  (_year48388_
                   (let () (declare (not safe)) (##vector-ref _g283537_ 3))))
              (let* ((_hours48390_ (quotient _secs48385_ (* '60 '60)))
                     (_rem48392_ (remainder _secs48385_ (* '60 '60)))
                     (_minutes48394_ (quotient _rem48392_ '60))
                     (_seconds48396_ (remainder _rem48392_ '60)))
                (let ((__tmp283539
                       (##structure-ref
                        _time48375_
                        '2
                        std/srfi/19#time::t
                        '#f)))
                  (declare (not safe))
                  (##structure
                   std/srfi/19#date::t
                   __tmp283539
                   _seconds48396_
                   _minutes48394_
                   _hours48390_
                   _date48386_
                   _month48387_
                   _year48388_
                   _offset48382_)))))))))
  (define std/srfi/19#time-tai->date
    (lambda (_time48370_ . _tz-offset48371_)
      (if (std/srfi/19#tm:tai-before-leap-second?
           (##structure-ref _time48370_ '3 std/srfi/19#time::t '#f))
          (let ((_d48373_
                 (std/srfi/19#tm:time->date
                  (std/srfi/19#subtract-duration!
                   (std/srfi/19#time-tai->time-utc _time48370_)
                   (let ()
                     (declare (not safe))
                     (##structure
                      std/srfi/19#time::t
                      std/srfi/19#time-duration
                      '0
                      '1)))
                  _tz-offset48371_
                  std/srfi/19#time-utc)))
            (##structure-set! _d48373_ '60 '2 std/srfi/19#date::t '#f)
            _d48373_)
          (std/srfi/19#tm:time->date
           (std/srfi/19#time-tai->time-utc _time48370_)
           _tz-offset48371_
           std/srfi/19#time-utc))))
  (define std/srfi/19#time-utc->date
    (lambda (_time48367_ . _tz-offset48368_)
      (std/srfi/19#tm:time->date
       _time48367_
       _tz-offset48368_
       std/srfi/19#time-utc)))
  (define std/srfi/19#time-monotonic->date
    (lambda (_time48364_ . _tz-offset48365_)
      (std/srfi/19#tm:time->date
       _time48364_
       _tz-offset48365_
       std/srfi/19#time-monotonic)))
  (define std/srfi/19#date->time-utc
    (lambda (_date48351_)
      (let ((_nanosecond48353_
             (##structure-ref _date48351_ '1 std/srfi/19#date::t '#f))
            (_second48354_
             (##structure-ref _date48351_ '2 std/srfi/19#date::t '#f))
            (_minute48355_
             (##structure-ref _date48351_ '3 std/srfi/19#date::t '#f))
            (_hour48356_
             (##structure-ref _date48351_ '4 std/srfi/19#date::t '#f))
            (_day48357_
             (##structure-ref _date48351_ '5 std/srfi/19#date::t '#f))
            (_month48358_
             (##structure-ref _date48351_ '6 std/srfi/19#date::t '#f))
            (_year48359_
             (##structure-ref _date48351_ '7 std/srfi/19#date::t '#f))
            (_offset48360_
             (##structure-ref _date48351_ '8 std/srfi/19#date::t '#f)))
        (let* ((_jdays48362_
                (- (std/srfi/19#tm:encode-julian-day-number
                    _day48357_
                    _month48358_
                    _year48359_)
                   std/srfi/19#tm:tai-epoch-in-jd))
               (__tmp283540
                (+ (* (- _jdays48362_ '1/2) '24 '60 '60)
                   (* _hour48356_ '60 '60)
                   (* _minute48355_ '60)
                   _second48354_
                   (- _offset48360_))))
          (declare (not safe))
          (##structure
           std/srfi/19#time::t
           std/srfi/19#time-utc
           _nanosecond48353_
           __tmp283540)))))
  (define std/srfi/19#date->time-tai
    (lambda (_d48349_)
      (if (= (##structure-ref _d48349_ '2 std/srfi/19#date::t '#f) '60)
          (std/srfi/19#subtract-duration!
           (std/srfi/19#time-utc->time-tai!
            (std/srfi/19#date->time-utc _d48349_))
           (let ()
             (declare (not safe))
             (##structure
              std/srfi/19#time::t
              std/srfi/19#time-duration
              '0
              '1)))
          (std/srfi/19#time-utc->time-tai!
           (std/srfi/19#date->time-utc _d48349_)))))
  (define std/srfi/19#date->time-monotonic
    (lambda (_date48347_)
      (std/srfi/19#time-utc->time-monotonic!
       (std/srfi/19#date->time-utc _date48347_))))
  (define std/srfi/19#tm:leap-year?
    (lambda (_year48342_)
      (let ((_$e48344_ (= (modulo _year48342_ '400) '0)))
        (if _$e48344_
            _$e48344_
            (if (= (modulo _year48342_ '4) '0)
                (not (= (modulo _year48342_ '100) '0))
                '#f)))))
  (define std/srfi/19#leap-year?
    (lambda (_date48340_)
      (std/srfi/19#tm:leap-year?
       (##structure-ref _date48340_ '7 std/srfi/19#date::t '#f))))
  (define std/srfi/19#tm:month-assoc
    '((0 . 0)
      (1 . 31)
      (2 . 59)
      (3 . 90)
      (4 . 120)
      (5 . 151)
      (6 . 181)
      (7 . 212)
      (8 . 243)
      (9 . 273)
      (10 . 304)
      (11 . 334)))
  (define std/srfi/19#tm:year-day
    (lambda (_day48334_ _month48335_ _year48336_)
      (let ((_days-pr48338_
             (assoc (- _month48335_ '1) std/srfi/19#tm:month-assoc)))
        (if (not _days-pr48338_)
            (std/srfi/19#tm:time-error
             'date-year-day
             'invalid-month-specification
             _month48335_)
            '#!void)
        (if (and (std/srfi/19#tm:leap-year? _year48336_) (> _month48335_ '2))
            (+ _day48334_ (cdr _days-pr48338_) '1)
            (+ _day48334_ (cdr _days-pr48338_))))))
  (define std/srfi/19#date-year-day
    (lambda (_date48332_)
      (std/srfi/19#tm:year-day
       (##structure-ref _date48332_ '5 std/srfi/19#date::t '#f)
       (##structure-ref _date48332_ '6 std/srfi/19#date::t '#f)
       (##structure-ref _date48332_ '7 std/srfi/19#date::t '#f))))
  (define std/srfi/19#tm:week-day
    (lambda (_day48321_ _month48322_ _year48323_)
      (let* ((_a48325_ (quotient (- '14 _month48322_) '12))
             (_y48327_ (- _year48323_ _a48325_))
             (_m48329_ (+ _month48322_ (* '12 _a48325_) '-2)))
        (modulo (+ _day48321_
                   _y48327_
                   (quotient _y48327_ '4)
                   (- (quotient _y48327_ '100))
                   (quotient _y48327_ '400)
                   (quotient (* '31 _m48329_) '12))
                '7))))
  (define std/srfi/19#date-week-day
    (lambda (_date48319_)
      (std/srfi/19#tm:week-day
       (##structure-ref _date48319_ '5 std/srfi/19#date::t '#f)
       (##structure-ref _date48319_ '6 std/srfi/19#date::t '#f)
       (##structure-ref _date48319_ '7 std/srfi/19#date::t '#f))))
  (define std/srfi/19#tm:days-before-first-week
    (lambda (_date48311_ _day-of-week-starting-week48312_)
      (let* ((_first-day48314_
              (let ((__tmp283541
                     (##structure-ref _date48311_ '7 std/srfi/19#date::t '#f)))
                (declare (not safe))
                (##structure
                 std/srfi/19#date::t
                 '0
                 '0
                 '0
                 '0
                 '1
                 '1
                 __tmp283541
                 '#f)))
             (_fdweek-day48316_ (std/srfi/19#date-week-day _first-day48314_)))
        (modulo (- _day-of-week-starting-week48312_ _fdweek-day48316_) '7))))
  (define std/srfi/19#date-week-number
    (lambda (_date48308_ _day-of-week-starting-week48309_)
      (quotient
       (- (std/srfi/19#date-year-day _date48308_)
          (std/srfi/19#tm:days-before-first-week
           _date48308_
           _day-of-week-starting-week48309_))
       '7)))
  (define std/srfi/19#current-date
    (lambda _tz-offset48303_
      (std/srfi/19#time-utc->date
       (std/srfi/19#current-time std/srfi/19#time-utc)
       (let ((_maybe-arg48305_ _tz-offset48303_))
         (if (null? _maybe-arg48305_)
             (std/srfi/19#tm:local-tz-offset)
             (if (null? (cdr _maybe-arg48305_))
                 (car _maybe-arg48305_)
                 (error '"too many optional arguments" _maybe-arg48305_)))))))
  (define std/srfi/19#tm:natural-year
    (lambda (_n48296_)
      (let* ((_current-year48298_
              (##structure-ref
               (std/srfi/19#current-date)
               '7
               std/srfi/19#date::t
               '#f))
             (_current-century48300_
              (* (quotient _current-year48298_ '100) '100)))
        (if (>= _n48296_ '100)
            _n48296_
            (if (< _n48296_ '0)
                _n48296_
                (if (<= (- (+ _current-century48300_ _n48296_)
                           _current-year48298_)
                        '50)
                    (+ _current-century48300_ _n48296_)
                    (+ (- _current-century48300_ '100) _n48296_)))))))
  (define std/srfi/19#date->julian-day
    (lambda (_date48285_)
      (let ((_nanosecond48287_
             (##structure-ref _date48285_ '1 std/srfi/19#date::t '#f))
            (_second48288_
             (##structure-ref _date48285_ '2 std/srfi/19#date::t '#f))
            (_minute48289_
             (##structure-ref _date48285_ '3 std/srfi/19#date::t '#f))
            (_hour48290_
             (##structure-ref _date48285_ '4 std/srfi/19#date::t '#f))
            (_day48291_
             (##structure-ref _date48285_ '5 std/srfi/19#date::t '#f))
            (_month48292_
             (##structure-ref _date48285_ '6 std/srfi/19#date::t '#f))
            (_year48293_
             (##structure-ref _date48285_ '7 std/srfi/19#date::t '#f))
            (_offset48294_
             (##structure-ref _date48285_ '8 std/srfi/19#date::t '#f)))
        (+ (std/srfi/19#tm:encode-julian-day-number
            _day48291_
            _month48292_
            _year48293_)
           (- '1/2)
           (+ (/ (/ (+ (* _hour48290_ '60 '60)
                       (* _minute48289_ '60)
                       _second48288_
                       (/ _nanosecond48287_ std/srfi/19#tm:nano))
                    std/srfi/19#tm:sid)
                 (- _offset48294_)))))))
  (define std/srfi/19#date->modified-julian-day
    (lambda (_date48283_)
      (- (std/srfi/19#date->julian-day _date48283_) '4800001/2)))
  (define std/srfi/19#time-utc->julian-day
    (lambda (_time48281_)
      (if (not (eq? (##structure-ref _time48281_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-utc))
          (std/srfi/19#tm:time-error
           'time-utc->julian-day
           'incompatible-time-types
           _time48281_)
          '#!void)
      (+ (/ (+ (##structure-ref _time48281_ '3 std/srfi/19#time::t '#f)
               (/ (##structure-ref _time48281_ '2 std/srfi/19#time::t '#f)
                  std/srfi/19#tm:nano))
            std/srfi/19#tm:sid)
         std/srfi/19#tm:tai-epoch-in-jd)))
  (define std/srfi/19#time-utc->modified-julian-day
    (lambda (_time48279_)
      (- (std/srfi/19#time-utc->julian-day _time48279_) '4800001/2)))
  (define std/srfi/19#time-tai->julian-day
    (lambda (_time48277_)
      (if (not (eq? (##structure-ref _time48277_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-tai))
          (std/srfi/19#tm:time-error
           'time-tai->julian-day
           'incompatible-time-types
           _time48277_)
          '#!void)
      (+ (/ (+ (- (##structure-ref _time48277_ '3 std/srfi/19#time::t '#f)
                  (std/srfi/19#tm:leap-second-delta
                   (##structure-ref _time48277_ '3 std/srfi/19#time::t '#f)))
               (/ (##structure-ref _time48277_ '2 std/srfi/19#time::t '#f)
                  std/srfi/19#tm:nano))
            std/srfi/19#tm:sid)
         std/srfi/19#tm:tai-epoch-in-jd)))
  (define std/srfi/19#time-tai->modified-julian-day
    (lambda (_time48275_)
      (- (std/srfi/19#time-tai->julian-day _time48275_) '4800001/2)))
  (define std/srfi/19#time-monotonic->julian-day
    (lambda (_time48273_)
      (if (not (eq? (##structure-ref _time48273_ '1 std/srfi/19#time::t '#f)
                    std/srfi/19#time-monotonic))
          (std/srfi/19#tm:time-error
           'time-monotonic->julian-day
           'incompatible-time-types
           _time48273_)
          '#!void)
      (+ (/ (+ (- (##structure-ref _time48273_ '3 std/srfi/19#time::t '#f)
                  (std/srfi/19#tm:leap-second-delta
                   (##structure-ref _time48273_ '3 std/srfi/19#time::t '#f)))
               (/ (##structure-ref _time48273_ '2 std/srfi/19#time::t '#f)
                  std/srfi/19#tm:nano))
            std/srfi/19#tm:sid)
         std/srfi/19#tm:tai-epoch-in-jd)))
  (define std/srfi/19#time-monotonic->modified-julian-day
    (lambda (_time48271_)
      (- (std/srfi/19#time-monotonic->julian-day _time48271_) '4800001/2)))
  (define std/srfi/19#julian-day->time-utc
    (lambda (_jdn48267_)
      (let ((_nanosecs48269_
             (* std/srfi/19#tm:nano
                std/srfi/19#tm:sid
                (- _jdn48267_ std/srfi/19#tm:tai-epoch-in-jd))))
        (let ((__tmp283543 (remainder _nanosecs48269_ std/srfi/19#tm:nano))
              (__tmp283542 (floor (/ _nanosecs48269_ std/srfi/19#tm:nano))))
          (declare (not safe))
          (##structure
           std/srfi/19#time::t
           std/srfi/19#time-utc
           __tmp283543
           __tmp283542)))))
  (define std/srfi/19#julian-day->time-tai
    (lambda (_jdn48265_)
      (std/srfi/19#time-utc->time-tai!
       (std/srfi/19#julian-day->time-utc _jdn48265_))))
  (define std/srfi/19#julian-day->time-monotonic
    (lambda (_jdn48263_)
      (std/srfi/19#time-utc->time-monotonic!
       (std/srfi/19#julian-day->time-utc _jdn48263_))))
  (define std/srfi/19#julian-day->date
    (lambda (_jdn48255_ . _tz-offset48256_)
      (let ((_offset48261_
             (let ((_maybe-arg48258_ _tz-offset48256_))
               (if (null? _maybe-arg48258_)
                   (std/srfi/19#tm:local-tz-offset)
                   (if (null? (cdr _maybe-arg48258_))
                       (car _maybe-arg48258_)
                       (error '"too many optional arguments"
                              _maybe-arg48258_))))))
        (std/srfi/19#time-utc->date
         (std/srfi/19#julian-day->time-utc _jdn48255_)
         _offset48261_))))
  (define std/srfi/19#modified-julian-day->date
    (lambda (_jdn48247_ . _tz-offset48248_)
      (let ((_offset48253_
             (let ((_maybe-arg48250_ _tz-offset48248_))
               (if (null? _maybe-arg48250_)
                   (std/srfi/19#tm:local-tz-offset)
                   (if (null? (cdr _maybe-arg48250_))
                       (car _maybe-arg48250_)
                       (error '"too many optional arguments"
                              _maybe-arg48250_))))))
        (std/srfi/19#julian-day->date
         (+ _jdn48247_ '4800001/2)
         _offset48253_))))
  (define std/srfi/19#modified-julian-day->time-utc
    (lambda (_jdn48245_)
      (std/srfi/19#julian-day->time-utc (+ _jdn48245_ '4800001/2))))
  (define std/srfi/19#modified-julian-day->time-tai
    (lambda (_jdn48243_)
      (std/srfi/19#julian-day->time-tai (+ _jdn48243_ '4800001/2))))
  (define std/srfi/19#modified-julian-day->time-monotonic
    (lambda (_jdn48241_)
      (std/srfi/19#julian-day->time-monotonic (+ _jdn48241_ '4800001/2))))
  (define std/srfi/19#current-julian-day
    (lambda ()
      (std/srfi/19#time-utc->julian-day
       (std/srfi/19#current-time std/srfi/19#time-utc))))
  (define std/srfi/19#current-modified-julian-day
    (lambda ()
      (std/srfi/19#time-utc->modified-julian-day
       (std/srfi/19#current-time std/srfi/19#time-utc))))
  (define std/srfi/19#tm:padding
    (lambda (_n48217_ _pad-with48218_ _length48219_)
      (let* ((_str48221_ (number->string _n48217_))
             (_str-len48223_ (string-length _str48221_)))
        (if (or (> _str-len48223_ _length48219_) (not _pad-with48218_))
            _str48221_
            (let* ((_new-str48229_ (make-string _length48219_ _pad-with48218_))
                   (_new-str-offset48231_
                    (- (string-length _new-str48229_) _str-len48223_)))
              (let _$loop48234_ ((_i48237_ '0))
                (if (>= _i48237_ (string-length _str48221_))
                    '#!void
                    (begin
                      (string-set!
                       _new-str48229_
                       (+ _new-str-offset48231_ _i48237_)
                       (string-ref _str48221_ _i48237_))
                      (_$loop48234_ (+ _i48237_ '1)))))
              _new-str48229_)))))
  (define std/srfi/19#tm:last-n-digits
    (lambda (_i48214_ _n48215_)
      (abs (remainder _i48214_ (expt '10 _n48215_)))))
  (define std/srfi/19#tm:locale-abbr-weekday
    (lambda (_n48212_)
      (vector-ref std/srfi/19#tm:locale-abbr-weekday-vector _n48212_)))
  (define std/srfi/19#tm:locale-long-weekday
    (lambda (_n48210_)
      (vector-ref std/srfi/19#tm:locale-long-weekday-vector _n48210_)))
  (define std/srfi/19#tm:locale-abbr-month
    (lambda (_n48208_)
      (vector-ref std/srfi/19#tm:locale-abbr-month-vector _n48208_)))
  (define std/srfi/19#tm:locale-long-month
    (lambda (_n48206_)
      (vector-ref std/srfi/19#tm:locale-long-month-vector _n48206_)))
  (define std/srfi/19#tm:vector-find
    (lambda (_needle48196_ _haystack48197_ _comparator48198_)
      (let ((_len48200_ (vector-length _haystack48197_)))
        (letrec ((_tm:vector-find-int48202_
                  (lambda (_index48204_)
                    (if (>= _index48204_ _len48200_)
                        '#f
                        (if (_comparator48198_
                             _needle48196_
                             (vector-ref _haystack48197_ _index48204_))
                            _index48204_
                            (_tm:vector-find-int48202_
                             (+ _index48204_ '1)))))))
          (_tm:vector-find-int48202_ '0)))))
  (define std/srfi/19#tm:locale-abbr-weekday->index
    (lambda (_string48194_)
      (std/srfi/19#tm:vector-find
       _string48194_
       std/srfi/19#tm:locale-abbr-weekday-vector
       string=?)))
  (define std/srfi/19#tm:locale-long-weekday->index
    (lambda (_string48192_)
      (std/srfi/19#tm:vector-find
       _string48192_
       std/srfi/19#tm:locale-long-weekday-vector
       string=?)))
  (define std/srfi/19#tm:locale-abbr-month->index
    (lambda (_string48190_)
      (std/srfi/19#tm:vector-find
       _string48190_
       std/srfi/19#tm:locale-abbr-month-vector
       string=?)))
  (define std/srfi/19#tm:locale-long-month->index
    (lambda (_string48188_)
      (std/srfi/19#tm:vector-find
       _string48188_
       std/srfi/19#tm:locale-long-month-vector
       string=?)))
  (define std/srfi/19#tm:locale-print-time-zone
    (lambda (_date48185_ _port48186_) '#!void))
  (define std/srfi/19#tm:locale-am/pm
    (lambda (_hr48183_)
      (if (> _hr48183_ '11)
          std/srfi/19#tm:locale-pm
          std/srfi/19#tm:locale-am)))
  (define std/srfi/19#tm:tz-printer
    (lambda (_offset48177_ _port48178_)
      (if (= _offset48177_ '0)
          (display '"Z" _port48178_)
          (if (negative? _offset48177_)
              (display '"-" _port48178_)
              (display '"+" _port48178_)))
      (if (not (= _offset48177_ '0))
          (let ((_hours48180_ (abs (quotient _offset48177_ (* '60 '60))))
                (_minutes48181_
                 (abs (quotient (remainder _offset48177_ (* '60 '60)) '60))))
            (display (std/srfi/19#tm:padding _hours48180_ '#\0 '2) _port48178_)
            (display (std/srfi/19#tm:padding _minutes48181_ '#\0 '2)
                     _port48178_))
          '#!void)))
  (define std/srfi/19#tm:directives
    (list (cons '#\~
                (lambda (_date48004_ _pad-with48005_ _port48006_)
                  (display '#\~ _port48006_)))
          (cons '#\a
                (lambda (_date48008_ _pad-with48009_ _port48010_)
                  (display (std/srfi/19#tm:locale-abbr-weekday
                            (std/srfi/19#date-week-day _date48008_))
                           _port48010_)))
          (cons '#\A
                (lambda (_date48012_ _pad-with48013_ _port48014_)
                  (display (std/srfi/19#tm:locale-long-weekday
                            (std/srfi/19#date-week-day _date48012_))
                           _port48014_)))
          (cons '#\b
                (lambda (_date48016_ _pad-with48017_ _port48018_)
                  (display (std/srfi/19#tm:locale-abbr-month
                            (##structure-ref
                             _date48016_
                             '6
                             std/srfi/19#date::t
                             '#f))
                           _port48018_)))
          (cons '#\B
                (lambda (_date48020_ _pad-with48021_ _port48022_)
                  (display (std/srfi/19#tm:locale-long-month
                            (##structure-ref
                             _date48020_
                             '6
                             std/srfi/19#date::t
                             '#f))
                           _port48022_)))
          (cons '#\c
                (lambda (_date48024_ _pad-with48025_ _port48026_)
                  (display (std/srfi/19#date->string
                            _date48024_
                            std/srfi/19#tm:locale-date-time-format)
                           _port48026_)))
          (cons '#\d
                (lambda (_date48028_ _pad-with48029_ _port48030_)
                  (display (std/srfi/19#tm:padding
                            (##structure-ref
                             _date48028_
                             '5
                             std/srfi/19#date::t
                             '#f)
                            '#\0
                            '2)
                           _port48030_)))
          (cons '#\D
                (lambda (_date48032_ _pad-with48033_ _port48034_)
                  (display (std/srfi/19#date->string _date48032_ '"~m/~d/~y")
                           _port48034_)))
          (cons '#\e
                (lambda (_date48036_ _pad-with48037_ _port48038_)
                  (display (std/srfi/19#tm:padding
                            (##structure-ref
                             _date48036_
                             '5
                             std/srfi/19#date::t
                             '#f)
                            '#\space
                            '2)
                           _port48038_)))
          (cons '#\f
                (lambda (_date48040_ _pad-with48041_ _port48042_)
                  (if (> (##structure-ref
                          _date48040_
                          '1
                          std/srfi/19#date::t
                          '#f)
                         std/srfi/19#tm:nano)
                      (display (std/srfi/19#tm:padding
                                (+ (##structure-ref
                                    _date48040_
                                    '2
                                    std/srfi/19#date::t
                                    '#f)
                                   '1)
                                _pad-with48041_
                                '2)
                               _port48042_)
                      (display (std/srfi/19#tm:padding
                                (##structure-ref
                                 _date48040_
                                 '2
                                 std/srfi/19#date::t
                                 '#f)
                                _pad-with48041_
                                '2)
                               _port48042_))
                  (let* ((_ns48044_
                          (std/srfi/19#tm:fractional-part
                           (/ (##structure-ref
                               _date48040_
                               '1
                               std/srfi/19#date::t
                               '#f)
                              std/srfi/19#tm:nano
                              '1.)))
                         (_le48046_ (string-length _ns48044_)))
                    (if (> _le48046_ '2)
                        (begin
                          (display std/srfi/19#tm:locale-number-separator
                                   _port48042_)
                          (display (substring _ns48044_ '2 _le48046_)
                                   _port48042_))
                        '#!void))))
          (cons '#\h
                (lambda (_date48049_ _pad-with48050_ _port48051_)
                  (display (std/srfi/19#date->string _date48049_ '"~b")
                           _port48051_)))
          (cons '#\H
                (lambda (_date48053_ _pad-with48054_ _port48055_)
                  (display (std/srfi/19#tm:padding
                            (##structure-ref
                             _date48053_
                             '4
                             std/srfi/19#date::t
                             '#f)
                            _pad-with48054_
                            '2)
                           _port48055_)))
          (cons '#\I
                (lambda (_date48057_ _pad-with48058_ _port48059_)
                  (let ((_hr48061_
                         (##structure-ref
                          _date48057_
                          '4
                          std/srfi/19#date::t
                          '#f)))
                    (if (> _hr48061_ '12)
                        (display (std/srfi/19#tm:padding
                                  (- _hr48061_ '12)
                                  _pad-with48058_
                                  '2)
                                 _port48059_)
                        (display (std/srfi/19#tm:padding
                                  _hr48061_
                                  _pad-with48058_
                                  '2)
                                 _port48059_)))))
          (cons '#\j
                (lambda (_date48063_ _pad-with48064_ _port48065_)
                  (display (std/srfi/19#tm:padding
                            (std/srfi/19#date-year-day _date48063_)
                            _pad-with48064_
                            '3)
                           _port48065_)))
          (cons '#\k
                (lambda (_date48067_ _pad-with48068_ _port48069_)
                  (display (std/srfi/19#tm:padding
                            (##structure-ref
                             _date48067_
                             '4
                             std/srfi/19#date::t
                             '#f)
                            '#\0
                            '2)
                           _port48069_)))
          (cons '#\l
                (lambda (_date48071_ _pad-with48072_ _port48073_)
                  (let ((_hr48075_
                         (if (> (##structure-ref
                                 _date48071_
                                 '4
                                 std/srfi/19#date::t
                                 '#f)
                                '12)
                             (- (##structure-ref
                                 _date48071_
                                 '4
                                 std/srfi/19#date::t
                                 '#f)
                                '12)
                             (##structure-ref
                              _date48071_
                              '4
                              std/srfi/19#date::t
                              '#f))))
                    (display (std/srfi/19#tm:padding _hr48075_ '#\space '2)
                             _port48073_))))
          (cons '#\m
                (lambda (_date48077_ _pad-with48078_ _port48079_)
                  (display (std/srfi/19#tm:padding
                            (##structure-ref
                             _date48077_
                             '6
                             std/srfi/19#date::t
                             '#f)
                            _pad-with48078_
                            '2)
                           _port48079_)))
          (cons '#\M
                (lambda (_date48081_ _pad-with48082_ _port48083_)
                  (display (std/srfi/19#tm:padding
                            (##structure-ref
                             _date48081_
                             '3
                             std/srfi/19#date::t
                             '#f)
                            _pad-with48082_
                            '2)
                           _port48083_)))
          (cons '#\n
                (lambda (_date48085_ _pad-with48086_ _port48087_)
                  (newline _port48087_)))
          (cons '#\N
                (lambda (_date48089_ _pad-with48090_ _port48091_)
                  (display (std/srfi/19#tm:padding
                            (##structure-ref
                             _date48089_
                             '1
                             std/srfi/19#date::t
                             '#f)
                            _pad-with48090_
                            '9)
                           _port48091_)))
          (cons '#\p
                (lambda (_date48093_ _pad-with48094_ _port48095_)
                  (display (std/srfi/19#tm:locale-am/pm
                            (##structure-ref
                             _date48093_
                             '4
                             std/srfi/19#date::t
                             '#f))
                           _port48095_)))
          (cons '#\r
                (lambda (_date48097_ _pad-with48098_ _port48099_)
                  (display (std/srfi/19#date->string
                            _date48097_
                            '"~I:~M:~S ~p")
                           _port48099_)))
          (cons '#\s
                (lambda (_date48101_ _pad-with48102_ _port48103_)
                  (display (##structure-ref
                            (std/srfi/19#date->time-utc _date48101_)
                            '3
                            std/srfi/19#time::t
                            '#f)
                           _port48103_)))
          (cons '#\S
                (lambda (_date48105_ _pad-with48106_ _port48107_)
                  (if (> (##structure-ref
                          _date48105_
                          '1
                          std/srfi/19#date::t
                          '#f)
                         std/srfi/19#tm:nano)
                      (display (std/srfi/19#tm:padding
                                (+ (##structure-ref
                                    _date48105_
                                    '2
                                    std/srfi/19#date::t
                                    '#f)
                                   '1)
                                _pad-with48106_
                                '2)
                               _port48107_)
                      (display (std/srfi/19#tm:padding
                                (##structure-ref
                                 _date48105_
                                 '2
                                 std/srfi/19#date::t
                                 '#f)
                                _pad-with48106_
                                '2)
                               _port48107_))))
          (cons '#\t
                (lambda (_date48109_ _pad-with48110_ _port48111_)
                  (display (integer->char '9) _port48111_)))
          (cons '#\T
                (lambda (_date48113_ _pad-with48114_ _port48115_)
                  (display (std/srfi/19#date->string _date48113_ '"~H:~M:~S")
                           _port48115_)))
          (cons '#\U
                (lambda (_date48117_ _pad-with48118_ _port48119_)
                  (if (> (std/srfi/19#tm:days-before-first-week _date48117_ '0)
                         '0)
                      (display (std/srfi/19#tm:padding
                                (+ (std/srfi/19#date-week-number
                                    _date48117_
                                    '0)
                                   '1)
                                '#\0
                                '2)
                               _port48119_)
                      (display (std/srfi/19#tm:padding
                                (std/srfi/19#date-week-number _date48117_ '0)
                                '#\0
                                '2)
                               _port48119_))))
          (cons '#\V
                (lambda (_date48121_ _pad-with48122_ _port48123_)
                  (display (std/srfi/19#tm:padding
                            (std/srfi/19#date-week-number _date48121_ '1)
                            '#\0
                            '2)
                           _port48123_)))
          (cons '#\w
                (lambda (_date48125_ _pad-with48126_ _port48127_)
                  (display (std/srfi/19#date-week-day _date48125_)
                           _port48127_)))
          (cons '#\x
                (lambda (_date48129_ _pad-with48130_ _port48131_)
                  (display (std/srfi/19#date->string
                            _date48129_
                            std/srfi/19#tm:locale-short-date-format)
                           _port48131_)))
          (cons '#\X
                (lambda (_date48133_ _pad-with48134_ _port48135_)
                  (display (std/srfi/19#date->string
                            _date48133_
                            std/srfi/19#tm:locale-time-format)
                           _port48135_)))
          (cons '#\W
                (lambda (_date48137_ _pad-with48138_ _port48139_)
                  (if (> (std/srfi/19#tm:days-before-first-week _date48137_ '1)
                         '0)
                      (display (std/srfi/19#tm:padding
                                (+ (std/srfi/19#date-week-number
                                    _date48137_
                                    '1)
                                   '1)
                                '#\0
                                '2)
                               _port48139_)
                      (display (std/srfi/19#tm:padding
                                (std/srfi/19#date-week-number _date48137_ '1)
                                '#\0
                                '2)
                               _port48139_))))
          (cons '#\y
                (lambda (_date48141_ _pad-with48142_ _port48143_)
                  (display (std/srfi/19#tm:padding
                            (std/srfi/19#tm:last-n-digits
                             (##structure-ref
                              _date48141_
                              '7
                              std/srfi/19#date::t
                              '#f)
                             '2)
                            _pad-with48142_
                            '2)
                           _port48143_)))
          (cons '#\Y
                (lambda (_date48145_ _pad-with48146_ _port48147_)
                  (display (##structure-ref
                            _date48145_
                            '7
                            std/srfi/19#date::t
                            '#f)
                           _port48147_)))
          (cons '#\z
                (lambda (_date48149_ _pad-with48150_ _port48151_)
                  (std/srfi/19#tm:tz-printer
                   (##structure-ref _date48149_ '8 std/srfi/19#date::t '#f)
                   _port48151_)))
          (cons '#\Z
                (lambda (_date48153_ _pad-with48154_ _port48155_)
                  (std/srfi/19#tm:locale-print-time-zone
                   _date48153_
                   _port48155_)))
          (cons '#\1
                (lambda (_date48157_ _pad-with48158_ _port48159_)
                  (display (std/srfi/19#date->string _date48157_ '"~Y-~m-~d")
                           _port48159_)))
          (cons '#\2
                (lambda (_date48161_ _pad-with48162_ _port48163_)
                  (display (std/srfi/19#date->string _date48161_ '"~k:~M:~S~z")
                           _port48163_)))
          (cons '#\3
                (lambda (_date48165_ _pad-with48166_ _port48167_)
                  (display (std/srfi/19#date->string _date48165_ '"~k:~M:~S")
                           _port48167_)))
          (cons '#\4
                (lambda (_date48169_ _pad-with48170_ _port48171_)
                  (display (std/srfi/19#date->string
                            _date48169_
                            '"~Y-~m-~dT~k:~M:~S~z")
                           _port48171_)))
          (cons '#\5
                (lambda (_date48173_ _pad-with48174_ _port48175_)
                  (display (std/srfi/19#date->string
                            _date48173_
                            '"~Y-~m-~dT~k:~M:~S")
                           _port48175_)))))
  (define std/srfi/19#tm:get-formatter
    (lambda (_char48000_)
      (let ((_associated48002_ (assoc _char48000_ std/srfi/19#tm:directives)))
        (if _associated48002_ (cdr _associated48002_) '#f))))
  (define std/srfi/19#tm:date-printer
    (lambda (_date47984_
             _index47985_
             _format-string47986_
             _str-len47987_
             _port47988_)
      (if (>= _index47985_ _str-len47987_)
          '#!void
          (let ((_current-char47990_
                 (string-ref _format-string47986_ _index47985_)))
            (if (not (char=? _current-char47990_ '#\~))
                (begin
                  (display _current-char47990_ _port47988_)
                  (std/srfi/19#tm:date-printer
                   _date47984_
                   (+ _index47985_ '1)
                   _format-string47986_
                   _str-len47987_
                   _port47988_))
                (if (= (+ _index47985_ '1) _str-len47987_)
                    (std/srfi/19#tm:time-error
                     'tm:date-printer
                     'bad-date-format-string
                     _format-string47986_)
                    (let ((_pad-char?47992_
                           (string-ref
                            _format-string47986_
                            (+ _index47985_ '1))))
                      (if (char=? _pad-char?47992_ '#\-)
                          (if (= (+ _index47985_ '2) _str-len47987_)
                              (std/srfi/19#tm:time-error
                               'tm:date-printer
                               'bad-date-format-string
                               _format-string47986_)
                              (let ((_formatter47994_
                                     (std/srfi/19#tm:get-formatter
                                      (string-ref
                                       _format-string47986_
                                       (+ _index47985_ '2)))))
                                (if (not _formatter47994_)
                                    (std/srfi/19#tm:time-error
                                     'tm:date-printer
                                     'bad-date-format-string
                                     _format-string47986_)
                                    (begin
                                      (_formatter47994_
                                       _date47984_
                                       '#f
                                       _port47988_)
                                      (std/srfi/19#tm:date-printer
                                       _date47984_
                                       (+ _index47985_ '3)
                                       _format-string47986_
                                       _str-len47987_
                                       _port47988_)))))
                          (if (char=? _pad-char?47992_ '#\_)
                              (if (= (+ _index47985_ '2) _str-len47987_)
                                  (std/srfi/19#tm:time-error
                                   'tm:date-printer
                                   'bad-date-format-string
                                   _format-string47986_)
                                  (let ((_formatter47996_
                                         (std/srfi/19#tm:get-formatter
                                          (string-ref
                                           _format-string47986_
                                           (+ _index47985_ '2)))))
                                    (if (not _formatter47996_)
                                        (std/srfi/19#tm:time-error
                                         'tm:date-printer
                                         'bad-date-format-string
                                         _format-string47986_)
                                        (begin
                                          (_formatter47996_
                                           _date47984_
                                           '#\space
                                           _port47988_)
                                          (std/srfi/19#tm:date-printer
                                           _date47984_
                                           (+ _index47985_ '3)
                                           _format-string47986_
                                           _str-len47987_
                                           _port47988_)))))
                              (let ((_formatter47998_
                                     (std/srfi/19#tm:get-formatter
                                      (string-ref
                                       _format-string47986_
                                       (+ _index47985_ '1)))))
                                (if (not _formatter47998_)
                                    (std/srfi/19#tm:time-error
                                     'tm:date-printer
                                     'bad-date-format-string
                                     _format-string47986_)
                                    (begin
                                      (_formatter47998_
                                       _date47984_
                                       '#\0
                                       _port47988_)
                                      (std/srfi/19#tm:date-printer
                                       _date47984_
                                       (+ _index47985_ '2)
                                       _format-string47986_
                                       _str-len47987_
                                       _port47988_)))))))))))))
  (define std/srfi/19#date->string
    (lambda (_date47975_ . _format-string47976_)
      (let ((_str-port47981_ (open-output-string))
            (_fmt-str47982_
             (let ((_maybe-arg47978_ _format-string47976_))
               (if (null? _maybe-arg47978_)
                   '"~c"
                   (if (null? (cdr _maybe-arg47978_))
                       (car _maybe-arg47978_)
                       (error '"too many optional arguments"
                              _maybe-arg47978_))))))
        (std/srfi/19#tm:date-printer
         _date47975_
         '0
         _fmt-str47982_
         (string-length _fmt-str47982_)
         _str-port47981_)
        (get-output-string _str-port47981_))))
  (define std/srfi/19#tm:char->int
    (lambda (_ch47973_)
      (if (char=? _ch47973_ '#\0)
          '0
          (if (char=? _ch47973_ '#\1)
              '1
              (if (char=? _ch47973_ '#\2)
                  '2
                  (if (char=? _ch47973_ '#\3)
                      '3
                      (if (char=? _ch47973_ '#\4)
                          '4
                          (if (char=? _ch47973_ '#\5)
                              '5
                              (if (char=? _ch47973_ '#\6)
                                  '6
                                  (if (char=? _ch47973_ '#\7)
                                      '7
                                      (if (char=? _ch47973_ '#\8)
                                          '8
                                          (if (char=? _ch47973_ '#\9)
                                              '9
                                              (std/srfi/19#tm:time-error
                                               'string->date
                                               'bad-date-template-string
                                               (list '"Non-integer character"
                                                     _ch47973_))))))))))))))
  (define std/srfi/19#tm:integer-reader
    (lambda (_upto47956_ _port47957_)
      (letrec ((_accum-int47959_
                (lambda (_port47961_ _accum47962_ _nchars47963_)
                  (let ((_ch47965_ (peek-char _port47961_)))
                    (if (or (eof-object? _ch47965_)
                            (not (char-numeric? _ch47965_))
                            (and _upto47956_ (>= _nchars47963_ _upto47956_)))
                        _accum47962_
                        (_accum-int47959_
                         _port47961_
                         (+ (* _accum47962_ '10)
                            (std/srfi/19#tm:char->int (read-char _port47961_)))
                         (+ _nchars47963_ '1)))))))
        (_accum-int47959_ _port47957_ '0 '0))))
  (define std/srfi/19#tm:make-integer-reader
    (lambda (_upto47952_)
      (lambda (_port47954_)
        (std/srfi/19#tm:integer-reader _upto47952_ _port47954_))))
  (define std/srfi/19#tm:fractional-integer-reader
    (lambda (_upto47935_ _port47936_)
      (letrec ((_accum-int47938_
                (lambda (_port47940_ _accum47941_ _nchars47942_)
                  (let ((_ch47944_ (peek-char _port47940_)))
                    (if (or (eof-object? _ch47944_)
                            (not (char-numeric? _ch47944_))
                            (and _upto47935_ (>= _nchars47942_ _upto47935_)))
                        (* _accum47941_
                           (expt '10 (- _upto47935_ _nchars47942_)))
                        (_accum-int47938_
                         _port47940_
                         (+ (* _accum47941_ '10)
                            (std/srfi/19#tm:char->int (read-char _port47940_)))
                         (+ _nchars47942_ '1)))))))
        (_accum-int47938_ _port47936_ '0 '0))))
  (define std/srfi/19#tm:make-fractional-integer-reader
    (lambda (_upto47931_)
      (lambda (_port47933_)
        (std/srfi/19#tm:fractional-integer-reader _upto47931_ _port47933_))))
  (define std/srfi/19#tm:integer-reader-exact
    (lambda (_n47918_ _port47919_)
      (let ((_padding-ok47921_ '#t))
        (letrec ((_accum-int47923_
                  (lambda (_port47925_ _accum47926_ _nchars47927_)
                    (let ((_ch47929_ (peek-char _port47925_)))
                      (if (>= _nchars47927_ _n47918_)
                          _accum47926_
                          (if (eof-object? _ch47929_)
                              (std/srfi/19#tm:time-error
                               'string->date
                               'bad-date-template-string
                               '"Premature ending to integer read.")
                              (if (char-numeric? _ch47929_)
                                  (begin
                                    (set! _padding-ok47921_ '#f)
                                    (_accum-int47923_
                                     _port47925_
                                     (+ (* _accum47926_ '10)
                                        (std/srfi/19#tm:char->int
                                         (read-char _port47925_)))
                                     (+ _nchars47927_ '1)))
                                  (if _padding-ok47921_
                                      (begin
                                        (read-char _port47925_)
                                        (_accum-int47923_
                                         _port47925_
                                         _accum47926_
                                         (+ _nchars47927_ '1)))
                                      (std/srfi/19#tm:time-error
                                       'string->date
                                       'bad-date-template-string
                                       '"Non-numeric characters in integer read.")))))))))
          (_accum-int47923_ _port47919_ '0 '0)))))
  (define std/srfi/19#tm:make-integer-exact-reader
    (lambda (_n47914_)
      (lambda (_port47916_)
        (std/srfi/19#tm:integer-reader-exact _n47914_ _port47916_))))
  (define std/srfi/19#tm:zone-reader
    (lambda (_port47896_)
      (let ((_offset47898_ '0) (_positive?47899_ '#f))
        (let ((_ch47901_ (read-char _port47896_)))
          (if (eof-object? _ch47901_)
              (std/srfi/19#tm:time-error
               'string->date
               'bad-date-template-string
               (list '"Invalid time zone +/-" _ch47901_))
              '#!void)
          (if (or (char=? _ch47901_ '#\Z) (char=? _ch47901_ '#\z))
              '0
              (begin
                (if (char=? _ch47901_ '#\+)
                    (set! _positive?47899_ '#t)
                    (if (char=? _ch47901_ '#\-)
                        (set! _positive?47899_ '#f)
                        (std/srfi/19#tm:time-error
                         'string->date
                         'bad-date-template-string
                         (list '"Invalid time zone +/-" _ch47901_))))
                (let ((_ch47906_ (read-char _port47896_)))
                  (if (eof-object? _ch47906_)
                      (std/srfi/19#tm:time-error
                       'string->date
                       'bad-date-template-string
                       (list '"Invalid time zone number" _ch47906_))
                      '#!void)
                  (set! _offset47898_
                        (* (std/srfi/19#tm:char->int _ch47906_) '10 '60 '60)))
                (let ((_ch47908_ (read-char _port47896_)))
                  (if (eof-object? _ch47908_)
                      (std/srfi/19#tm:time-error
                       'string->date
                       'bad-date-template-string
                       (list '"Invalid time zone number" _ch47908_))
                      '#!void)
                  (set! _offset47898_
                        (+ _offset47898_
                           (* (std/srfi/19#tm:char->int _ch47908_) '60 '60))))
                (let ((_ch47910_ (read-char _port47896_)))
                  (if (eof-object? _ch47910_)
                      (std/srfi/19#tm:time-error
                       'string->date
                       'bad-date-template-string
                       (list '"Invalid time zone number" _ch47910_))
                      '#!void)
                  (set! _offset47898_
                        (+ _offset47898_
                           (* (std/srfi/19#tm:char->int _ch47910_) '10 '60))))
                (let ((_ch47912_ (read-char _port47896_)))
                  (if (eof-object? _ch47912_)
                      (std/srfi/19#tm:time-error
                       'string->date
                       'bad-date-template-string
                       (list '"Invalid time zone number" _ch47912_))
                      '#!void)
                  (set! _offset47898_
                        (+ _offset47898_
                           (* (std/srfi/19#tm:char->int _ch47912_) '60))))
                (if _positive?47899_ _offset47898_ (- _offset47898_))))))))
  (define std/srfi/19#tm:locale-reader
    (lambda (_port47881_ _indexer47882_)
      (let ((_string-port47884_ (open-output-string)))
        (letrec ((_read-char-string47886_
                  (lambda ()
                    (let ((_ch47894_ (peek-char _port47881_)))
                      (if (char-alphabetic? _ch47894_)
                          (begin
                            (write-char
                             (read-char _port47881_)
                             _string-port47884_)
                            (_read-char-string47886_))
                          (get-output-string _string-port47884_))))))
          (let* ((_str47888_ (_read-char-string47886_))
                 (_index47890_ (_indexer47882_ _str47888_)))
            (if _index47890_
                _index47890_
                (std/srfi/19#tm:time-error
                 'string->date
                 'bad-date-template-string
                 (list '"Invalid string for " _indexer47882_))))))))
  (define std/srfi/19#tm:make-locale-reader
    (lambda (_indexer47877_)
      (lambda (_port47879_)
        (std/srfi/19#tm:locale-reader _port47879_ _indexer47877_))))
  (define std/srfi/19#tm:make-char-id-reader
    (lambda (_char47873_)
      (lambda (_port47875_)
        (if (char=? _char47873_ (read-char _port47875_))
            _char47873_
            (std/srfi/19#tm:time-error
             'string->date
             'bad-date-template-string
             '"Invalid character match.")))))
  (define std/srfi/19#tm:read-directives
    (let ((_ireader447807_ (std/srfi/19#tm:make-integer-reader '4))
          (_ireader247808_ (std/srfi/19#tm:make-integer-reader '2))
          (_fireader947809_ (std/srfi/19#tm:make-fractional-integer-reader '9))
          (_ireaderf47810_ (std/srfi/19#tm:make-integer-reader '#f))
          (_eireader247811_ (std/srfi/19#tm:make-integer-exact-reader '2))
          (_eireader447812_ (std/srfi/19#tm:make-integer-exact-reader '4))
          (_locale-reader-abbr-weekday47813_
           (std/srfi/19#tm:make-locale-reader
            std/srfi/19#tm:locale-abbr-weekday->index))
          (_locale-reader-long-weekday47814_
           (std/srfi/19#tm:make-locale-reader
            std/srfi/19#tm:locale-long-weekday->index))
          (_locale-reader-abbr-month47815_
           (std/srfi/19#tm:make-locale-reader
            std/srfi/19#tm:locale-abbr-month->index))
          (_locale-reader-long-month47816_
           (std/srfi/19#tm:make-locale-reader
            std/srfi/19#tm:locale-long-month->index))
          (_char-fail47817_ (lambda (_ch47802_) '#t))
          (_do-nothing47818_ (lambda (_val47804_ _object47805_) '#!void)))
      (list (list '#\~
                  _char-fail47817_
                  (std/srfi/19#tm:make-char-id-reader '#\~)
                  _do-nothing47818_)
            (list '#\a
                  char-alphabetic?
                  _locale-reader-abbr-weekday47813_
                  _do-nothing47818_)
            (list '#\A
                  char-alphabetic?
                  _locale-reader-long-weekday47814_
                  _do-nothing47818_)
            (list '#\b
                  char-alphabetic?
                  _locale-reader-abbr-month47815_
                  (lambda (_val47820_ _object47821_)
                    (##structure-set!
                     _object47821_
                     _val47820_
                     '6
                     std/srfi/19#date::t
                     '#f)))
            (list '#\B
                  char-alphabetic?
                  _locale-reader-long-month47816_
                  (lambda (_val47823_ _object47824_)
                    (##structure-set!
                     _object47824_
                     _val47823_
                     '6
                     std/srfi/19#date::t
                     '#f)))
            (list '#\d
                  char-numeric?
                  _ireader247808_
                  (lambda (_val47826_ _object47827_)
                    (##structure-set!
                     _object47827_
                     _val47826_
                     '5
                     std/srfi/19#date::t
                     '#f)))
            (list '#\e
                  _char-fail47817_
                  _eireader247811_
                  (lambda (_val47829_ _object47830_)
                    (##structure-set!
                     _object47830_
                     _val47829_
                     '5
                     std/srfi/19#date::t
                     '#f)))
            (list '#\h
                  char-alphabetic?
                  _locale-reader-abbr-month47815_
                  (lambda (_val47832_ _object47833_)
                    (##structure-set!
                     _object47833_
                     _val47832_
                     '6
                     std/srfi/19#date::t
                     '#f)))
            (list '#\H
                  char-numeric?
                  _ireader247808_
                  (lambda (_val47835_ _object47836_)
                    (##structure-set!
                     _object47836_
                     _val47835_
                     '4
                     std/srfi/19#date::t
                     '#f)))
            (list '#\k
                  _char-fail47817_
                  _eireader247811_
                  (lambda (_val47838_ _object47839_)
                    (##structure-set!
                     _object47839_
                     _val47838_
                     '4
                     std/srfi/19#date::t
                     '#f)))
            (list '#\m
                  char-numeric?
                  _ireader247808_
                  (lambda (_val47841_ _object47842_)
                    (##structure-set!
                     _object47842_
                     _val47841_
                     '6
                     std/srfi/19#date::t
                     '#f)))
            (list '#\M
                  char-numeric?
                  _ireader247808_
                  (lambda (_val47844_ _object47845_)
                    (##structure-set!
                     _object47845_
                     _val47844_
                     '3
                     std/srfi/19#date::t
                     '#f)))
            (list '#\N
                  char-numeric?
                  _fireader947809_
                  (lambda (_val47847_ _object47848_)
                    (##structure-set!
                     _object47848_
                     _val47847_
                     '1
                     std/srfi/19#date::t
                     '#f)))
            (list '#\S
                  char-numeric?
                  _ireader247808_
                  (lambda (_val47850_ _object47851_)
                    (##structure-set!
                     _object47851_
                     _val47850_
                     '2
                     std/srfi/19#date::t
                     '#f)))
            (list '#\y
                  _char-fail47817_
                  _eireader247811_
                  (lambda (_val47853_ _object47854_)
                    (##structure-set!
                     _object47854_
                     (std/srfi/19#tm:natural-year _val47853_)
                     '7
                     std/srfi/19#date::t
                     '#f)))
            (list '#\Y
                  char-numeric?
                  _ireader447807_
                  (lambda (_val47856_ _object47857_)
                    (##structure-set!
                     _object47857_
                     _val47856_
                     '7
                     std/srfi/19#date::t
                     '#f)))
            (list '#\z
                  (lambda (_c47859_)
                    (let ((_$e47861_ (char=? _c47859_ '#\Z)))
                      (if _$e47861_
                          _$e47861_
                          (let ((_$e47864_ (char=? _c47859_ '#\z)))
                            (if _$e47864_
                                _$e47864_
                                (let ((_$e47867_ (char=? _c47859_ '#\+)))
                                  (if _$e47867_
                                      _$e47867_
                                      (char=? _c47859_ '#\-))))))))
                  std/srfi/19#tm:zone-reader
                  (lambda (_val47870_ _object47871_)
                    (##structure-set!
                     _object47871_
                     _val47870_
                     '8
                     std/srfi/19#date::t
                     '#f))))))
  (define std/srfi/19#tm:string->date
    (lambda (_date47770_
             _index47771_
             _format-string47772_
             _str-len47773_
             _port47774_
             _template-string47775_)
      (letrec ((_skip-until47777_
                (lambda (_port47797_ _skipper47798_)
                  (let ((_ch47800_ (peek-char _port47797_)))
                    (if (eof-object? _ch47800_)
                        (std/srfi/19#tm:time-error
                         'string->date
                         'bad-date-format-string
                         _template-string47775_)
                        (if (not (_skipper47798_ _ch47800_))
                            (begin
                              (read-char _port47797_)
                              (_skip-until47777_ _port47797_ _skipper47798_))
                            '#!void))))))
        (if (>= _index47771_ _str-len47773_)
            '#!void
            (let ((_current-char47779_
                   (string-ref _format-string47772_ _index47771_)))
              (if (not (char=? _current-char47779_ '#\~))
                  (let ((_port-char47781_ (read-char _port47774_)))
                    (if (or (eof-object? _port-char47781_)
                            (not (char=? _current-char47779_
                                         _port-char47781_)))
                        (std/srfi/19#tm:time-error
                         'string->date
                         'bad-date-format-string
                         _template-string47775_)
                        '#!void)
                    (std/srfi/19#tm:string->date
                     _date47770_
                     (+ _index47771_ '1)
                     _format-string47772_
                     _str-len47773_
                     _port47774_
                     _template-string47775_))
                  (if (> (+ _index47771_ '1) _str-len47773_)
                      (std/srfi/19#tm:time-error
                       'string->date
                       'bad-date-format-string
                       _template-string47775_)
                      (let* ((_format-char47786_
                              (string-ref
                               _format-string47772_
                               (+ _index47771_ '1)))
                             (_format-info47788_
                              (assoc _format-char47786_
                                     std/srfi/19#tm:read-directives)))
                        (if (not _format-info47788_)
                            (std/srfi/19#tm:time-error
                             'string->date
                             'bad-date-format-string
                             _template-string47775_)
                            (let ((_skipper47791_ (cadr _format-info47788_))
                                  (_reader47792_ (caddr _format-info47788_))
                                  (_actor47793_ (cadddr _format-info47788_)))
                              (_skip-until47777_ _port47774_ _skipper47791_)
                              (let ((_val47795_ (_reader47792_ _port47774_)))
                                (if (eof-object? _val47795_)
                                    (std/srfi/19#tm:time-error
                                     'string->date
                                     'bad-date-format-string
                                     _template-string47775_)
                                    (_actor47793_ _val47795_ _date47770_)))
                              (std/srfi/19#tm:string->date
                               _date47770_
                               (+ _index47771_ '2)
                               _format-string47772_
                               _str-len47773_
                               _port47774_
                               _template-string47775_)))))))))))
  (define std/srfi/19#string->date
    (lambda (_input-string47761_ _template-string47762_)
      (letrec ((_tm:date-ok?47764_
                (lambda (_date47768_)
                  (if (##structure-ref _date47768_ '1 std/srfi/19#date::t '#f)
                      (if (##structure-ref
                           _date47768_
                           '2
                           std/srfi/19#date::t
                           '#f)
                          (if (##structure-ref
                               _date47768_
                               '3
                               std/srfi/19#date::t
                               '#f)
                              (if (##structure-ref
                                   _date47768_
                                   '4
                                   std/srfi/19#date::t
                                   '#f)
                                  (if (##structure-ref
                                       _date47768_
                                       '5
                                       std/srfi/19#date::t
                                       '#f)
                                      (if (##structure-ref
                                           _date47768_
                                           '6
                                           std/srfi/19#date::t
                                           '#f)
                                          (if (##structure-ref
                                               _date47768_
                                               '7
                                               std/srfi/19#date::t
                                               '#f)
                                              (##structure-ref
                                               _date47768_
                                               '8
                                               std/srfi/19#date::t
                                               '#f)
                                              '#f)
                                          '#f)
                                      '#f)
                                  '#f)
                              '#f)
                          '#f)
                      '#f))))
        (let ((_newdate47766_
               (let ()
                 (declare (not safe))
                 (##structure
                  std/srfi/19#date::t
                  '0
                  '0
                  '0
                  '0
                  '#f
                  '#f
                  '#f
                  '0))))
          (std/srfi/19#tm:string->date
           _newdate47766_
           '0
           _template-string47762_
           (string-length _template-string47762_)
           (open-input-string _input-string47761_)
           _template-string47762_)
          (if (_tm:date-ok?47764_ _newdate47766_)
              _newdate47766_
              (std/srfi/19#tm:time-error
               'string->date
               'bad-date-format-string
               (list '"Incomplete date read. "
                     _newdate47766_
                     _template-string47762_))))))))
