(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/srfi/43#nonneg-int?
    (lambda (_x88743_)
      (if (integer? _x88743_) (not (negative? _x88743_)) '#f)))
  (define std/srfi/43#between?
    (lambda (_x88739_ _y88740_ _z88741_)
      (if (< _x88739_ _y88740_) (<= _y88740_ _z88741_) '#f)))
  (define std/srfi/43#unspecified-value (lambda () (if '#f '#f '#!void)))
  (define std/srfi/43#vectors-ref
    (lambda (_vectors88733_ _i88734_)
      (map (lambda (_v88736_) (vector-ref _v88736_ _i88734_)) _vectors88733_)))
  (define std/srfi/43#check-type
    (lambda (_pred?88729_ _value88730_ _callee88731_)
      (if (_pred?88729_ _value88730_)
          _value88730_
          (std/srfi/43#check-type
           _pred?88729_
           (error '"erroneous value"
                  (list _pred?88729_ _value88730_)
                  (cons 'while (cons 'calling (cons _callee88731_ '()))))
           _callee88731_))))
  (define std/srfi/43#check-index
    (lambda (_vec88723_ _index88724_ _callee88725_)
      (let ((_index88727_
             (std/srfi/43#check-type integer? _index88724_ _callee88725_)))
        (if (< _index88727_ '0)
            (std/srfi/43#check-index
             _vec88723_
             (error '"vector index too low"
                    _index88727_
                    (cons 'into (cons 'vector (cons _vec88723_ '())))
                    (cons 'while (cons 'calling (cons _callee88725_ '()))))
             _callee88725_)
            (if (>= _index88727_ (vector-length _vec88723_))
                (std/srfi/43#check-index
                 _vec88723_
                 (error '"vector index too high"
                        _index88727_
                        (cons 'into (cons 'vector (cons _vec88723_ '())))
                        (cons 'while (cons 'calling (cons _callee88725_ '()))))
                 _callee88725_)
                _index88727_)))))
  (define std/srfi/43#check-indices
    (lambda (_vec88707_
             _start88708_
             _start-name88709_
             _end88710_
             _end-name88711_
             _callee88712_)
      (let ((_lose88716_
             (lambda _things88714_
               (apply error
                      '"vector range out of bounds"
                      (append _things88714_
                              (cons 'vector (cons 'was (cons _vec88707_ '())))
                              (cons _start-name88709_
                                    (cons 'was (cons _start88708_ '())))
                              (cons _end-name88711_
                                    (cons 'was (cons _end88710_ '())))
                              (cons 'while
                                    (cons 'calling
                                          (cons _callee88712_ '())))))))
            (_start88717_
             (std/srfi/43#check-type integer? _start88708_ _callee88712_))
            (_end88718_
             (std/srfi/43#check-type integer? _end88710_ _callee88712_)))
        (if (> _start88717_ _end88718_)
            (let ((_g288575_
                   (_lose88716_
                    (cons _end-name88711_
                          (cons '< (cons _start-name88709_ '()))))))
              (begin
                (let ((_g288576_
                       (let ()
                         (declare (not safe))
                         (if (##values? _g288575_)
                             (##vector-length _g288575_)
                             1))))
                  (if (not (let () (declare (not safe)) (##fx= _g288576_ 2)))
                      (error "Context expects 2 values" _g288576_)))
                (let ((_new-start88720_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g288575_ 0)))
                      (_new-end88721_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g288575_ 1))))
                  (std/srfi/43#check-indices
                   _vec88707_
                   _new-start88720_
                   _start-name88709_
                   _new-end88721_
                   _end-name88711_
                   _callee88712_))))
            (if (< _start88717_ '0)
                (std/srfi/43#check-indices
                 _vec88707_
                 (_lose88716_ (cons _start-name88709_ (cons '< (cons '0 '()))))
                 _start-name88709_
                 _end88718_
                 _end-name88711_
                 _callee88712_)
                (if (>= _start88717_ (vector-length _vec88707_))
                    (std/srfi/43#check-indices
                     _vec88707_
                     (_lose88716_
                      (cons _start-name88709_ (cons '> (cons 'len '())))
                      (cons 'len
                            (cons 'was (cons (vector-length _vec88707_) '()))))
                     _start-name88709_
                     _end88718_
                     _end-name88711_
                     _callee88712_)
                    (if (> _end88718_ (vector-length _vec88707_))
                        (std/srfi/43#check-indices
                         _vec88707_
                         _start88717_
                         _start-name88709_
                         (_lose88716_
                          (cons _end-name88711_ (cons '> (cons 'len '())))
                          (cons 'len
                                (cons 'was
                                      (cons (vector-length _vec88707_) '()))))
                         _end-name88711_
                         _callee88712_)
                        (values _start88717_ _end88718_))))))))
  (define std/srfi/43#vector-parse-start+end
    (lambda (_vec88699_
             _args88700_
             _start-name88701_
             _end-name88702_
             _callee88703_)
      (let ((_len88705_ (vector-length _vec88699_)))
        (if (null? _args88700_)
            (values '0 _len88705_)
            (if (null? (cdr _args88700_))
                (std/srfi/43#check-indices
                 _vec88699_
                 (car _args88700_)
                 _start-name88701_
                 _len88705_
                 _end-name88702_
                 _callee88703_)
                (if (null? (cddr _args88700_))
                    (std/srfi/43#check-indices
                     _vec88699_
                     (car _args88700_)
                     _start-name88701_
                     (cadr _args88700_)
                     _end-name88702_
                     _callee88703_)
                    (error '"too many arguments"
                           (cons 'extra
                                 (cons 'args
                                       (cons 'were
                                             (cons (cddr _args88700_) '()))))
                           (cons 'while
                                 (cons 'calling
                                       (cons _callee88703_ '()))))))))))
  (define std/srfi/43#%smallest-length
    (letrec ((_loop88693_
              (lambda (_vector-list88695_ _length88696_ _callee88697_)
                (if (null? _vector-list88695_)
                    _length88696_
                    (_loop88693_
                     (cdr _vector-list88695_)
                     (min (vector-length
                           (std/srfi/43#check-type
                            vector?
                            (car _vector-list88695_)
                            _callee88697_))
                          _length88696_)
                     _callee88697_)))))
      _loop88693_))
  (define std/srfi/43#%vector-copy!
    (letrec ((_loop/l->r88672_
              (lambda (_target88675_
                       _source88676_
                       _send88677_
                       _i88678_
                       _j88679_)
                (if (< _i88678_ _send88677_)
                    (begin
                      (vector-set!
                       _target88675_
                       _j88679_
                       (vector-ref _source88676_ _i88678_))
                      (_loop/l->r88672_
                       _target88675_
                       _source88676_
                       _send88677_
                       (+ _i88678_ '1)
                       (+ _j88679_ '1)))
                    '#!void)))
             (_loop/r->l88673_
              (lambda (_target88681_
                       _source88682_
                       _sstart88683_
                       _i88684_
                       _j88685_)
                (if (>= _i88684_ _sstart88683_)
                    (begin
                      (vector-set!
                       _target88681_
                       _j88685_
                       (vector-ref _source88682_ _i88684_))
                      (_loop/r->l88673_
                       _target88681_
                       _source88682_
                       _sstart88683_
                       (- _i88684_ '1)
                       (- _j88685_ '1)))
                    '#!void))))
      (lambda (_target88687_
               _tstart88688_
               _source88689_
               _sstart88690_
               _send88691_)
        (if (> _sstart88690_ _tstart88688_)
            (_loop/l->r88672_
             _target88687_
             _source88689_
             _send88691_
             _sstart88690_
             _tstart88688_)
            (_loop/r->l88673_
             _target88687_
             _source88689_
             _sstart88690_
             (- _send88691_ '1)
             (+ '-1 _tstart88688_ _send88691_ (- _sstart88690_)))))))
  (define std/srfi/43#%vector-reverse-copy!
    (letrec ((_loop88658_
              (lambda (_target88660_
                       _source88661_
                       _sstart88662_
                       _i88663_
                       _j88664_)
                (if (>= _i88663_ _sstart88662_)
                    (begin
                      (vector-set!
                       _target88660_
                       _j88664_
                       (vector-ref _source88661_ _i88663_))
                      (_loop88658_
                       _target88660_
                       _source88661_
                       _sstart88662_
                       (- _i88663_ '1)
                       (+ _j88664_ '1)))
                    '#!void))))
      (lambda (_target88666_
               _tstart88667_
               _source88668_
               _sstart88669_
               _send88670_)
        (_loop88658_
         _target88666_
         _source88668_
         _sstart88669_
         (- _send88670_ '1)
         _tstart88667_))))
  (define std/srfi/43#%vector-reverse!
    (letrec ((_loop88646_
              (lambda (_vec88648_ _i88649_ _j88650_)
                (if (<= _i88649_ _j88650_)
                    (let ((_v88652_ (vector-ref _vec88648_ _i88649_)))
                      (vector-set!
                       _vec88648_
                       _i88649_
                       (vector-ref _vec88648_ _j88650_))
                      (vector-set! _vec88648_ _j88650_ _v88652_)
                      (_loop88646_ _vec88648_ (+ _i88649_ '1) (- _j88650_ '1)))
                    '#!void))))
      (lambda (_vec88654_ _start88655_ _end88656_)
        (_loop88646_ _vec88654_ _start88655_ (- _end88656_ '1)))))
  (define std/srfi/43#%vector-fold1
    (letrec ((_loop88633_
              (lambda (_kons88635_ _knil88636_ _len88637_ _vec88638_ _i88639_)
                (if (= _i88639_ _len88637_)
                    _knil88636_
                    (_loop88633_
                     _kons88635_
                     (_kons88635_
                      _i88639_
                      _knil88636_
                      (vector-ref _vec88638_ _i88639_))
                     _len88637_
                     _vec88638_
                     (+ _i88639_ '1))))))
      (lambda (_kons88641_ _knil88642_ _len88643_ _vec88644_)
        (_loop88633_ _kons88641_ _knil88642_ _len88643_ _vec88644_ '0))))
  (define std/srfi/43#%vector-fold2+
    (letrec ((_loop88620_
              (lambda (_kons88622_
                       _knil88623_
                       _len88624_
                       _vectors88625_
                       _i88626_)
                (if (= _i88626_ _len88624_)
                    _knil88623_
                    (_loop88620_
                     _kons88622_
                     (apply _kons88622_
                            _i88626_
                            _knil88623_
                            (std/srfi/43#vectors-ref _vectors88625_ _i88626_))
                     _len88624_
                     _vectors88625_
                     (+ _i88626_ '1))))))
      (lambda (_kons88628_ _knil88629_ _len88630_ _vectors88631_)
        (_loop88620_ _kons88628_ _knil88629_ _len88630_ _vectors88631_ '0))))
  (define std/srfi/43#%vector-map1!
    (letrec ((_loop88606_
              (lambda (_f88608_ _target88609_ _vec88610_ _i88611_)
                (if (zero? _i88611_)
                    _target88609_
                    (let ((_j88613_ (- _i88611_ '1)))
                      (vector-set!
                       _target88609_
                       _j88613_
                       (_f88608_ _j88613_ (vector-ref _vec88610_ _j88613_)))
                      (_loop88606_
                       _f88608_
                       _target88609_
                       _vec88610_
                       _j88613_))))))
      (lambda (_f88615_ _target88616_ _vec88617_ _len88618_)
        (_loop88606_ _f88615_ _target88616_ _vec88617_ _len88618_))))
  (define std/srfi/43#%vector-map2+!
    (letrec ((_loop88592_
              (lambda (_f88594_ _target88595_ _vectors88596_ _i88597_)
                (if (zero? _i88597_)
                    _target88595_
                    (let ((_j88599_ (- _i88597_ '1)))
                      (vector-set!
                       _target88595_
                       _j88599_
                       (apply _f88594_
                              _j88599_
                              (std/srfi/43#vectors-ref
                               _vectors88596_
                               _j88599_)))
                      (_loop88592_
                       _f88594_
                       _target88595_
                       _vectors88596_
                       _j88599_))))))
      (lambda (_f88601_ _target88602_ _vectors88603_ _len88604_)
        (_loop88592_ _f88601_ _target88602_ _vectors88603_ _len88604_))))
  (define std/srfi/43#vector-unfold
    (letrec ((_tabulate!88556_
              (lambda (_f88560_ _vec88561_ _i88562_ _len88563_)
                (if (< _i88562_ _len88563_)
                    (begin
                      (vector-set! _vec88561_ _i88562_ (_f88560_ _i88562_))
                      (_tabulate!88556_
                       _f88560_
                       _vec88561_
                       (+ _i88562_ '1)
                       _len88563_))
                    '#!void)))
             (_unfold1!88557_
              (lambda (_f88565_ _vec88566_ _i88567_ _len88568_ _seed88569_)
                (if (< _i88567_ _len88568_)
                    (let ((_g288577_ (_f88565_ _i88567_ _seed88569_)))
                      (begin
                        (let ((_g288578_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g288577_)
                                     (##vector-length _g288577_)
                                     1))))
                          (if (not (let ()
                                     (declare (not safe))
                                     (##fx= _g288578_ 2)))
                              (error "Context expects 2 values" _g288578_)))
                        (let ((_elt88571_
                               (let ()
                                 (declare (not safe))
                                 (##vector-ref _g288577_ 0)))
                              (_new-seed88572_
                               (let ()
                                 (declare (not safe))
                                 (##vector-ref _g288577_ 1))))
                          (begin
                            (vector-set! _vec88566_ _i88567_ _elt88571_)
                            (_unfold1!88557_
                             _f88565_
                             _vec88566_
                             (+ _i88567_ '1)
                             _len88568_
                             _new-seed88572_)))))
                    '#!void)))
             (_unfold2+!88558_
              (lambda (_f88574_ _vec88575_ _i88576_ _len88577_ _seeds88578_)
                (if (< _i88576_ _len88577_)
                    (let ((_g288579_ (apply _f88574_ _i88576_ _seeds88578_)))
                      (begin
                        (let ((_g288580_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g288579_)
                                     (##vector-length _g288579_)
                                     1))))
                          (if (not (let ()
                                     (declare (not safe))
                                     (##fx>= _g288580_ 1)))
                              (error "Context expects at least 1 values"
                                     _g288580_)))
                        (let ((_elt88580_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g288579_)
                                     (##vector-ref _g288579_ 0)
                                     _g288579_)))
                              (_new-seeds88581_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g288579_)
                                     (##cdr (##vector->list _g288579_))
                                     '()))))
                          (begin
                            (vector-set! _vec88575_ _i88576_ _elt88580_)
                            (_unfold2+!88558_
                             _f88574_
                             _vec88575_
                             (+ _i88576_ '1)
                             _len88577_
                             _new-seeds88581_)))))
                    '#!void))))
      (lambda (_f88583_ _len88584_ . _initial-seeds88585_)
        (let ((_f88587_
               (std/srfi/43#check-type
                procedure?
                _f88583_
                std/srfi/43#vector-unfold))
              (_len88588_
               (std/srfi/43#check-type
                std/srfi/43#nonneg-int?
                _len88584_
                std/srfi/43#vector-unfold)))
          (let ((_vec88590_ (make-vector _len88588_)))
            (if (null? _initial-seeds88585_)
                (_tabulate!88556_ _f88587_ _vec88590_ '0 _len88588_)
                (if (null? (cdr _initial-seeds88585_))
                    (_unfold1!88557_
                     _f88587_
                     _vec88590_
                     '0
                     _len88588_
                     (car _initial-seeds88585_))
                    (_unfold2+!88558_
                     _f88587_
                     _vec88590_
                     '0
                     _len88588_
                     _initial-seeds88585_)))
            _vec88590_)))))
  (define std/srfi/43#vector-unfold-right
    (letrec ((_tabulate!88522_
              (lambda (_f88526_ _vec88527_ _i88528_)
                (if (>= _i88528_ '0)
                    (begin
                      (vector-set! _vec88527_ _i88528_ (_f88526_ _i88528_))
                      (_tabulate!88522_ _f88526_ _vec88527_ (- _i88528_ '1)))
                    '#!void)))
             (_unfold1!88523_
              (lambda (_f88530_ _vec88531_ _i88532_ _seed88533_)
                (if (>= _i88532_ '0)
                    (let ((_g288581_ (_f88530_ _i88532_ _seed88533_)))
                      (begin
                        (let ((_g288582_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g288581_)
                                     (##vector-length _g288581_)
                                     1))))
                          (if (not (let ()
                                     (declare (not safe))
                                     (##fx= _g288582_ 2)))
                              (error "Context expects 2 values" _g288582_)))
                        (let ((_elt88535_
                               (let ()
                                 (declare (not safe))
                                 (##vector-ref _g288581_ 0)))
                              (_new-seed88536_
                               (let ()
                                 (declare (not safe))
                                 (##vector-ref _g288581_ 1))))
                          (begin
                            (vector-set! _vec88531_ _i88532_ _elt88535_)
                            (_unfold1!88523_
                             _f88530_
                             _vec88531_
                             (- _i88532_ '1)
                             _new-seed88536_)))))
                    '#!void)))
             (_unfold2+!88524_
              (lambda (_f88538_ _vec88539_ _i88540_ _seeds88541_)
                (if (>= _i88540_ '0)
                    (let ((_g288583_ (apply _f88538_ _i88540_ _seeds88541_)))
                      (begin
                        (let ((_g288584_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g288583_)
                                     (##vector-length _g288583_)
                                     1))))
                          (if (not (let ()
                                     (declare (not safe))
                                     (##fx>= _g288584_ 1)))
                              (error "Context expects at least 1 values"
                                     _g288584_)))
                        (let ((_elt88543_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g288583_)
                                     (##vector-ref _g288583_ 0)
                                     _g288583_)))
                              (_new-seeds88544_
                               (let ()
                                 (declare (not safe))
                                 (if (##values? _g288583_)
                                     (##cdr (##vector->list _g288583_))
                                     '()))))
                          (begin
                            (vector-set! _vec88539_ _i88540_ _elt88543_)
                            (_unfold2+!88524_
                             _f88538_
                             _vec88539_
                             (- _i88540_ '1)
                             _new-seeds88544_)))))
                    '#!void))))
      (lambda (_f88546_ _len88547_ . _initial-seeds88548_)
        (let ((_f88550_
               (std/srfi/43#check-type
                procedure?
                _f88546_
                std/srfi/43#vector-unfold-right))
              (_len88551_
               (std/srfi/43#check-type
                std/srfi/43#nonneg-int?
                _len88547_
                std/srfi/43#vector-unfold-right)))
          (let ((_vec88553_ (make-vector _len88551_))
                (_i88554_ (- _len88551_ '1)))
            (if (null? _initial-seeds88548_)
                (_tabulate!88522_ _f88550_ _vec88553_ _i88554_)
                (if (null? (cdr _initial-seeds88548_))
                    (_unfold1!88523_
                     _f88550_
                     _vec88553_
                     _i88554_
                     (car _initial-seeds88548_))
                    (_unfold2+!88524_
                     _f88550_
                     _vec88553_
                     _i88554_
                     _initial-seeds88548_)))
            _vec88553_)))))
  (define std/srfi/43#vector-copy
    (lambda (_vec88511_ . _args88512_)
      (let* ((_vec88514_
              (std/srfi/43#check-type
               vector?
               _vec88511_
               std/srfi/43#vector-copy))
             (_g288585_
              (std/srfi/43#vector-copy:parse-args _vec88514_ _args88512_)))
        (begin
          (let ((_g288586_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g288585_) (##vector-length _g288585_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g288586_ 3)))
                (error "Context expects 3 values" _g288586_)))
          (let ((_start88516_
                 (let () (declare (not safe)) (##vector-ref _g288585_ 0)))
                (_end88517_
                 (let () (declare (not safe)) (##vector-ref _g288585_ 1)))
                (_fill88518_
                 (let () (declare (not safe)) (##vector-ref _g288585_ 2))))
            (let ((_new-vector88520_
                   (make-vector (- _end88517_ _start88516_) _fill88518_)))
              (std/srfi/43#%vector-copy!
               _new-vector88520_
               '0
               _vec88514_
               _start88516_
               (if (> _end88517_ (vector-length _vec88514_))
                   (vector-length _vec88514_)
                   _end88517_))
              _new-vector88520_))))))
  (define std/srfi/43#vector-copy:parse-args
    (lambda (_vec88496_ _args88497_)
      (letrec ((_parse-args88499_
                (lambda (_start88503_ _end88504_ _n88505_ _fill88506_)
                  (let ((_start88508_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _start88503_
                          std/srfi/43#vector-copy))
                        (_end88509_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _end88504_
                          std/srfi/43#vector-copy)))
                    (if (and (<= '0 _start88508_ _end88509_)
                             (<= _start88508_ _n88505_))
                        (values _start88508_ _end88509_ _fill88506_)
                        (error '"illegal arguments"
                               (cons 'while
                                     (cons 'calling
                                           (cons std/srfi/43#vector-copy '())))
                               (cons 'start
                                     (cons 'was (cons _start88508_ '())))
                               (cons 'end (cons 'was (cons _end88509_ '())))
                               (cons 'vector
                                     (cons 'was (cons _vec88496_ '())))))))))
        (let ((_n88501_ (vector-length _vec88496_)))
          (if (null? _args88497_)
              (_parse-args88499_
               '0
               _n88501_
               _n88501_
               (std/srfi/43#unspecified-value))
              (if (null? (cdr _args88497_))
                  (_parse-args88499_
                   (car _args88497_)
                   _n88501_
                   _n88501_
                   (std/srfi/43#unspecified-value))
                  (if (null? (cddr _args88497_))
                      (_parse-args88499_
                       (car _args88497_)
                       (cadr _args88497_)
                       _n88501_
                       (std/srfi/43#unspecified-value))
                      (if (null? (cdddr _args88497_))
                          (_parse-args88499_
                           (car _args88497_)
                           (cadr _args88497_)
                           _n88501_
                           (caddr _args88497_))
                          (error '"too many arguments"
                                 std/srfi/43#vector-copy
                                 (cdddr _args88497_))))))))))
  (define std/srfi/43#vector-reverse-copy
    (lambda (_vec88486_ . _maybe-start+end88487_)
      (let* ((_vec88489_
              (std/srfi/43#check-type
               vector?
               _vec88486_
               std/srfi/43#vector-reverse-copy))
             (_g288587_
              (std/srfi/43#vector-parse-start+end
               _vec88489_
               _maybe-start+end88487_
               'start
               'end
               std/srfi/43#vector-reverse-copy)))
        (begin
          (let ((_g288588_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g288587_) (##vector-length _g288587_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g288588_ 2)))
                (error "Context expects 2 values" _g288588_)))
          (let ((_start88491_
                 (let () (declare (not safe)) (##vector-ref _g288587_ 0)))
                (_end88492_
                 (let () (declare (not safe)) (##vector-ref _g288587_ 1))))
            (let ((_new88494_ (make-vector (- _end88492_ _start88491_))))
              (std/srfi/43#%vector-reverse-copy!
               _new88494_
               '0
               _vec88489_
               _start88491_
               _end88492_)
              _new88494_))))))
  (define std/srfi/43#vector-append
    (lambda _vectors88484_
      (std/srfi/43#vector-concatenate:aux
       _vectors88484_
       std/srfi/43#vector-append)))
  (define std/srfi/43#vector-concatenate
    (lambda (_vector-list88482_)
      (std/srfi/43#vector-concatenate:aux
       _vector-list88482_
       std/srfi/43#vector-concatenate)))
  (define std/srfi/43#vector-concatenate:aux
    (letrec ((_compute-length88452_
              (lambda (_vectors88455_ _len88456_ _callee88457_)
                (if (null? _vectors88455_)
                    _len88456_
                    (let ((_vec88459_
                           (std/srfi/43#check-type
                            vector?
                            (car _vectors88455_)
                            _callee88457_)))
                      (_compute-length88452_
                       (cdr _vectors88455_)
                       (+ (vector-length _vec88459_) _len88456_)
                       _callee88457_)))))
             (_concatenate!88453_
              (lambda (_vectors88461_ _target88462_ _to88463_)
                (if (null? _vectors88461_)
                    _target88462_
                    (let* ((_vec188465_ (car _vectors88461_))
                           (_len88467_ (vector-length _vec188465_)))
                      (std/srfi/43#%vector-copy!
                       _target88462_
                       _to88463_
                       _vec188465_
                       '0
                       _len88467_)
                      (_concatenate!88453_
                       (cdr _vectors88461_)
                       _target88462_
                       (+ _to88463_ _len88467_)))))))
      (lambda (_vectors88470_ _callee88471_)
        (if (null? _vectors88470_)
            (make-vector '0)
            (if (null? (cdr _vectors88470_))
                (let* ((_vec88473_
                        (std/srfi/43#check-type
                         vector?
                         (car _vectors88470_)
                         _callee88471_))
                       (_len88475_ (vector-length _vec88473_))
                       (_new88477_ (make-vector _len88475_)))
                  (std/srfi/43#%vector-copy!
                   _new88477_
                   '0
                   _vec88473_
                   '0
                   _len88475_)
                  _new88477_)
                (let ((_new-vector88480_
                       (make-vector
                        (_compute-length88452_
                         _vectors88470_
                         '0
                         _callee88471_))))
                  (_concatenate!88453_ _vectors88470_ _new-vector88480_ '0)
                  _new-vector88480_))))))
  (define std/srfi/43#vector-empty?
    (lambda (_vec88448_)
      (let ((_vec88450_
             (std/srfi/43#check-type
              vector?
              _vec88448_
              std/srfi/43#vector-empty?)))
        (zero? (vector-length _vec88450_)))))
  (define std/srfi/43#vector=
    (lambda (_elt=?88433_ . _vectors88434_)
      (let ((_elt=?88436_
             (std/srfi/43#check-type
              procedure?
              _elt=?88433_
              std/srfi/43#vector=)))
        (if (null? _vectors88434_)
            '#t
            (if (null? (cdr _vectors88434_))
                (begin
                  (std/srfi/43#check-type
                   vector?
                   (car _vectors88434_)
                   std/srfi/43#vector=)
                  '#t)
                (let _loop88438_ ((_vecs88440_ _vectors88434_))
                  (let ((_vec188442_
                         (std/srfi/43#check-type
                          vector?
                          (car _vecs88440_)
                          std/srfi/43#vector=))
                        (_vec2+88443_ (cdr _vecs88440_)))
                    (let ((_$e88445_ (null? _vec2+88443_)))
                      (if _$e88445_
                          _$e88445_
                          (if (std/srfi/43#binary-vector=
                               _elt=?88436_
                               _vec188442_
                               (car _vec2+88443_))
                              (_loop88438_ _vec2+88443_)
                              '#f))))))))))
  (define std/srfi/43#binary-vector=
    (lambda (_elt=?88408_ _vector-a88409_ _vector-b88410_)
      (let ((_$e88412_ (eq? _vector-a88409_ _vector-b88410_)))
        (if _$e88412_
            _$e88412_
            (let ((_length-a88415_ (vector-length _vector-a88409_))
                  (_length-b88416_ (vector-length _vector-b88410_)))
              (letrec ((_loop88418_
                        (lambda (_i88421_)
                          (let ((_$e88423_ (= _i88421_ _length-a88415_)))
                            (if _$e88423_
                                _$e88423_
                                (if (< _i88421_ _length-b88416_)
                                    (_test88419_
                                     (vector-ref _vector-a88409_ _i88421_)
                                     (vector-ref _vector-b88410_ _i88421_)
                                     _i88421_)
                                    '#f)))))
                       (_test88419_
                        (lambda (_elt-a88426_ _elt-b88427_ _i88428_)
                          (if (or (eq? _elt-a88426_ _elt-b88427_)
                                  (_elt=?88408_ _elt-a88426_ _elt-b88427_))
                              (_loop88418_ (+ _i88428_ '1))
                              '#f))))
                (if (= _length-a88415_ _length-b88416_)
                    (_loop88418_ '0)
                    '#f)))))))
  (define std/srfi/43#vector-fold
    (lambda (_kons88400_ _knil88401_ _vec88402_ . _vectors88403_)
      (let ((_kons88405_
             (std/srfi/43#check-type
              procedure?
              _kons88400_
              std/srfi/43#vector-fold))
            (_vec88406_
             (std/srfi/43#check-type
              vector?
              _vec88402_
              std/srfi/43#vector-fold)))
        (if (null? _vectors88403_)
            (std/srfi/43#%vector-fold1
             _kons88405_
             _knil88401_
             (vector-length _vec88406_)
             _vec88406_)
            (std/srfi/43#%vector-fold2+
             _kons88405_
             _knil88401_
             (std/srfi/43#%smallest-length
              _vectors88403_
              (vector-length _vec88406_)
              std/srfi/43#vector-fold)
             (cons _vec88406_ _vectors88403_))))))
  (define std/srfi/43#vector-fold-right
    (letrec ((_loop188379_
              (lambda (_kons88382_ _knil88383_ _vec88384_ _i88385_)
                (if (negative? _i88385_)
                    _knil88383_
                    (_loop188379_
                     _kons88382_
                     (_kons88382_
                      _i88385_
                      _knil88383_
                      (vector-ref _vec88384_ _i88385_))
                     _vec88384_
                     (- _i88385_ '1)))))
             (_loop2+88380_
              (lambda (_kons88387_ _knil88388_ _vectors88389_ _i88390_)
                (if (negative? _i88390_)
                    _knil88388_
                    (_loop2+88380_
                     _kons88387_
                     (apply _kons88387_
                            _i88390_
                            _knil88388_
                            (std/srfi/43#vectors-ref _vectors88389_ _i88390_))
                     _vectors88389_
                     (- _i88390_ '1))))))
      (lambda (_kons88392_ _knil88393_ _vec88394_ . _vectors88395_)
        (let ((_kons88397_
               (std/srfi/43#check-type
                procedure?
                _kons88392_
                std/srfi/43#vector-fold-right))
              (_vec88398_
               (std/srfi/43#check-type
                vector?
                _vec88394_
                std/srfi/43#vector-fold-right)))
          (if (null? _vectors88395_)
              (_loop188379_
               _kons88397_
               _knil88393_
               _vec88398_
               (- (vector-length _vec88398_) '1))
              (_loop2+88380_
               _kons88397_
               _knil88393_
               (cons _vec88398_ _vectors88395_)
               (- (std/srfi/43#%smallest-length
                   _vectors88395_
                   (vector-length _vec88398_)
                   std/srfi/43#vector-fold-right)
                  '1)))))))
  (define std/srfi/43#vector-map
    (lambda (_f88368_ _vec88369_ . _vectors88370_)
      (let ((_f88372_
             (std/srfi/43#check-type
              procedure?
              _f88368_
              std/srfi/43#vector-map))
            (_vec88373_
             (std/srfi/43#check-type
              vector?
              _vec88369_
              std/srfi/43#vector-map)))
        (if (null? _vectors88370_)
            (let ((_len88375_ (vector-length _vec88373_)))
              (std/srfi/43#%vector-map1!
               _f88372_
               (make-vector _len88375_)
               _vec88373_
               _len88375_))
            (let ((_len88377_
                   (std/srfi/43#%smallest-length
                    _vectors88370_
                    (vector-length _vec88373_)
                    std/srfi/43#vector-map)))
              (std/srfi/43#%vector-map2+!
               _f88372_
               (make-vector _len88377_)
               (cons _vec88373_ _vectors88370_)
               _len88377_))))))
  (define std/srfi/43#vector-map!
    (lambda (_f88361_ _vec88362_ . _vectors88363_)
      (let ((_f88365_
             (std/srfi/43#check-type
              procedure?
              _f88361_
              std/srfi/43#vector-map!))
            (_vec88366_
             (std/srfi/43#check-type
              vector?
              _vec88362_
              std/srfi/43#vector-map!)))
        (if (null? _vectors88363_)
            (std/srfi/43#%vector-map1!
             _f88365_
             _vec88366_
             _vec88366_
             (vector-length _vec88366_))
            (std/srfi/43#%vector-map2+!
             _f88365_
             _vec88366_
             (cons _vec88366_ _vectors88363_)
             (std/srfi/43#%smallest-length
              _vectors88363_
              (vector-length _vec88366_)
              std/srfi/43#vector-map!)))
        (std/srfi/43#unspecified-value))))
  (define std/srfi/43#vector-for-each
    (letrec ((_for-each188341_
              (lambda (_f88344_ _vec88345_ _i88346_ _len88347_)
                (if (< _i88346_ _len88347_)
                    (begin
                      (_f88344_ _i88346_ (vector-ref _vec88345_ _i88346_))
                      (_for-each188341_
                       _f88344_
                       _vec88345_
                       (+ _i88346_ '1)
                       _len88347_))
                    '#!void)))
             (_for-each2+88342_
              (lambda (_f88349_ _vecs88350_ _i88351_ _len88352_)
                (if (< _i88351_ _len88352_)
                    (begin
                      (apply _f88349_
                             _i88351_
                             (std/srfi/43#vectors-ref _vecs88350_ _i88351_))
                      (_for-each2+88342_
                       _f88349_
                       _vecs88350_
                       (+ _i88351_ '1)
                       _len88352_))
                    '#!void))))
      (lambda (_f88354_ _vec88355_ . _vectors88356_)
        (let ((_f88358_
               (std/srfi/43#check-type
                procedure?
                _f88354_
                std/srfi/43#vector-for-each))
              (_vec88359_
               (std/srfi/43#check-type
                vector?
                _vec88355_
                std/srfi/43#vector-for-each)))
          (if (null? _vectors88356_)
              (_for-each188341_
               _f88358_
               _vec88359_
               '0
               (vector-length _vec88359_))
              (_for-each2+88342_
               _f88358_
               (cons _vec88359_ _vectors88356_)
               '0
               (std/srfi/43#%smallest-length
                _vectors88356_
                (vector-length _vec88359_)
                std/srfi/43#vector-for-each)))))))
  (define std/srfi/43#vector-count
    (lambda (_pred?88326_ _vec88327_ . _vectors88328_)
      (let ((_pred?88330_
             (std/srfi/43#check-type
              procedure?
              _pred?88326_
              std/srfi/43#vector-count))
            (_vec88331_
             (std/srfi/43#check-type
              vector?
              _vec88327_
              std/srfi/43#vector-count)))
        (if (null? _vectors88328_)
            (std/srfi/43#%vector-fold1
             (lambda (_index88333_ _count88334_ _elt88335_)
               (if (_pred?88330_ _index88333_ _elt88335_)
                   (+ _count88334_ '1)
                   _count88334_))
             '0
             (vector-length _vec88331_)
             _vec88331_)
            (std/srfi/43#%vector-fold2+
             (lambda (_index88337_ _count88338_ . _elts88339_)
               (if (apply _pred?88330_ _index88337_ _elts88339_)
                   (+ _count88338_ '1)
                   _count88338_))
             '0
             (std/srfi/43#%smallest-length
              _vectors88328_
              (vector-length _vec88331_)
              std/srfi/43#vector-count)
             (cons _vec88331_ _vectors88328_))))))
  (define std/srfi/43#vector-index
    (lambda (_pred?88322_ _vec88323_ . _vectors88324_)
      (std/srfi/43#vector-index/skip
       _pred?88322_
       _vec88323_
       _vectors88324_
       std/srfi/43#vector-index)))
  (define std/srfi/43#vector-skip
    (lambda (_pred?88316_ _vec88317_ . _vectors88318_)
      (std/srfi/43#vector-index/skip
       (lambda _elts88320_ (not (apply _pred?88316_ _elts88320_)))
       _vec88317_
       _vectors88318_
       std/srfi/43#vector-skip)))
  (define std/srfi/43#vector-index/skip
    (letrec ((_loop188295_
              (lambda (_pred?88298_ _vec88299_ _len88300_ _i88301_)
                (if (= _i88301_ _len88300_)
                    '#f
                    (if (_pred?88298_ (vector-ref _vec88299_ _i88301_))
                        _i88301_
                        (_loop188295_
                         _pred?88298_
                         _vec88299_
                         _len88300_
                         (+ _i88301_ '1))))))
             (_loop2+88296_
              (lambda (_pred?88303_ _vectors88304_ _len88305_ _i88306_)
                (if (= _i88306_ _len88305_)
                    '#f
                    (if (apply _pred?88303_
                               (std/srfi/43#vectors-ref
                                _vectors88304_
                                _i88306_))
                        _i88306_
                        (_loop2+88296_
                         _pred?88303_
                         _vectors88304_
                         _len88305_
                         (+ _i88306_ '1)))))))
      (lambda (_pred?88308_ _vec88309_ _vectors88310_ _callee88311_)
        (let ((_pred?88313_
               (std/srfi/43#check-type procedure? _pred?88308_ _callee88311_))
              (_vec88314_
               (std/srfi/43#check-type vector? _vec88309_ _callee88311_)))
          (if (null? _vectors88310_)
              (_loop188295_
               _pred?88313_
               _vec88314_
               (vector-length _vec88314_)
               '0)
              (_loop2+88296_
               _pred?88313_
               (cons _vec88314_ _vectors88310_)
               (std/srfi/43#%smallest-length
                _vectors88310_
                (vector-length _vec88314_)
                _callee88311_)
               '0))))))
  (define std/srfi/43#vector-index-right
    (lambda (_pred?88291_ _vec88292_ . _vectors88293_)
      (std/srfi/43#vector-index/skip-right
       _pred?88291_
       _vec88292_
       _vectors88293_
       std/srfi/43#vector-index-right)))
  (define std/srfi/43#vector-skip-right
    (lambda (_pred?88285_ _vec88286_ . _vectors88287_)
      (std/srfi/43#vector-index/skip-right
       (lambda _elts88289_ (not (apply _pred?88285_ _elts88289_)))
       _vec88286_
       _vectors88287_
       std/srfi/43#vector-index-right)))
  (define std/srfi/43#vector-index/skip-right
    (letrec ((_loop188266_
              (lambda (_pred?88269_ _vec88270_ _i88271_)
                (if (negative? _i88271_)
                    '#f
                    (if (_pred?88269_ (vector-ref _vec88270_ _i88271_))
                        _i88271_
                        (_loop188266_
                         _pred?88269_
                         _vec88270_
                         (- _i88271_ '1))))))
             (_loop2+88267_
              (lambda (_pred?88273_ _vectors88274_ _i88275_)
                (if (negative? _i88275_)
                    '#f
                    (if (apply _pred?88273_
                               (std/srfi/43#vectors-ref
                                _vectors88274_
                                _i88275_))
                        _i88275_
                        (_loop2+88267_
                         _pred?88273_
                         _vectors88274_
                         (- _i88275_ '1)))))))
      (lambda (_pred?88277_ _vec88278_ _vectors88279_ _callee88280_)
        (let ((_pred?88282_
               (std/srfi/43#check-type procedure? _pred?88277_ _callee88280_))
              (_vec88283_
               (std/srfi/43#check-type vector? _vec88278_ _callee88280_)))
          (if (null? _vectors88279_)
              (_loop188266_
               _pred?88282_
               _vec88283_
               (- (vector-length _vec88283_) '1))
              (_loop2+88267_
               _pred?88282_
               (cons _vec88283_ _vectors88279_)
               (- (std/srfi/43#%smallest-length
                   _vectors88279_
                   (vector-length _vec88283_)
                   _callee88280_)
                  '1)))))))
  (define std/srfi/43#vector-binary-search
    (lambda (_vec88241_ _value88242_ _cmp88243_ . _maybe-start+end88244_)
      (let* ((_cmp88246_
              (std/srfi/43#check-type
               procedure?
               _cmp88243_
               std/srfi/43#vector-binary-search))
             (_vec88248_
              (std/srfi/43#check-type
               vector?
               _vec88241_
               std/srfi/43#vector-binary-search))
             (_g288589_
              (std/srfi/43#vector-parse-start+end
               _vec88248_
               _maybe-start+end88244_
               'start
               'end
               std/srfi/43#vector-binary-search)))
        (begin
          (let ((_g288590_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g288589_) (##vector-length _g288589_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g288590_ 2)))
                (error "Context expects 2 values" _g288590_)))
          (let ((_start88250_
                 (let () (declare (not safe)) (##vector-ref _g288589_ 0)))
                (_end88251_
                 (let () (declare (not safe)) (##vector-ref _g288589_ 1))))
            (let _loop88253_ ((_start88255_ _start88250_)
                              (_end88256_ _end88251_)
                              (_j88257_ '#f))
              (let ((_i88259_ (quotient (+ _start88255_ _end88256_) '2)))
                (if (or (= _start88255_ _end88256_)
                        (and _j88257_ (= _i88259_ _j88257_)))
                    '#f
                    (let ((_comparison88264_
                           (std/srfi/43#check-type
                            integer?
                            (_cmp88246_
                             (vector-ref _vec88248_ _i88259_)
                             _value88242_)
                            (cons _cmp88246_
                                  (cons 'for
                                        (cons std/srfi/43#vector-binary-search
                                              '()))))))
                      (if (zero? _comparison88264_)
                          _i88259_
                          (if (positive? _comparison88264_)
                              (_loop88253_ _start88255_ _i88259_ _i88259_)
                              (_loop88253_
                               _i88259_
                               _end88256_
                               _i88259_))))))))))))
  (define std/srfi/43#vector-any
    (letrec ((_loop188209_
              (lambda (_pred?88212_
                       _vec88213_
                       _i88214_
                       _len88215_
                       _len-188216_)
                (if (not (= _i88214_ _len88215_))
                    (if (= _i88214_ _len-188216_)
                        (_pred?88212_ (vector-ref _vec88213_ _i88214_))
                        (let ((_$e88218_
                               (_pred?88212_
                                (vector-ref _vec88213_ _i88214_))))
                          (if _$e88218_
                              _$e88218_
                              (_loop188209_
                               _pred?88212_
                               _vec88213_
                               (+ _i88214_ '1)
                               _len88215_
                               _len-188216_))))
                    '#f)))
             (_loop2+88210_
              (lambda (_pred?88221_
                       _vectors88222_
                       _i88223_
                       _len88224_
                       _len-188225_)
                (if (not (= _i88223_ _len88224_))
                    (if (= _i88223_ _len-188225_)
                        (apply _pred?88221_
                               (std/srfi/43#vectors-ref
                                _vectors88222_
                                _i88223_))
                        (let ((_$e88227_
                               (apply _pred?88221_
                                      (std/srfi/43#vectors-ref
                                       _vectors88222_
                                       _i88223_))))
                          (if _$e88227_
                              _$e88227_
                              (_loop2+88210_
                               _pred?88221_
                               _vectors88222_
                               (+ _i88223_ '1)
                               _len88224_
                               _len-188225_))))
                    '#f))))
      (lambda (_pred?88230_ _vec88231_ . _vectors88232_)
        (let ((_pred?88234_
               (std/srfi/43#check-type
                procedure?
                _pred?88230_
                std/srfi/43#vector-any))
              (_vec88235_
               (std/srfi/43#check-type
                vector?
                _vec88231_
                std/srfi/43#vector-any)))
          (if (null? _vectors88232_)
              (let ((_len88237_ (vector-length _vec88235_)))
                (_loop188209_
                 _pred?88234_
                 _vec88235_
                 '0
                 _len88237_
                 (- _len88237_ '1)))
              (let ((_len88239_
                     (std/srfi/43#%smallest-length
                      _vectors88232_
                      (vector-length _vec88235_)
                      std/srfi/43#vector-any)))
                (_loop2+88210_
                 _pred?88234_
                 (cons _vec88235_ _vectors88232_)
                 '0
                 _len88239_
                 (- _len88239_ '1))))))))
  (define std/srfi/43#vector-every
    (letrec ((_loop188177_
              (lambda (_pred?88180_
                       _vec88181_
                       _i88182_
                       _len88183_
                       _len-188184_)
                (let ((_$e88186_ (= _i88182_ _len88183_)))
                  (if _$e88186_
                      _$e88186_
                      (if (= _i88182_ _len-188184_)
                          (_pred?88180_ (vector-ref _vec88181_ _i88182_))
                          (if (_pred?88180_ (vector-ref _vec88181_ _i88182_))
                              (_loop188177_
                               _pred?88180_
                               _vec88181_
                               (+ _i88182_ '1)
                               _len88183_
                               _len-188184_)
                              '#f))))))
             (_loop2+88178_
              (lambda (_pred?88189_
                       _vectors88190_
                       _i88191_
                       _len88192_
                       _len-188193_)
                (let ((_$e88195_ (= _i88191_ _len88192_)))
                  (if _$e88195_
                      _$e88195_
                      (if (= _i88191_ _len-188193_)
                          (apply _pred?88189_
                                 (std/srfi/43#vectors-ref
                                  _vectors88190_
                                  _i88191_))
                          (if (apply _pred?88189_
                                     (std/srfi/43#vectors-ref
                                      _vectors88190_
                                      _i88191_))
                              (_loop2+88178_
                               _pred?88189_
                               _vectors88190_
                               (+ _i88191_ '1)
                               _len88192_
                               _len-188193_)
                              '#f)))))))
      (lambda (_pred?88198_ _vec88199_ . _vectors88200_)
        (let ((_pred?88202_
               (std/srfi/43#check-type
                procedure?
                _pred?88198_
                std/srfi/43#vector-every))
              (_vec88203_
               (std/srfi/43#check-type
                vector?
                _vec88199_
                std/srfi/43#vector-every)))
          (if (null? _vectors88200_)
              (let ((_len88205_ (vector-length _vec88203_)))
                (_loop188177_
                 _pred?88202_
                 _vec88203_
                 '0
                 _len88205_
                 (- _len88205_ '1)))
              (let ((_len88207_
                     (std/srfi/43#%smallest-length
                      _vectors88200_
                      (vector-length _vec88203_)
                      std/srfi/43#vector-every)))
                (_loop2+88178_
                 _pred?88202_
                 (cons _vec88203_ _vectors88200_)
                 '0
                 _len88207_
                 (- _len88207_ '1))))))))
  (define std/srfi/43#vector-swap!
    (lambda (_vec88166_ _i88167_ _j88168_)
      (let ((_vec88170_
             (std/srfi/43#check-type
              vector?
              _vec88166_
              std/srfi/43#vector-swap!)))
        (let ((_i88172_
               (std/srfi/43#check-index
                _vec88170_
                _i88167_
                std/srfi/43#vector-swap!))
              (_j88173_
               (std/srfi/43#check-index
                _vec88170_
                _j88168_
                std/srfi/43#vector-swap!)))
          (let ((_x88175_ (vector-ref _vec88170_ _i88172_)))
            (vector-set! _vec88170_ _i88172_ (vector-ref _vec88170_ _j88173_))
            (vector-set! _vec88170_ _j88173_ _x88175_))))))
  (define std/srfi/43#%%vector-fill!
    (let ((_%vector-fill!88150_ vector-fill!))
      (lambda (_vec88152_ _value88153_ . _maybe-start+end88154_)
        (if (null? _maybe-start+end88154_)
            (_%vector-fill!88150_ _vec88152_ _value88153_)
            (let* ((_vec88156_
                    (std/srfi/43#check-type vector? _vec88152_ vector-fill!))
                   (_g288591_
                    (std/srfi/43#vector-parse-start+end
                     _vec88156_
                     _maybe-start+end88154_
                     'start
                     'end
                     vector-fill!)))
              (begin
                (let ((_g288592_
                       (let ()
                         (declare (not safe))
                         (if (##values? _g288591_)
                             (##vector-length _g288591_)
                             1))))
                  (if (not (let () (declare (not safe)) (##fx= _g288592_ 2)))
                      (error "Context expects 2 values" _g288592_)))
                (let ((_start88158_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g288591_ 0)))
                      (_end88159_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g288591_ 1))))
                  (let _$loop88161_ ((_i88164_ _start88158_))
                    (if (= _i88164_ _end88159_)
                        '#!void
                        (begin
                          (vector-set! _vec88156_ _i88164_ _value88153_)
                          (_$loop88161_ (+ _i88164_ '1))))))))))))
  (define std/srfi/43#vector-copy!
    (lambda (_target88133_
             _tstart88134_
             _source88135_
             .
             _maybe-sstart+send88136_)
      (letrec ((_doit!88138_
                (lambda (_sstart88142_ _send88143_ _source-length88144_)
                  (let ((_tstart88146_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _tstart88134_
                          std/srfi/43#vector-copy!))
                        (_sstart88147_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _sstart88142_
                          std/srfi/43#vector-copy!))
                        (_send88148_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _send88143_
                          std/srfi/43#vector-copy!)))
                    (if (and (<= '0
                                 _sstart88147_
                                 _send88148_
                                 _source-length88144_)
                             (<= (+ _tstart88146_
                                    (- _send88148_ _sstart88147_))
                                 (vector-length _target88133_)))
                        (std/srfi/43#%vector-copy!
                         _target88133_
                         _tstart88146_
                         _source88135_
                         _sstart88147_
                         _send88148_)
                        (error '"illegal arguments"
                               (cons 'while
                                     (cons 'calling
                                           (cons std/srfi/43#vector-copy!
                                                 '())))
                               (cons 'target
                                     (cons 'was (cons _target88133_ '())))
                               (cons 'target-length
                                     (cons 'was
                                           (cons (vector-length _target88133_)
                                                 '())))
                               (cons 'tstart
                                     (cons 'was (cons _tstart88146_ '())))
                               (cons 'source
                                     (cons 'was (cons _source88135_ '())))
                               (cons 'source-length
                                     (cons 'was
                                           (cons _source-length88144_ '())))
                               (cons 'sstart
                                     (cons 'was (cons _sstart88147_ '())))
                               (cons 'send
                                     (cons 'was (cons _send88148_ '())))))))))
        (let ((_n88140_ (vector-length _source88135_)))
          (if (null? _maybe-sstart+send88136_)
              (_doit!88138_ '0 _n88140_ _n88140_)
              (if (null? (cdr _maybe-sstart+send88136_))
                  (_doit!88138_
                   (car _maybe-sstart+send88136_)
                   _n88140_
                   _n88140_)
                  (if (null? (cddr _maybe-sstart+send88136_))
                      (_doit!88138_
                       (car _maybe-sstart+send88136_)
                       (cadr _maybe-sstart+send88136_)
                       _n88140_)
                      (error '"too many arguments"
                             std/srfi/43#vector-copy!
                             (cddr _maybe-sstart+send88136_)))))))))
  (define std/srfi/43#vector-reverse-copy!
    (lambda (_target88113_
             _tstart88114_
             _source88115_
             .
             _maybe-sstart+send88116_)
      (letrec ((_doit!88118_
                (lambda (_sstart88122_ _send88123_ _source-length88124_)
                  (let ((_tstart88126_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _tstart88114_
                          std/srfi/43#vector-reverse-copy!))
                        (_sstart88127_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _sstart88122_
                          std/srfi/43#vector-reverse-copy!))
                        (_send88128_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _send88123_
                          std/srfi/43#vector-reverse-copy!)))
                    (if (and (eq? _target88113_ _source88115_)
                             (or (std/srfi/43#between?
                                  _sstart88127_
                                  _tstart88126_
                                  _send88128_)
                                 (std/srfi/43#between?
                                  _tstart88126_
                                  _sstart88127_
                                  (+ _tstart88126_
                                     (- _send88128_ _sstart88127_)))))
                        (error '"vector range for self-copying overlaps"
                               std/srfi/43#vector-reverse-copy!
                               (cons 'vector
                                     (cons 'was (cons _target88113_ '())))
                               (cons 'tstart
                                     (cons 'was (cons _tstart88126_ '())))
                               (cons 'sstart
                                     (cons 'was (cons _sstart88127_ '())))
                               (cons 'send (cons 'was (cons _send88128_ '()))))
                        (if (and (<= '0
                                     _sstart88127_
                                     _send88128_
                                     _source-length88124_)
                                 (<= (+ _tstart88126_
                                        (- _send88128_ _sstart88127_))
                                     (vector-length _target88113_)))
                            (std/srfi/43#%vector-reverse-copy!
                             _target88113_
                             _tstart88126_
                             _source88115_
                             _sstart88127_
                             _send88128_)
                            (error '"illegal arguments"
                                   (cons 'while
                                         (cons 'calling
                                               (cons std/srfi/43#vector-reverse-copy!
                                                     '())))
                                   (cons 'target
                                         (cons 'was (cons _target88113_ '())))
                                   (cons 'target-length
                                         (cons 'was
                                               (cons (vector-length
                                                      _target88113_)
                                                     '())))
                                   (cons 'tstart
                                         (cons 'was (cons _tstart88126_ '())))
                                   (cons 'source
                                         (cons 'was (cons _source88115_ '())))
                                   (cons 'source-length
                                         (cons 'was
                                               (cons _source-length88124_
                                                     '())))
                                   (cons 'sstart
                                         (cons 'was (cons _sstart88127_ '())))
                                   (cons 'send
                                         (cons 'was
                                               (cons _send88128_ '()))))))))))
        (let ((_n88120_ (vector-length _source88115_)))
          (if (null? _maybe-sstart+send88116_)
              (_doit!88118_ '0 _n88120_ _n88120_)
              (if (null? (cdr _maybe-sstart+send88116_))
                  (_doit!88118_
                   (car _maybe-sstart+send88116_)
                   _n88120_
                   _n88120_)
                  (if (null? (cddr _maybe-sstart+send88116_))
                      (_doit!88118_
                       (car _maybe-sstart+send88116_)
                       (cadr _maybe-sstart+send88116_)
                       _n88120_)
                      (error '"too many arguments"
                             std/srfi/43#vector-reverse-copy!
                             (cddr _maybe-sstart+send88116_)))))))))
  (define std/srfi/43#vector-reverse!
    (lambda (_vec88105_ . _start+end88106_)
      (let* ((_vec88108_
              (std/srfi/43#check-type
               vector?
               _vec88105_
               std/srfi/43#vector-reverse!))
             (_g288593_
              (std/srfi/43#vector-parse-start+end
               _vec88108_
               _start+end88106_
               'start
               'end
               std/srfi/43#vector-reverse!)))
        (begin
          (let ((_g288594_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g288593_) (##vector-length _g288593_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g288594_ 2)))
                (error "Context expects 2 values" _g288594_)))
          (let ((_start88110_
                 (let () (declare (not safe)) (##vector-ref _g288593_ 0)))
                (_end88111_
                 (let () (declare (not safe)) (##vector-ref _g288593_ 1))))
            (std/srfi/43#%vector-reverse!
             _vec88108_
             _start88110_
             _end88111_))))))
  (define std/srfi/43#%%vector->list
    (let ((_%vector->list88089_ vector->list))
      (lambda (_vec88091_ . _maybe-start+end88092_)
        (if (null? _maybe-start+end88092_)
            (_%vector->list88089_ _vec88091_)
            (let* ((_vec88094_
                    (std/srfi/43#check-type vector? _vec88091_ vector->list))
                   (_g288595_
                    (std/srfi/43#vector-parse-start+end
                     _vec88094_
                     _maybe-start+end88092_
                     'start
                     'end
                     vector->list)))
              (begin
                (let ((_g288596_
                       (let ()
                         (declare (not safe))
                         (if (##values? _g288595_)
                             (##vector-length _g288595_)
                             1))))
                  (if (not (let () (declare (not safe)) (##fx= _g288596_ 2)))
                      (error "Context expects 2 values" _g288596_)))
                (let ((_start88096_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g288595_ 0)))
                      (_end88097_
                       (let ()
                         (declare (not safe))
                         (##vector-ref _g288595_ 1))))
                  (let _$loop88099_ ((_i88102_ (- _end88097_ '1))
                                     (_result88103_ '()))
                    (if (< _i88102_ _start88096_)
                        _result88103_
                        (_$loop88099_
                         (- _i88102_ '1)
                         (cons (vector-ref _vec88094_ _i88102_)
                               _result88103_)))))))))))
  (define std/srfi/43#reverse-vector->list
    (lambda (_vec88075_ . _maybe-start+end88076_)
      (let* ((_vec88078_
              (std/srfi/43#check-type
               vector?
               _vec88075_
               std/srfi/43#reverse-vector->list))
             (_g288597_
              (std/srfi/43#vector-parse-start+end
               _vec88078_
               _maybe-start+end88076_
               'start
               'end
               std/srfi/43#reverse-vector->list)))
        (begin
          (let ((_g288598_
                 (let ()
                   (declare (not safe))
                   (if (##values? _g288597_) (##vector-length _g288597_) 1))))
            (if (not (let () (declare (not safe)) (##fx= _g288598_ 2)))
                (error "Context expects 2 values" _g288598_)))
          (let ((_start88080_
                 (let () (declare (not safe)) (##vector-ref _g288597_ 0)))
                (_end88081_
                 (let () (declare (not safe)) (##vector-ref _g288597_ 1))))
            (let _$loop88083_ ((_i88086_ _start88080_) (_result88087_ '()))
              (if (= _i88086_ _end88081_)
                  _result88087_
                  (_$loop88083_
                   (+ _i88086_ '1)
                   (cons (vector-ref _vec88078_ _i88086_)
                         _result88087_)))))))))
  (define std/srfi/43#%%list->vector
    (let ((_%list->vector88029_ list->vector))
      (lambda (_lst88031_ . _maybe-start+end88032_)
        (if (null? _maybe-start+end88032_)
            (_%list->vector88029_ _lst88031_)
            (if (null? _maybe-start+end88032_)
                (let* ((_start88034_ '0) (_end88036_ (length _lst88031_)))
                  (let ((_start88039_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _start88034_
                          list->vector))
                        (_end88040_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _end88036_
                          list->vector)))
                    ((lambda (_f88042_)
                       (std/srfi/43#vector-unfold
                        _f88042_
                        (- _end88040_ _start88039_)
                        (list-tail _lst88031_ _start88039_)))
                     (lambda (_index88044_ _l88045_)
                       (if (null? _l88045_)
                           (error '"list was too short"
                                  (cons 'list
                                        (cons 'was (cons _lst88031_ '())))
                                  (cons 'attempted
                                        (cons 'end
                                              (cons 'was
                                                    (cons _end88040_ '()))))
                                  (cons 'while
                                        (cons 'calling
                                              (cons std/srfi/43#%%list->vector
                                                    '()))))
                           (if (pair? _l88045_)
                               (values (car _l88045_) (cdr _l88045_))
                               (error '"erroneous value"
                                      (list list? _lst88031_)
                                      (cons 'while
                                            (cons 'calling
                                                  (cons std/srfi/43#%%list->vector
                                                        '()))))))))))
                (let ((_start88047_ (car _maybe-start+end88032_))
                      (_new-args88048_ (cdr _maybe-start+end88032_)))
                  (if (null? _new-args88048_)
                      (let ((_end88051_ (length _lst88031_)))
                        (let ((_start88054_
                               (std/srfi/43#check-type
                                std/srfi/43#nonneg-int?
                                _start88047_
                                list->vector))
                              (_end88055_
                               (std/srfi/43#check-type
                                std/srfi/43#nonneg-int?
                                _end88051_
                                list->vector)))
                          ((lambda (_f88057_)
                             (std/srfi/43#vector-unfold
                              _f88057_
                              (- _end88055_ _start88054_)
                              (list-tail _lst88031_ _start88054_)))
                           (lambda (_index88059_ _l88060_)
                             (if (null? _l88060_)
                                 (error '"list was too short"
                                        (cons 'list
                                              (cons 'was
                                                    (cons _lst88031_ '())))
                                        (cons 'attempted
                                              (cons 'end
                                                    (cons 'was
                                                          (cons _end88055_
                                                                '()))))
                                        (cons 'while
                                              (cons 'calling
                                                    (cons std/srfi/43#%%list->vector
                                                          '()))))
                                 (if (pair? _l88060_)
                                     (values (car _l88060_) (cdr _l88060_))
                                     (error '"erroneous value"
                                            (list list? _lst88031_)
                                            (cons 'while
                                                  (cons 'calling
                                                        (cons std/srfi/43#%%list->vector
                                                              '()))))))))))
                      (let ((_end88062_ (car _new-args88048_))
                            (_new-args88063_ (cdr _new-args88048_)))
                        (if (null? _new-args88063_)
                            (let ()
                              (let ((_start88067_
                                     (std/srfi/43#check-type
                                      std/srfi/43#nonneg-int?
                                      _start88047_
                                      list->vector))
                                    (_end88068_
                                     (std/srfi/43#check-type
                                      std/srfi/43#nonneg-int?
                                      _end88062_
                                      list->vector)))
                                ((lambda (_f88070_)
                                   (std/srfi/43#vector-unfold
                                    _f88070_
                                    (- _end88068_ _start88067_)
                                    (list-tail _lst88031_ _start88067_)))
                                 (lambda (_index88072_ _l88073_)
                                   (if (null? _l88073_)
                                       (error '"list was too short"
                                              (cons 'list
                                                    (cons 'was
                                                          (cons _lst88031_
                                                                '())))
                                              (cons 'attempted
                                                    (cons 'end
                                                          (cons 'was
                                                                (cons _end88068_
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              '()))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (cons 'while
                                                    (cons 'calling
                                                          (cons std/srfi/43#%%list->vector
                                                                '()))))
                                       (if (pair? _l88073_)
                                           (values (car _l88073_)
                                                   (cdr _l88073_))
                                           (error '"erroneous value"
                                                  (list list? _lst88031_)
                                                  (cons 'while
                                                        (cons 'calling
                                                              (cons std/srfi/43#%%list->vector
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                            '()))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                            (error '"too many arguments"
                                   (length _maybe-start+end88032_)
                                   _maybe-start+end88032_))))))))))
  (define std/srfi/43#reverse-list->vector
    (lambda (_lst87985_ . _maybe-start+end87986_)
      (if (null? _maybe-start+end87986_)
          (let* ((_start87988_ '0) (_end87990_ (length _lst87985_)))
            (let ((_start87993_
                   (std/srfi/43#check-type
                    std/srfi/43#nonneg-int?
                    _start87988_
                    std/srfi/43#reverse-list->vector))
                  (_end87994_
                   (std/srfi/43#check-type
                    std/srfi/43#nonneg-int?
                    _end87990_
                    std/srfi/43#reverse-list->vector)))
              ((lambda (_f87996_)
                 (std/srfi/43#vector-unfold-right
                  _f87996_
                  (- _end87994_ _start87993_)
                  (list-tail _lst87985_ _start87993_)))
               (lambda (_index87998_ _l87999_)
                 (if (null? _l87999_)
                     (error '"list too short"
                            (cons 'list (cons 'was (cons _lst87985_ '())))
                            (cons 'attempted
                                  (cons 'end
                                        (cons 'was (cons _end87994_ '()))))
                            (cons 'while
                                  (cons 'calling
                                        (cons std/srfi/43#reverse-list->vector
                                              '()))))
                     (if (pair? _l87999_)
                         (values (car _l87999_) (cdr _l87999_))
                         (error '"erroneous value"
                                (list list? _lst87985_)
                                (cons 'while
                                      (cons 'calling
                                            (cons std/srfi/43#reverse-list->vector
                                                  '()))))))))))
          (let ((_start88001_ (car _maybe-start+end87986_))
                (_new-args88002_ (cdr _maybe-start+end87986_)))
            (if (null? _new-args88002_)
                (let ((_end88005_ (length _lst87985_)))
                  (let ((_start88008_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _start88001_
                          std/srfi/43#reverse-list->vector))
                        (_end88009_
                         (std/srfi/43#check-type
                          std/srfi/43#nonneg-int?
                          _end88005_
                          std/srfi/43#reverse-list->vector)))
                    ((lambda (_f88011_)
                       (std/srfi/43#vector-unfold-right
                        _f88011_
                        (- _end88009_ _start88008_)
                        (list-tail _lst87985_ _start88008_)))
                     (lambda (_index88013_ _l88014_)
                       (if (null? _l88014_)
                           (error '"list too short"
                                  (cons 'list
                                        (cons 'was (cons _lst87985_ '())))
                                  (cons 'attempted
                                        (cons 'end
                                              (cons 'was
                                                    (cons _end88009_ '()))))
                                  (cons 'while
                                        (cons 'calling
                                              (cons std/srfi/43#reverse-list->vector
                                                    '()))))
                           (if (pair? _l88014_)
                               (values (car _l88014_) (cdr _l88014_))
                               (error '"erroneous value"
                                      (list list? _lst87985_)
                                      (cons 'while
                                            (cons 'calling
                                                  (cons std/srfi/43#reverse-list->vector
                                                        '()))))))))))
                (let ((_end88016_ (car _new-args88002_))
                      (_new-args88017_ (cdr _new-args88002_)))
                  (if (null? _new-args88017_)
                      (let ()
                        (let ((_start88021_
                               (std/srfi/43#check-type
                                std/srfi/43#nonneg-int?
                                _start88001_
                                std/srfi/43#reverse-list->vector))
                              (_end88022_
                               (std/srfi/43#check-type
                                std/srfi/43#nonneg-int?
                                _end88016_
                                std/srfi/43#reverse-list->vector)))
                          ((lambda (_f88024_)
                             (std/srfi/43#vector-unfold-right
                              _f88024_
                              (- _end88022_ _start88021_)
                              (list-tail _lst87985_ _start88021_)))
                           (lambda (_index88026_ _l88027_)
                             (if (null? _l88027_)
                                 (error '"list too short"
                                        (cons 'list
                                              (cons 'was
                                                    (cons _lst87985_ '())))
                                        (cons 'attempted
                                              (cons 'end
                                                    (cons 'was
                                                          (cons _end88022_
                                                                '()))))
                                        (cons 'while
                                              (cons 'calling
                                                    (cons std/srfi/43#reverse-list->vector
                                                          '()))))
                                 (if (pair? _l88027_)
                                     (values (car _l88027_) (cdr _l88027_))
                                     (error '"erroneous value"
                                            (list list? _lst87985_)
                                            (cons 'while
                                                  (cons 'calling
                                                        (cons std/srfi/43#reverse-list->vector
                                                              '()))))))))))
                      (error '"too many arguments"
                             (length _maybe-start+end87986_)
                             _maybe-start+end87986_)))))))))
