(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/text/yaml#yaml-key-format (make-parameter values))
  (define std/text/yaml#yaml-load
    (lambda (_fname170472_)
      (let ((_$e170474_
             (std/text/libyaml#open_yaml_input_file
              (path-normalize _fname170472_))))
        (if _$e170474_
            ((lambda (_file170477_)
               (with-unwind-protect
                (lambda () (std/text/yaml#yaml-parse-file _file170477_))
                (lambda () (std/text/libyaml#close_yaml_file _file170477_))))
             _$e170474_)
            (error '"Cannot open yaml input file" _fname170472_)))))
  (define std/text/yaml#yaml-load-string
    (lambda (_str170463_)
      (let ((_$e170465_ (std/text/libyaml#yaml_strdup _str170463_)))
        (if _$e170465_
            ((lambda (_xstr170468_)
               (with-unwind-protect
                (lambda () (std/text/yaml#yaml-parse-string _xstr170468_))
                (lambda () (std/text/libyaml#yaml_strfree _xstr170468_))))
             _$e170465_)
            (error '"Failed to allocate memory for string" _str170463_)))))
  (define std/text/yaml#yaml-parse-file
    (lambda (_file170461_)
      (std/text/yaml#yaml-parse-input
       _file170461_
       std/text/libyaml#yaml_parser_set_input_file)))
  (define std/text/yaml#yaml-parse-string
    (lambda (_str170459_)
      (std/text/yaml#yaml-parse-input
       _str170459_
       std/text/libyaml#yaml_parser_set_input_string)))
  (define std/text/yaml#yaml-parse-input
    (lambda (_file170447_ _parser-set-input!170448_)
      (let* ((_parser170450_ (std/text/libyaml#make_yaml_parser))
             (_g300777_
              (std/text/libyaml#yaml_parser_initialize _parser170450_))
             (_g300778_
              (_parser-set-input!170448_ _parser170450_ _file170447_))
             (_event170454_ (std/text/libyaml#make_yaml_event)))
        (with-unwind-protect
         (lambda () (std/text/yaml#yaml-parse _parser170450_ _event170454_))
         (lambda () (std/text/libyaml#yaml_parser_delete _parser170450_))))))
  (define std/text/yaml#yaml-parse
    (lambda (_parser169995_ _event169996_)
      (letrec* ((_anchors169998_ (make-table))
                (_parse169999_
                 (lambda ()
                   (let ((_r170445_
                          (std/text/libyaml#yaml_parser_parse
                           _parser169995_
                           _event169996_)))
                     (if (zero? _r170445_)
                         (std/error#raise-io-error
                          'yaml-load
                          '"LibYAML parse error"
                          (std/text/libyaml#yaml_parser_error _parser169995_))
                         '#!void))))
                (_stream-start170000_
                 (lambda ()
                   (let* ((_g300779_ (_parse169999_))
                          (_t170441_
                           (std/text/libyaml#yaml_event_type _event169996_)))
                     (if (eq? _t170441_
                              std/text/libyaml#YAML_STREAM_START_EVENT)
                         (begin
                           (std/text/libyaml#yaml_event_delete _event169996_)
                           (_read-stream170001_))
                         (if (eq? _t170441_ std/text/libyaml#YAML_NO_EVENT)
                             (_stream-start170000_)
                             (std/error#raise-io-error
                              'yaml-load
                              '"stream-start: unexpected event"
                              _t170441_))))))
                (_read-stream170001_
                 (lambda ()
                   (let* ((_head170264_ (cons '#f '()))
                          (_tail170267_ _head170264_))
                     (let _lp170426_ ()
                       (let* ((_g300780_ (_parse169999_))
                              (_t170430_
                               (std/text/libyaml#yaml_event_type
                                _event169996_)))
                         (let ((_$e170433_
                                (eq? _t170430_
                                     std/text/libyaml#YAML_STREAM_END_EVENT)))
                           (if _$e170433_
                               _$e170433_
                               (if (eq? _t170430_
                                        std/text/libyaml#YAML_DOCUMENT_START_EVENT)
                                   (begin
                                     (std/text/libyaml#yaml_event_delete
                                      _event169996_)
                                     (let ((_new-tail170436_
                                            (cons (_read-node__0__300775300776_)
                                                  '())))
                                       (let ()
                                         (declare (not safe))
                                         (##set-cdr!
                                          _tail170267_
                                          _new-tail170436_))
                                       (set! _tail170267_ _new-tail170436_))
                                     (_lp170426_))
                                   (if (eq? _t170430_
                                            std/text/libyaml#YAML_DOCUMENT_END_EVENT)
                                       (_lp170426_)
                                       (if (eq? _t170430_
                                                std/text/libyaml#YAML_NO_EVENT)
                                           (_lp170426_)
                                           (std/error#raise-io-error
                                            'yaml-load
                                            '"read-stream: unexpected event"
                                            _t170430_))))))))
                     (let () (declare (not safe)) (##cdr _head170264_)))))
                (_end-token170002_ '#(end))
                (_read-node__300773300774_
                 (lambda (_end-event-t170216_)
                   (let* ((_g300781_ (_parse169999_))
                          (_t170219_
                           (std/text/libyaml#yaml_event_type _event169996_)))
                     (if (eq? _t170219_ std/text/libyaml#YAML_ALIAS_EVENT)
                         (let* ((_anchor170222_
                                 (std/text/libyaml#yaml_event_anchor
                                  _event169996_))
                                (_g300782_
                                 (std/text/libyaml#yaml_event_delete
                                  _event169996_)))
                           (if (hash-key? _anchors169998_ _anchor170222_)
                               (table-ref _anchors169998_ _anchor170222_)
                               (std/error#raise-io-error
                                'yaml-load
                                '"read-node: undefined alias"
                                _anchor170222_)))
                         (if (eq? _t170219_ std/text/libyaml#YAML_SCALAR_EVENT)
                             (let* ((_anchor170226_
                                     (std/text/libyaml#yaml_event_anchor
                                      _event169996_))
                                    (_tag170228_
                                     (std/text/libyaml#yaml_event_tag
                                      _event169996_))
                                    (_len170230_
                                     (std/text/libyaml#yaml_event_scalar_length
                                      _event169996_))
                                    (_data170232_ (make-u8vector _len170230_))
                                    (_g300783_
                                     (std/text/libyaml#yaml_event_scalar_bytes
                                      _event169996_
                                      _data170232_))
                                    (_g300784_
                                     (std/text/libyaml#yaml_event_delete
                                      _event169996_))
                                    (_value170236_
                                     (_parse-scalar170007_
                                      _data170232_
                                      _tag170228_)))
                               (if _anchor170226_
                                   (table-set!
                                    _anchors169998_
                                    _anchor170226_
                                    _value170236_)
                                   '#!void)
                               _value170236_)
                             (if (eq? _t170219_
                                      std/text/libyaml#YAML_SEQUENCE_START_EVENT)
                                 (let* ((_anchor170239_
                                         (std/text/libyaml#yaml_event_anchor
                                          _event169996_))
                                        (_tag170241_
                                         (std/text/libyaml#yaml_event_tag
                                          _event169996_))
                                        (_g300785_
                                         (std/text/libyaml#yaml_event_delete
                                          _event169996_))
                                        (_value170244_
                                         (_read-sequence170004_ _tag170241_)))
                                   (if _anchor170239_
                                       (table-set!
                                        _anchors169998_
                                        _anchor170239_
                                        _value170244_)
                                       '#!void)
                                   _value170244_)
                                 (if (eq? _t170219_
                                          std/text/libyaml#YAML_MAPPING_START_EVENT)
                                     (let* ((_anchor170247_
                                             (std/text/libyaml#yaml_event_anchor
                                              _event169996_))
                                            (_tag170249_
                                             (std/text/libyaml#yaml_event_tag
                                              _event169996_))
                                            (_g300786_
                                             (std/text/libyaml#yaml_event_delete
                                              _event169996_))
                                            (_value170252_
                                             (_read-mapping170006_
                                              _tag170249_)))
                                       (if _anchor170247_
                                           (table-set!
                                            _anchors169998_
                                            _anchor170247_
                                            _value170252_)
                                           '#!void)
                                       _value170252_)
                                     (if (eq? _t170219_ _end-event-t170216_)
                                         _end-token170002_
                                         (if (eq? _t170219_
                                                  std/text/libyaml#YAML_NO_EVENT)
                                             (_read-node__0__300775300776_)
                                             (std/error#raise-io-error
                                              'yaml-load
                                              '"read-object: unexpected event"
                                              _t170219_))))))))))
                (_read-node__0__300775300776_
                 (lambda ()
                   (let ((_end-event-t170259_ '#f))
                     (_read-node__300773300774_ _end-event-t170259_))))
                (_read-node170003_
                 (lambda _g300788_
                   (let ((_g300787_
                          (let () (declare (not safe)) (##length _g300788_))))
                     (cond ((let () (declare (not safe)) (##fx= _g300787_ 0))
                            (apply _read-node__0__300775300776_ _g300788_))
                           ((let () (declare (not safe)) (##fx= _g300787_ 1))
                            (apply _read-node__300773300774_ _g300788_))
                           (else
                            (##raise-wrong-number-of-arguments-exception
                             'case-lambda-dispatch
                             _g300788_))))))
                (_read-sequence170004_
                 (lambda (_tag170037_)
                   (let* ((_head170039_ (cons '#f '()))
                          (_tail170042_ _head170039_))
                     (let _lp170207_ ()
                       (let ((_next170210_
                              (_read-node__300773300774_
                               std/text/libyaml#YAML_SEQUENCE_END_EVENT)))
                         (if (eq? _next170210_ _end-token170002_)
                             '#!void
                             (begin
                               (let ((_new-tail170212_
                                      (cons _next170210_ '())))
                                 (let ()
                                   (declare (not safe))
                                   (##set-cdr! _tail170042_ _new-tail170212_))
                                 (set! _tail170042_ _new-tail170212_))
                               (_lp170207_)))))
                     (let () (declare (not safe)) (##cdr _head170039_)))))
                (_format-map-key170005_
                 (lambda (_key170035_)
                   (if (string? _key170035_)
                       ((std/text/yaml#yaml-key-format) _key170035_)
                       _key170035_)))
                (_read-mapping170006_
                 (lambda (_tag170024_)
                   (let ((_ht170026_ (make-table)))
                     (let _lp170028_ ()
                       (let ((_key170031_
                              (_read-node__300773300774_
                               std/text/libyaml#YAML_MAPPING_END_EVENT)))
                         (if (eq? _key170031_ _end-token170002_)
                             _ht170026_
                             (let ((_value170033_
                                    (_read-node__0__300775300776_)))
                               (table-set!
                                _ht170026_
                                (_format-map-key170005_ _key170031_)
                                _value170033_)
                               (_lp170028_))))))))
                (_parse-scalar170007_
                 (lambda (_data170009_ _tag170010_)
                   (let* ((_str170012_
                           (std/text/utf8#utf8->string__0 _data170009_))
                          (_$e170014_
                           (table-ref
                            std/text/yaml#yaml-scalar-tags
                            _tag170010_
                            '#f)))
                     (if _$e170014_
                         ((lambda (_g170016170018_)
                            (_g170016170018_ _str170012_))
                          _$e170014_)
                         (if (or (std/pregexp#pregexp-match
                                  std/text/yaml#rx-scalar-decimal
                                  _str170012_)
                                 (std/pregexp#pregexp-match
                                  std/text/yaml#rx-scalar-float
                                  _str170012_))
                             (string->number _str170012_)
                             (if (std/pregexp#pregexp-match
                                  std/text/yaml#rx-scalar-octal
                                  _str170012_)
                                 (string->number
                                  (substring
                                   _str170012_
                                   '1
                                   (string-length _str170012_))
                                  '8)
                                 (if (std/pregexp#pregexp-match
                                      std/text/yaml#rx-scalar-hex
                                      _str170012_)
                                     (string->number
                                      (substring
                                       _str170012_
                                       '2
                                       (string-length _str170012_))
                                      '16)
                                     (if (equal? '".inf" _str170012_)
                                         '+inf.0
                                         (if (equal? '"-.inf" _str170012_)
                                             '-inf.0
                                             (if (equal? '".NaN" _str170012_)
                                                 '+nan.0
                                                 (if (equal? '"true"
                                                             _str170012_)
                                                     '#t
                                                     (if (equal? '"false"
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                         _str170012_)
                 '#f
                 (if (equal? '"null" _str170012_)
                     '#!void
                     _str170012_))))))))))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
        (_stream-start170000_))))
  (define std/text/yaml#rx-scalar-decimal
    (std/pregexp#pregexp '"^[-+]?[0-9]+$"))
  (define std/text/yaml#rx-scalar-float
    (std/pregexp#pregexp '"^[-+]?[0-9]*[.][0-9]+([eE][-+]?[0-9]+)?$"))
  (define std/text/yaml#rx-scalar-octal (std/pregexp#pregexp '"^0o[0-7]+$"))
  (define std/text/yaml#rx-scalar-hex
    (std/pregexp#pregexp '"^0x[0-9a-fA-F]+$"))
  (define std/text/yaml#yaml-string->float
    (lambda (_str169993_)
      (if (equal? _str169993_ '".inf")
          '+inf.0
          (if (equal? _str169993_ '"-.inf")
              '-inf.0
              (if (equal? _str169993_ '".nan")
                  '+nan.0
                  (string->number _str169993_))))))
  (define std/text/yaml#yaml-scalar-tags
    (let ((_ht169986_ (make-table 'size: '4)))
      (table-set! _ht169986_ '"!!null" void)
      (table-set!
       _ht169986_
       '"!!bool"
       (lambda (_g169988169990_) (equal? _g169988169990_ '"true")))
      (table-set! _ht169986_ '"!!int" string->number)
      (table-set! _ht169986_ '"!!float" std/text/yaml#yaml-string->float)
      _ht169986_))
  (define std/text/yaml#yaml-dump
    (lambda (_fname169976_ . _args169977_)
      (let ((_$e169979_
             (std/text/libyaml#open_yaml_output_file
              (path-normalize _fname169976_))))
        (if _$e169979_
            ((lambda (_file169982_)
               (with-unwind-protect
                (lambda ()
                  (std/text/yaml#yaml-dump-file _file169982_ _args169977_))
                (lambda () (std/text/libyaml#close_yaml_file _file169982_))))
             _$e169979_)
            (error '"Cannot open yaml input file" _fname169976_)))))
  (define std/text/yaml#yaml-dump-file
    (lambda (_file169964_ _args169965_)
      (let* ((_emitter169967_ (std/text/libyaml#make_yaml_emitter))
             (_g300789_
              (std/text/libyaml#yaml_emitter_initialize _emitter169967_))
             (_g300790_
              (std/text/libyaml#yaml_emitter_set_output_file
               _emitter169967_
               _file169964_))
             (_event169971_ (std/text/libyaml#make_yaml_event)))
        (with-unwind-protect
         (lambda ()
           (std/text/yaml#yaml-emit
            _emitter169967_
            _event169971_
            _args169965_))
         (lambda () (std/text/libyaml#yaml_emitter_delete _emitter169967_))))))
  (define std/text/yaml#yaml-emit
    (lambda (_emitter169880_ _event169881_ _args169882_)
      (letrec ((_emit169884_
                (lambda ()
                  (let ((_r169962_
                         (std/text/libyaml#yaml_emitter_emit
                          _emitter169880_
                          _event169881_)))
                    (if (zero? _r169962_)
                        (std/error#raise-io-error
                         'yaml-dump
                         '"LibYAML emit error"
                         (std/text/libyaml#yaml_emitter_error _emitter169880_))
                        '#!void))))
               (_emit-document169885_
                (lambda (_obj169959_)
                  (std/text/libyaml#yaml_event_document_start _event169881_)
                  (_emit169884_)
                  (_emit-object169886_ _obj169959_)
                  (std/text/libyaml#yaml_event_document_end _event169881_)
                  (_emit169884_)))
               (_emit-object169886_
                (lambda (_obj169888_)
                  (if (string? _obj169888_)
                      (begin
                        (std/text/libyaml#yaml_event_scalar
                         _event169881_
                         _obj169888_)
                        (_emit169884_))
                      (if (symbol? _obj169888_)
                          (let ((_str169890_ (symbol->string _obj169888_)))
                            (std/text/libyaml#yaml_event_scalar
                             _event169881_
                             _str169890_)
                            (_emit169884_))
                          (if (and (number? _obj169888_) (real? _obj169888_))
                              (let ((_str169892_
                                     (if (integer? _obj169888_)
                                         (number->string _obj169888_)
                                         (if (finite? _obj169888_)
                                             (number->string
                                              (exact->inexact _obj169888_))
                                             (if (eqv? _obj169888_ '+inf.0)
                                                 '".inf"
                                                 (if (eqv? _obj169888_ '-inf.0)
                                                     '"-.inf"
                                                     (if (eqv? _obj169888_
                                                               '+nan.0)
                                                         '".NaN"
                                                         (error '"Bad YAML object"
                                                                _obj169888_))))))))
                                (std/text/libyaml#yaml_event_scalar
                                 _event169881_
                                 _str169892_)
                                (_emit169884_))
                              (if (list? _obj169888_)
                                  (begin
                                    (std/text/libyaml#yaml_event_sequence_start
                                     _event169881_)
                                    (_emit169884_)
                                    (for-each _emit-object169886_ _obj169888_)
                                    (std/text/libyaml#yaml_event_sequence_end
                                     _event169881_)
                                    (_emit169884_))
                                  (if (vector? _obj169888_)
                                      (_emit-object169886_
                                       (vector->list _obj169888_))
                                      (if (table? _obj169888_)
                                          (begin
                                            (std/text/libyaml#yaml_event_mapping_start
                                             _event169881_)
                                            (_emit169884_)
                                            (let ((_iterable169926_
                                                   _obj169888_)
                                                  (_iter-do169928_
                                                   (lambda (_val169894_)
                                                     (let* ((_val169896169903_
                                                             _val169894_)
                                                            (_E169898169907_
                                                             (lambda ()
                                                               (error '"No clause matching"
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                              _val169896169903_)))
                    (_K169899169913_
                     (lambda (_val169910_ _key169911_)
                       (_emit-object169886_ _key169911_)
                       (_emit-object169886_ _val169910_))))
               (if (let ((__tmp300791
                          (if (let ()
                                (declare (not safe))
                                (##values? _val169896169903_))
                              (let ()
                                (declare (not safe))
                                (##vector-length _val169896169903_))
                              '1)))
                     (declare (not safe))
                     (##fx= __tmp300791 '2))
                   (let* ((_e169900169916_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _val169896169903_ '0)))
                          (_key169919_ _e169900169916_)
                          (_e169901169921_
                           (let ()
                             (declare (not safe))
                             (##vector-ref _val169896169903_ '1)))
                          (_val169924_ _e169901169921_))
                     (_K169899169913_ _val169924_ _key169919_))
                   (_E169898169907_))))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                              (if (pair? _iterable169926_)
                                                  (for-each
                                                   _iter-do169928_
                                                   _iterable169926_)
                                                  (if (null? _iterable169926_)
                                                      '#!void
                                                      (let* ((_it169931_
                                                              (std/iter#iter
                                                               _iterable169926_))
                                                             (_next!169934_
                                                              (let ()
                                                                (declare
;;<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                          (not safe))
                        (##unchecked-structure-ref
                         _it169931_
                         '2
                         std/iter#iterator::t
                         '#f))))
                (declare (not safe))
                (begin
                  (let _lp169939_ ()
                    (let ((_val169943_ (_next!169934_ _it169931_)))
                      (if (eq? std/iter#iter-end _val169943_)
                          '#!void
                          (begin (_iter-do169928_ _val169943_) (_lp169939_)))))
                  (let ((_$e169945_
                         (##unchecked-structure-ref
                          _it169931_
                          '3
                          std/iter#iterator::t
                          '#f)))
                    (if _$e169945_
                        ((lambda (_g169947169949_)
                           (_g169947169949_ _it169931_))
                         _$e169945_)
                        '#!void))
                  '#!void)))))
;;>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                                            (std/text/libyaml#yaml_event_mapping_end
                                             _event169881_)
                                            (_emit169884_))
                                          (if (boolean? _obj169888_)
                                              (let ((_str169952_
                                                     (if _obj169888_
                                                         '"true"
                                                         '"false")))
                                                (std/text/libyaml#yaml_event_scalar
                                                 _event169881_
                                                 _str169952_)
                                                (_emit169884_))
                                              (if (eq? _obj169888_ '#!void)
                                                  (begin
                                                    (std/text/libyaml#yaml_event_scalar
                                                     _event169881_
                                                     '"null")
                                                    (_emit169884_))
                                                  (let ((_$e169954_
                                                         (method-ref
                                                          _obj169888_
                                                          ':yaml)))
                                                    (if _$e169954_
                                                        ((lambda (_yamlf169957_)
                                                           (_emit-object169886_
                                                            (_yamlf169957_
                                                             _obj169888_)))
                                                         _$e169954_)
                                                        (error '"Bad YAML object"
                                                               _obj169888_))))))))))))))
        (std/text/libyaml#yaml_event_stream_start _event169881_)
        (_emit169884_)
        (for-each _emit-document169885_ _args169882_)
        (std/text/libyaml#yaml_event_stream_end _event169881_)
        (_emit169884_)))))
