(declare (block) (standard-bindings) (extended-bindings))
(begin
  (define std/text/zlib#compress__%
    (lambda (_data170800_ _level170801_)
      (if (u8vector? _data170800_)
          (std/text/zlib#compress-bytes _data170800_ _level170801_)
          (if (string? _data170800_)
              (std/text/zlib#compress-bytes
               (std/text/utf8#string->utf8__0 _data170800_)
               _level170801_)
              (if (input-port? _data170800_)
                  (std/text/zlib#compress-port _data170800_ _level170801_)
                  (error '"Bad input source" _data170800_))))))
  (define std/text/zlib#compress__0
    (lambda (_data170806_)
      (let ((_level170808_ std/text/_zlib#Z_DEFAULT_COMPRESSION))
        (std/text/zlib#compress__% _data170806_ _level170808_))))
  (define std/text/zlib#compress
    (lambda _g290297_
      (let ((_g290296_ (let () (declare (not safe)) (##length _g290297_))))
        (cond ((let () (declare (not safe)) (##fx= _g290296_ 1))
               (apply std/text/zlib#compress__0 _g290297_))
              ((let () (declare (not safe)) (##fx= _g290296_ 2))
               (apply std/text/zlib#compress__% _g290297_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/zlib#compress
                _g290297_))))))
  (define std/text/zlib#compress-bytes
    (lambda (_data170791_ _level170792_)
      (let* ((_buf170794_
              (make-u8vector
               (std/text/_zlib#compressBound (u8vector-length _data170791_))))
             (_res170796_
              (std/text/_zlib#compress2
               _buf170794_
               _data170791_
               _level170792_)))
        (if (let () (declare (not safe)) (##fxnegative? _res170796_))
            (std/error#raise-io-error 'compress '"zlib error" _res170796_)
            (begin (u8vector-shrink! _buf170794_ _res170796_) _buf170794_)))))
  (define std/text/zlib#compress-port
    (lambda (_inp170788_ _level170789_)
      (std/text/zlib#deflate-port
       _inp170788_
       _level170789_
       std/text/_zlib#deflateInit)))
  (define std/text/zlib#compress-gz__%
    (lambda (_data170775_ _level170776_)
      (if (u8vector? _data170775_)
          (std/text/zlib#compress-gz-bytes _data170775_ _level170776_)
          (if (string? _data170775_)
              (std/text/zlib#compress-gz-bytes
               (std/text/utf8#string->utf8__0 _data170775_)
               _level170776_)
              (if (input-port? _data170775_)
                  (std/text/zlib#compress-gz-port _data170775_ _level170776_)
                  (error '"Bad input source" _data170775_))))))
  (define std/text/zlib#compress-gz__0
    (lambda (_data170781_)
      (let ((_level170783_ std/text/_zlib#Z_DEFAULT_COMPRESSION))
        (std/text/zlib#compress-gz__% _data170781_ _level170783_))))
  (define std/text/zlib#compress-gz
    (lambda _g290299_
      (let ((_g290298_ (let () (declare (not safe)) (##length _g290299_))))
        (cond ((let () (declare (not safe)) (##fx= _g290298_ 1))
               (apply std/text/zlib#compress-gz__0 _g290299_))
              ((let () (declare (not safe)) (##fx= _g290298_ 2))
               (apply std/text/zlib#compress-gz__% _g290299_))
              (else
               (##raise-wrong-number-of-arguments-exception
                std/text/zlib#compress-gz
                _g290299_))))))
  (define std/text/zlib#compress-gz-bytes
    (lambda (_data170763_ _level170764_)
      (let* ((_zs170766_ (std/text/_zlib#make_z_stream))
             (_res170768_
              (std/text/_zlib#deflateInit_gz _zs170766_ _level170764_)))
        (if (eq? _res170768_ std/text/_zlib#Z_OK)
            '#!void
            (std/error#raise-io-error
             'compress
             '"zlib stream initialization error"
             _res170768_))
        (with-unwind-protect
         (lambda () (std/text/zlib#compress-gz-data _zs170766_ _data170763_))
         (lambda () (std/text/_zlib#deflateEnd _zs170766_))))))
  (define std/text/zlib#compress-gz-data
    (lambda (_zs170755_ _data170756_)
      (let* ((_buf170758_
              (make-u8vector
               (std/text/_zlib#deflateBound
                _zs170755_
                (u8vector-length _data170756_))))
             (_res170760_
              (std/text/_zlib#deflate
               _zs170755_
               _buf170758_
               _data170756_
               '0
               std/text/_zlib#Z_FINISH)))
        (if (eq? _res170760_ std/text/_zlib#Z_STREAM_END)
            '#!void
            (std/error#raise-io-error
             'compress-gz
             '"incomplete deflate"
             (std/text/_zlib#z_stream_msg _zs170755_)
             _res170760_))
        (u8vector-shrink!
         _buf170758_
         (std/text/_zlib#z_stream_total_out _zs170755_))
        _buf170758_)))
  (define std/text/zlib#compress-gz-port
    (lambda (_inp170752_ _level170753_)
      (std/text/zlib#deflate-port
       _inp170752_
       _level170753_
       std/text/_zlib#deflateInit_gz)))
  (define std/text/zlib#deflate-port
    (lambda (_inp170740_ _level170741_ _init-e170742_)
      (let* ((_zs170744_ (std/text/_zlib#make_z_stream))
             (_res170746_ (_init-e170742_ _zs170744_ _level170741_)))
        (if (eq? _res170746_ std/text/_zlib#Z_OK)
            '#!void
            (std/error#raise-io-error
             'compress
             '"zlib stream initialization error"
             _res170746_))
        (with-unwind-protect
         (lambda () (std/text/zlib#do-deflate-port _zs170744_ _inp170740_))
         (lambda () (std/text/_zlib#deflateEnd _zs170744_))))))
  (define std/text/zlib#do-deflate-port
    (lambda (_zs170698_ _inp170699_)
      (letrec* ((_buflen170701_ '1024)
                (_fini170702_
                 (lambda (_r170738_)
                   (u8vector-concatenate (reverse _r170738_))))
                (_deflate-next170703_
                 (lambda (_ibuf170715_ _r170716_ _flush170717_)
                   (let _lp170719_ ((_obuf170721_
                                     (make-u8vector _buflen170701_))
                                    (_start170722_ '0)
                                    (_r170723_ _r170716_))
                     (let* ((_icount170725_
                             (std/text/_zlib#z_stream_total_in _zs170698_))
                            (_ocount170727_
                             (std/text/_zlib#z_stream_total_out _zs170698_))
                            (_res170729_
                             (std/text/_zlib#deflate
                              _zs170698_
                              _obuf170721_
                              _ibuf170715_
                              _start170722_
                              _flush170717_))
                            (_ocount170731_
                             (let ((__tmp290300
                                    (std/text/_zlib#z_stream_total_out
                                     _zs170698_)))
                               (declare (not safe))
                               (##fx- __tmp290300 _ocount170727_))))
                       (if (eq? _res170729_ std/text/_zlib#Z_OK)
                           (let ((_acount170734_
                                  (std/text/_zlib#z_stream_avail_out
                                   _zs170698_)))
                             (if (let ()
                                   (declare (not safe))
                                   (##fxzero? _acount170734_))
                                 (let ((_icount170736_
                                        (let ((__tmp290301
                                               (std/text/_zlib#z_stream_total_in
                                                _zs170698_)))
                                          (declare (not safe))
                                          (##fx- __tmp290301 _icount170725_))))
                                   (u8vector-shrink!
                                    _obuf170721_
                                    _ocount170731_)
                                   (_lp170719_
                                    (make-u8vector _buflen170701_)
                                    (let ()
                                      (declare (not safe))
                                      (##fx+ _start170722_ _icount170736_))
                                    (cons _obuf170721_ _r170723_)))
                                 (if (let ()
                                       (declare (not safe))
                                       (##fx> _ocount170731_ '0))
                                     (begin
                                       (u8vector-shrink!
                                        _obuf170721_
                                        _ocount170731_)
                                       (cons _obuf170721_ _r170723_))
                                     _r170723_)))
                           (if (eq? _res170729_ std/text/_zlib#Z_STREAM_END)
                               (if (let ()
                                     (declare (not safe))
                                     (##fx> _ocount170731_ '0))
                                   (begin
                                     (u8vector-shrink!
                                      _obuf170721_
                                      _ocount170731_)
                                     (cons _obuf170721_ _r170723_))
                                   _r170723_)
                               (std/error#raise-io-error
                                'deflate-port
                                '"deflate: zlib error"
                                (std/text/_zlib#z_stream_msg _zs170698_)
                                _res170729_))))))))
        (let ((_ibuf170705_ (make-u8vector _buflen170701_)))
          (let _lp170707_ ((_r170709_ '()))
            (let ((_rd170711_
                   (read-subu8vector
                    _ibuf170705_
                    '0
                    _buflen170701_
                    _inp170699_)))
              (if (let () (declare (not safe)) (##fxzero? _rd170711_))
                  (_fini170702_
                   (_deflate-next170703_
                    '#f
                    _r170709_
                    std/text/_zlib#Z_FINISH))
                  (if (let ()
                        (declare (not safe))
                        (##fx< _rd170711_ _buflen170701_))
                      (begin
                        (u8vector-shrink! _ibuf170705_ _rd170711_)
                        (_fini170702_
                         (_deflate-next170703_
                          _ibuf170705_
                          _r170709_
                          std/text/_zlib#Z_FINISH)))
                      (let ((_r170713_
                             (_deflate-next170703_
                              _ibuf170705_
                              _r170709_
                              std/text/_zlib#Z_NO_FLUSH)))
                        (_lp170707_ _r170713_))))))))))
  (define std/text/zlib#uncompress
    (lambda (_data170696_)
      (if (u8vector? _data170696_)
          (std/text/zlib#uncompress-bytes _data170696_)
          (if (input-port? _data170696_)
              (std/text/zlib#uncompress-port _data170696_)
              (error '"Bad input source" _data170696_)))))
  (define std/text/zlib#uncompress-bytes
    (lambda (_data170694_)
      (std/text/zlib#do-inflate _data170694_ std/text/zlib#uncompress-data)))
  (define std/text/zlib#do-inflate
    (lambda (_data170683_ _inflate-e170684_)
      (let* ((_zs170686_ (std/text/_zlib#make_z_stream))
             (_res170688_ (std/text/_zlib#inflateInit _zs170686_)))
        (if (eq? _res170688_ std/text/_zlib#Z_OK)
            '#!void
            (std/error#raise-io-error
             'uncompress
             '"zlib stream initialization error"
             _res170688_))
        (with-unwind-protect
         (lambda () (_inflate-e170684_ _zs170686_ _data170683_))
         (lambda () (std/text/_zlib#inflateEnd _zs170686_))))))
  (define std/text/zlib#uncompress-data
    (lambda (_zs170660_ _data170661_)
      (letrec* ((_buflen170663_ '1024))
        (let _lp170665_ ((_start170667_ '0) (_r170668_ '()))
          (let* ((_buf170670_ (make-u8vector _buflen170663_))
                 (_icount170672_ (std/text/_zlib#z_stream_total_in _zs170660_))
                 (_ocount170674_
                  (std/text/_zlib#z_stream_total_out _zs170660_))
                 (_res170676_
                  (std/text/_zlib#inflate
                   _zs170660_
                   _buf170670_
                   _data170661_
                   _start170667_))
                 (_ocount170678_
                  (let ((__tmp290302
                         (std/text/_zlib#z_stream_total_out _zs170660_)))
                    (declare (not safe))
                    (##fx- __tmp290302 _ocount170674_))))
            (if (eq? _res170676_ std/text/_zlib#Z_OK)
                (let ((_icount170681_
                       (let ((__tmp290303
                              (std/text/_zlib#z_stream_total_in _zs170660_)))
                         (declare (not safe))
                         (##fx- __tmp290303 _icount170672_))))
                  (u8vector-shrink! _buf170670_ _ocount170678_)
                  (_lp170665_
                   (let ()
                     (declare (not safe))
                     (##fx+ _start170667_ _icount170681_))
                   (cons _buf170670_ _r170668_)))
                (if (eq? _res170676_ std/text/_zlib#Z_STREAM_END)
                    (begin
                      (u8vector-shrink! _buf170670_ _ocount170678_)
                      (u8vector-concatenate
                       (reverse (cons _buf170670_ _r170668_))))
                    (std/error#raise-io-error
                     'uncompress
                     '"zlib error"
                     (std/text/_zlib#z_stream_msg _zs170660_)
                     _res170676_))))))))
  (define std/text/zlib#uncompress-port
    (lambda (_inp170658_)
      (std/text/zlib#do-inflate _inp170658_ std/text/zlib#do-inflate-port)))
  (define std/text/zlib#do-inflate-port
    (lambda (_zs170618_ _inp170619_)
      (letrec* ((_buflen170621_ '1024)
                (_fini170622_
                 (lambda (_r170656_)
                   (u8vector-concatenate (reverse _r170656_))))
                (_inflate-next170623_
                 (lambda (_ibuf170633_ _r170634_)
                   (let _lp170636_ ((_obuf170638_
                                     (make-u8vector _buflen170621_))
                                    (_start170639_ '0)
                                    (_r170640_ _r170634_))
                     (let* ((_icount170642_
                             (std/text/_zlib#z_stream_total_in _zs170618_))
                            (_ocount170644_
                             (std/text/_zlib#z_stream_total_out _zs170618_))
                            (_res170646_
                             (std/text/_zlib#inflate
                              _zs170618_
                              _obuf170638_
                              _ibuf170633_
                              _start170639_))
                            (_ocount170648_
                             (let ((__tmp290304
                                    (std/text/_zlib#z_stream_total_out
                                     _zs170618_)))
                               (declare (not safe))
                               (##fx- __tmp290304 _ocount170644_))))
                       (if (eq? _res170646_ std/text/_zlib#Z_OK)
                           (let* ((_icount170651_
                                   (let ((__tmp290305
                                          (std/text/_zlib#z_stream_total_in
                                           _zs170618_)))
                                     (declare (not safe))
                                     (##fx- __tmp290305 _icount170642_)))
                                  (_start170653_
                                   (let ()
                                     (declare (not safe))
                                     (##fx+ _start170639_ _icount170651_))))
                             (u8vector-shrink! _obuf170638_ _ocount170648_)
                             (if (let ()
                                   (declare (not safe))
                                   (##fx< _start170653_ _buflen170621_))
                                 (_lp170636_
                                  (make-u8vector _buflen170621_)
                                  _start170653_
                                  (cons _obuf170638_ _r170640_))
                                 (cons _obuf170638_ _r170640_)))
                           (if (eq? _res170646_ std/text/_zlib#Z_STREAM_END)
                               (begin
                                 (u8vector-shrink! _obuf170638_ _ocount170648_)
                                 (cons _obuf170638_ _r170640_))
                               (std/error#raise-io-error
                                'inflate-port
                                '"zlib error"
                                (std/text/_zlib#z_stream_msg _zs170618_)
                                _res170646_))))))))
        (let ((_ibuf170625_ (make-u8vector _buflen170621_)))
          (let _lp170627_ ((_r170629_ '()))
            (let ((_rd170631_
                   (read-subu8vector
                    _ibuf170625_
                    '0
                    _buflen170621_
                    _inp170619_)))
              (if (let () (declare (not safe)) (##fxzero? _rd170631_))
                  (_fini170622_ _r170629_)
                  (if (let ()
                        (declare (not safe))
                        (##fx< _rd170631_ _buflen170621_))
                      (begin
                        (u8vector-shrink! _ibuf170625_ _rd170631_)
                        (_fini170622_
                         (_inflate-next170623_ _ibuf170625_ _r170629_)))
                      (_lp170627_
                       (_inflate-next170623_ _ibuf170625_ _r170629_)))))))))))
